/* nintendo-ds-runner.c generated by valac 0.56.3, the Vala compiler
 * generated from nintendo-ds-runner.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <retro-gtk.h>
#include <gio/gio.h>
#include "linux/input-event-codes.h"
#include "games-nintendo-ds-plugin.h"

#define GAMES_NINTENDO_DS_RUNNER_SCREENS_LAYOUT_OPTION "desmume_screens_layout"
#define GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_OPTION "desmume_screens_gap"
#define GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_NONE "0"
#define GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_DEFAULT "80"
#define GAMES_NINTENDO_DS_RUNNER_HEADER_GAME_CODE_OFFSET ((gsize) 12)
#define GAMES_NINTENDO_DS_RUNNER_HEADER_GAME_CODE_SIZE ((gsize) 3)

#define GAMES_TYPE_NINTENDO_DS_RUNNER (games_nintendo_ds_runner_get_type ())
#define GAMES_NINTENDO_DS_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunner))
#define GAMES_NINTENDO_DS_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunnerClass))
#define GAMES_IS_NINTENDO_DS_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_NINTENDO_DS_RUNNER))
#define GAMES_IS_NINTENDO_DS_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_NINTENDO_DS_RUNNER))
#define GAMES_NINTENDO_DS_RUNNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunnerClass))

typedef struct _GamesNintendoDsRunner GamesNintendoDsRunner;
typedef struct _GamesNintendoDsRunnerClass GamesNintendoDsRunnerClass;
typedef struct _GamesNintendoDsRunnerPrivate GamesNintendoDsRunnerPrivate;
enum  {
	GAMES_NINTENDO_DS_RUNNER_0_PROPERTY,
	GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY,
	GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY,
	GAMES_NINTENDO_DS_RUNNER_NUM_PROPERTIES
};
static GParamSpec* games_nintendo_ds_runner_properties[GAMES_NINTENDO_DS_RUNNER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GamesNintendoDsRunner {
	GamesRetroRunner parent_instance;
	GamesNintendoDsRunnerPrivate * priv;
};

struct _GamesNintendoDsRunnerClass {
	GamesRetroRunnerClass parent_class;
};

struct _GamesNintendoDsRunnerPrivate {
	GamesScreenLayout _screen_layout;
	gboolean _view_bottom_screen;
};

static gint GamesNintendoDsRunner_private_offset;
static gpointer games_nintendo_ds_runner_parent_class = NULL;
static GHashTable* games_nintendo_ds_runner_layouts;
static GHashTable* games_nintendo_ds_runner_layouts = NULL;
static GHashTable* games_nintendo_ds_runner_gap_overrides;
static GHashTable* games_nintendo_ds_runner_gap_overrides = NULL;
static GType games_nintendo_ds_runner_type_id = 0;

GType games_nintendo_ds_runner_register_type (GTypeModule * module);
VALA_EXTERN GType games_nintendo_ds_runner_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesNintendoDsRunner* games_nintendo_ds_runner_new (GamesGame* game,
                                                     GamesRetroCoreSource* source);
VALA_EXTERN GamesNintendoDsRunner* games_nintendo_ds_runner_construct (GType object_type,
                                                           GamesGame* game,
                                                           GamesRetroCoreSource* source);
static gboolean games_nintendo_ds_runner_core_supports_layouts (GamesNintendoDsRunner* self);
static gchar* games_nintendo_ds_runner_get_screen_gap_width (GamesNintendoDsRunner* self);
static void games_nintendo_ds_runner_update_screen_layout (GamesNintendoDsRunner* self);
VALA_EXTERN gchar* games_nintendo_ds_layout_get_value (GamesScreenLayout layout);
VALA_EXTERN GamesScreenLayout games_nintendo_ds_runner_get_screen_layout (GamesNintendoDsRunner* self);
VALA_EXTERN gboolean games_nintendo_ds_runner_get_view_bottom_screen (GamesNintendoDsRunner* self);
static GamesHeaderBarWidget* games_nintendo_ds_runner_real_get_extra_widget (GamesRetroRunner* base);
static gboolean games_nintendo_ds_runner_real_key_press_event (GamesRetroRunner* base,
                                                        guint keyval,
                                                        GdkModifierType state);
static GamesScreenLayout* _games_screen_layout_dup (GamesScreenLayout* self);
VALA_EXTERN void games_nintendo_ds_runner_set_screen_layout (GamesNintendoDsRunner* self,
                                                 GamesScreenLayout value);
static gboolean games_nintendo_ds_runner_swap_screens (GamesNintendoDsRunner* self);
static gboolean games_nintendo_ds_runner_real_gamepad_button_press_event (GamesRetroRunner* base,
                                                                   guint16 button);
VALA_EXTERN void games_nintendo_ds_runner_set_view_bottom_screen (GamesNintendoDsRunner* self,
                                                      gboolean value);
static void games_nintendo_ds_runner_real_save_to_snapshot (GamesRetroRunner* base,
                                                     GamesSnapshot* snapshot,
                                                     GError** error);
static void games_nintendo_ds_runner_real_load_from_snapshot (GamesRetroRunner* base,
                                                       GamesSnapshot* snapshot,
                                                       GError** error);
static void games_nintendo_ds_runner_real_reset_with_snapshot (GamesRetroRunner* base,
                                                        GamesSnapshot* last_snapshot,
                                                        GError** error);
static void _g_free0_ (gpointer var);
static void games_nintendo_ds_runner_finalize (GObject * obj);
static void _vala_games_nintendo_ds_runner_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_games_nintendo_ds_runner_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
games_nintendo_ds_runner_get_instance_private (GamesNintendoDsRunner* self)
{
	return G_STRUCT_MEMBER_P (self, GamesNintendoDsRunner_private_offset);
}

GamesNintendoDsRunner*
games_nintendo_ds_runner_construct (GType object_type,
                                    GamesGame* game,
                                    GamesRetroCoreSource* source)
{
	GamesNintendoDsRunner * self = NULL;
#line 68 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 68 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 69 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) games_retro_runner_construct_from_source (object_type, game, source);
#line 68 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return self;
#line 146 "nintendo-ds-runner.c"
}

GamesNintendoDsRunner*
games_nintendo_ds_runner_new (GamesGame* game,
                              GamesRetroCoreSource* source)
{
#line 68 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return games_nintendo_ds_runner_construct (GAMES_TYPE_NINTENDO_DS_RUNNER, game, source);
#line 155 "nintendo-ds-runner.c"
}

static gboolean
games_nintendo_ds_runner_core_supports_layouts (GamesNintendoDsRunner* self)
{
	RetroCore* core = NULL;
	RetroCore* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	RetroCore* _tmp3_;
	gboolean result;
#line 72 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = games_retro_runner_get_core ((GamesRetroRunner*) self);
#line 73 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	core = _tmp0_;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = core;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp3_ != NULL) {
#line 177 "nintendo-ds-runner.c"
		RetroCore* _tmp4_;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp4_ = core;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp2_ = retro_core_has_option (_tmp4_, GAMES_NINTENDO_DS_RUNNER_SCREENS_LAYOUT_OPTION);
#line 183 "nintendo-ds-runner.c"
	} else {
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp2_ = FALSE;
#line 187 "nintendo-ds-runner.c"
	}
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp2_) {
#line 191 "nintendo-ds-runner.c"
		RetroCore* _tmp5_;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp5_ = core;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp1_ = retro_core_has_option (_tmp5_, GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_OPTION);
#line 197 "nintendo-ds-runner.c"
	} else {
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp1_ = FALSE;
#line 201 "nintendo-ds-runner.c"
	}
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = _tmp1_;
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (core);
#line 75 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 209 "nintendo-ds-runner.c"
}

static gchar*
games_nintendo_ds_runner_get_screen_gap_width (GamesNintendoDsRunner* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 78 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 219 "nintendo-ds-runner.c"
	{
		GamesMediaSet* _tmp0_;
		GamesMediaSet* _tmp1_;
		GamesMedia* _tmp2_ = NULL;
		GamesMediaSet* _tmp3_;
		GamesMediaSet* _tmp4_;
		GamesMedia* _tmp5_;
		GamesUri** uris = NULL;
		gint _tmp6_ = 0;
		GamesUri** _tmp7_;
		gint uris_length1;
		gint _uris_size_;
		GFile* file = NULL;
		GamesUri** _tmp8_;
		gint _tmp8__length1;
		GamesUri* _tmp9_;
		GFile* _tmp10_;
		GamesStringInputStream* stream = NULL;
		GFile* _tmp11_;
		GamesStringInputStream* _tmp12_;
		gchar* game_code = NULL;
		GamesStringInputStream* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_ = NULL;
		GHashTable* _tmp16_;
		const gchar* _tmp17_;
		gconstpointer _tmp18_;
		gchar* _tmp19_;
#line 80 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp0_ = games_runner_get_media_set ((GamesRunner*) self);
#line 80 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp1_ = _tmp0_;
#line 80 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_vala_assert (games_media_set_get_size (_tmp1_) == 1, "media_set.get_size () == 1");
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp3_ = games_runner_get_media_set ((GamesRunner*) self);
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp4_ = _tmp3_;
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp5_ = games_media_set_get_media (_tmp4_, (guint) 0, &_inner_error0_);
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp2_ = _tmp5_;
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "nintendo-ds-runner.c"
			goto __catch0_g_error;
		}
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp7_ = games_media_get_uris (_tmp2_, &_tmp6_);
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		uris = _tmp7_;
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		uris_length1 = _tmp6_;
#line 81 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_uris_size_ = uris_length1;
#line 82 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp8_ = uris;
#line 82 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp8__length1 = uris_length1;
#line 82 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp9_ = _tmp8_[0];
#line 82 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp10_ = games_uri_to_file (_tmp9_);
#line 82 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		file = _tmp10_;
#line 83 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp11_ = file;
#line 83 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp12_ = games_string_input_stream_new (_tmp11_);
#line 83 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		stream = _tmp12_;
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp13_ = stream;
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp14_ = games_string_input_stream_read_string_for_size (_tmp13_, GAMES_NINTENDO_DS_RUNNER_HEADER_GAME_CODE_OFFSET, GAMES_NINTENDO_DS_RUNNER_HEADER_GAME_CODE_SIZE, &_inner_error0_);
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		game_code = _tmp14_;
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_g_object_unref0 (stream);
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_g_object_unref0 (file);
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) games_uri_unref), NULL);
#line 84 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_g_object_unref0 (_tmp2_);
#line 307 "nintendo-ds-runner.c"
			goto __catch0_g_error;
		}
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp16_ = games_nintendo_ds_runner_gap_overrides;
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp17_ = game_code;
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp18_ = g_hash_table_lookup (_tmp16_, _tmp17_);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp15_ = (const gchar*) _tmp18_;
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (_tmp15_ == NULL) {
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_tmp15_ = GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_DEFAULT;
#line 322 "nintendo-ds-runner.c"
		}
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp19_ = g_strdup (_tmp15_);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = _tmp19_;
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (game_code);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (stream);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (file);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) games_uri_unref), NULL);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (_tmp2_);
#line 86 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 340 "nintendo-ds-runner.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 79 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		e = _inner_error0_;
#line 79 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_inner_error0_ = NULL;
#line 89 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp20_ = e;
#line 89 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp21_ = _tmp20_->message;
#line 89 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_critical ("nintendo-ds-runner.vala:89: Couldn't read the header: %s", _tmp21_);
#line 91 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp22_ = g_strdup (GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_DEFAULT);
#line 91 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = _tmp22_;
#line 91 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_error_free0 (e);
#line 91 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 367 "nintendo-ds-runner.c"
	}
	__finally0:
#line 79 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_clear_error (&_inner_error0_);
#line 79 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return NULL;
#line 376 "nintendo-ds-runner.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return self ? g_object_ref (self) : NULL;
#line 384 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_update_screen_layout (GamesNintendoDsRunner* self)
{
	RetroCore* core = NULL;
	RetroCore* _tmp0_;
	RetroOption* screens_layout_option = NULL;
	RetroCore* _tmp1_;
	RetroOption* _tmp2_;
	RetroOption* _tmp3_;
	gchar* screens_layout_option_value = NULL;
	GamesScreenLayout _tmp4_;
	GamesScreenLayout _tmp5_;
	gchar* _tmp6_;
	GamesScreenLayout _tmp7_;
	GamesScreenLayout _tmp8_;
	RetroOption* screens_gap_option = NULL;
	RetroCore* _tmp13_;
	RetroOption* _tmp14_;
	RetroOption* _tmp15_;
	gchar* screens_gap = NULL;
	GamesScreenLayout _tmp16_;
	GamesScreenLayout _tmp17_;
	GError* _inner_error0_ = NULL;
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_if_fail (self != NULL);
#line 96 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (!games_nintendo_ds_runner_core_supports_layouts (self)) {
#line 97 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return;
#line 416 "nintendo-ds-runner.c"
	}
#line 99 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = games_retro_runner_get_core ((GamesRetroRunner*) self);
#line 99 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	core = _tmp0_;
#line 101 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = core;
#line 101 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = retro_core_get_option (_tmp1_, GAMES_NINTENDO_DS_RUNNER_SCREENS_LAYOUT_OPTION);
#line 101 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 101 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	screens_layout_option = _tmp3_;
#line 102 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp4_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 102 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp5_ = _tmp4_;
#line 102 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp6_ = games_nintendo_ds_layout_get_value (_tmp5_);
#line 102 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	screens_layout_option_value = _tmp6_;
#line 103 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp7_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 103 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp8_ = _tmp7_;
#line 103 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp8_ == GAMES_SCREEN_LAYOUT_QUICK_SWITCH) {
#line 444 "nintendo-ds-runner.c"
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_;
		gboolean _tmp11_;
		gchar* _tmp12_;
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp10_ = games_nintendo_ds_runner_get_view_bottom_screen (self);
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp11_ = _tmp10_;
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (_tmp11_) {
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_tmp9_ = "bottom only";
#line 457 "nintendo-ds-runner.c"
		} else {
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_tmp9_ = "top only";
#line 461 "nintendo-ds-runner.c"
		}
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp12_ = g_strdup (_tmp9_);
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (screens_layout_option_value);
#line 104 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		screens_layout_option_value = _tmp12_;
#line 469 "nintendo-ds-runner.c"
	}
#line 106 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp13_ = core;
#line 106 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp14_ = retro_core_get_option (_tmp13_, GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_OPTION);
#line 106 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 106 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	screens_gap_option = _tmp15_;
#line 108 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp16_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 108 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp17_ = _tmp16_;
#line 108 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp17_ == GAMES_SCREEN_LAYOUT_TOP_BOTTOM) {
#line 485 "nintendo-ds-runner.c"
		gchar* _tmp18_;
#line 109 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp18_ = games_nintendo_ds_runner_get_screen_gap_width (self);
#line 109 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (screens_gap);
#line 109 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		screens_gap = _tmp18_;
#line 493 "nintendo-ds-runner.c"
	} else {
		gchar* _tmp19_;
#line 111 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp19_ = g_strdup (GAMES_NINTENDO_DS_RUNNER_SCREENS_GAP_NONE);
#line 111 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (screens_gap);
#line 111 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		screens_gap = _tmp19_;
#line 502 "nintendo-ds-runner.c"
	}
	{
		RetroOption* _tmp20_;
		const gchar* _tmp21_;
		RetroOption* _tmp22_;
		const gchar* _tmp23_;
#line 114 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp20_ = screens_layout_option;
#line 114 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp21_ = screens_layout_option_value;
#line 114 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		retro_option_set_value (_tmp20_, _tmp21_, &_inner_error0_);
#line 114 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 517 "nintendo-ds-runner.c"
			goto __catch0_g_error;
		}
#line 115 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp22_ = screens_gap_option;
#line 115 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp23_ = screens_gap;
#line 115 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		retro_option_set_value (_tmp22_, _tmp23_, &_inner_error0_);
#line 115 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 528 "nintendo-ds-runner.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		e = _inner_error0_;
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_inner_error0_ = NULL;
#line 118 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp24_ = e;
#line 118 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp25_ = _tmp24_->message;
#line 118 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_critical ("nintendo-ds-runner.vala:118: Failed to set desmume option: %s", _tmp25_);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_error_free0 (e);
#line 550 "nintendo-ds-runner.c"
	}
	__finally0:
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (screens_gap);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (screens_gap_option);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (screens_layout_option_value);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (screens_layout_option);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_object_unref0 (core);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_clear_error (&_inner_error0_);
#line 113 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return;
#line 571 "nintendo-ds-runner.c"
	}
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_free0 (screens_gap);
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (screens_gap_option);
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_free0 (screens_layout_option_value);
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (screens_layout_option);
#line 95 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (core);
#line 583 "nintendo-ds-runner.c"
}

static GamesHeaderBarWidget*
games_nintendo_ds_runner_real_get_extra_widget (GamesRetroRunner* base)
{
	GamesNintendoDsRunner * self;
	GamesScreenLayoutSwitcher* switcher = NULL;
	GamesScreenLayoutSwitcher* _tmp0_;
	GamesScreenLayoutSwitcher* _tmp1_;
	GamesScreenLayoutSwitcher* _tmp2_;
	GamesHeaderBarWidget* result;
#line 122 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 123 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (!games_nintendo_ds_runner_core_supports_layouts (self)) {
#line 124 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = NULL;
#line 124 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 603 "nintendo-ds-runner.c"
	}
#line 126 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = games_screen_layout_switcher_new ();
#line 126 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_ref_sink (_tmp0_);
#line 126 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	switcher = _tmp0_;
#line 128 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = switcher;
#line 128 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_bind_property_with_closures ((GObject*) self, "screen-layout", (GObject*) _tmp1_, "screen-layout", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 130 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = switcher;
#line 130 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_bind_property_with_closures ((GObject*) self, "view-bottom-screen", (GObject*) _tmp2_, "view-bottom-screen", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 133 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = (GamesHeaderBarWidget*) switcher;
#line 133 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 623 "nintendo-ds-runner.c"
}

static GamesScreenLayout*
_games_screen_layout_dup (GamesScreenLayout* self)
{
	GamesScreenLayout* dup;
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	dup = g_new0 (GamesScreenLayout, 1);
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	memcpy (dup, self, sizeof (GamesScreenLayout));
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return dup;
#line 636 "nintendo-ds-runner.c"
}

static gpointer
__games_screen_layout_dup0 (gpointer self)
{
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return self ? _games_screen_layout_dup (self) : NULL;
#line 644 "nintendo-ds-runner.c"
}

static gboolean
games_nintendo_ds_runner_real_key_press_event (GamesRetroRunner* base,
                                               guint keyval,
                                               GdkModifierType state)
{
	GamesNintendoDsRunner * self;
	GamesScreenLayout _tmp5_;
	GamesScreenLayout _tmp6_;
	guint _tmp7_ = 0U;
	gboolean _tmp8_;
	gboolean _tmp9_;
	guint switch_keyval = 0U;
	gboolean result;
#line 136 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 137 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (state == GDK_MOD1_MASK) {
#line 664 "nintendo-ds-runner.c"
		GamesScreenLayout* shortcut_layout = NULL;
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		GamesScreenLayout* _tmp2_;
		GamesScreenLayout* _tmp3_;
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp0_ = games_nintendo_ds_runner_layouts;
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((guintptr) keyval));
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp2_ = __games_screen_layout_dup0 ((GamesScreenLayout*) _tmp1_);
#line 139 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		shortcut_layout = _tmp2_;
#line 140 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp3_ = shortcut_layout;
#line 140 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (_tmp3_ != NULL) {
#line 682 "nintendo-ds-runner.c"
			GamesScreenLayout* _tmp4_;
#line 141 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_tmp4_ = shortcut_layout;
#line 141 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			games_nintendo_ds_runner_set_screen_layout (self, *_tmp4_);
#line 143 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			result = TRUE;
#line 143 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			_g_free0 (shortcut_layout);
#line 143 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			return result;
#line 694 "nintendo-ds-runner.c"
		}
#line 137 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (shortcut_layout);
#line 698 "nintendo-ds-runner.c"
	}
#line 147 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp5_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 147 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp6_ = _tmp5_;
#line 147 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp6_ != GAMES_SCREEN_LAYOUT_QUICK_SWITCH) {
#line 148 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = FALSE;
#line 148 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 710 "nintendo-ds-runner.c"
	}
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp8_ = games_nintendo_ds_runner_get_view_bottom_screen (self);
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp9_ = _tmp8_;
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp9_) {
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp7_ = GDK_KEY_Page_Up;
#line 720 "nintendo-ds-runner.c"
	} else {
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp7_ = GDK_KEY_Page_Down;
#line 724 "nintendo-ds-runner.c"
	}
#line 150 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	switch_keyval = _tmp7_;
#line 151 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (keyval == switch_keyval) {
#line 152 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = games_nintendo_ds_runner_swap_screens (self);
#line 152 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 734 "nintendo-ds-runner.c"
	}
#line 154 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = FALSE;
#line 154 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 740 "nintendo-ds-runner.c"
}

static gboolean
games_nintendo_ds_runner_real_gamepad_button_press_event (GamesRetroRunner* base,
                                                          guint16 button)
{
	GamesNintendoDsRunner * self;
	gboolean result;
#line 157 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 158 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (button == BTN_THUMBR) {
#line 159 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = games_nintendo_ds_runner_swap_screens (self);
#line 159 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 757 "nintendo-ds-runner.c"
	}
#line 161 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = FALSE;
#line 161 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 763 "nintendo-ds-runner.c"
}

static gboolean
games_nintendo_ds_runner_swap_screens (GamesNintendoDsRunner* self)
{
	GamesScreenLayout _tmp0_;
	GamesScreenLayout _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 164 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 165 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = _tmp0_;
#line 165 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (_tmp1_ != GAMES_SCREEN_LAYOUT_QUICK_SWITCH) {
#line 166 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		result = FALSE;
#line 166 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return result;
#line 786 "nintendo-ds-runner.c"
	}
#line 168 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = games_nintendo_ds_runner_get_view_bottom_screen (self);
#line 168 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = _tmp2_;
#line 168 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_set_view_bottom_screen (self, !_tmp3_);
#line 170 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = TRUE;
#line 170 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 798 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_real_save_to_snapshot (GamesRetroRunner* base,
                                                GamesSnapshot* snapshot,
                                                GError** error)
{
	GamesNintendoDsRunner * self;
	GamesNintendoDsSnapshot* ds_snapshot = NULL;
	GamesNintendoDsSnapshot* _tmp0_;
	GamesNintendoDsSnapshot* _tmp1_;
	GamesScreenLayout _tmp2_;
	GamesScreenLayout _tmp3_;
	GamesNintendoDsSnapshot* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
#line 173 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 173 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_if_fail (snapshot != NULL);
#line 174 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	GAMES_RETRO_RUNNER_CLASS (games_nintendo_ds_runner_parent_class)->save_to_snapshot (G_TYPE_CHECK_INSTANCE_CAST (self, GAMES_TYPE_RETRO_RUNNER, GamesRetroRunner), snapshot, &_inner_error0_);
#line 174 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_propagate_error (error, _inner_error0_);
#line 174 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return;
#line 828 "nintendo-ds-runner.c"
	}
#line 176 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_vala_assert (GAMES_IS_NINTENDO_DS_SNAPSHOT (snapshot), "snapshot is NintendoDsSnapshot");
#line 178 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = _g_object_ref0 (GAMES_IS_NINTENDO_DS_SNAPSHOT (snapshot) ? ((GamesNintendoDsSnapshot*) snapshot) : NULL);
#line 178 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	ds_snapshot = _tmp0_;
#line 179 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = ds_snapshot;
#line 179 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = games_nintendo_ds_runner_get_screen_layout (self);
#line 179 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = _tmp2_;
#line 179 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_snapshot_set_screen_layout (_tmp1_, _tmp3_);
#line 180 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp4_ = ds_snapshot;
#line 180 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp5_ = games_nintendo_ds_runner_get_view_bottom_screen (self);
#line 180 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp6_ = _tmp5_;
#line 180 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_snapshot_set_view_bottom_screen (_tmp4_, _tmp6_);
#line 173 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (ds_snapshot);
#line 854 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_real_load_from_snapshot (GamesRetroRunner* base,
                                                  GamesSnapshot* snapshot,
                                                  GError** error)
{
	GamesNintendoDsRunner * self;
	GamesNintendoDsSnapshot* ds_snapshot = NULL;
	GamesNintendoDsSnapshot* _tmp0_;
	GamesNintendoDsSnapshot* _tmp1_;
	GamesScreenLayout _tmp2_;
	GamesScreenLayout _tmp3_;
	GamesNintendoDsSnapshot* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
#line 183 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 183 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_if_fail (snapshot != NULL);
#line 184 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	GAMES_RETRO_RUNNER_CLASS (games_nintendo_ds_runner_parent_class)->load_from_snapshot (G_TYPE_CHECK_INSTANCE_CAST (self, GAMES_TYPE_RETRO_RUNNER, GamesRetroRunner), snapshot, &_inner_error0_);
#line 184 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_propagate_error (error, _inner_error0_);
#line 184 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return;
#line 884 "nintendo-ds-runner.c"
	}
#line 186 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_vala_assert (GAMES_IS_NINTENDO_DS_SNAPSHOT (snapshot), "snapshot is NintendoDsSnapshot");
#line 188 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = _g_object_ref0 (GAMES_IS_NINTENDO_DS_SNAPSHOT (snapshot) ? ((GamesNintendoDsSnapshot*) snapshot) : NULL);
#line 188 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	ds_snapshot = _tmp0_;
#line 189 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = ds_snapshot;
#line 189 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = games_nintendo_ds_snapshot_get_screen_layout (_tmp1_);
#line 189 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = _tmp2_;
#line 189 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_set_screen_layout (self, _tmp3_);
#line 190 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp4_ = ds_snapshot;
#line 190 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp5_ = games_nintendo_ds_snapshot_get_view_bottom_screen (_tmp4_);
#line 190 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp6_ = _tmp5_;
#line 190 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_set_view_bottom_screen (self, _tmp6_);
#line 183 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_object_unref0 (ds_snapshot);
#line 910 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_real_reset_with_snapshot (GamesRetroRunner* base,
                                                   GamesSnapshot* last_snapshot,
                                                   GError** error)
{
	GamesNintendoDsRunner * self;
	GError* _inner_error0_ = NULL;
#line 193 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = (GamesNintendoDsRunner*) base;
#line 194 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	GAMES_RETRO_RUNNER_CLASS (games_nintendo_ds_runner_parent_class)->reset_with_snapshot (G_TYPE_CHECK_INSTANCE_CAST (self, GAMES_TYPE_RETRO_RUNNER, GamesRetroRunner), last_snapshot, &_inner_error0_);
#line 194 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_propagate_error (error, _inner_error0_);
#line 194 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		return;
#line 930 "nintendo-ds-runner.c"
	}
#line 196 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_set_screen_layout (self, GAMES_SCREEN_LAYOUT_TOP_BOTTOM);
#line 197 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_set_view_bottom_screen (self, FALSE);
#line 936 "nintendo-ds-runner.c"
}

GamesScreenLayout
games_nintendo_ds_runner_get_screen_layout (GamesNintendoDsRunner* self)
{
	GamesScreenLayout result;
#line 18 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = self->priv->_screen_layout;
#line 18 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 949 "nintendo-ds-runner.c"
}

void
games_nintendo_ds_runner_set_screen_layout (GamesNintendoDsRunner* self,
                                            GamesScreenLayout value)
{
#line 19 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_if_fail (self != NULL);
#line 20 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self->priv->_screen_layout = value;
#line 21 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_update_screen_layout (self);
#line 19 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_notify_by_pspec ((GObject *) self, games_nintendo_ds_runner_properties[GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY]);
#line 964 "nintendo-ds-runner.c"
}

gboolean
games_nintendo_ds_runner_get_view_bottom_screen (GamesNintendoDsRunner* self)
{
	gboolean result;
#line 27 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	result = self->priv->_view_bottom_screen;
#line 27 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	return result;
#line 977 "nintendo-ds-runner.c"
}

void
games_nintendo_ds_runner_set_view_bottom_screen (GamesNintendoDsRunner* self,
                                                 gboolean value)
{
#line 28 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_return_if_fail (self != NULL);
#line 29 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self->priv->_view_bottom_screen = value;
#line 30 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_update_screen_layout (self);
#line 28 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_notify_by_pspec ((GObject *) self, games_nintendo_ds_runner_properties[GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY]);
#line 992 "nintendo-ds-runner.c"
}

static void
_g_free0_ (gpointer var)
{
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 1000 "nintendo-ds-runner.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1021 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_class_init (GamesNintendoDsRunnerClass * klass,
                                     gpointer klass_data)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GamesScreenLayout _tmp4_;
	GamesScreenLayout* _tmp5_;
	GHashTable* _tmp6_;
	GamesScreenLayout _tmp7_;
	GamesScreenLayout* _tmp8_;
	GHashTable* _tmp9_;
	GamesScreenLayout _tmp10_;
	GamesScreenLayout* _tmp11_;
	GHashTable* _tmp12_;
	GamesScreenLayout _tmp13_;
	GamesScreenLayout* _tmp14_;
	GHashFunc _tmp15_;
	GEqualFunc _tmp16_;
	GHashTable* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_parent_class = g_type_class_peek_parent (klass);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_type_class_adjust_private_offset (klass, &GamesNintendoDsRunner_private_offset);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->get_extra_widget = (GamesHeaderBarWidget* (*) (GamesRetroRunner*)) games_nintendo_ds_runner_real_get_extra_widget;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->key_press_event = (gboolean (*) (GamesRetroRunner*, guint, GdkModifierType)) games_nintendo_ds_runner_real_key_press_event;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->gamepad_button_press_event = (gboolean (*) (GamesRetroRunner*, guint16)) games_nintendo_ds_runner_real_gamepad_button_press_event;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->save_to_snapshot = (void (*) (GamesRetroRunner*, GamesSnapshot*, GError**)) games_nintendo_ds_runner_real_save_to_snapshot;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->load_from_snapshot = (void (*) (GamesRetroRunner*, GamesSnapshot*, GError**)) games_nintendo_ds_runner_real_load_from_snapshot;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	((GamesRetroRunnerClass *) klass)->reset_with_snapshot = (void (*) (GamesRetroRunner*, GamesSnapshot*, GError**)) games_nintendo_ds_runner_real_reset_with_snapshot;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_nintendo_ds_runner_get_property;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_nintendo_ds_runner_set_property;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	G_OBJECT_CLASS (klass)->finalize = games_nintendo_ds_runner_finalize;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY, games_nintendo_ds_runner_properties[GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY] = g_param_spec_enum ("screen-layout", "screen-layout", "screen-layout", GAMES_TYPE_SCREEN_LAYOUT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY, games_nintendo_ds_runner_properties[GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY] = g_param_spec_boolean ("view-bottom-screen", "view-bottom-screen", "view-bottom-screen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp0_ = g_direct_hash;
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp1_ = g_direct_equal;
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_hash_table_unref0 (games_nintendo_ds_runner_layouts);
#line 35 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_layouts = _tmp2_;
#line 37 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp3_ = games_nintendo_ds_runner_layouts;
#line 37 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp4_ = GAMES_SCREEN_LAYOUT_TOP_BOTTOM;
#line 37 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp5_ = __games_screen_layout_dup0 (&_tmp4_);
#line 37 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_hash_table_insert (_tmp3_, (gpointer) ((guintptr) GDK_KEY_1), (gpointer) ((gintptr) _tmp5_));
#line 38 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp6_ = games_nintendo_ds_runner_layouts;
#line 38 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp7_ = GAMES_SCREEN_LAYOUT_LEFT_RIGHT;
#line 38 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp8_ = __games_screen_layout_dup0 (&_tmp7_);
#line 38 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_hash_table_insert (_tmp6_, (gpointer) ((guintptr) GDK_KEY_2), (gpointer) ((gintptr) _tmp8_));
#line 39 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp9_ = games_nintendo_ds_runner_layouts;
#line 39 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp10_ = GAMES_SCREEN_LAYOUT_RIGHT_LEFT;
#line 39 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp11_ = __games_screen_layout_dup0 (&_tmp10_);
#line 39 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_hash_table_insert (_tmp9_, (gpointer) ((guintptr) GDK_KEY_3), (gpointer) ((gintptr) _tmp11_));
#line 40 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp12_ = games_nintendo_ds_runner_layouts;
#line 40 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp13_ = GAMES_SCREEN_LAYOUT_QUICK_SWITCH;
#line 40 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp14_ = __games_screen_layout_dup0 (&_tmp13_);
#line 40 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	g_hash_table_insert (_tmp12_, (gpointer) ((guintptr) GDK_KEY_4), (gpointer) ((gintptr) _tmp14_));
#line 42 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp15_ = g_str_hash;
#line 42 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp16_ = g_str_equal;
#line 42 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_tmp17_ = g_hash_table_new_full (_tmp15_, _tmp16_, _g_free0_, _g_free0_);
#line 42 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	_g_hash_table_unref0 (games_nintendo_ds_runner_gap_overrides);
#line 42 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	games_nintendo_ds_runner_gap_overrides = _tmp17_;
#line 1125 "nintendo-ds-runner.c"
	{
		GBytes* bytes = NULL;
		GBytes* _tmp18_;
		gchar* text = NULL;
		GBytes* _tmp19_;
		gsize _tmp20_ = 0;
		guint8* _tmp21_;
		gchar* _tmp22_;
		gchar** lines = NULL;
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gint lines_length1;
		gint _lines_size_;
		gchar** _tmp26_;
		gint _tmp26__length1;
#line 45 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp18_ = g_resources_lookup_data ("/org/gnome/Games/plugins/nintendo-ds/layout-overrides", G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 45 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		bytes = _tmp18_;
#line 45 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1148 "nintendo-ds-runner.c"
			goto __catch0_g_error;
		}
#line 46 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp19_ = bytes;
#line 46 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp21_ = g_bytes_get_data (_tmp19_, &_tmp20_);
#line 46 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp22_ = g_strdup ((const gchar*) _tmp21_);
#line 46 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		text = _tmp22_;
#line 47 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp23_ = text;
#line 47 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "\n", 0);
#line 47 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		lines = _tmp25_;
#line 47 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		lines_length1 = _vala_array_length (_tmp24_);
#line 47 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_lines_size_ = lines_length1;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp26_ = lines;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp26__length1 = lines_length1;
#line 1173 "nintendo-ds-runner.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			line_collection = _tmp26_;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			line_collection_length1 = _tmp26__length1;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1185 "nintendo-ds-runner.c"
				gchar* _tmp27_;
				gchar* line = NULL;
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
				_tmp27_ = g_strdup (line_collection[line_it]);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
				line = _tmp27_;
#line 1192 "nintendo-ds-runner.c"
				{
					gchar** data = NULL;
					const gchar* _tmp28_;
					gchar** _tmp29_;
					gchar** _tmp30_;
					gint data_length1;
					gint _data_size_;
					gchar** _tmp31_;
					gint _tmp31__length1;
					gchar** fields = NULL;
					gchar** _tmp32_;
					gint _tmp32__length1;
					const gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gchar** _tmp36_;
					gchar** _tmp37_;
					gchar** _tmp38_;
					gint _tmp38__length1;
					gint fields_length1;
					gint _fields_size_;
					gchar** _tmp39_;
					gint _tmp39__length1;
					gchar* key = NULL;
					gchar** _tmp40_;
					gint _tmp40__length1;
					const gchar* _tmp41_;
					gchar* _tmp42_;
					gchar* value = NULL;
					gchar** _tmp43_;
					gint _tmp43__length1;
					const gchar* _tmp44_;
					gchar* _tmp45_;
					GHashTable* _tmp46_;
					const gchar* _tmp47_;
					gchar* _tmp48_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
#line 50 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp28_ = line;
#line 50 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, "#", 2);
#line 50 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					data = _tmp30_;
#line 50 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					data_length1 = _vala_array_length (_tmp29_);
#line 50 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_data_size_ = data_length1;
#line 51 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp31_ = data;
#line 51 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp31__length1 = data_length1;
#line 51 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					if (_tmp31__length1 < 2) {
#line 52 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						_g_free0 (line);
#line 52 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						continue;
#line 1253 "nintendo-ds-runner.c"
					}
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp32_ = data;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp32__length1 = data_length1;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp33_ = _tmp32_[0];
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp34_ = string_strip (_tmp33_);
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp35_ = _tmp34_;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp37_ = _tmp36_ = g_strsplit (_tmp35_, " ", 2);
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp38_ = _tmp37_;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp38__length1 = _vala_array_length (_tmp36_);
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_g_free0 (_tmp35_);
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					fields = _tmp38_;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					fields_length1 = _tmp38__length1;
#line 54 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_fields_size_ = fields_length1;
#line 55 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp39_ = fields;
#line 55 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp39__length1 = fields_length1;
#line 55 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					if (_tmp39__length1 < 2) {
#line 56 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 56 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 56 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						_g_free0 (line);
#line 56 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
						continue;
#line 1293 "nintendo-ds-runner.c"
					}
#line 58 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp40_ = fields;
#line 58 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp40__length1 = fields_length1;
#line 58 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp41_ = _tmp40_[0];
#line 58 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp42_ = g_strdup (_tmp41_);
#line 58 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					key = _tmp42_;
#line 59 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp43_ = fields;
#line 59 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp43__length1 = fields_length1;
#line 59 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp44_ = _tmp43_[1];
#line 59 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp45_ = g_strdup (_tmp44_);
#line 59 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					value = _tmp45_;
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp46_ = games_nintendo_ds_runner_gap_overrides;
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp47_ = key;
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp48_ = g_strdup (_tmp47_);
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp49_ = value;
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_tmp50_ = g_strdup (_tmp49_);
#line 60 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					g_hash_table_insert (_tmp46_, _tmp48_, _tmp50_);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_g_free0 (value);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_g_free0 (key);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 49 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
					_g_free0 (line);
#line 1337 "nintendo-ds-runner.c"
				}
			}
		}
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_free0 (text);
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_bytes_unref0 (bytes);
#line 1347 "nintendo-ds-runner.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		e = _inner_error0_;
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_inner_error0_ = NULL;
#line 64 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp51_ = e;
#line 64 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_tmp52_ = _tmp51_->message;
#line 64 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_critical ("nintendo-ds-runner.vala:64: Couldn't read layout overrides: %s", _tmp52_);
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		_g_error_free0 (e);
#line 1367 "nintendo-ds-runner.c"
	}
	__finally0:
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 44 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_clear_error (&_inner_error0_);
#line 1376 "nintendo-ds-runner.c"
	}
}

static void
games_nintendo_ds_runner_instance_init (GamesNintendoDsRunner * self,
                                        gpointer klass)
{
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self->priv = games_nintendo_ds_runner_get_instance_private (self);
#line 1386 "nintendo-ds-runner.c"
}

static void
games_nintendo_ds_runner_finalize (GObject * obj)
{
	GamesNintendoDsRunner * self;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunner);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	G_OBJECT_CLASS (games_nintendo_ds_runner_parent_class)->finalize (obj);
#line 1397 "nintendo-ds-runner.c"
}

GType
games_nintendo_ds_runner_get_type (void)
{
	return games_nintendo_ds_runner_type_id;
}

GType
games_nintendo_ds_runner_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesNintendoDsRunnerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_nintendo_ds_runner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesNintendoDsRunner), 0, (GInstanceInitFunc) games_nintendo_ds_runner_instance_init, NULL };
	games_nintendo_ds_runner_type_id = g_type_module_register_type (module, GAMES_TYPE_RETRO_RUNNER, "GamesNintendoDsRunner", &g_define_type_info, 0);
	GamesNintendoDsRunner_private_offset = sizeof (GamesNintendoDsRunnerPrivate);
	return games_nintendo_ds_runner_type_id;
}

static void
_vala_games_nintendo_ds_runner_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GamesNintendoDsRunner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunner);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	switch (property_id) {
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		case GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_value_set_enum (value, games_nintendo_ds_runner_get_screen_layout (self));
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		case GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		g_value_set_boolean (value, games_nintendo_ds_runner_get_view_bottom_screen (self));
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 1437 "nintendo-ds-runner.c"
		default:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 1443 "nintendo-ds-runner.c"
	}
}

static void
_vala_games_nintendo_ds_runner_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GamesNintendoDsRunner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_NINTENDO_DS_RUNNER, GamesNintendoDsRunner);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
	switch (property_id) {
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		case GAMES_NINTENDO_DS_RUNNER_SCREEN_LAYOUT_PROPERTY:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		games_nintendo_ds_runner_set_screen_layout (self, g_value_get_enum (value));
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		case GAMES_NINTENDO_DS_RUNNER_VIEW_BOTTOM_SCREEN_PROPERTY:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		games_nintendo_ds_runner_set_view_bottom_screen (self, g_value_get_boolean (value));
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 1469 "nintendo-ds-runner.c"
		default:
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../plugins/nintendo-ds/src/nintendo-ds-runner.vala"
		break;
#line 1475 "nintendo-ds-runner.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

