/* wii-header.c generated by valac 0.56.3, the Vala compiler
 * generated from wii-header.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/
/* Documentation: http://wiibrew.org/wiki/Wii_Disc*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "games-wii-plugin.h"

#define GAMES_WII_HEADER_MAGIC_OFFSET ((gsize) 0x18)
#define GAMES_WII_HEADER_MAGIC_VALUE "\x5d\x1c\x9e\xa3"

#define GAMES_TYPE_WII_HEADER (games_wii_header_get_type ())
#define GAMES_WII_HEADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_WII_HEADER, GamesWiiHeader))
#define GAMES_WII_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_WII_HEADER, GamesWiiHeaderClass))
#define GAMES_IS_WII_HEADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_WII_HEADER))
#define GAMES_IS_WII_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_WII_HEADER))
#define GAMES_WII_HEADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_WII_HEADER, GamesWiiHeaderClass))

typedef struct _GamesWiiHeader GamesWiiHeader;
typedef struct _GamesWiiHeaderClass GamesWiiHeaderClass;
typedef struct _GamesWiiHeaderPrivate GamesWiiHeaderPrivate;
enum  {
	GAMES_WII_HEADER_0_PROPERTY,
	GAMES_WII_HEADER_NUM_PROPERTIES
};
static GParamSpec* games_wii_header_properties[GAMES_WII_HEADER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAMES_TYPE_WII_ERROR (games_wii_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GamesWiiHeader {
	GObject parent_instance;
	GamesWiiHeaderPrivate * priv;
};

struct _GamesWiiHeaderClass {
	GObjectClass parent_class;
};

struct _GamesWiiHeaderPrivate {
	GFile* file;
};

typedef enum  {
	GAMES_WII_ERROR_CANT_READ_FILE,
	GAMES_WII_ERROR_INVALID_SIZE,
	GAMES_WII_ERROR_INVALID_HEADER
} GamesWiiError;
#define GAMES_WII_ERROR games_wii_error_quark ()

static gint GamesWiiHeader_private_offset;
static gpointer games_wii_header_parent_class = NULL;
static GType games_wii_header_type_id = 0;

GType games_wii_header_register_type (GTypeModule * module);
VALA_EXTERN GType games_wii_header_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesWiiHeader* games_wii_header_new (GFile* file);
VALA_EXTERN GamesWiiHeader* games_wii_header_construct (GType object_type,
                                            GFile* file);
VALA_EXTERN GQuark games_wii_error_quark (void);
GType games_wii_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void games_wii_header_check_validity (GamesWiiHeader* self,
                                      GError** error);
static GFileInputStream* games_wii_header_get_stream (GamesWiiHeader* self,
                                               GError** error);
VALA_EXTERN gchar* games_wii_header_get_game_id (GamesWiiHeader* self,
                                     GError** error);
static void games_wii_header_finalize (GObject * obj);

static inline gpointer
games_wii_header_get_instance_private (GamesWiiHeader* self)
{
	return G_STRUCT_MEMBER_P (self, GamesWiiHeader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 11 "../plugins/wii/src/wii-header.vala"
	return self ? g_object_ref (self) : NULL;
#line 89 "wii-header.c"
}

GamesWiiHeader*
games_wii_header_construct (GType object_type,
                            GFile* file)
{
	GamesWiiHeader * self = NULL;
	GFile* _tmp0_;
#line 10 "../plugins/wii/src/wii-header.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 10 "../plugins/wii/src/wii-header.vala"
	self = (GamesWiiHeader*) g_object_new (object_type, NULL);
#line 11 "../plugins/wii/src/wii-header.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 11 "../plugins/wii/src/wii-header.vala"
	_g_object_unref0 (self->priv->file);
#line 11 "../plugins/wii/src/wii-header.vala"
	self->priv->file = _tmp0_;
#line 10 "../plugins/wii/src/wii-header.vala"
	return self;
#line 110 "wii-header.c"
}

GamesWiiHeader*
games_wii_header_new (GFile* file)
{
#line 10 "../plugins/wii/src/wii-header.vala"
	return games_wii_header_construct (GAMES_TYPE_WII_HEADER, file);
#line 118 "wii-header.c"
}

void
games_wii_header_check_validity (GamesWiiHeader* self,
                                 GError** error)
{
	GFileInputStream* stream = NULL;
	GFileInputStream* _tmp0_;
	guint8* buffer = NULL;
	gint _tmp5_;
	gint _tmp6_;
	guint8* _tmp7_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* magic = NULL;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 14 "../plugins/wii/src/wii-header.vala"
	g_return_if_fail (self != NULL);
#line 15 "../plugins/wii/src/wii-header.vala"
	_tmp0_ = games_wii_header_get_stream (self, &_inner_error0_);
#line 15 "../plugins/wii/src/wii-header.vala"
	stream = _tmp0_;
#line 15 "../plugins/wii/src/wii-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 15 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 15 "../plugins/wii/src/wii-header.vala"
			return;
#line 153 "wii-header.c"
		} else {
#line 15 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 15 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 15 "../plugins/wii/src/wii-header.vala"
			return;
#line 161 "wii-header.c"
		}
	}
	{
		GFileInputStream* _tmp1_;
#line 17 "../plugins/wii/src/wii-header.vala"
		_tmp1_ = stream;
#line 17 "../plugins/wii/src/wii-header.vala"
		G_TYPE_INSTANCE_GET_CLASS (_tmp1_, g_file_input_stream_get_type (), GFileInputStreamClass)->seek (_tmp1_, (gint64) GAMES_WII_HEADER_MAGIC_OFFSET, G_SEEK_SET, NULL, &_inner_error0_);
#line 17 "../plugins/wii/src/wii-header.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "wii-header.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
#line 16 "../plugins/wii/src/wii-header.vala"
		e = _inner_error0_;
#line 16 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = NULL;
#line 20 "../plugins/wii/src/wii-header.vala"
		_tmp2_ = e;
#line 20 "../plugins/wii/src/wii-header.vala"
		_tmp3_ = _tmp2_->message;
#line 20 "../plugins/wii/src/wii-header.vala"
		_tmp4_ = g_error_new (GAMES_WII_ERROR, GAMES_WII_ERROR_INVALID_SIZE, "Invalid Wii header size: %s", _tmp3_);
#line 20 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = _tmp4_;
#line 20 "../plugins/wii/src/wii-header.vala"
		_g_error_free0 (e);
#line 197 "wii-header.c"
		goto __finally0;
	}
	__finally0:
#line 16 "../plugins/wii/src/wii-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 16 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 16 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 16 "../plugins/wii/src/wii-header.vala"
			return;
#line 211 "wii-header.c"
		} else {
#line 16 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 16 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 16 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 16 "../plugins/wii/src/wii-header.vala"
			return;
#line 221 "wii-header.c"
		}
	}
#line 23 "../plugins/wii/src/wii-header.vala"
	_tmp5_ = strlen (GAMES_WII_HEADER_MAGIC_VALUE);
#line 23 "../plugins/wii/src/wii-header.vala"
	_tmp6_ = _tmp5_;
#line 23 "../plugins/wii/src/wii-header.vala"
	_tmp7_ = g_new0 (guint8, _tmp6_);
#line 23 "../plugins/wii/src/wii-header.vala"
	buffer = _tmp7_;
#line 23 "../plugins/wii/src/wii-header.vala"
	buffer_length1 = _tmp6_;
#line 23 "../plugins/wii/src/wii-header.vala"
	_buffer_size_ = buffer_length1;
#line 236 "wii-header.c"
	{
		GFileInputStream* _tmp8_;
		guint8* _tmp9_;
		gint _tmp9__length1;
#line 25 "../plugins/wii/src/wii-header.vala"
		_tmp8_ = stream;
#line 25 "../plugins/wii/src/wii-header.vala"
		_tmp9_ = buffer;
#line 25 "../plugins/wii/src/wii-header.vala"
		_tmp9__length1 = buffer_length1;
#line 25 "../plugins/wii/src/wii-header.vala"
		g_input_stream_read ((GInputStream*) _tmp8_, _tmp9_, (gsize) _tmp9__length1, NULL, &_inner_error0_);
#line 25 "../plugins/wii/src/wii-header.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "wii-header.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
#line 24 "../plugins/wii/src/wii-header.vala"
		e = _inner_error0_;
#line 24 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = NULL;
#line 28 "../plugins/wii/src/wii-header.vala"
		_tmp10_ = e;
#line 28 "../plugins/wii/src/wii-header.vala"
		_tmp11_ = _tmp10_->message;
#line 28 "../plugins/wii/src/wii-header.vala"
		_tmp12_ = g_error_new_literal (GAMES_WII_ERROR, GAMES_WII_ERROR_INVALID_SIZE, _tmp11_);
#line 28 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = _tmp12_;
#line 28 "../plugins/wii/src/wii-header.vala"
		_g_error_free0 (e);
#line 276 "wii-header.c"
		goto __finally1;
	}
	__finally1:
#line 24 "../plugins/wii/src/wii-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 24 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 24 "../plugins/wii/src/wii-header.vala"
			buffer = (g_free (buffer), NULL);
#line 24 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 24 "../plugins/wii/src/wii-header.vala"
			return;
#line 292 "wii-header.c"
		} else {
#line 24 "../plugins/wii/src/wii-header.vala"
			buffer = (g_free (buffer), NULL);
#line 24 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 24 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 24 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 24 "../plugins/wii/src/wii-header.vala"
			return;
#line 304 "wii-header.c"
		}
	}
#line 31 "../plugins/wii/src/wii-header.vala"
	_tmp13_ = buffer;
#line 31 "../plugins/wii/src/wii-header.vala"
	_tmp13__length1 = buffer_length1;
#line 31 "../plugins/wii/src/wii-header.vala"
	_tmp14_ = g_strdup ((const gchar*) _tmp13_);
#line 31 "../plugins/wii/src/wii-header.vala"
	magic = _tmp14_;
#line 32 "../plugins/wii/src/wii-header.vala"
	_tmp15_ = magic;
#line 32 "../plugins/wii/src/wii-header.vala"
	if (g_strcmp0 (_tmp15_, GAMES_WII_HEADER_MAGIC_VALUE) != 0) {
#line 319 "wii-header.c"
		GError* _tmp16_;
#line 33 "../plugins/wii/src/wii-header.vala"
		_tmp16_ = g_error_new_literal (GAMES_WII_ERROR, GAMES_WII_ERROR_INVALID_HEADER, "The file doesn’t have a Wii header.");
#line 33 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = _tmp16_;
#line 33 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 33 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 33 "../plugins/wii/src/wii-header.vala"
			_g_free0 (magic);
#line 33 "../plugins/wii/src/wii-header.vala"
			buffer = (g_free (buffer), NULL);
#line 33 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 33 "../plugins/wii/src/wii-header.vala"
			return;
#line 337 "wii-header.c"
		} else {
#line 33 "../plugins/wii/src/wii-header.vala"
			_g_free0 (magic);
#line 33 "../plugins/wii/src/wii-header.vala"
			buffer = (g_free (buffer), NULL);
#line 33 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 33 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 33 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 33 "../plugins/wii/src/wii-header.vala"
			return;
#line 351 "wii-header.c"
		}
	}
#line 14 "../plugins/wii/src/wii-header.vala"
	_g_free0 (magic);
#line 14 "../plugins/wii/src/wii-header.vala"
	buffer = (g_free (buffer), NULL);
#line 14 "../plugins/wii/src/wii-header.vala"
	_g_object_unref0 (stream);
#line 360 "wii-header.c"
}

gchar*
games_wii_header_get_game_id (GamesWiiHeader* self,
                              GError** error)
{
	guint8 buffer[6] = {0};
	GFileInputStream* stream = NULL;
	GFileInputStream* _tmp0_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 36 "../plugins/wii/src/wii-header.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../plugins/wii/src/wii-header.vala"
	_tmp0_ = games_wii_header_get_stream (self, &_inner_error0_);
#line 39 "../plugins/wii/src/wii-header.vala"
	stream = _tmp0_;
#line 39 "../plugins/wii/src/wii-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 39 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 39 "../plugins/wii/src/wii-header.vala"
			return NULL;
#line 387 "wii-header.c"
		} else {
#line 39 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 39 "../plugins/wii/src/wii-header.vala"
			return NULL;
#line 395 "wii-header.c"
		}
	}
	{
		GFileInputStream* _tmp1_;
#line 41 "../plugins/wii/src/wii-header.vala"
		_tmp1_ = stream;
#line 41 "../plugins/wii/src/wii-header.vala"
		g_input_stream_read ((GInputStream*) _tmp1_, buffer, (gsize) 6, NULL, &_inner_error0_);
#line 41 "../plugins/wii/src/wii-header.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 406 "wii-header.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _tmp2_;
#line 40 "../plugins/wii/src/wii-header.vala"
		g_clear_error (&_inner_error0_);
#line 44 "../plugins/wii/src/wii-header.vala"
		_tmp2_ = g_error_new_literal (GAMES_WII_ERROR, GAMES_WII_ERROR_INVALID_HEADER, "The file doesn’t have a Wii header.");
#line 44 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = _tmp2_;
#line 420 "wii-header.c"
		goto __finally0;
	}
	__finally0:
#line 40 "../plugins/wii/src/wii-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../plugins/wii/src/wii-header.vala"
		if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 40 "../plugins/wii/src/wii-header.vala"
			g_propagate_error (error, _inner_error0_);
#line 40 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 40 "../plugins/wii/src/wii-header.vala"
			return NULL;
#line 434 "wii-header.c"
		} else {
#line 40 "../plugins/wii/src/wii-header.vala"
			_g_object_unref0 (stream);
#line 40 "../plugins/wii/src/wii-header.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "../plugins/wii/src/wii-header.vala"
			g_clear_error (&_inner_error0_);
#line 40 "../plugins/wii/src/wii-header.vala"
			return NULL;
#line 444 "wii-header.c"
		}
	}
#line 47 "../plugins/wii/src/wii-header.vala"
	_tmp3_ = g_strdup ((const gchar*) buffer);
#line 47 "../plugins/wii/src/wii-header.vala"
	result = _tmp3_;
#line 47 "../plugins/wii/src/wii-header.vala"
	_g_object_unref0 (stream);
#line 47 "../plugins/wii/src/wii-header.vala"
	return result;
#line 455 "wii-header.c"
}

static GFileInputStream*
games_wii_header_get_stream (GamesWiiHeader* self,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
	GFileInputStream* result;
#line 50 "../plugins/wii/src/wii-header.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 466 "wii-header.c"
	{
		GFileInputStream* _tmp0_ = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		GFileInputStream* _tmp3_;
#line 52 "../plugins/wii/src/wii-header.vala"
		_tmp1_ = self->priv->file;
#line 52 "../plugins/wii/src/wii-header.vala"
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 52 "../plugins/wii/src/wii-header.vala"
		_tmp0_ = _tmp2_;
#line 52 "../plugins/wii/src/wii-header.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "wii-header.c"
			goto __catch0_g_error;
		}
#line 52 "../plugins/wii/src/wii-header.vala"
		_tmp3_ = _tmp0_;
#line 52 "../plugins/wii/src/wii-header.vala"
		_tmp0_ = NULL;
#line 52 "../plugins/wii/src/wii-header.vala"
		result = _tmp3_;
#line 52 "../plugins/wii/src/wii-header.vala"
		_g_object_unref0 (_tmp0_);
#line 52 "../plugins/wii/src/wii-header.vala"
		return result;
#line 493 "wii-header.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
#line 51 "../plugins/wii/src/wii-header.vala"
		e = _inner_error0_;
#line 51 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = NULL;
#line 55 "../plugins/wii/src/wii-header.vala"
		_tmp4_ = e;
#line 55 "../plugins/wii/src/wii-header.vala"
		_tmp5_ = _tmp4_->message;
#line 55 "../plugins/wii/src/wii-header.vala"
		_tmp6_ = g_error_new (GAMES_WII_ERROR, GAMES_WII_ERROR_CANT_READ_FILE, "Couldn’t read file: %s", _tmp5_);
#line 55 "../plugins/wii/src/wii-header.vala"
		_inner_error0_ = _tmp6_;
#line 55 "../plugins/wii/src/wii-header.vala"
		_g_error_free0 (e);
#line 516 "wii-header.c"
		goto __finally0;
	}
	__finally0:
#line 51 "../plugins/wii/src/wii-header.vala"
	if (_inner_error0_->domain == GAMES_WII_ERROR) {
#line 51 "../plugins/wii/src/wii-header.vala"
		g_propagate_error (error, _inner_error0_);
#line 51 "../plugins/wii/src/wii-header.vala"
		return NULL;
#line 526 "wii-header.c"
	} else {
#line 51 "../plugins/wii/src/wii-header.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 51 "../plugins/wii/src/wii-header.vala"
		g_clear_error (&_inner_error0_);
#line 51 "../plugins/wii/src/wii-header.vala"
		return NULL;
#line 534 "wii-header.c"
	}
}

static void
games_wii_header_class_init (GamesWiiHeaderClass * klass,
                             gpointer klass_data)
{
#line 4 "../plugins/wii/src/wii-header.vala"
	games_wii_header_parent_class = g_type_class_peek_parent (klass);
#line 4 "../plugins/wii/src/wii-header.vala"
	g_type_class_adjust_private_offset (klass, &GamesWiiHeader_private_offset);
#line 4 "../plugins/wii/src/wii-header.vala"
	G_OBJECT_CLASS (klass)->finalize = games_wii_header_finalize;
#line 548 "wii-header.c"
}

static void
games_wii_header_instance_init (GamesWiiHeader * self,
                                gpointer klass)
{
#line 4 "../plugins/wii/src/wii-header.vala"
	self->priv = games_wii_header_get_instance_private (self);
#line 557 "wii-header.c"
}

static void
games_wii_header_finalize (GObject * obj)
{
	GamesWiiHeader * self;
#line 4 "../plugins/wii/src/wii-header.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_WII_HEADER, GamesWiiHeader);
#line 8 "../plugins/wii/src/wii-header.vala"
	_g_object_unref0 (self->priv->file);
#line 4 "../plugins/wii/src/wii-header.vala"
	G_OBJECT_CLASS (games_wii_header_parent_class)->finalize (obj);
#line 570 "wii-header.c"
}

GType
games_wii_header_get_type (void)
{
	return games_wii_header_type_id;
}

GType
games_wii_header_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesWiiHeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_wii_header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesWiiHeader), 0, (GInstanceInitFunc) games_wii_header_instance_init, NULL };
	games_wii_header_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "GamesWiiHeader", &g_define_type_info, 0);
	GamesWiiHeader_private_offset = sizeof (GamesWiiHeaderPrivate);
	return games_wii_header_type_id;
}

GQuark
games_wii_error_quark (void)
{
	return g_quark_from_static_string ("games-wii-error-quark");
}

static GType
games_wii_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GAMES_WII_ERROR_CANT_READ_FILE, "GAMES_WII_ERROR_CANT_READ_FILE", "cant-read-file"}, {GAMES_WII_ERROR_INVALID_SIZE, "GAMES_WII_ERROR_INVALID_SIZE", "invalid-size"}, {GAMES_WII_ERROR_INVALID_HEADER, "GAMES_WII_ERROR_INVALID_HEADER", "invalid-header"}, {0, NULL, NULL}};
	GType games_wii_error_type_id;
	games_wii_error_type_id = g_enum_register_static ("GamesWiiError", values);
	return games_wii_error_type_id;
}

GType
games_wii_error_get_type (void)
{
	static volatile gsize games_wii_error_type_id__once = 0;
	if (g_once_init_enter (&games_wii_error_type_id__once)) {
		GType games_wii_error_type_id;
		games_wii_error_type_id = games_wii_error_get_type_once ();
		g_once_init_leave (&games_wii_error_type_id__once, games_wii_error_type_id);
	}
	return games_wii_error_type_id__once;
}

