/* snapshot.c generated by valac 0.56.3, the Vala compiler
 * generated from snapshot.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

enum  {
	GAMES_SNAPSHOT_0_PROPERTY,
	GAMES_SNAPSHOT_PATH_PROPERTY,
	GAMES_SNAPSHOT_PLATFORM_PROPERTY,
	GAMES_SNAPSHOT_CORE_PROPERTY,
	GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY,
	GAMES_SNAPSHOT_NAME_PROPERTY,
	GAMES_SNAPSHOT_CREATION_DATE_PROPERTY,
	GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY,
	GAMES_SNAPSHOT_NUM_PROPERTIES
};
static GParamSpec* games_snapshot_properties[GAMES_SNAPSHOT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))

struct _GamesSnapshotPrivate {
	gchar* _path;
	GamesPlatform* _platform;
	gchar* _core;
	gboolean _is_automatic;
	gchar* _name;
	GDateTime* _creation_date;
	gdouble _screenshot_aspect_ratio;
};

static gint GamesSnapshot_private_offset;
static gpointer games_snapshot_parent_class = NULL;

static void games_snapshot_load_keyfile (GamesSnapshot* self);
static void games_snapshot_real_load_metadata (GamesSnapshot* self,
                                        GKeyFile* keyfile,
                                        GError** error);
static void games_snapshot_real_save_metadata (GamesSnapshot* self,
                                        GKeyFile* keyfile);
static void games_snapshot_finalize (GObject * obj);
static GType games_snapshot_get_type_once (void);
static void _vala_games_snapshot_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_games_snapshot_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
games_snapshot_get_instance_private (GamesSnapshot* self)
{
	return G_STRUCT_MEMBER_P (self, GamesSnapshot_private_offset);
}

GamesSnapshot*
games_snapshot_load (GamesPlatform* platform,
                     const gchar* core_id,
                     const gchar* path)
{
	GType type = 0UL;
	GamesSnapshot* snapshot = NULL;
	GObject* _tmp0_;
	GObject* _tmp1_;
	GamesSnapshot* _tmp2_;
	GamesSnapshot* result;
#line 15 "../src/core/snapshot.vala"
	g_return_val_if_fail (platform != NULL, NULL);
#line 15 "../src/core/snapshot.vala"
	g_return_val_if_fail (core_id != NULL, NULL);
#line 15 "../src/core/snapshot.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 16 "../src/core/snapshot.vala"
	type = games_platform_get_snapshot_type (platform);
#line 18 "../src/core/snapshot.vala"
	_tmp0_ = g_object_new (type, "path", path, "platform", platform, "core", core_id, NULL, NULL);
#line 18 "../src/core/snapshot.vala"
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 18 "../src/core/snapshot.vala"
	_tmp2_ = GAMES_IS_SNAPSHOT (_tmp1_) ? ((GamesSnapshot*) _tmp1_) : NULL;
#line 18 "../src/core/snapshot.vala"
	if (_tmp2_ == NULL) {
#line 18 "../src/core/snapshot.vala"
		_g_object_unref0 (_tmp1_);
#line 107 "snapshot.c"
	}
#line 18 "../src/core/snapshot.vala"
	snapshot = _tmp2_;
#line 24 "../src/core/snapshot.vala"
	games_snapshot_load_keyfile (snapshot);
#line 26 "../src/core/snapshot.vala"
	result = snapshot;
#line 26 "../src/core/snapshot.vala"
	return result;
#line 117 "snapshot.c"
}

static void
games_snapshot_load_keyfile (GamesSnapshot* self)
{
	gchar* metadata_file_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* metadata_file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 29 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 30 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "metadata", NULL);
#line 30 "../src/core/snapshot.vala"
	metadata_file_path = _tmp1_;
#line 31 "../src/core/snapshot.vala"
	_tmp2_ = metadata_file_path;
#line 31 "../src/core/snapshot.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 31 "../src/core/snapshot.vala"
	metadata_file = _tmp3_;
#line 33 "../src/core/snapshot.vala"
	_tmp4_ = metadata_file;
#line 33 "../src/core/snapshot.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 34 "../src/core/snapshot.vala"
		_g_object_unref0 (metadata_file);
#line 34 "../src/core/snapshot.vala"
		_g_free0 (metadata_file_path);
#line 34 "../src/core/snapshot.vala"
		return;
#line 157 "snapshot.c"
	}
#line 36 "../src/core/snapshot.vala"
	_tmp5_ = g_key_file_new ();
#line 36 "../src/core/snapshot.vala"
	keyfile = _tmp5_;
#line 163 "snapshot.c"
	{
		GKeyFile* _tmp6_;
		const gchar* _tmp7_;
		GKeyFile* _tmp8_;
#line 39 "../src/core/snapshot.vala"
		_tmp6_ = keyfile;
#line 39 "../src/core/snapshot.vala"
		_tmp7_ = metadata_file_path;
#line 39 "../src/core/snapshot.vala"
		g_key_file_load_from_file (_tmp6_, _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 39 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "snapshot.c"
			goto __catch0_g_error;
		}
#line 41 "../src/core/snapshot.vala"
		_tmp8_ = keyfile;
#line 41 "../src/core/snapshot.vala"
		games_snapshot_load_metadata (self, _tmp8_, &_inner_error0_);
#line 41 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "snapshot.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 38 "../src/core/snapshot.vala"
		e = _inner_error0_;
#line 38 "../src/core/snapshot.vala"
		_inner_error0_ = NULL;
#line 44 "../src/core/snapshot.vala"
		_tmp9_ = self->priv->_path;
#line 44 "../src/core/snapshot.vala"
		_tmp10_ = e;
#line 44 "../src/core/snapshot.vala"
		_tmp11_ = _tmp10_->message;
#line 44 "../src/core/snapshot.vala"
		g_critical ("snapshot.vala:44: Failed to load metadata for snapshot at %s: %s", _tmp9_, _tmp11_);
#line 38 "../src/core/snapshot.vala"
		_g_error_free0 (e);
#line 210 "snapshot.c"
	}
	__finally0:
#line 38 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../src/core/snapshot.vala"
		_g_key_file_unref0 (keyfile);
#line 38 "../src/core/snapshot.vala"
		_g_object_unref0 (metadata_file);
#line 38 "../src/core/snapshot.vala"
		_g_free0 (metadata_file_path);
#line 38 "../src/core/snapshot.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../src/core/snapshot.vala"
		g_clear_error (&_inner_error0_);
#line 38 "../src/core/snapshot.vala"
		return;
#line 227 "snapshot.c"
	}
#line 29 "../src/core/snapshot.vala"
	_g_key_file_unref0 (keyfile);
#line 29 "../src/core/snapshot.vala"
	_g_object_unref0 (metadata_file);
#line 29 "../src/core/snapshot.vala"
	_g_free0 (metadata_file_path);
#line 235 "snapshot.c"
}

gchar*
games_snapshot_get_snapshot_path (GamesSnapshot* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 48 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 49 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "snapshot", NULL);
#line 49 "../src/core/snapshot.vala"
	result = _tmp1_;
#line 49 "../src/core/snapshot.vala"
	return result;
#line 254 "snapshot.c"
}

gchar*
games_snapshot_get_save_ram_path (GamesSnapshot* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 52 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 53 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "save", NULL);
#line 53 "../src/core/snapshot.vala"
	result = _tmp1_;
#line 53 "../src/core/snapshot.vala"
	return result;
#line 273 "snapshot.c"
}

gchar*
games_snapshot_get_screenshot_path (GamesSnapshot* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 56 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 57 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "screenshot", NULL);
#line 57 "../src/core/snapshot.vala"
	result = _tmp1_;
#line 57 "../src/core/snapshot.vala"
	return result;
#line 292 "snapshot.c"
}

gchar*
games_snapshot_get_save_directory_path (GamesSnapshot* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 60 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 61 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "save-dir", NULL);
#line 61 "../src/core/snapshot.vala"
	result = _tmp1_;
#line 61 "../src/core/snapshot.vala"
	return result;
#line 311 "snapshot.c"
}

gboolean
games_snapshot_has_media_data (GamesSnapshot* self)
{
	gchar* media_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 64 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 65 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "media", NULL);
#line 65 "../src/core/snapshot.vala"
	media_path = _tmp1_;
#line 67 "../src/core/snapshot.vala"
	result = g_file_test (media_path, G_FILE_TEST_EXISTS);
#line 67 "../src/core/snapshot.vala"
	_g_free0 (media_path);
#line 67 "../src/core/snapshot.vala"
	return result;
#line 335 "snapshot.c"
}

gint
games_snapshot_get_media_data (GamesSnapshot* self,
                               GError** error)
{
	gchar* media_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* contents = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gint media_number = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 72 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 73 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "media", NULL);
#line 73 "../src/core/snapshot.vala"
	media_path = _tmp1_;
#line 75 "../src/core/snapshot.vala"
	_tmp2_ = media_path;
#line 75 "../src/core/snapshot.vala"
	if (!g_file_test (_tmp2_, G_FILE_TEST_EXISTS)) {
#line 364 "snapshot.c"
		const gchar* _tmp3_;
		GError* _tmp4_;
		gint _tmp5_ = -1;
#line 76 "../src/core/snapshot.vala"
		_tmp3_ = self->priv->_path;
#line 76 "../src/core/snapshot.vala"
		_tmp4_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_ACCES, "Snapshot at %s does not contain media file", _tmp3_);
#line 76 "../src/core/snapshot.vala"
		_inner_error0_ = _tmp4_;
#line 76 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 76 "../src/core/snapshot.vala"
		_g_free0 (media_path);
#line 76 "../src/core/snapshot.vala"
		return _tmp5_;
#line 380 "snapshot.c"
	}
#line 79 "../src/core/snapshot.vala"
	_tmp6_ = media_path;
#line 79 "../src/core/snapshot.vala"
	g_file_get_contents (_tmp6_, &_tmp7_, NULL, &_inner_error0_);
#line 79 "../src/core/snapshot.vala"
	_g_free0 (contents);
#line 79 "../src/core/snapshot.vala"
	contents = _tmp7_;
#line 79 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "snapshot.c"
		gint _tmp8_ = -1;
#line 79 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/core/snapshot.vala"
		_g_free0 (contents);
#line 79 "../src/core/snapshot.vala"
		_g_free0 (media_path);
#line 79 "../src/core/snapshot.vala"
		return _tmp8_;
#line 402 "snapshot.c"
	}
#line 81 "../src/core/snapshot.vala"
	media_number = atoi (contents);
#line 83 "../src/core/snapshot.vala"
	result = media_number;
#line 83 "../src/core/snapshot.vala"
	_g_free0 (contents);
#line 83 "../src/core/snapshot.vala"
	_g_free0 (media_path);
#line 83 "../src/core/snapshot.vala"
	return result;
#line 414 "snapshot.c"
}

void
games_snapshot_set_media_data (GamesSnapshot* self,
                               GamesMediaSet* media_set,
                               GError** error)
{
	gchar* media_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* contents = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GError* _inner_error0_ = NULL;
#line 86 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/core/snapshot.vala"
	g_return_if_fail (media_set != NULL);
#line 87 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 87 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "media", NULL);
#line 87 "../src/core/snapshot.vala"
	media_path = _tmp1_;
#line 88 "../src/core/snapshot.vala"
	_tmp2_ = games_media_set_get_selected_media_number (media_set);
#line 88 "../src/core/snapshot.vala"
	_tmp3_ = _tmp2_;
#line 88 "../src/core/snapshot.vala"
	_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 88 "../src/core/snapshot.vala"
	contents = _tmp4_;
#line 90 "../src/core/snapshot.vala"
	_tmp5_ = strlen (contents);
#line 90 "../src/core/snapshot.vala"
	_tmp6_ = _tmp5_;
#line 90 "../src/core/snapshot.vala"
	g_file_set_contents (media_path, contents, (gssize) _tmp6_, &_inner_error0_);
#line 90 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 90 "../src/core/snapshot.vala"
		_g_free0 (contents);
#line 90 "../src/core/snapshot.vala"
		_g_free0 (media_path);
#line 90 "../src/core/snapshot.vala"
		return;
#line 466 "snapshot.c"
	}
#line 86 "../src/core/snapshot.vala"
	_g_free0 (contents);
#line 86 "../src/core/snapshot.vala"
	_g_free0 (media_path);
#line 472 "snapshot.c"
}

static void
games_snapshot_real_load_metadata (GamesSnapshot* self,
                                   GKeyFile* keyfile,
                                   GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* creation_date_str = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 93 "../src/core/snapshot.vala"
	g_return_if_fail (keyfile != NULL);
#line 94 "../src/core/snapshot.vala"
	_tmp0_ = g_key_file_get_boolean (keyfile, "Metadata", "Automatic", &_inner_error0_);
#line 94 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/core/snapshot.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 94 "../src/core/snapshot.vala"
			g_propagate_error (error, _inner_error0_);
#line 94 "../src/core/snapshot.vala"
			return;
#line 502 "snapshot.c"
		} else {
#line 94 "../src/core/snapshot.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/core/snapshot.vala"
			g_clear_error (&_inner_error0_);
#line 94 "../src/core/snapshot.vala"
			return;
#line 510 "snapshot.c"
		}
	}
#line 94 "../src/core/snapshot.vala"
	games_snapshot_set_is_automatic (self, _tmp0_);
#line 96 "../src/core/snapshot.vala"
	_tmp1_ = self->priv->_is_automatic;
#line 96 "../src/core/snapshot.vala"
	if (_tmp1_) {
#line 97 "../src/core/snapshot.vala"
		games_snapshot_set_name (self, NULL);
#line 521 "snapshot.c"
	} else {
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
#line 99 "../src/core/snapshot.vala"
		_tmp3_ = g_key_file_get_string (keyfile, "Metadata", "Name", &_inner_error0_);
#line 99 "../src/core/snapshot.vala"
		_tmp2_ = _tmp3_;
#line 99 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/core/snapshot.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 99 "../src/core/snapshot.vala"
				g_propagate_error (error, _inner_error0_);
#line 99 "../src/core/snapshot.vala"
				return;
#line 537 "snapshot.c"
			} else {
#line 99 "../src/core/snapshot.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/core/snapshot.vala"
				g_clear_error (&_inner_error0_);
#line 99 "../src/core/snapshot.vala"
				return;
#line 545 "snapshot.c"
			}
		}
#line 99 "../src/core/snapshot.vala"
		games_snapshot_set_name (self, _tmp2_);
#line 96 "../src/core/snapshot.vala"
		_g_free0 (_tmp2_);
#line 552 "snapshot.c"
	}
#line 101 "../src/core/snapshot.vala"
	_tmp4_ = g_key_file_get_string (keyfile, "Metadata", "Creation Date", &_inner_error0_);
#line 101 "../src/core/snapshot.vala"
	creation_date_str = _tmp4_;
#line 101 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/core/snapshot.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 101 "../src/core/snapshot.vala"
			g_propagate_error (error, _inner_error0_);
#line 101 "../src/core/snapshot.vala"
			return;
#line 566 "snapshot.c"
		} else {
#line 101 "../src/core/snapshot.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/core/snapshot.vala"
			g_clear_error (&_inner_error0_);
#line 101 "../src/core/snapshot.vala"
			return;
#line 574 "snapshot.c"
		}
	}
#line 102 "../src/core/snapshot.vala"
	_tmp5_ = creation_date_str;
#line 102 "../src/core/snapshot.vala"
	_tmp6_ = g_time_zone_new_local ();
#line 102 "../src/core/snapshot.vala"
	_tmp7_ = _tmp6_;
#line 102 "../src/core/snapshot.vala"
	_tmp8_ = g_date_time_new_from_iso8601 (_tmp5_, _tmp7_);
#line 102 "../src/core/snapshot.vala"
	_tmp9_ = _tmp8_;
#line 102 "../src/core/snapshot.vala"
	games_snapshot_set_creation_date (self, _tmp9_);
#line 102 "../src/core/snapshot.vala"
	_g_date_time_unref0 (_tmp9_);
#line 102 "../src/core/snapshot.vala"
	_g_time_zone_unref0 (_tmp7_);
#line 105 "../src/core/snapshot.vala"
	if (g_key_file_has_group (keyfile, "Screenshot")) {
#line 595 "snapshot.c"
		gdouble _tmp10_ = 0.0;
#line 106 "../src/core/snapshot.vala"
		_tmp10_ = g_key_file_get_double (keyfile, "Screenshot", "Aspect Ratio", &_inner_error0_);
#line 106 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/core/snapshot.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 106 "../src/core/snapshot.vala"
				g_propagate_error (error, _inner_error0_);
#line 106 "../src/core/snapshot.vala"
				_g_free0 (creation_date_str);
#line 106 "../src/core/snapshot.vala"
				return;
#line 609 "snapshot.c"
			} else {
#line 106 "../src/core/snapshot.vala"
				_g_free0 (creation_date_str);
#line 106 "../src/core/snapshot.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../src/core/snapshot.vala"
				g_clear_error (&_inner_error0_);
#line 106 "../src/core/snapshot.vala"
				return;
#line 619 "snapshot.c"
			}
		}
#line 106 "../src/core/snapshot.vala"
		games_snapshot_set_screenshot_aspect_ratio (self, _tmp10_);
#line 624 "snapshot.c"
	} else {
#line 108 "../src/core/snapshot.vala"
		games_snapshot_set_screenshot_aspect_ratio (self, (gdouble) 0);
#line 628 "snapshot.c"
	}
#line 93 "../src/core/snapshot.vala"
	_g_free0 (creation_date_str);
#line 632 "snapshot.c"
}

void
games_snapshot_load_metadata (GamesSnapshot* self,
                              GKeyFile* keyfile,
                              GError** error)
{
	GamesSnapshotClass* _klass_;
#line 93 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/core/snapshot.vala"
	_klass_ = GAMES_SNAPSHOT_GET_CLASS (self);
#line 93 "../src/core/snapshot.vala"
	if (_klass_->load_metadata) {
#line 93 "../src/core/snapshot.vala"
		_klass_->load_metadata (self, keyfile, error);
#line 649 "snapshot.c"
	}
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3320 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3321 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3321 "glib-2.0.vapi"
	result = _tmp0_;
#line 3321 "glib-2.0.vapi"
	return result;
#line 666 "snapshot.c"
}

static void
games_snapshot_real_save_metadata (GamesSnapshot* self,
                                   GKeyFile* keyfile)
{
	gboolean _tmp0_;
	const gchar* _tmp1_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GamesPlatform* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gdouble _tmp10_;
#line 111 "../src/core/snapshot.vala"
	g_return_if_fail (keyfile != NULL);
#line 112 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_is_automatic;
#line 112 "../src/core/snapshot.vala"
	g_key_file_set_boolean (keyfile, "Metadata", "Automatic", _tmp0_);
#line 113 "../src/core/snapshot.vala"
	_tmp1_ = self->priv->_name;
#line 113 "../src/core/snapshot.vala"
	if (_tmp1_ != NULL) {
#line 693 "snapshot.c"
		const gchar* _tmp2_;
#line 114 "../src/core/snapshot.vala"
		_tmp2_ = self->priv->_name;
#line 114 "../src/core/snapshot.vala"
		g_key_file_set_string (keyfile, "Metadata", "Name", _tmp2_);
#line 699 "snapshot.c"
	}
#line 115 "../src/core/snapshot.vala"
	_tmp3_ = self->priv->_creation_date;
#line 115 "../src/core/snapshot.vala"
	_tmp4_ = g_date_time_to_string (_tmp3_);
#line 115 "../src/core/snapshot.vala"
	_tmp5_ = _tmp4_;
#line 115 "../src/core/snapshot.vala"
	g_key_file_set_string (keyfile, "Metadata", "Creation Date", _tmp5_);
#line 115 "../src/core/snapshot.vala"
	_g_free0 (_tmp5_);
#line 118 "../src/core/snapshot.vala"
	_tmp6_ = self->priv->_platform;
#line 118 "../src/core/snapshot.vala"
	_tmp7_ = games_platform_get_uid_prefix (_tmp6_);
#line 118 "../src/core/snapshot.vala"
	_tmp8_ = _tmp7_;
#line 118 "../src/core/snapshot.vala"
	g_key_file_set_string (keyfile, "Metadata", "Platform", _tmp8_);
#line 118 "../src/core/snapshot.vala"
	_g_free0 (_tmp8_);
#line 119 "../src/core/snapshot.vala"
	_tmp9_ = self->priv->_core;
#line 119 "../src/core/snapshot.vala"
	g_key_file_set_string (keyfile, "Metadata", "Core", _tmp9_);
#line 121 "../src/core/snapshot.vala"
	_tmp10_ = self->priv->_screenshot_aspect_ratio;
#line 121 "../src/core/snapshot.vala"
	g_key_file_set_double (keyfile, "Screenshot", "Aspect Ratio", _tmp10_);
#line 729 "snapshot.c"
}

void
games_snapshot_save_metadata (GamesSnapshot* self,
                              GKeyFile* keyfile)
{
	GamesSnapshotClass* _klass_;
#line 111 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/core/snapshot.vala"
	_klass_ = GAMES_SNAPSHOT_GET_CLASS (self);
#line 111 "../src/core/snapshot.vala"
	if (_klass_->save_metadata) {
#line 111 "../src/core/snapshot.vala"
		_klass_->save_metadata (self, keyfile);
#line 745 "snapshot.c"
	}
}

void
games_snapshot_write_metadata (GamesSnapshot* self,
                               GError** error)
{
	gchar* metadata_file_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* metadata_file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GKeyFile* metadata = NULL;
	GKeyFile* _tmp4_;
	GFile* _tmp5_;
	GKeyFile* _tmp7_;
	GKeyFile* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 125 "../src/core/snapshot.vala"
	_tmp1_ = g_build_filename (_tmp0_, "metadata", NULL);
#line 125 "../src/core/snapshot.vala"
	metadata_file_path = _tmp1_;
#line 126 "../src/core/snapshot.vala"
	_tmp2_ = metadata_file_path;
#line 126 "../src/core/snapshot.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 126 "../src/core/snapshot.vala"
	metadata_file = _tmp3_;
#line 127 "../src/core/snapshot.vala"
	_tmp4_ = g_key_file_new ();
#line 127 "../src/core/snapshot.vala"
	metadata = _tmp4_;
#line 129 "../src/core/snapshot.vala"
	_tmp5_ = metadata_file;
#line 129 "../src/core/snapshot.vala"
	if (g_file_query_exists (_tmp5_, NULL)) {
#line 788 "snapshot.c"
		GFile* _tmp6_;
#line 130 "../src/core/snapshot.vala"
		_tmp6_ = metadata_file;
#line 130 "../src/core/snapshot.vala"
		g_file_delete (_tmp6_, NULL, &_inner_error0_);
#line 130 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/core/snapshot.vala"
			g_propagate_error (error, _inner_error0_);
#line 130 "../src/core/snapshot.vala"
			_g_key_file_unref0 (metadata);
#line 130 "../src/core/snapshot.vala"
			_g_object_unref0 (metadata_file);
#line 130 "../src/core/snapshot.vala"
			_g_free0 (metadata_file_path);
#line 130 "../src/core/snapshot.vala"
			return;
#line 806 "snapshot.c"
		}
	}
#line 132 "../src/core/snapshot.vala"
	_tmp7_ = metadata;
#line 132 "../src/core/snapshot.vala"
	games_snapshot_save_metadata (self, _tmp7_);
#line 134 "../src/core/snapshot.vala"
	_tmp8_ = metadata;
#line 134 "../src/core/snapshot.vala"
	_tmp9_ = metadata_file_path;
#line 134 "../src/core/snapshot.vala"
	g_key_file_save_to_file (_tmp8_, _tmp9_, &_inner_error0_);
#line 134 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 134 "../src/core/snapshot.vala"
		_g_key_file_unref0 (metadata);
#line 134 "../src/core/snapshot.vala"
		_g_object_unref0 (metadata_file);
#line 134 "../src/core/snapshot.vala"
		_g_free0 (metadata_file_path);
#line 134 "../src/core/snapshot.vala"
		return;
#line 831 "snapshot.c"
	}
#line 124 "../src/core/snapshot.vala"
	_g_key_file_unref0 (metadata);
#line 124 "../src/core/snapshot.vala"
	_g_object_unref0 (metadata_file);
#line 124 "../src/core/snapshot.vala"
	_g_free0 (metadata_file_path);
#line 839 "snapshot.c"
}

void
games_snapshot_delete_from_disk (GamesSnapshot* self)
{
	GFile* snapshot_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 137 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 138 "../src/core/snapshot.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 138 "../src/core/snapshot.vala"
	snapshot_dir = _tmp1_;
#line 857 "snapshot.c"
	{
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 143 "../src/core/snapshot.vala"
		_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 143 "../src/core/snapshot.vala"
		_tmp3_ = _tmp2_;
#line 143 "../src/core/snapshot.vala"
		_tmp3__length1 = 0;
#line 143 "../src/core/snapshot.vala"
		games_file_operations_delete_files (snapshot_dir, _tmp3_, (gint) 0, &_inner_error0_);
#line 143 "../src/core/snapshot.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 143 "../src/core/snapshot.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 874 "snapshot.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 142 "../src/core/snapshot.vala"
		e = _inner_error0_;
#line 142 "../src/core/snapshot.vala"
		_inner_error0_ = NULL;
#line 146 "../src/core/snapshot.vala"
		_tmp4_ = self->priv->_path;
#line 146 "../src/core/snapshot.vala"
		_tmp5_ = e;
#line 146 "../src/core/snapshot.vala"
		_tmp6_ = _tmp5_->message;
#line 146 "../src/core/snapshot.vala"
		g_warning ("snapshot.vala:146: Failed to delete snapshot at %s: %s", _tmp4_, _tmp6_);
#line 142 "../src/core/snapshot.vala"
		_g_error_free0 (e);
#line 899 "snapshot.c"
	}
	__finally0:
#line 142 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/core/snapshot.vala"
		_g_object_unref0 (snapshot_dir);
#line 142 "../src/core/snapshot.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/core/snapshot.vala"
		g_clear_error (&_inner_error0_);
#line 142 "../src/core/snapshot.vala"
		return;
#line 912 "snapshot.c"
	}
#line 137 "../src/core/snapshot.vala"
	_g_object_unref0 (snapshot_dir);
#line 916 "snapshot.c"
}

GamesSnapshot*
games_snapshot_create_empty (GamesGame* game,
                             const gchar* core_id,
                             const gchar* path,
                             GError** error)
{
	guint32 random = 0U;
	gchar* cache_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* tmp_path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* dir = NULL;
	const gchar* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* save_dir = NULL;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GamesPlatform* _tmp15_;
	GamesPlatform* _tmp16_;
	const gchar* _tmp17_;
	GamesSnapshot* _tmp18_;
	GError* _inner_error0_ = NULL;
	GamesSnapshot* result;
#line 150 "../src/core/snapshot.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 150 "../src/core/snapshot.vala"
	g_return_val_if_fail (core_id != NULL, NULL);
#line 150 "../src/core/snapshot.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 151 "../src/core/snapshot.vala"
	random = g_random_int ();
#line 152 "../src/core/snapshot.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 152 "../src/core/snapshot.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 152 "../src/core/snapshot.vala"
	cache_path = _tmp1_;
#line 153 "../src/core/snapshot.vala"
	_tmp2_ = cache_path;
#line 153 "../src/core/snapshot.vala"
	_tmp3_ = g_strdup_printf ("%u", random);
#line 153 "../src/core/snapshot.vala"
	_tmp4_ = _tmp3_;
#line 153 "../src/core/snapshot.vala"
	_tmp5_ = g_strconcat ("snapshot-", _tmp4_, NULL);
#line 153 "../src/core/snapshot.vala"
	_tmp6_ = _tmp5_;
#line 153 "../src/core/snapshot.vala"
	_tmp7_ = g_build_filename (_tmp2_, "gnome-games", _tmp6_, NULL);
#line 153 "../src/core/snapshot.vala"
	_tmp8_ = _tmp7_;
#line 153 "../src/core/snapshot.vala"
	_g_free0 (_tmp6_);
#line 153 "../src/core/snapshot.vala"
	_g_free0 (_tmp4_);
#line 153 "../src/core/snapshot.vala"
	tmp_path = _tmp8_;
#line 155 "../src/core/snapshot.vala"
	_tmp9_ = tmp_path;
#line 155 "../src/core/snapshot.vala"
	_tmp10_ = g_file_new_for_path (_tmp9_);
#line 155 "../src/core/snapshot.vala"
	dir = _tmp10_;
#line 156 "../src/core/snapshot.vala"
	_tmp11_ = dir;
#line 156 "../src/core/snapshot.vala"
	g_file_make_directory (_tmp11_, NULL, &_inner_error0_);
#line 156 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 156 "../src/core/snapshot.vala"
		_g_object_unref0 (dir);
#line 156 "../src/core/snapshot.vala"
		_g_free0 (tmp_path);
#line 156 "../src/core/snapshot.vala"
		_g_free0 (cache_path);
#line 156 "../src/core/snapshot.vala"
		return NULL;
#line 1007 "snapshot.c"
	}
#line 158 "../src/core/snapshot.vala"
	_tmp12_ = dir;
#line 158 "../src/core/snapshot.vala"
	_tmp13_ = g_file_get_child (_tmp12_, "save-dir");
#line 158 "../src/core/snapshot.vala"
	save_dir = _tmp13_;
#line 159 "../src/core/snapshot.vala"
	_tmp14_ = save_dir;
#line 159 "../src/core/snapshot.vala"
	g_file_make_directory (_tmp14_, NULL, &_inner_error0_);
#line 159 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 159 "../src/core/snapshot.vala"
		_g_object_unref0 (save_dir);
#line 159 "../src/core/snapshot.vala"
		_g_object_unref0 (dir);
#line 159 "../src/core/snapshot.vala"
		_g_free0 (tmp_path);
#line 159 "../src/core/snapshot.vala"
		_g_free0 (cache_path);
#line 159 "../src/core/snapshot.vala"
		return NULL;
#line 1033 "snapshot.c"
	}
#line 161 "../src/core/snapshot.vala"
	_tmp15_ = games_game_get_platform (game);
#line 161 "../src/core/snapshot.vala"
	_tmp16_ = _tmp15_;
#line 161 "../src/core/snapshot.vala"
	_tmp17_ = tmp_path;
#line 161 "../src/core/snapshot.vala"
	_tmp18_ = games_snapshot_load (_tmp16_, core_id, _tmp17_);
#line 161 "../src/core/snapshot.vala"
	result = _tmp18_;
#line 161 "../src/core/snapshot.vala"
	_g_object_unref0 (save_dir);
#line 161 "../src/core/snapshot.vala"
	_g_object_unref0 (dir);
#line 161 "../src/core/snapshot.vala"
	_g_free0 (tmp_path);
#line 161 "../src/core/snapshot.vala"
	_g_free0 (cache_path);
#line 161 "../src/core/snapshot.vala"
	return result;
#line 1055 "snapshot.c"
}

GamesSnapshot*
games_snapshot_move_to (GamesSnapshot* self,
                        const gchar* dest_path,
                        GError** error)
{
	GFile* current_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* dest_dir = NULL;
	GFile* _tmp2_;
	gchar* dest = NULL;
	gchar* _tmp3_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GamesPlatform* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GamesSnapshot* _tmp14_;
	GError* _inner_error0_ = NULL;
	GamesSnapshot* result;
#line 164 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/core/snapshot.vala"
	g_return_val_if_fail (dest_path != NULL, NULL);
#line 165 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 165 "../src/core/snapshot.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 165 "../src/core/snapshot.vala"
	current_dir = _tmp1_;
#line 166 "../src/core/snapshot.vala"
	_tmp2_ = g_file_new_for_path (dest_path);
#line 166 "../src/core/snapshot.vala"
	dest_dir = _tmp2_;
#line 168 "../src/core/snapshot.vala"
	_tmp3_ = g_strdup (dest_path);
#line 168 "../src/core/snapshot.vala"
	dest = _tmp3_;
#line 169 "../src/core/snapshot.vala"
	while (TRUE) {
#line 1098 "snapshot.c"
		GFile* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		GFile* _tmp8_;
#line 169 "../src/core/snapshot.vala"
		_tmp4_ = dest_dir;
#line 169 "../src/core/snapshot.vala"
		if (!g_file_query_exists (_tmp4_, NULL)) {
#line 169 "../src/core/snapshot.vala"
			break;
#line 1110 "snapshot.c"
		}
#line 170 "../src/core/snapshot.vala"
		_tmp5_ = dest;
#line 170 "../src/core/snapshot.vala"
		_tmp6_ = g_strconcat (_tmp5_, "_", NULL);
#line 170 "../src/core/snapshot.vala"
		_g_free0 (dest);
#line 170 "../src/core/snapshot.vala"
		dest = _tmp6_;
#line 171 "../src/core/snapshot.vala"
		_tmp7_ = dest;
#line 171 "../src/core/snapshot.vala"
		_tmp8_ = g_file_new_for_path (_tmp7_);
#line 171 "../src/core/snapshot.vala"
		_g_object_unref0 (dest_dir);
#line 171 "../src/core/snapshot.vala"
		dest_dir = _tmp8_;
#line 1128 "snapshot.c"
	}
#line 174 "../src/core/snapshot.vala"
	_tmp9_ = current_dir;
#line 174 "../src/core/snapshot.vala"
	_tmp10_ = dest_dir;
#line 174 "../src/core/snapshot.vala"
	g_file_move (_tmp9_, _tmp10_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 174 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 174 "../src/core/snapshot.vala"
		_g_free0 (dest);
#line 174 "../src/core/snapshot.vala"
		_g_object_unref0 (dest_dir);
#line 174 "../src/core/snapshot.vala"
		_g_object_unref0 (current_dir);
#line 174 "../src/core/snapshot.vala"
		return NULL;
#line 1148 "snapshot.c"
	}
#line 176 "../src/core/snapshot.vala"
	_tmp11_ = self->priv->_platform;
#line 176 "../src/core/snapshot.vala"
	_tmp12_ = self->priv->_core;
#line 176 "../src/core/snapshot.vala"
	_tmp13_ = dest;
#line 176 "../src/core/snapshot.vala"
	_tmp14_ = games_snapshot_load (_tmp11_, _tmp12_, _tmp13_);
#line 176 "../src/core/snapshot.vala"
	result = _tmp14_;
#line 176 "../src/core/snapshot.vala"
	_g_free0 (dest);
#line 176 "../src/core/snapshot.vala"
	_g_object_unref0 (dest_dir);
#line 176 "../src/core/snapshot.vala"
	_g_object_unref0 (current_dir);
#line 176 "../src/core/snapshot.vala"
	return result;
#line 1168 "snapshot.c"
}

void
games_snapshot_copy_save_dir_to (GamesSnapshot* self,
                                 const gchar* dest,
                                 GError** error)
{
	GFile* save_dir_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* dest_file = NULL;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 179 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/core/snapshot.vala"
	g_return_if_fail (dest != NULL);
#line 180 "../src/core/snapshot.vala"
	_tmp0_ = games_snapshot_get_save_directory_path (self);
#line 180 "../src/core/snapshot.vala"
	_tmp1_ = _tmp0_;
#line 180 "../src/core/snapshot.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 180 "../src/core/snapshot.vala"
	_tmp3_ = _tmp2_;
#line 180 "../src/core/snapshot.vala"
	_g_free0 (_tmp1_);
#line 180 "../src/core/snapshot.vala"
	save_dir_file = _tmp3_;
#line 181 "../src/core/snapshot.vala"
	_tmp4_ = g_file_new_for_path (dest);
#line 181 "../src/core/snapshot.vala"
	dest_file = _tmp4_;
#line 183 "../src/core/snapshot.vala"
	games_file_operations_copy_contents (save_dir_file, dest_file, &_inner_error0_);
#line 183 "../src/core/snapshot.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/core/snapshot.vala"
		g_propagate_error (error, _inner_error0_);
#line 183 "../src/core/snapshot.vala"
		_g_object_unref0 (dest_file);
#line 183 "../src/core/snapshot.vala"
		_g_object_unref0 (save_dir_file);
#line 183 "../src/core/snapshot.vala"
		return;
#line 1216 "snapshot.c"
	}
#line 179 "../src/core/snapshot.vala"
	_g_object_unref0 (dest_file);
#line 179 "../src/core/snapshot.vala"
	_g_object_unref0 (save_dir_file);
#line 1222 "snapshot.c"
}

gint
games_snapshot_compare (GamesSnapshot* s1,
                        GamesSnapshot* s2)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint result;
#line 186 "../src/core/snapshot.vala"
	g_return_val_if_fail (s1 != NULL, 0);
#line 186 "../src/core/snapshot.vala"
	g_return_val_if_fail (s2 != NULL, 0);
#line 187 "../src/core/snapshot.vala"
	_tmp0_ = s1->priv->_path;
#line 187 "../src/core/snapshot.vala"
	_tmp1_ = s2->priv->_path;
#line 187 "../src/core/snapshot.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) < 0) {
#line 188 "../src/core/snapshot.vala"
		result = 1;
#line 188 "../src/core/snapshot.vala"
		return result;
#line 1248 "snapshot.c"
	}
#line 190 "../src/core/snapshot.vala"
	_tmp2_ = s1->priv->_path;
#line 190 "../src/core/snapshot.vala"
	_tmp3_ = s2->priv->_path;
#line 190 "../src/core/snapshot.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 191 "../src/core/snapshot.vala"
		result = 0;
#line 191 "../src/core/snapshot.vala"
		return result;
#line 1260 "snapshot.c"
	}
#line 194 "../src/core/snapshot.vala"
	result = -1;
#line 194 "../src/core/snapshot.vala"
	return result;
#line 1266 "snapshot.c"
}

GamesSnapshot*
games_snapshot_construct (GType object_type)
{
	GamesSnapshot * self = NULL;
#line 3 "../src/core/snapshot.vala"
	self = (GamesSnapshot*) g_object_new (object_type, NULL);
#line 3 "../src/core/snapshot.vala"
	return self;
#line 1277 "snapshot.c"
}

GamesSnapshot*
games_snapshot_new (void)
{
#line 3 "../src/core/snapshot.vala"
	return games_snapshot_construct (GAMES_TYPE_SNAPSHOT);
#line 1285 "snapshot.c"
}

const gchar*
games_snapshot_get_path (GamesSnapshot* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 4 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_path;
#line 4 "../src/core/snapshot.vala"
	result = _tmp0_;
#line 4 "../src/core/snapshot.vala"
	return result;
#line 1301 "snapshot.c"
}

static void
games_snapshot_set_path (GamesSnapshot* self,
                         const gchar* value)
{
	gchar* old_value;
#line 4 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 4 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_path (self);
#line 4 "../src/core/snapshot.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1315 "snapshot.c"
		gchar* _tmp0_;
#line 4 "../src/core/snapshot.vala"
		_tmp0_ = g_strdup (value);
#line 4 "../src/core/snapshot.vala"
		_g_free0 (self->priv->_path);
#line 4 "../src/core/snapshot.vala"
		self->priv->_path = _tmp0_;
#line 4 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_PATH_PROPERTY]);
#line 1325 "snapshot.c"
	}
}

GamesPlatform*
games_snapshot_get_platform (GamesSnapshot* self)
{
	GamesPlatform* result;
	GamesPlatform* _tmp0_;
#line 5 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_platform;
#line 5 "../src/core/snapshot.vala"
	result = _tmp0_;
#line 5 "../src/core/snapshot.vala"
	return result;
#line 1342 "snapshot.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 5 "../src/core/snapshot.vala"
	return self ? g_object_ref (self) : NULL;
#line 1350 "snapshot.c"
}

static void
games_snapshot_set_platform (GamesSnapshot* self,
                             GamesPlatform* value)
{
	GamesPlatform* old_value;
#line 5 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 5 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_platform (self);
#line 5 "../src/core/snapshot.vala"
	if (old_value != value) {
#line 1364 "snapshot.c"
		GamesPlatform* _tmp0_;
#line 5 "../src/core/snapshot.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 5 "../src/core/snapshot.vala"
		_g_object_unref0 (self->priv->_platform);
#line 5 "../src/core/snapshot.vala"
		self->priv->_platform = _tmp0_;
#line 5 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_PLATFORM_PROPERTY]);
#line 1374 "snapshot.c"
	}
}

const gchar*
games_snapshot_get_core (GamesSnapshot* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 6 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_core;
#line 6 "../src/core/snapshot.vala"
	result = _tmp0_;
#line 6 "../src/core/snapshot.vala"
	return result;
#line 1391 "snapshot.c"
}

static void
games_snapshot_set_core (GamesSnapshot* self,
                         const gchar* value)
{
	gchar* old_value;
#line 6 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 6 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_core (self);
#line 6 "../src/core/snapshot.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1405 "snapshot.c"
		gchar* _tmp0_;
#line 6 "../src/core/snapshot.vala"
		_tmp0_ = g_strdup (value);
#line 6 "../src/core/snapshot.vala"
		_g_free0 (self->priv->_core);
#line 6 "../src/core/snapshot.vala"
		self->priv->_core = _tmp0_;
#line 6 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_CORE_PROPERTY]);
#line 1415 "snapshot.c"
	}
}

gboolean
games_snapshot_get_is_automatic (GamesSnapshot* self)
{
	gboolean result;
#line 10 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 10 "../src/core/snapshot.vala"
	result = self->priv->_is_automatic;
#line 10 "../src/core/snapshot.vala"
	return result;
#line 1429 "snapshot.c"
}

void
games_snapshot_set_is_automatic (GamesSnapshot* self,
                                 gboolean value)
{
	gboolean old_value;
#line 10 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_is_automatic (self);
#line 10 "../src/core/snapshot.vala"
	if (old_value != value) {
#line 10 "../src/core/snapshot.vala"
		self->priv->_is_automatic = value;
#line 10 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY]);
#line 1447 "snapshot.c"
	}
}

const gchar*
games_snapshot_get_name (GamesSnapshot* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 11 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_name;
#line 11 "../src/core/snapshot.vala"
	result = _tmp0_;
#line 11 "../src/core/snapshot.vala"
	return result;
#line 1464 "snapshot.c"
}

void
games_snapshot_set_name (GamesSnapshot* self,
                         const gchar* value)
{
	gchar* old_value;
#line 11 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_name (self);
#line 11 "../src/core/snapshot.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1478 "snapshot.c"
		gchar* _tmp0_;
#line 11 "../src/core/snapshot.vala"
		_tmp0_ = g_strdup (value);
#line 11 "../src/core/snapshot.vala"
		_g_free0 (self->priv->_name);
#line 11 "../src/core/snapshot.vala"
		self->priv->_name = _tmp0_;
#line 11 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_NAME_PROPERTY]);
#line 1488 "snapshot.c"
	}
}

GDateTime*
games_snapshot_get_creation_date (GamesSnapshot* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 12 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../src/core/snapshot.vala"
	_tmp0_ = self->priv->_creation_date;
#line 12 "../src/core/snapshot.vala"
	result = _tmp0_;
#line 12 "../src/core/snapshot.vala"
	return result;
#line 1505 "snapshot.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 12 "../src/core/snapshot.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1513 "snapshot.c"
}

void
games_snapshot_set_creation_date (GamesSnapshot* self,
                                  GDateTime* value)
{
	GDateTime* old_value;
#line 12 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_creation_date (self);
#line 12 "../src/core/snapshot.vala"
	if (old_value != value) {
#line 1527 "snapshot.c"
		GDateTime* _tmp0_;
#line 12 "../src/core/snapshot.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 12 "../src/core/snapshot.vala"
		_g_date_time_unref0 (self->priv->_creation_date);
#line 12 "../src/core/snapshot.vala"
		self->priv->_creation_date = _tmp0_;
#line 12 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_CREATION_DATE_PROPERTY]);
#line 1537 "snapshot.c"
	}
}

gdouble
games_snapshot_get_screenshot_aspect_ratio (GamesSnapshot* self)
{
	gdouble result;
#line 13 "../src/core/snapshot.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 13 "../src/core/snapshot.vala"
	result = self->priv->_screenshot_aspect_ratio;
#line 13 "../src/core/snapshot.vala"
	return result;
#line 1551 "snapshot.c"
}

void
games_snapshot_set_screenshot_aspect_ratio (GamesSnapshot* self,
                                            gdouble value)
{
	gdouble old_value;
#line 13 "../src/core/snapshot.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/core/snapshot.vala"
	old_value = games_snapshot_get_screenshot_aspect_ratio (self);
#line 13 "../src/core/snapshot.vala"
	if (old_value != value) {
#line 13 "../src/core/snapshot.vala"
		self->priv->_screenshot_aspect_ratio = value;
#line 13 "../src/core/snapshot.vala"
		g_object_notify_by_pspec ((GObject *) self, games_snapshot_properties[GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY]);
#line 1569 "snapshot.c"
	}
}

static void
games_snapshot_class_init (GamesSnapshotClass * klass,
                           gpointer klass_data)
{
#line 3 "../src/core/snapshot.vala"
	games_snapshot_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/core/snapshot.vala"
	g_type_class_adjust_private_offset (klass, &GamesSnapshot_private_offset);
#line 3 "../src/core/snapshot.vala"
	((GamesSnapshotClass *) klass)->load_metadata = (void (*) (GamesSnapshot*, GKeyFile*, GError**)) games_snapshot_real_load_metadata;
#line 3 "../src/core/snapshot.vala"
	((GamesSnapshotClass *) klass)->save_metadata = (void (*) (GamesSnapshot*, GKeyFile*)) games_snapshot_real_save_metadata;
#line 3 "../src/core/snapshot.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_snapshot_get_property;
#line 3 "../src/core/snapshot.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_snapshot_set_property;
#line 3 "../src/core/snapshot.vala"
	G_OBJECT_CLASS (klass)->finalize = games_snapshot_finalize;
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_PATH_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_PLATFORM_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_PLATFORM_PROPERTY] = g_param_spec_object ("platform", "platform", "platform", GAMES_TYPE_PLATFORM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_CORE_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_CORE_PROPERTY] = g_param_spec_string ("core", "core", "core", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY] = g_param_spec_boolean ("is-automatic", "is-automatic", "is-automatic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_NAME_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_CREATION_DATE_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_CREATION_DATE_PROPERTY] = g_param_spec_boxed ("creation-date", "creation-date", "creation-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3 "../src/core/snapshot.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY, games_snapshot_properties[GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY] = g_param_spec_double ("screenshot-aspect-ratio", "screenshot-aspect-ratio", "screenshot-aspect-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1605 "snapshot.c"
}

static void
games_snapshot_instance_init (GamesSnapshot * self,
                              gpointer klass)
{
#line 3 "../src/core/snapshot.vala"
	self->priv = games_snapshot_get_instance_private (self);
#line 1614 "snapshot.c"
}

static void
games_snapshot_finalize (GObject * obj)
{
	GamesSnapshot * self;
#line 3 "../src/core/snapshot.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_SNAPSHOT, GamesSnapshot);
#line 4 "../src/core/snapshot.vala"
	_g_free0 (self->priv->_path);
#line 5 "../src/core/snapshot.vala"
	_g_object_unref0 (self->priv->_platform);
#line 6 "../src/core/snapshot.vala"
	_g_free0 (self->priv->_core);
#line 11 "../src/core/snapshot.vala"
	_g_free0 (self->priv->_name);
#line 12 "../src/core/snapshot.vala"
	_g_date_time_unref0 (self->priv->_creation_date);
#line 15 "../src/core/snapshot.vala"
	G_OBJECT_CLASS (games_snapshot_parent_class)->finalize (obj);
#line 1635 "snapshot.c"
}

static GType
games_snapshot_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesSnapshot), 0, (GInstanceInitFunc) games_snapshot_instance_init, NULL };
	GType games_snapshot_type_id;
	games_snapshot_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesSnapshot", &g_define_type_info, 0);
	GamesSnapshot_private_offset = g_type_add_instance_private (games_snapshot_type_id, sizeof (GamesSnapshotPrivate));
	return games_snapshot_type_id;
}

GType
games_snapshot_get_type (void)
{
	static volatile gsize games_snapshot_type_id__once = 0;
	if (g_once_init_enter (&games_snapshot_type_id__once)) {
		GType games_snapshot_type_id;
		games_snapshot_type_id = games_snapshot_get_type_once ();
		g_once_init_leave (&games_snapshot_type_id__once, games_snapshot_type_id);
	}
	return games_snapshot_type_id__once;
}

static void
_vala_games_snapshot_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	GamesSnapshot * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_SNAPSHOT, GamesSnapshot);
#line 3 "../src/core/snapshot.vala"
	switch (property_id) {
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_PATH_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_string (value, games_snapshot_get_path (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_PLATFORM_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_object (value, games_snapshot_get_platform (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_CORE_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_string (value, games_snapshot_get_core (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_boolean (value, games_snapshot_get_is_automatic (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_NAME_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_string (value, games_snapshot_get_name (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_CREATION_DATE_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_boxed (value, games_snapshot_get_creation_date (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		g_value_set_double (value, games_snapshot_get_screenshot_aspect_ratio (self));
#line 3 "../src/core/snapshot.vala"
		break;
#line 1712 "snapshot.c"
		default:
#line 3 "../src/core/snapshot.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/core/snapshot.vala"
		break;
#line 1718 "snapshot.c"
	}
}

static void
_vala_games_snapshot_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	GamesSnapshot * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_SNAPSHOT, GamesSnapshot);
#line 3 "../src/core/snapshot.vala"
	switch (property_id) {
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_PATH_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_path (self, g_value_get_string (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_PLATFORM_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_platform (self, g_value_get_object (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_CORE_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_core (self, g_value_get_string (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_IS_AUTOMATIC_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_is_automatic (self, g_value_get_boolean (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_NAME_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_name (self, g_value_get_string (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_CREATION_DATE_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_creation_date (self, g_value_get_boxed (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 3 "../src/core/snapshot.vala"
		case GAMES_SNAPSHOT_SCREENSHOT_ASPECT_RATIO_PROPERTY:
#line 3 "../src/core/snapshot.vala"
		games_snapshot_set_screenshot_aspect_ratio (self, g_value_get_double (value));
#line 3 "../src/core/snapshot.vala"
		break;
#line 1774 "snapshot.c"
		default:
#line 3 "../src/core/snapshot.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/core/snapshot.vala"
		break;
#line 1780 "snapshot.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1791 "snapshot.c"
		gssize i;
#line 3 "../src/core/snapshot.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 3 "../src/core/snapshot.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 3 "../src/core/snapshot.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1799 "snapshot.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 3 "../src/core/snapshot.vala"
	g_free (array);
#line 1814 "snapshot.c"
}

