/* game-thumbnail.c generated by valac 0.56.3, the Vala compiler
 * generated from game-thumbnail.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "gnome-games.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"

#define GAMES_GAME_THUMBNAIL_EMBLEM_SCALE 0.125
#define GAMES_GAME_THUMBNAIL_ICON_SCALE 0.75
#define GAMES_GAME_THUMBNAIL_EMBLEM_MIN_SIZE ((gdouble) 16)

#define GAMES_TYPE_GAME_THUMBNAIL (games_game_thumbnail_get_type ())
#define GAMES_GAME_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnail))
#define GAMES_GAME_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnailClass))
#define GAMES_IS_GAME_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_GAME_THUMBNAIL))
#define GAMES_IS_GAME_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_GAME_THUMBNAIL))
#define GAMES_GAME_THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnailClass))

typedef struct _GamesGameThumbnail GamesGameThumbnail;
typedef struct _GamesGameThumbnailClass GamesGameThumbnailClass;
typedef struct _GamesGameThumbnailPrivate GamesGameThumbnailPrivate;
enum  {
	GAMES_GAME_THUMBNAIL_0_PROPERTY,
	GAMES_GAME_THUMBNAIL_GAME_PROPERTY,
	GAMES_GAME_THUMBNAIL_NUM_PROPERTIES
};
static GParamSpec* games_game_thumbnail_properties[GAMES_GAME_THUMBNAIL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAMES_GAME_THUMBNAIL_TYPE_DRAWING_CONTEXT (games_game_thumbnail_drawing_context_get_type ())
typedef struct _GamesGameThumbnailDrawingContext GamesGameThumbnailDrawingContext;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GamesGameThumbnail {
	GtkDrawingArea parent_instance;
	GamesGameThumbnailPrivate * priv;
};

struct _GamesGameThumbnailClass {
	GtkDrawingAreaClass parent_class;
};

struct _GamesGameThumbnailPrivate {
	gulong cover_changed_id;
	GamesIcon* icon;
	GamesCover* cover;
	GamesGame* _game;
	GdkPixbuf* cover_pixbuf;
	GdkPixbuf* icon_pixbuf;
	gboolean try_load_cover;
	gint last_scale_factor;
	gint last_cover_size;
};

struct _GamesGameThumbnailDrawingContext {
	cairo_t* cr;
	GtkStyleContext* style;
	GtkStateFlags state;
	gint width;
	gint height;
};

static gint GamesGameThumbnail_private_offset;
static gpointer games_game_thumbnail_parent_class = NULL;

VALA_EXTERN GType games_game_thumbnail_get_type (void) G_GNUC_CONST ;
static GtkSizeRequestMode games_game_thumbnail_real_get_request_mode (GtkWidget* base);
static void games_game_thumbnail_real_get_preferred_height_for_width (GtkWidget* base,
                                                               gint width,
                                                               gint* minimum_height,
                                                               gint* natural_height);
static void games_game_thumbnail_real_size_allocate (GtkWidget* base,
                                              GtkAllocation* alloc);
static gboolean games_game_thumbnail_real_draw (GtkWidget* base,
                                         cairo_t* cr);
VALA_EXTERN GType games_game_thumbnail_drawing_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesGameThumbnailDrawingContext* games_game_thumbnail_drawing_context_dup (const GamesGameThumbnailDrawingContext* self);
VALA_EXTERN void games_game_thumbnail_drawing_context_free (GamesGameThumbnailDrawingContext* self);
VALA_EXTERN void games_game_thumbnail_drawing_context_copy (const GamesGameThumbnailDrawingContext* self,
                                                GamesGameThumbnailDrawingContext* dest);
VALA_EXTERN void games_game_thumbnail_drawing_context_destroy (GamesGameThumbnailDrawingContext* self);
VALA_EXTERN void games_game_thumbnail_draw_image (GamesGameThumbnail* self,
                                      GamesGameThumbnailDrawingContext* context);
static void games_game_thumbnail_update_style_classes (GamesGameThumbnail* self);
static void games_game_thumbnail_get_icon_and_cover (GamesGameThumbnail* self,
                                              GamesGameThumbnailDrawingContext* context,
                                              GdkPixbuf** cover,
                                              GdkPixbuf** icon);
static void games_game_thumbnail_draw_pixbuf (GamesGameThumbnail* self,
                                       GamesGameThumbnailDrawingContext* context,
                                       GdkPixbuf* pixbuf);
static GdkPixbuf* games_game_thumbnail_get_emblem (GamesGameThumbnail* self,
                                            GamesGameThumbnailDrawingContext* context);
VALA_EXTERN GamesApplication* games_application_get_default (void);
VALA_EXTERN GamesCoverLoader* games_application_get_cover_loader (GamesApplication* self);
VALA_EXTERN GamesGame* games_game_thumbnail_get_game (GamesGameThumbnail* self);
static void __lambda20_ (GamesGameThumbnail* self,
                  gint scale_factor,
                  gint cover_size,
                  GdkPixbuf* cover_pixbuf,
                  gint icon_size,
                  GdkPixbuf* icon_pixbuf);
static void ___lambda20__games_cover_loader_cover_ready_callback (gint scale_factor,
                                                           gint cover_size,
                                                           GdkPixbuf* cover_pixbuf,
                                                           gint icon_size,
                                                           GdkPixbuf* icon_pixbuf,
                                                           gpointer self);
static void games_game_thumbnail_rounded_rectangle (GamesGameThumbnail* self,
                                             cairo_t* cr,
                                             gdouble x,
                                             gdouble y,
                                             gdouble width,
                                             gdouble height,
                                             gdouble radius);
VALA_EXTERN GamesGameThumbnail* games_game_thumbnail_new (void);
VALA_EXTERN GamesGameThumbnail* games_game_thumbnail_construct (GType object_type);
VALA_EXTERN void games_game_thumbnail_set_game (GamesGameThumbnail* self,
                                    GamesGame* value);
static void _games_game_thumbnail_game____lambda19_ (GamesGameThumbnail* self);
static void __games_game_thumbnail_game____lambda19__games_cover_changed (GamesCover* _sender,
                                                                   gpointer self);
static GObject * games_game_thumbnail_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void games_game_thumbnail_finalize (GObject * obj);
static GType games_game_thumbnail_get_type_once (void);
static void _vala_games_game_thumbnail_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_games_game_thumbnail_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
games_game_thumbnail_get_instance_private (GamesGameThumbnail* self)
{
	return G_STRUCT_MEMBER_P (self, GamesGameThumbnail_private_offset);
}

static GtkSizeRequestMode
games_game_thumbnail_real_get_request_mode (GtkWidget* base)
{
	GamesGameThumbnail * self;
	GtkSizeRequestMode result;
#line 60 "../src/ui/game-thumbnail.vala"
	self = (GamesGameThumbnail*) base;
#line 61 "../src/ui/game-thumbnail.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 61 "../src/ui/game-thumbnail.vala"
	return result;
#line 170 "game-thumbnail.c"
}

static void
games_game_thumbnail_real_get_preferred_height_for_width (GtkWidget* base,
                                                          gint width,
                                                          gint* minimum_height,
                                                          gint* natural_height)
{
	GamesGameThumbnail * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
#line 64 "../src/ui/game-thumbnail.vala"
	self = (GamesGameThumbnail*) base;
#line 65 "../src/ui/game-thumbnail.vala"
	_vala_natural_height = width;
#line 65 "../src/ui/game-thumbnail.vala"
	_vala_minimum_height = _vala_natural_height;
#line 64 "../src/ui/game-thumbnail.vala"
	if (minimum_height) {
#line 64 "../src/ui/game-thumbnail.vala"
		*minimum_height = _vala_minimum_height;
#line 192 "game-thumbnail.c"
	}
#line 64 "../src/ui/game-thumbnail.vala"
	if (natural_height) {
#line 64 "../src/ui/game-thumbnail.vala"
		*natural_height = _vala_natural_height;
#line 198 "game-thumbnail.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 69 "../src/ui/game-thumbnail.vala"
	return self ? g_object_ref (self) : NULL;
#line 207 "game-thumbnail.c"
}

static void
games_game_thumbnail_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* alloc)
{
	GamesGameThumbnail * self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GdkRectangle clip = {0};
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	GdkRectangle _tmp6_ = {0};
	GtkAllocation _tmp7_;
	GdkRectangle _tmp8_;
#line 68 "../src/ui/game-thumbnail.vala"
	self = (GamesGameThumbnail*) base;
#line 68 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (alloc != NULL);
#line 69 "../src/ui/game-thumbnail.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 69 "../src/ui/game-thumbnail.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 69 "../src/ui/game-thumbnail.vala"
	context = _tmp1_;
#line 70 "../src/ui/game-thumbnail.vala"
	_tmp2_ = *alloc;
#line 70 "../src/ui/game-thumbnail.vala"
	_tmp3_ = *alloc;
#line 70 "../src/ui/game-thumbnail.vala"
	_tmp4_ = *alloc;
#line 70 "../src/ui/game-thumbnail.vala"
	_tmp5_ = *alloc;
#line 70 "../src/ui/game-thumbnail.vala"
	gtk_render_background_get_clip (context, (gdouble) _tmp2_.x, (gdouble) _tmp3_.y, (gdouble) _tmp4_.width, (gdouble) _tmp5_.height, &_tmp6_);
#line 70 "../src/ui/game-thumbnail.vala"
	clip = _tmp6_;
#line 77 "../src/ui/game-thumbnail.vala"
	_tmp7_ = *alloc;
#line 77 "../src/ui/game-thumbnail.vala"
	GTK_WIDGET_CLASS (games_game_thumbnail_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), &_tmp7_);
#line 79 "../src/ui/game-thumbnail.vala"
	_tmp8_ = clip;
#line 79 "../src/ui/game-thumbnail.vala"
	gtk_widget_set_clip ((GtkWidget*) self, &_tmp8_);
#line 68 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (context);
#line 258 "game-thumbnail.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 88 "../src/ui/game-thumbnail.vala"
	return self ? cairo_reference (self) : NULL;
#line 266 "game-thumbnail.c"
}

static gboolean
games_game_thumbnail_real_draw (GtkWidget* base,
                                cairo_t* cr)
{
	GamesGameThumbnail * self;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	gint width = 0;
	gint height = 0;
	GamesGameThumbnailDrawingContext context = {0};
	cairo_t* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GamesGameThumbnailDrawingContext _tmp5_ = {0};
	GamesIcon* _tmp6_;
	GamesCover* _tmp7_;
	GamesGameThumbnailDrawingContext _tmp8_;
	GtkStyleContext* _tmp9_;
	GamesGameThumbnailDrawingContext _tmp10_;
	GtkStyleContext* _tmp11_;
	GamesGameThumbnailDrawingContext _tmp12_;
	gboolean result;
#line 82 "../src/ui/game-thumbnail.vala"
	self = (GamesGameThumbnail*) base;
#line 82 "../src/ui/game-thumbnail.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 83 "../src/ui/game-thumbnail.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 83 "../src/ui/game-thumbnail.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 83 "../src/ui/game-thumbnail.vala"
	style = _tmp1_;
#line 84 "../src/ui/game-thumbnail.vala"
	state = gtk_widget_get_state_flags ((GtkWidget*) self);
#line 85 "../src/ui/game-thumbnail.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 86 "../src/ui/game-thumbnail.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp2_ = _cairo_reference0 (cr);
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp3_ = style;
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 88 "../src/ui/game-thumbnail.vala"
	_cairo_destroy0 (_tmp5_.cr);
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp5_.cr = _tmp2_;
#line 88 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (_tmp5_.style);
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp5_.style = _tmp4_;
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp5_.state = state;
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp5_.width = width;
#line 88 "../src/ui/game-thumbnail.vala"
	_tmp5_.height = height;
#line 88 "../src/ui/game-thumbnail.vala"
	context = _tmp5_;
#line 92 "../src/ui/game-thumbnail.vala"
	_tmp6_ = self->priv->icon;
#line 92 "../src/ui/game-thumbnail.vala"
	if (_tmp6_ == NULL) {
#line 93 "../src/ui/game-thumbnail.vala"
		result = GDK_EVENT_PROPAGATE;
#line 93 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_drawing_context_destroy (&context);
#line 93 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (style);
#line 93 "../src/ui/game-thumbnail.vala"
		return result;
#line 343 "game-thumbnail.c"
	}
#line 95 "../src/ui/game-thumbnail.vala"
	_tmp7_ = self->priv->cover;
#line 95 "../src/ui/game-thumbnail.vala"
	if (_tmp7_ == NULL) {
#line 96 "../src/ui/game-thumbnail.vala"
		result = GDK_EVENT_PROPAGATE;
#line 96 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_drawing_context_destroy (&context);
#line 96 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (style);
#line 96 "../src/ui/game-thumbnail.vala"
		return result;
#line 357 "game-thumbnail.c"
	}
#line 98 "../src/ui/game-thumbnail.vala"
	_tmp8_ = context;
#line 98 "../src/ui/game-thumbnail.vala"
	_tmp9_ = _tmp8_.style;
#line 98 "../src/ui/game-thumbnail.vala"
	gtk_render_background (_tmp9_, cr, 0.0, 0.0, (gdouble) width, (gdouble) height);
#line 99 "../src/ui/game-thumbnail.vala"
	_tmp10_ = context;
#line 99 "../src/ui/game-thumbnail.vala"
	_tmp11_ = _tmp10_.style;
#line 99 "../src/ui/game-thumbnail.vala"
	gtk_render_frame (_tmp11_, cr, 0.0, 0.0, (gdouble) width, (gdouble) height);
#line 101 "../src/ui/game-thumbnail.vala"
	_tmp12_ = context;
#line 101 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_draw_image (self, &_tmp12_);
#line 103 "../src/ui/game-thumbnail.vala"
	result = GDK_EVENT_PROPAGATE;
#line 103 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_drawing_context_destroy (&context);
#line 103 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (style);
#line 103 "../src/ui/game-thumbnail.vala"
	return result;
#line 383 "game-thumbnail.c"
}

static void
games_game_thumbnail_update_style_classes (GamesGameThumbnail* self)
{
	GdkPixbuf* _tmp0_;
	gboolean _tmp3_ = FALSE;
	GdkPixbuf* _tmp4_;
#line 106 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/ui/game-thumbnail.vala"
	_tmp0_ = self->priv->cover_pixbuf;
#line 107 "../src/ui/game-thumbnail.vala"
	if (_tmp0_ != NULL) {
#line 398 "game-thumbnail.c"
		GtkStyleContext* _tmp1_;
#line 108 "../src/ui/game-thumbnail.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 108 "../src/ui/game-thumbnail.vala"
		gtk_style_context_add_class (_tmp1_, "cover");
#line 404 "game-thumbnail.c"
	} else {
		GtkStyleContext* _tmp2_;
#line 110 "../src/ui/game-thumbnail.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 110 "../src/ui/game-thumbnail.vala"
		gtk_style_context_remove_class (_tmp2_, "cover");
#line 411 "game-thumbnail.c"
	}
#line 112 "../src/ui/game-thumbnail.vala"
	_tmp4_ = self->priv->icon_pixbuf;
#line 112 "../src/ui/game-thumbnail.vala"
	if (_tmp4_ != NULL) {
#line 417 "game-thumbnail.c"
		GdkPixbuf* _tmp5_;
#line 112 "../src/ui/game-thumbnail.vala"
		_tmp5_ = self->priv->cover_pixbuf;
#line 112 "../src/ui/game-thumbnail.vala"
		_tmp3_ = _tmp5_ == NULL;
#line 423 "game-thumbnail.c"
	} else {
#line 112 "../src/ui/game-thumbnail.vala"
		_tmp3_ = FALSE;
#line 427 "game-thumbnail.c"
	}
#line 112 "../src/ui/game-thumbnail.vala"
	if (_tmp3_) {
#line 431 "game-thumbnail.c"
		GtkStyleContext* _tmp6_;
#line 113 "../src/ui/game-thumbnail.vala"
		_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 113 "../src/ui/game-thumbnail.vala"
		gtk_style_context_add_class (_tmp6_, "icon");
#line 437 "game-thumbnail.c"
	} else {
		GtkStyleContext* _tmp7_;
#line 115 "../src/ui/game-thumbnail.vala"
		_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 115 "../src/ui/game-thumbnail.vala"
		gtk_style_context_remove_class (_tmp7_, "icon");
#line 444 "game-thumbnail.c"
	}
}

void
games_game_thumbnail_draw_image (GamesGameThumbnail* self,
                                 GamesGameThumbnailDrawingContext* context)
{
	GdkPixbuf* cover = NULL;
	GdkPixbuf* icon = NULL;
	GamesGameThumbnailDrawingContext _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* emblem = NULL;
	GamesGameThumbnailDrawingContext _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
#line 118 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (context != NULL);
#line 120 "../src/ui/game-thumbnail.vala"
	_tmp0_ = *context;
#line 120 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_get_icon_and_cover (self, &_tmp0_, &_tmp1_, &_tmp2_);
#line 120 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (cover);
#line 120 "../src/ui/game-thumbnail.vala"
	cover = _tmp1_;
#line 120 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (icon);
#line 120 "../src/ui/game-thumbnail.vala"
	icon = _tmp2_;
#line 122 "../src/ui/game-thumbnail.vala"
	_tmp3_ = cover;
#line 122 "../src/ui/game-thumbnail.vala"
	if (_tmp3_ != NULL) {
#line 483 "game-thumbnail.c"
		GamesGameThumbnailDrawingContext _tmp4_;
		GdkPixbuf* _tmp5_;
#line 123 "../src/ui/game-thumbnail.vala"
		_tmp4_ = *context;
#line 123 "../src/ui/game-thumbnail.vala"
		_tmp5_ = cover;
#line 123 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_draw_pixbuf (self, &_tmp4_, _tmp5_);
#line 125 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (icon);
#line 125 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (cover);
#line 125 "../src/ui/game-thumbnail.vala"
		return;
#line 498 "game-thumbnail.c"
	}
#line 128 "../src/ui/game-thumbnail.vala"
	_tmp6_ = icon;
#line 128 "../src/ui/game-thumbnail.vala"
	if (_tmp6_ != NULL) {
#line 504 "game-thumbnail.c"
		GamesGameThumbnailDrawingContext _tmp7_;
		GdkPixbuf* _tmp8_;
#line 129 "../src/ui/game-thumbnail.vala"
		_tmp7_ = *context;
#line 129 "../src/ui/game-thumbnail.vala"
		_tmp8_ = icon;
#line 129 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_draw_pixbuf (self, &_tmp7_, _tmp8_);
#line 131 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (icon);
#line 131 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (cover);
#line 131 "../src/ui/game-thumbnail.vala"
		return;
#line 519 "game-thumbnail.c"
	}
#line 134 "../src/ui/game-thumbnail.vala"
	_tmp9_ = *context;
#line 134 "../src/ui/game-thumbnail.vala"
	_tmp10_ = games_game_thumbnail_get_emblem (self, &_tmp9_);
#line 134 "../src/ui/game-thumbnail.vala"
	emblem = _tmp10_;
#line 136 "../src/ui/game-thumbnail.vala"
	_tmp11_ = emblem;
#line 136 "../src/ui/game-thumbnail.vala"
	if (_tmp11_ != NULL) {
#line 531 "game-thumbnail.c"
		GamesGameThumbnailDrawingContext _tmp12_;
		GdkPixbuf* _tmp13_;
#line 137 "../src/ui/game-thumbnail.vala"
		_tmp12_ = *context;
#line 137 "../src/ui/game-thumbnail.vala"
		_tmp13_ = emblem;
#line 137 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_draw_pixbuf (self, &_tmp12_, _tmp13_);
#line 540 "game-thumbnail.c"
	}
#line 118 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (emblem);
#line 118 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (icon);
#line 118 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (cover);
#line 548 "game-thumbnail.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 561 "game-thumbnail.c"
}

static GdkPixbuf*
games_game_thumbnail_get_emblem (GamesGameThumbnail* self,
                                 GamesGameThumbnailDrawingContext* context)
{
	gchar* icon_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GdkPixbuf* emblem = NULL;
	GdkRGBA color = {0};
	GamesGameThumbnailDrawingContext _tmp2_;
	GtkStyleContext* _tmp3_;
	GamesGameThumbnailDrawingContext _tmp4_;
	GdkRGBA _tmp5_ = {0};
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp6_;
	GtkIconTheme* _tmp7_;
	gdouble size = 0.0;
	GamesGameThumbnailDrawingContext _tmp8_;
	GamesGameThumbnailDrawingContext _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 140 "../src/ui/game-thumbnail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../src/ui/game-thumbnail.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 141 "../src/ui/game-thumbnail.vala"
	_tmp0_ = string_to_string (APPLICATION_ID);
#line 141 "../src/ui/game-thumbnail.vala"
	_tmp1_ = g_strconcat (_tmp0_, "-symbolic", NULL);
#line 141 "../src/ui/game-thumbnail.vala"
	icon_name = _tmp1_;
#line 142 "../src/ui/game-thumbnail.vala"
	emblem = NULL;
#line 144 "../src/ui/game-thumbnail.vala"
	_tmp2_ = *context;
#line 144 "../src/ui/game-thumbnail.vala"
	_tmp3_ = _tmp2_.style;
#line 144 "../src/ui/game-thumbnail.vala"
	_tmp4_ = *context;
#line 144 "../src/ui/game-thumbnail.vala"
	gtk_style_context_get_color (_tmp3_, _tmp4_.state, &_tmp5_);
#line 144 "../src/ui/game-thumbnail.vala"
	color = _tmp5_;
#line 146 "../src/ui/game-thumbnail.vala"
	_tmp6_ = gtk_icon_theme_get_default ();
#line 146 "../src/ui/game-thumbnail.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 146 "../src/ui/game-thumbnail.vala"
	theme = _tmp7_;
#line 147 "../src/ui/game-thumbnail.vala"
	_tmp8_ = *context;
#line 147 "../src/ui/game-thumbnail.vala"
	_tmp9_ = *context;
#line 147 "../src/ui/game-thumbnail.vala"
	_tmp10_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 147 "../src/ui/game-thumbnail.vala"
	_tmp11_ = _tmp10_;
#line 147 "../src/ui/game-thumbnail.vala"
	size = (MIN (_tmp8_.width, _tmp9_.height) * GAMES_GAME_THUMBNAIL_EMBLEM_SCALE) * _tmp11_;
#line 148 "../src/ui/game-thumbnail.vala"
	_tmp12_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 148 "../src/ui/game-thumbnail.vala"
	_tmp13_ = _tmp12_;
#line 148 "../src/ui/game-thumbnail.vala"
	size = MAX (size, GAMES_GAME_THUMBNAIL_EMBLEM_MIN_SIZE * _tmp13_);
#line 633 "game-thumbnail.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconInfo* _tmp14_;
		GdkPixbuf* _tmp15_ = NULL;
		GdkRGBA _tmp16_;
		GdkPixbuf* _tmp17_;
		GdkPixbuf* _tmp18_;
#line 150 "../src/ui/game-thumbnail.vala"
		_tmp14_ = gtk_icon_theme_lookup_icon (theme, icon_name, (gint) size, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 150 "../src/ui/game-thumbnail.vala"
		icon_info = _tmp14_;
#line 151 "../src/ui/game-thumbnail.vala"
		_tmp16_ = color;
#line 151 "../src/ui/game-thumbnail.vala"
		_tmp17_ = gtk_icon_info_load_symbolic (icon_info, &_tmp16_, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 151 "../src/ui/game-thumbnail.vala"
		_tmp15_ = _tmp17_;
#line 151 "../src/ui/game-thumbnail.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/ui/game-thumbnail.vala"
			_g_object_unref0 (icon_info);
#line 655 "game-thumbnail.c"
			goto __catch0_g_error;
		}
#line 151 "../src/ui/game-thumbnail.vala"
		_tmp18_ = _tmp15_;
#line 151 "../src/ui/game-thumbnail.vala"
		_tmp15_ = NULL;
#line 151 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (emblem);
#line 151 "../src/ui/game-thumbnail.vala"
		emblem = _tmp18_;
#line 149 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (_tmp15_);
#line 149 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (icon_info);
#line 670 "game-thumbnail.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 149 "../src/ui/game-thumbnail.vala"
		_error_ = _inner_error0_;
#line 149 "../src/ui/game-thumbnail.vala"
		_inner_error0_ = NULL;
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp19_ = string_to_string (icon_name);
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp20_ = _error_;
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp21_ = _tmp20_->message;
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp22_ = string_to_string (_tmp21_);
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp23_ = g_strconcat ("Unable to get icon “", _tmp19_, "”: ", _tmp22_, NULL);
#line 154 "../src/ui/game-thumbnail.vala"
		_tmp24_ = _tmp23_;
#line 154 "../src/ui/game-thumbnail.vala"
		g_warning ("game-thumbnail.vala:154: %s", _tmp24_);
#line 154 "../src/ui/game-thumbnail.vala"
		_g_free0 (_tmp24_);
#line 149 "../src/ui/game-thumbnail.vala"
		_g_error_free0 (_error_);
#line 704 "game-thumbnail.c"
	}
	__finally0:
#line 149 "../src/ui/game-thumbnail.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (theme);
#line 149 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (emblem);
#line 149 "../src/ui/game-thumbnail.vala"
		_g_free0 (icon_name);
#line 149 "../src/ui/game-thumbnail.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/ui/game-thumbnail.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/ui/game-thumbnail.vala"
		return NULL;
#line 721 "game-thumbnail.c"
	}
#line 157 "../src/ui/game-thumbnail.vala"
	result = emblem;
#line 157 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (theme);
#line 157 "../src/ui/game-thumbnail.vala"
	_g_free0 (icon_name);
#line 157 "../src/ui/game-thumbnail.vala"
	return result;
#line 731 "game-thumbnail.c"
}

static void
__lambda20_ (GamesGameThumbnail* self,
             gint scale_factor,
             gint cover_size,
             GdkPixbuf* cover_pixbuf,
             gint icon_size,
             GdkPixbuf* icon_pixbuf)
{
	gboolean _tmp0_ = FALSE;
#line 184 "../src/ui/game-thumbnail.vala"
	if (scale_factor != self->priv->last_scale_factor) {
#line 184 "../src/ui/game-thumbnail.vala"
		_tmp0_ = TRUE;
#line 747 "game-thumbnail.c"
	} else {
#line 184 "../src/ui/game-thumbnail.vala"
		_tmp0_ = cover_size != self->priv->last_cover_size;
#line 751 "game-thumbnail.c"
	}
#line 184 "../src/ui/game-thumbnail.vala"
	if (_tmp0_) {
#line 185 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (self->priv->cover_pixbuf);
#line 185 "../src/ui/game-thumbnail.vala"
		self->priv->cover_pixbuf = NULL;
#line 186 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (self->priv->icon_pixbuf);
#line 186 "../src/ui/game-thumbnail.vala"
		self->priv->icon_pixbuf = NULL;
#line 188 "../src/ui/game-thumbnail.vala"
		self->priv->try_load_cover = TRUE;
#line 765 "game-thumbnail.c"
	} else {
#line 191 "../src/ui/game-thumbnail.vala"
		if (cover_pixbuf != NULL) {
#line 769 "game-thumbnail.c"
			GdkPixbuf* _tmp1_;
#line 192 "../src/ui/game-thumbnail.vala"
			_tmp1_ = _g_object_ref0 (cover_pixbuf);
#line 192 "../src/ui/game-thumbnail.vala"
			_g_object_unref0 (self->priv->cover_pixbuf);
#line 192 "../src/ui/game-thumbnail.vala"
			self->priv->cover_pixbuf = _tmp1_;
#line 777 "game-thumbnail.c"
		}
#line 194 "../src/ui/game-thumbnail.vala"
		if (icon_pixbuf != NULL) {
#line 781 "game-thumbnail.c"
			GdkPixbuf* _tmp2_;
#line 195 "../src/ui/game-thumbnail.vala"
			_tmp2_ = _g_object_ref0 (icon_pixbuf);
#line 195 "../src/ui/game-thumbnail.vala"
			_g_object_unref0 (self->priv->icon_pixbuf);
#line 195 "../src/ui/game-thumbnail.vala"
			self->priv->icon_pixbuf = _tmp2_;
#line 789 "game-thumbnail.c"
		}
	}
#line 198 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_update_style_classes (self);
#line 200 "../src/ui/game-thumbnail.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 796 "game-thumbnail.c"
}

static void
___lambda20__games_cover_loader_cover_ready_callback (gint scale_factor,
                                                      gint cover_size,
                                                      GdkPixbuf* cover_pixbuf,
                                                      gint icon_size,
                                                      GdkPixbuf* icon_pixbuf,
                                                      gpointer self)
{
#line 183 "../src/ui/game-thumbnail.vala"
	__lambda20_ ((GamesGameThumbnail*) self, scale_factor, cover_size, cover_pixbuf, icon_size, icon_pixbuf);
#line 809 "game-thumbnail.c"
}

static void
games_game_thumbnail_get_icon_and_cover (GamesGameThumbnail* self,
                                         GamesGameThumbnailDrawingContext* context,
                                         GdkPixbuf** cover,
                                         GdkPixbuf** icon)
{
	GdkPixbuf* _vala_cover = NULL;
	GdkPixbuf* _vala_icon = NULL;
	gint cover_size = 0;
	GamesGameThumbnailDrawingContext _tmp0_;
	GamesGameThumbnailDrawingContext _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint icon_size = 0;
	gboolean _tmp4_ = FALSE;
	GamesCoverLoader* loader = NULL;
	GamesApplication* _tmp11_;
	GamesApplication* _tmp12_;
	GamesCoverLoader* _tmp13_;
	GamesCoverLoader* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GamesCoverLoader* _tmp17_;
	GamesGame* _tmp18_;
	GamesGame* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GdkPixbuf* _tmp22_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* _tmp25_;
#line 160 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (context != NULL);
#line 161 "../src/ui/game-thumbnail.vala"
	_tmp0_ = *context;
#line 161 "../src/ui/game-thumbnail.vala"
	_tmp1_ = *context;
#line 161 "../src/ui/game-thumbnail.vala"
	_tmp2_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 161 "../src/ui/game-thumbnail.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/ui/game-thumbnail.vala"
	cover_size = MIN (_tmp0_.width, _tmp1_.height) * _tmp3_;
#line 162 "../src/ui/game-thumbnail.vala"
	icon_size = (gint) (cover_size * GAMES_GAME_THUMBNAIL_ICON_SCALE);
#line 164 "../src/ui/game-thumbnail.vala"
	if (cover_size != self->priv->last_cover_size) {
#line 164 "../src/ui/game-thumbnail.vala"
		_tmp4_ = TRUE;
#line 863 "game-thumbnail.c"
	} else {
		gint _tmp5_;
		gint _tmp6_;
#line 164 "../src/ui/game-thumbnail.vala"
		_tmp5_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 164 "../src/ui/game-thumbnail.vala"
		_tmp6_ = _tmp5_;
#line 164 "../src/ui/game-thumbnail.vala"
		_tmp4_ = _tmp6_ != self->priv->last_scale_factor;
#line 873 "game-thumbnail.c"
	}
#line 164 "../src/ui/game-thumbnail.vala"
	if (_tmp4_) {
#line 165 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (self->priv->cover_pixbuf);
#line 165 "../src/ui/game-thumbnail.vala"
		self->priv->cover_pixbuf = NULL;
#line 166 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (self->priv->icon_pixbuf);
#line 166 "../src/ui/game-thumbnail.vala"
		self->priv->icon_pixbuf = NULL;
#line 167 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_update_style_classes (self);
#line 168 "../src/ui/game-thumbnail.vala"
		self->priv->try_load_cover = TRUE;
#line 889 "game-thumbnail.c"
	}
#line 171 "../src/ui/game-thumbnail.vala"
	if (!self->priv->try_load_cover) {
#line 893 "game-thumbnail.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_;
#line 172 "../src/ui/game-thumbnail.vala"
		_tmp7_ = self->priv->cover_pixbuf;
#line 172 "../src/ui/game-thumbnail.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 172 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (_vala_cover);
#line 172 "../src/ui/game-thumbnail.vala"
		_vala_cover = _tmp8_;
#line 173 "../src/ui/game-thumbnail.vala"
		_tmp9_ = self->priv->icon_pixbuf;
#line 173 "../src/ui/game-thumbnail.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 173 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (_vala_icon);
#line 173 "../src/ui/game-thumbnail.vala"
		_vala_icon = _tmp10_;
#line 174 "../src/ui/game-thumbnail.vala"
		if (cover) {
#line 174 "../src/ui/game-thumbnail.vala"
			*cover = _vala_cover;
#line 918 "game-thumbnail.c"
		} else {
#line 174 "../src/ui/game-thumbnail.vala"
			_g_object_unref0 (_vala_cover);
#line 922 "game-thumbnail.c"
		}
#line 174 "../src/ui/game-thumbnail.vala"
		if (icon) {
#line 174 "../src/ui/game-thumbnail.vala"
			*icon = _vala_icon;
#line 928 "game-thumbnail.c"
		} else {
#line 174 "../src/ui/game-thumbnail.vala"
			_g_object_unref0 (_vala_icon);
#line 932 "game-thumbnail.c"
		}
#line 174 "../src/ui/game-thumbnail.vala"
		return;
#line 936 "game-thumbnail.c"
	}
#line 177 "../src/ui/game-thumbnail.vala"
	_tmp11_ = games_application_get_default ();
#line 177 "../src/ui/game-thumbnail.vala"
	_tmp12_ = _tmp11_;
#line 177 "../src/ui/game-thumbnail.vala"
	_tmp13_ = games_application_get_cover_loader (_tmp12_);
#line 177 "../src/ui/game-thumbnail.vala"
	_tmp14_ = _tmp13_;
#line 177 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (_tmp12_);
#line 177 "../src/ui/game-thumbnail.vala"
	loader = _tmp14_;
#line 179 "../src/ui/game-thumbnail.vala"
	self->priv->last_cover_size = cover_size;
#line 180 "../src/ui/game-thumbnail.vala"
	_tmp15_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 180 "../src/ui/game-thumbnail.vala"
	_tmp16_ = _tmp15_;
#line 180 "../src/ui/game-thumbnail.vala"
	self->priv->last_scale_factor = _tmp16_;
#line 182 "../src/ui/game-thumbnail.vala"
	self->priv->try_load_cover = FALSE;
#line 183 "../src/ui/game-thumbnail.vala"
	_tmp17_ = loader;
#line 183 "../src/ui/game-thumbnail.vala"
	_tmp18_ = games_game_thumbnail_get_game (self);
#line 183 "../src/ui/game-thumbnail.vala"
	_tmp19_ = _tmp18_;
#line 183 "../src/ui/game-thumbnail.vala"
	_tmp20_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 183 "../src/ui/game-thumbnail.vala"
	_tmp21_ = _tmp20_;
#line 183 "../src/ui/game-thumbnail.vala"
	games_cover_loader_fetch_cover (_tmp17_, _tmp19_, _tmp21_, cover_size, icon_size, ___lambda20__games_cover_loader_cover_ready_callback, self);
#line 203 "../src/ui/game-thumbnail.vala"
	_tmp22_ = self->priv->cover_pixbuf;
#line 203 "../src/ui/game-thumbnail.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 203 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (_vala_cover);
#line 203 "../src/ui/game-thumbnail.vala"
	_vala_cover = _tmp23_;
#line 204 "../src/ui/game-thumbnail.vala"
	_tmp24_ = self->priv->icon_pixbuf;
#line 204 "../src/ui/game-thumbnail.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 204 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (_vala_icon);
#line 204 "../src/ui/game-thumbnail.vala"
	_vala_icon = _tmp25_;
#line 160 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (loader);
#line 160 "../src/ui/game-thumbnail.vala"
	if (cover) {
#line 160 "../src/ui/game-thumbnail.vala"
		*cover = _vala_cover;
#line 994 "game-thumbnail.c"
	} else {
#line 160 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (_vala_cover);
#line 998 "game-thumbnail.c"
	}
#line 160 "../src/ui/game-thumbnail.vala"
	if (icon) {
#line 160 "../src/ui/game-thumbnail.vala"
		*icon = _vala_icon;
#line 1004 "game-thumbnail.c"
	} else {
#line 160 "../src/ui/game-thumbnail.vala"
		_g_object_unref0 (_vala_icon);
#line 1008 "game-thumbnail.c"
	}
}

static void
games_game_thumbnail_draw_pixbuf (GamesGameThumbnail* self,
                                  GamesGameThumbnailDrawingContext* context,
                                  GdkPixbuf* pixbuf)
{
	GamesGameThumbnailDrawingContext _tmp0_;
	cairo_t* _tmp1_;
	gint border_radius = 0;
	GamesGameThumbnailDrawingContext _tmp2_;
	GtkStyleContext* _tmp3_;
	GamesGameThumbnailDrawingContext _tmp4_;
	GValue _tmp5_ = {0};
	GValue _tmp6_;
	gint _tmp7_;
	GamesGameThumbnailDrawingContext _tmp8_;
	GamesGameThumbnailDrawingContext _tmp9_;
	GamesGameThumbnailDrawingContext _tmp10_;
	cairo_t* _tmp11_;
	GamesGameThumbnailDrawingContext _tmp12_;
	GamesGameThumbnailDrawingContext _tmp13_;
	GamesGameThumbnailDrawingContext _tmp14_;
	cairo_t* _tmp15_;
	gint x_offset = 0;
	GamesGameThumbnailDrawingContext _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint y_offset = 0;
	GamesGameThumbnailDrawingContext _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GamesGameThumbnailDrawingContext _tmp26_;
	cairo_t* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GamesGameThumbnailDrawingContext _tmp32_;
	cairo_t* _tmp33_;
	GamesGameThumbnailDrawingContext _tmp34_;
	cairo_t* _tmp35_;
	GamesGameThumbnailDrawingContext _tmp36_;
	cairo_t* _tmp37_;
#line 207 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (context != NULL);
#line 207 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (pixbuf != NULL);
#line 208 "../src/ui/game-thumbnail.vala"
	_tmp0_ = *context;
#line 208 "../src/ui/game-thumbnail.vala"
	_tmp1_ = _tmp0_.cr;
#line 208 "../src/ui/game-thumbnail.vala"
	cairo_save (_tmp1_);
#line 210 "../src/ui/game-thumbnail.vala"
	_tmp2_ = *context;
#line 210 "../src/ui/game-thumbnail.vala"
	_tmp3_ = _tmp2_.style;
#line 210 "../src/ui/game-thumbnail.vala"
	_tmp4_ = *context;
#line 210 "../src/ui/game-thumbnail.vala"
	gtk_style_context_get_property (_tmp3_, GTK_STYLE_PROPERTY_BORDER_RADIUS, _tmp4_.state, &_tmp5_);
#line 210 "../src/ui/game-thumbnail.vala"
	_tmp6_ = _tmp5_;
#line 210 "../src/ui/game-thumbnail.vala"
	_tmp7_ = g_value_get_int (&_tmp5_);
#line 210 "../src/ui/game-thumbnail.vala"
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 210 "../src/ui/game-thumbnail.vala"
	border_radius = _tmp7_;
#line 211 "../src/ui/game-thumbnail.vala"
	_tmp8_ = *context;
#line 211 "../src/ui/game-thumbnail.vala"
	_tmp9_ = *context;
#line 211 "../src/ui/game-thumbnail.vala"
	border_radius = CLAMP (border_radius, 0, MAX (_tmp8_.width / 2, _tmp9_.height / 2));
#line 213 "../src/ui/game-thumbnail.vala"
	_tmp10_ = *context;
#line 213 "../src/ui/game-thumbnail.vala"
	_tmp11_ = _tmp10_.cr;
#line 213 "../src/ui/game-thumbnail.vala"
	_tmp12_ = *context;
#line 213 "../src/ui/game-thumbnail.vala"
	_tmp13_ = *context;
#line 213 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_rounded_rectangle (self, _tmp11_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp12_.width, (gdouble) _tmp13_.height, (gdouble) border_radius);
#line 214 "../src/ui/game-thumbnail.vala"
	_tmp14_ = *context;
#line 214 "../src/ui/game-thumbnail.vala"
	_tmp15_ = _tmp14_.cr;
#line 214 "../src/ui/game-thumbnail.vala"
	cairo_clip (_tmp15_);
#line 216 "../src/ui/game-thumbnail.vala"
	_tmp16_ = *context;
#line 216 "../src/ui/game-thumbnail.vala"
	_tmp17_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 216 "../src/ui/game-thumbnail.vala"
	_tmp18_ = _tmp17_;
#line 216 "../src/ui/game-thumbnail.vala"
	_tmp19_ = gdk_pixbuf_get_width (pixbuf);
#line 216 "../src/ui/game-thumbnail.vala"
	_tmp20_ = _tmp19_;
#line 216 "../src/ui/game-thumbnail.vala"
	x_offset = ((_tmp16_.width * _tmp18_) - _tmp20_) / 2;
#line 217 "../src/ui/game-thumbnail.vala"
	_tmp21_ = *context;
#line 217 "../src/ui/game-thumbnail.vala"
	_tmp22_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 217 "../src/ui/game-thumbnail.vala"
	_tmp23_ = _tmp22_;
#line 217 "../src/ui/game-thumbnail.vala"
	_tmp24_ = gdk_pixbuf_get_height (pixbuf);
#line 217 "../src/ui/game-thumbnail.vala"
	_tmp25_ = _tmp24_;
#line 217 "../src/ui/game-thumbnail.vala"
	y_offset = ((_tmp21_.height * _tmp23_) - _tmp25_) / 2;
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp26_ = *context;
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp27_ = _tmp26_.cr;
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp28_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp29_ = _tmp28_;
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp30_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 219 "../src/ui/game-thumbnail.vala"
	_tmp31_ = _tmp30_;
#line 219 "../src/ui/game-thumbnail.vala"
	cairo_scale (_tmp27_, 1.0 / _tmp29_, 1.0 / _tmp31_);
#line 221 "../src/ui/game-thumbnail.vala"
	_tmp32_ = *context;
#line 221 "../src/ui/game-thumbnail.vala"
	_tmp33_ = _tmp32_.cr;
#line 221 "../src/ui/game-thumbnail.vala"
	gdk_cairo_set_source_pixbuf (_tmp33_, pixbuf, (gdouble) x_offset, (gdouble) y_offset);
#line 222 "../src/ui/game-thumbnail.vala"
	_tmp34_ = *context;
#line 222 "../src/ui/game-thumbnail.vala"
	_tmp35_ = _tmp34_.cr;
#line 222 "../src/ui/game-thumbnail.vala"
	cairo_paint (_tmp35_);
#line 224 "../src/ui/game-thumbnail.vala"
	_tmp36_ = *context;
#line 224 "../src/ui/game-thumbnail.vala"
	_tmp37_ = _tmp36_.cr;
#line 224 "../src/ui/game-thumbnail.vala"
	cairo_restore (_tmp37_);
#line 1164 "game-thumbnail.c"
}

static void
games_game_thumbnail_rounded_rectangle (GamesGameThumbnail* self,
                                        cairo_t* cr,
                                        gdouble x,
                                        gdouble y,
                                        gdouble width,
                                        gdouble height,
                                        gdouble radius)
{
#line 228 "../src/ui/game-thumbnail.vala"
	static const gdouble ARC_0 = (gdouble) 0;
#line 229 "../src/ui/game-thumbnail.vala"
	static const gdouble ARC_1 = G_PI * 0.5;
#line 230 "../src/ui/game-thumbnail.vala"
	static const gdouble ARC_2 = G_PI;
#line 231 "../src/ui/game-thumbnail.vala"
	static const gdouble ARC_3 = G_PI * 1.5;
#line 227 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (cr != NULL);
#line 233 "../src/ui/game-thumbnail.vala"
	cairo_new_sub_path (cr);
#line 234 "../src/ui/game-thumbnail.vala"
	cairo_arc (cr, (x + width) - radius, y + radius, radius, ARC_3, ARC_0);
#line 235 "../src/ui/game-thumbnail.vala"
	cairo_arc (cr, (x + width) - radius, (y + height) - radius, radius, ARC_0, ARC_1);
#line 236 "../src/ui/game-thumbnail.vala"
	cairo_arc (cr, x + radius, (y + height) - radius, radius, ARC_1, ARC_2);
#line 237 "../src/ui/game-thumbnail.vala"
	cairo_arc (cr, x + radius, y + radius, radius, ARC_2, ARC_3);
#line 238 "../src/ui/game-thumbnail.vala"
	cairo_close_path (cr);
#line 1200 "game-thumbnail.c"
}

GamesGameThumbnail*
games_game_thumbnail_construct (GType object_type)
{
	GamesGameThumbnail * self = NULL;
#line 3 "../src/ui/game-thumbnail.vala"
	self = (GamesGameThumbnail*) g_object_new (object_type, NULL);
#line 3 "../src/ui/game-thumbnail.vala"
	return self;
#line 1211 "game-thumbnail.c"
}

GamesGameThumbnail*
games_game_thumbnail_new (void)
{
#line 3 "../src/ui/game-thumbnail.vala"
	return games_game_thumbnail_construct (GAMES_TYPE_GAME_THUMBNAIL);
#line 1219 "game-thumbnail.c"
}

GamesGame*
games_game_thumbnail_get_game (GamesGameThumbnail* self)
{
	GamesGame* result;
	GamesGame* _tmp0_;
#line 14 "../src/ui/game-thumbnail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/ui/game-thumbnail.vala"
	_tmp0_ = self->priv->_game;
#line 14 "../src/ui/game-thumbnail.vala"
	result = _tmp0_;
#line 14 "../src/ui/game-thumbnail.vala"
	return result;
#line 1235 "game-thumbnail.c"
}

static void
_games_game_thumbnail_game____lambda19_ (GamesGameThumbnail* self)
{
#line 30 "../src/ui/game-thumbnail.vala"
	self->priv->try_load_cover = TRUE;
#line 31 "../src/ui/game-thumbnail.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1245 "game-thumbnail.c"
}

static void
__games_game_thumbnail_game____lambda19__games_cover_changed (GamesCover* _sender,
                                                              gpointer self)
{
#line 29 "../src/ui/game-thumbnail.vala"
	_games_game_thumbnail_game____lambda19_ ((GamesGameThumbnail*) self);
#line 1254 "game-thumbnail.c"
}

void
games_game_thumbnail_set_game (GamesGameThumbnail* self,
                               GamesGame* value)
{
	GamesGame* _tmp0_;
	GamesCover* _tmp1_;
	GamesGame* _tmp3_;
	GamesGame* _tmp4_;
	GamesGame* _tmp5_;
	GamesIcon* _tmp6_;
	GamesGame* _tmp7_;
	GamesGame* _tmp8_;
	GamesCover* _tmp9_;
	GamesCover* _tmp10_;
#line 15 "../src/ui/game-thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/ui/game-thumbnail.vala"
	_tmp0_ = self->priv->_game;
#line 16 "../src/ui/game-thumbnail.vala"
	if (_tmp0_ == value) {
#line 17 "../src/ui/game-thumbnail.vala"
		return;
#line 1279 "game-thumbnail.c"
	}
#line 19 "../src/ui/game-thumbnail.vala"
	_tmp1_ = self->priv->cover;
#line 19 "../src/ui/game-thumbnail.vala"
	if (_tmp1_ != NULL) {
#line 1285 "game-thumbnail.c"
		GamesCover* _tmp2_;
#line 20 "../src/ui/game-thumbnail.vala"
		_tmp2_ = self->priv->cover;
#line 20 "../src/ui/game-thumbnail.vala"
		g_signal_handler_disconnect ((GObject*) _tmp2_, self->priv->cover_changed_id);
#line 1291 "game-thumbnail.c"
	}
#line 22 "../src/ui/game-thumbnail.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 22 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->_game);
#line 22 "../src/ui/game-thumbnail.vala"
	self->priv->_game = _tmp3_;
#line 23 "../src/ui/game-thumbnail.vala"
	_tmp4_ = games_game_thumbnail_get_game (self);
#line 23 "../src/ui/game-thumbnail.vala"
	_tmp5_ = _tmp4_;
#line 23 "../src/ui/game-thumbnail.vala"
	_tmp6_ = games_game_get_icon (_tmp5_);
#line 23 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->icon);
#line 23 "../src/ui/game-thumbnail.vala"
	self->priv->icon = _tmp6_;
#line 24 "../src/ui/game-thumbnail.vala"
	_tmp7_ = games_game_thumbnail_get_game (self);
#line 24 "../src/ui/game-thumbnail.vala"
	_tmp8_ = _tmp7_;
#line 24 "../src/ui/game-thumbnail.vala"
	_tmp9_ = games_game_get_cover (_tmp8_);
#line 24 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->cover);
#line 24 "../src/ui/game-thumbnail.vala"
	self->priv->cover = _tmp9_;
#line 26 "../src/ui/game-thumbnail.vala"
	self->priv->try_load_cover = TRUE;
#line 28 "../src/ui/game-thumbnail.vala"
	_tmp10_ = self->priv->cover;
#line 28 "../src/ui/game-thumbnail.vala"
	if (_tmp10_ != NULL) {
#line 1325 "game-thumbnail.c"
		GamesCover* _tmp11_;
		gulong _tmp12_;
#line 29 "../src/ui/game-thumbnail.vala"
		_tmp11_ = self->priv->cover;
#line 29 "../src/ui/game-thumbnail.vala"
		_tmp12_ = g_signal_connect_object (_tmp11_, "changed", (GCallback) __games_game_thumbnail_game____lambda19__games_cover_changed, self, 0);
#line 29 "../src/ui/game-thumbnail.vala"
		self->priv->cover_changed_id = _tmp12_;
#line 1334 "game-thumbnail.c"
	}
#line 34 "../src/ui/game-thumbnail.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 15 "../src/ui/game-thumbnail.vala"
	g_object_notify_by_pspec ((GObject *) self, games_game_thumbnail_properties[GAMES_GAME_THUMBNAIL_GAME_PROPERTY]);
#line 1340 "game-thumbnail.c"
}

void
games_game_thumbnail_drawing_context_copy (const GamesGameThumbnailDrawingContext* self,
                                           GamesGameThumbnailDrawingContext* dest)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 44 "../src/ui/game-thumbnail.vala"
	_tmp0_ = (*self).cr;
#line 44 "../src/ui/game-thumbnail.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 44 "../src/ui/game-thumbnail.vala"
	_cairo_destroy0 ((*dest).cr);
#line 44 "../src/ui/game-thumbnail.vala"
	(*dest).cr = _tmp1_;
#line 44 "../src/ui/game-thumbnail.vala"
	_tmp2_ = (*self).style;
#line 44 "../src/ui/game-thumbnail.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 44 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 ((*dest).style);
#line 44 "../src/ui/game-thumbnail.vala"
	(*dest).style = _tmp3_;
#line 44 "../src/ui/game-thumbnail.vala"
	(*dest).state = (*self).state;
#line 44 "../src/ui/game-thumbnail.vala"
	(*dest).width = (*self).width;
#line 44 "../src/ui/game-thumbnail.vala"
	(*dest).height = (*self).height;
#line 1373 "game-thumbnail.c"
}

void
games_game_thumbnail_drawing_context_destroy (GamesGameThumbnailDrawingContext* self)
{
#line 45 "../src/ui/game-thumbnail.vala"
	_cairo_destroy0 ((*self).cr);
#line 46 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 ((*self).style);
#line 1383 "game-thumbnail.c"
}

GamesGameThumbnailDrawingContext*
games_game_thumbnail_drawing_context_dup (const GamesGameThumbnailDrawingContext* self)
{
	GamesGameThumbnailDrawingContext* dup;
#line 44 "../src/ui/game-thumbnail.vala"
	dup = g_new0 (GamesGameThumbnailDrawingContext, 1);
#line 44 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_drawing_context_copy (self, dup);
#line 44 "../src/ui/game-thumbnail.vala"
	return dup;
#line 1396 "game-thumbnail.c"
}

void
games_game_thumbnail_drawing_context_free (GamesGameThumbnailDrawingContext* self)
{
#line 44 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_drawing_context_destroy (self);
#line 44 "../src/ui/game-thumbnail.vala"
	g_free (self);
#line 1406 "game-thumbnail.c"
}

static GType
games_game_thumbnail_drawing_context_get_type_once (void)
{
	GType games_game_thumbnail_drawing_context_type_id;
	games_game_thumbnail_drawing_context_type_id = g_boxed_type_register_static ("GamesGameThumbnailDrawingContext", (GBoxedCopyFunc) games_game_thumbnail_drawing_context_dup, (GBoxedFreeFunc) games_game_thumbnail_drawing_context_free);
	return games_game_thumbnail_drawing_context_type_id;
}

GType
games_game_thumbnail_drawing_context_get_type (void)
{
	static volatile gsize games_game_thumbnail_drawing_context_type_id__once = 0;
	if (g_once_init_enter (&games_game_thumbnail_drawing_context_type_id__once)) {
		GType games_game_thumbnail_drawing_context_type_id;
		games_game_thumbnail_drawing_context_type_id = games_game_thumbnail_drawing_context_get_type_once ();
		g_once_init_leave (&games_game_thumbnail_drawing_context_type_id__once, games_game_thumbnail_drawing_context_type_id);
	}
	return games_game_thumbnail_drawing_context_type_id__once;
}

static GObject *
games_game_thumbnail_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GamesGameThumbnail * self;
#line 52 "../src/ui/game-thumbnail.vala"
	parent_class = G_OBJECT_CLASS (games_game_thumbnail_parent_class);
#line 52 "../src/ui/game-thumbnail.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/ui/game-thumbnail.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnail);
#line 53 "../src/ui/game-thumbnail.vala"
	self->priv->try_load_cover = TRUE;
#line 52 "../src/ui/game-thumbnail.vala"
	return obj;
#line 1447 "game-thumbnail.c"
}

static void
games_game_thumbnail_class_init (GamesGameThumbnailClass * klass,
                                 gpointer klass_data)
{
#line 3 "../src/ui/game-thumbnail.vala"
	games_game_thumbnail_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/ui/game-thumbnail.vala"
	g_type_class_adjust_private_offset (klass, &GamesGameThumbnail_private_offset);
#line 3 "../src/ui/game-thumbnail.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) games_game_thumbnail_real_get_request_mode;
#line 3 "../src/ui/game-thumbnail.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) games_game_thumbnail_real_get_preferred_height_for_width;
#line 3 "../src/ui/game-thumbnail.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) games_game_thumbnail_real_size_allocate;
#line 3 "../src/ui/game-thumbnail.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) games_game_thumbnail_real_draw;
#line 3 "../src/ui/game-thumbnail.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_game_thumbnail_get_property;
#line 3 "../src/ui/game-thumbnail.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_game_thumbnail_set_property;
#line 3 "../src/ui/game-thumbnail.vala"
	G_OBJECT_CLASS (klass)->constructor = games_game_thumbnail_constructor;
#line 3 "../src/ui/game-thumbnail.vala"
	G_OBJECT_CLASS (klass)->finalize = games_game_thumbnail_finalize;
#line 3 "../src/ui/game-thumbnail.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GAME_THUMBNAIL_GAME_PROPERTY, games_game_thumbnail_properties[GAMES_GAME_THUMBNAIL_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", GAMES_TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 57 "../src/ui/game-thumbnail.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "gamesgamethumbnail");
#line 1478 "game-thumbnail.c"
}

static void
games_game_thumbnail_instance_init (GamesGameThumbnail * self,
                                    gpointer klass)
{
#line 3 "../src/ui/game-thumbnail.vala"
	self->priv = games_game_thumbnail_get_instance_private (self);
#line 1487 "game-thumbnail.c"
}

static void
games_game_thumbnail_finalize (GObject * obj)
{
	GamesGameThumbnail * self;
#line 3 "../src/ui/game-thumbnail.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnail);
#line 9 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->icon);
#line 10 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->cover);
#line 12 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->_game);
#line 38 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->cover_pixbuf);
#line 39 "../src/ui/game-thumbnail.vala"
	_g_object_unref0 (self->priv->icon_pixbuf);
#line 3 "../src/ui/game-thumbnail.vala"
	G_OBJECT_CLASS (games_game_thumbnail_parent_class)->finalize (obj);
#line 1508 "game-thumbnail.c"
}

static GType
games_game_thumbnail_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesGameThumbnailClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_game_thumbnail_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesGameThumbnail), 0, (GInstanceInitFunc) games_game_thumbnail_instance_init, NULL };
	GType games_game_thumbnail_type_id;
	games_game_thumbnail_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GamesGameThumbnail", &g_define_type_info, 0);
	GamesGameThumbnail_private_offset = g_type_add_instance_private (games_game_thumbnail_type_id, sizeof (GamesGameThumbnailPrivate));
	return games_game_thumbnail_type_id;
}

GType
games_game_thumbnail_get_type (void)
{
	static volatile gsize games_game_thumbnail_type_id__once = 0;
	if (g_once_init_enter (&games_game_thumbnail_type_id__once)) {
		GType games_game_thumbnail_type_id;
		games_game_thumbnail_type_id = games_game_thumbnail_get_type_once ();
		g_once_init_leave (&games_game_thumbnail_type_id__once, games_game_thumbnail_type_id);
	}
	return games_game_thumbnail_type_id__once;
}

static void
_vala_games_game_thumbnail_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GamesGameThumbnail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnail);
#line 3 "../src/ui/game-thumbnail.vala"
	switch (property_id) {
#line 3 "../src/ui/game-thumbnail.vala"
		case GAMES_GAME_THUMBNAIL_GAME_PROPERTY:
#line 3 "../src/ui/game-thumbnail.vala"
		g_value_set_object (value, games_game_thumbnail_get_game (self));
#line 3 "../src/ui/game-thumbnail.vala"
		break;
#line 1549 "game-thumbnail.c"
		default:
#line 3 "../src/ui/game-thumbnail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/ui/game-thumbnail.vala"
		break;
#line 1555 "game-thumbnail.c"
	}
}

static void
_vala_games_game_thumbnail_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GamesGameThumbnail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GAME_THUMBNAIL, GamesGameThumbnail);
#line 3 "../src/ui/game-thumbnail.vala"
	switch (property_id) {
#line 3 "../src/ui/game-thumbnail.vala"
		case GAMES_GAME_THUMBNAIL_GAME_PROPERTY:
#line 3 "../src/ui/game-thumbnail.vala"
		games_game_thumbnail_set_game (self, g_value_get_object (value));
#line 3 "../src/ui/game-thumbnail.vala"
		break;
#line 1575 "game-thumbnail.c"
		default:
#line 3 "../src/ui/game-thumbnail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/ui/game-thumbnail.vala"
		break;
#line 1581 "game-thumbnail.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 1596 "game-thumbnail.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 1600 "game-thumbnail.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 1604 "game-thumbnail.c"
}

