/* cairo-blur.c generated by valac 0.56.3, the Vala compiler
 * generated from cairo-blur.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

VALA_EXTERN void games_cairo_blur_exp_blur (guchar* pixels,
                                gint pixels_length1,
                                gint width,
                                gint height,
                                gint rowstride,
                                gint channels,
                                gfloat radius,
                                gint aprec,
                                gint zprec);
VALA_EXTERN void games_cairo_blur_blur_row (guchar* pixels,
                                gint pixels_length1,
                                gint width,
                                gint height,
                                gint rowstride,
                                gint channels,
                                gint line,
                                gint alpha,
                                gint aprec,
                                gint zprec);
VALA_EXTERN void games_cairo_blur_blur_col (guchar* pixels,
                                gint pixels_length1,
                                gint width,
                                gint height,
                                gint rowstride,
                                gint channels,
                                gint x,
                                gint alpha,
                                gint aprec,
                                gint zprec);
VALA_EXTERN void games_cairo_blur_blur_inner (guchar* pixel,
                                  gint pixel_length1,
                                  gint offset,
                                  gint* zR,
                                  gint* zG,
                                  gint* zB,
                                  gint* zA,
                                  gint alpha,
                                  gint aprec,
                                  gint zprec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 11 "../src/utils/cairo-blur.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 63 "cairo-blur.c"
}

void
games_cairo_blur_blur_surface (cairo_surface_t* surface,
                               gfloat radius)
{
	cairo_surface_t* image_surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_format_t format = 0;
	cairo_surface_t* _tmp1_;
	gboolean _tmp2_ = FALSE;
	guchar* data = NULL;
	cairo_surface_t* _tmp3_;
	guchar* _tmp4_;
	gint data_length1;
	gint _data_size_;
	gint width = 0;
	cairo_surface_t* _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	gint stride = 0;
	cairo_surface_t* _tmp7_;
	guchar* _tmp8_;
	gint _tmp8__length1;
#line 4 "../src/utils/cairo-blur.vala"
	g_return_if_fail (surface != NULL);
#line 5 "../src/utils/cairo-blur.vala"
	if (surface == NULL) {
#line 6 "../src/utils/cairo-blur.vala"
		return;
#line 94 "cairo-blur.c"
	}
#line 8 "../src/utils/cairo-blur.vala"
	if (cairo_surface_get_type (surface) != CAIRO_SURFACE_TYPE_IMAGE) {
#line 9 "../src/utils/cairo-blur.vala"
		return;
#line 100 "cairo-blur.c"
	}
#line 11 "../src/utils/cairo-blur.vala"
	_tmp0_ = _cairo_surface_reference0 ((cairo_surface_t*) surface);
#line 11 "../src/utils/cairo-blur.vala"
	image_surface = _tmp0_;
#line 12 "../src/utils/cairo-blur.vala"
	_tmp1_ = image_surface;
#line 12 "../src/utils/cairo-blur.vala"
	format = cairo_image_surface_get_format (_tmp1_);
#line 13 "../src/utils/cairo-blur.vala"
	if (format != CAIRO_FORMAT_RGB24) {
#line 13 "../src/utils/cairo-blur.vala"
		_tmp2_ = format != CAIRO_FORMAT_ARGB32;
#line 114 "cairo-blur.c"
	} else {
#line 13 "../src/utils/cairo-blur.vala"
		_tmp2_ = FALSE;
#line 118 "cairo-blur.c"
	}
#line 13 "../src/utils/cairo-blur.vala"
	if (_tmp2_) {
#line 14 "../src/utils/cairo-blur.vala"
		_cairo_surface_destroy0 (image_surface);
#line 14 "../src/utils/cairo-blur.vala"
		return;
#line 126 "cairo-blur.c"
	}
#line 16 "../src/utils/cairo-blur.vala"
	if (radius == ((gfloat) 0)) {
#line 17 "../src/utils/cairo-blur.vala"
		_cairo_surface_destroy0 (image_surface);
#line 17 "../src/utils/cairo-blur.vala"
		return;
#line 134 "cairo-blur.c"
	}
#line 20 "../src/utils/cairo-blur.vala"
	cairo_surface_flush (surface);
#line 21 "../src/utils/cairo-blur.vala"
	_tmp3_ = image_surface;
#line 21 "../src/utils/cairo-blur.vala"
	_tmp4_ = cairo_image_surface_get_data (_tmp3_);
#line 21 "../src/utils/cairo-blur.vala"
	data = _tmp4_;
#line 21 "../src/utils/cairo-blur.vala"
	data_length1 = -1;
#line 21 "../src/utils/cairo-blur.vala"
	_data_size_ = data_length1;
#line 22 "../src/utils/cairo-blur.vala"
	_tmp5_ = image_surface;
#line 22 "../src/utils/cairo-blur.vala"
	width = cairo_image_surface_get_width (_tmp5_);
#line 23 "../src/utils/cairo-blur.vala"
	_tmp6_ = image_surface;
#line 23 "../src/utils/cairo-blur.vala"
	height = cairo_image_surface_get_height (_tmp6_);
#line 24 "../src/utils/cairo-blur.vala"
	_tmp7_ = image_surface;
#line 24 "../src/utils/cairo-blur.vala"
	stride = cairo_image_surface_get_stride (_tmp7_);
#line 26 "../src/utils/cairo-blur.vala"
	_tmp8_ = data;
#line 26 "../src/utils/cairo-blur.vala"
	_tmp8__length1 = data_length1;
#line 26 "../src/utils/cairo-blur.vala"
	games_cairo_blur_exp_blur (_tmp8_, (gint) _tmp8__length1, width, height, stride, 4, radius, 16, 7);
#line 36 "../src/utils/cairo-blur.vala"
	cairo_surface_mark_dirty (surface);
#line 4 "../src/utils/cairo-blur.vala"
	_cairo_surface_destroy0 (image_surface);
#line 170 "cairo-blur.c"
}

void
games_cairo_blur_exp_blur (guchar* pixels,
                           gint pixels_length1,
                           gint width,
                           gint height,
                           gint rowstride,
                           gint channels,
                           gfloat radius,
                           gint aprec,
                           gint zprec)
{
	gint alpha = 0;
#line 45 "../src/utils/cairo-blur.vala"
	alpha = (gint) ((1 << aprec) * (1.0f - expf ((-2.3f) / (radius + 1.0f))));
#line 187 "cairo-blur.c"
	{
		gint row = 0;
#line 47 "../src/utils/cairo-blur.vala"
		row = 0;
#line 192 "cairo-blur.c"
		{
			gboolean _tmp0_ = FALSE;
#line 47 "../src/utils/cairo-blur.vala"
			_tmp0_ = TRUE;
#line 47 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 47 "../src/utils/cairo-blur.vala"
				if (!_tmp0_) {
#line 201 "cairo-blur.c"
					gint _tmp1_;
#line 47 "../src/utils/cairo-blur.vala"
					_tmp1_ = row;
#line 47 "../src/utils/cairo-blur.vala"
					row = _tmp1_ + 1;
#line 207 "cairo-blur.c"
				}
#line 47 "../src/utils/cairo-blur.vala"
				_tmp0_ = FALSE;
#line 47 "../src/utils/cairo-blur.vala"
				if (!(row < height)) {
#line 47 "../src/utils/cairo-blur.vala"
					break;
#line 215 "cairo-blur.c"
				}
#line 48 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_row (pixels, (gint) pixels_length1, width, height, rowstride, channels, row, alpha, aprec, zprec);
#line 219 "cairo-blur.c"
			}
		}
	}
	{
		gint col = 0;
#line 52 "../src/utils/cairo-blur.vala"
		col = 0;
#line 227 "cairo-blur.c"
		{
			gboolean _tmp2_ = FALSE;
#line 52 "../src/utils/cairo-blur.vala"
			_tmp2_ = TRUE;
#line 52 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 52 "../src/utils/cairo-blur.vala"
				if (!_tmp2_) {
#line 236 "cairo-blur.c"
					gint _tmp3_;
#line 52 "../src/utils/cairo-blur.vala"
					_tmp3_ = col;
#line 52 "../src/utils/cairo-blur.vala"
					col = _tmp3_ + 1;
#line 242 "cairo-blur.c"
				}
#line 52 "../src/utils/cairo-blur.vala"
				_tmp2_ = FALSE;
#line 52 "../src/utils/cairo-blur.vala"
				if (!(col < width)) {
#line 52 "../src/utils/cairo-blur.vala"
					break;
#line 250 "cairo-blur.c"
				}
#line 53 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_col (pixels, (gint) pixels_length1, width, height, rowstride, channels, col, alpha, aprec, zprec);
#line 254 "cairo-blur.c"
			}
		}
	}
}

void
games_cairo_blur_blur_row (guchar* pixels,
                           gint pixels_length1,
                           gint width,
                           gint height,
                           gint rowstride,
                           gint channels,
                           gint line,
                           gint alpha,
                           gint aprec,
                           gint zprec)
{
	gint offset = 0;
	gint zR = 0;
	guchar _tmp0_;
	gint zG = 0;
	guchar _tmp1_;
	gint zB = 0;
	guchar _tmp2_;
	gint zA = 0;
	guchar _tmp3_;
#line 61 "../src/utils/cairo-blur.vala"
	offset = line * rowstride;
#line 63 "../src/utils/cairo-blur.vala"
	_tmp0_ = pixels[offset];
#line 63 "../src/utils/cairo-blur.vala"
	zR = _tmp0_ << zprec;
#line 64 "../src/utils/cairo-blur.vala"
	_tmp1_ = pixels[offset + 1];
#line 64 "../src/utils/cairo-blur.vala"
	zG = _tmp1_ << zprec;
#line 65 "../src/utils/cairo-blur.vala"
	_tmp2_ = pixels[offset + 2];
#line 65 "../src/utils/cairo-blur.vala"
	zB = _tmp2_ << zprec;
#line 66 "../src/utils/cairo-blur.vala"
	_tmp3_ = pixels[offset + 3];
#line 66 "../src/utils/cairo-blur.vala"
	zA = _tmp3_ << zprec;
#line 299 "cairo-blur.c"
	{
		gint index = 0;
#line 68 "../src/utils/cairo-blur.vala"
		index = 0;
#line 304 "cairo-blur.c"
		{
			gboolean _tmp4_ = FALSE;
#line 68 "../src/utils/cairo-blur.vala"
			_tmp4_ = TRUE;
#line 68 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 68 "../src/utils/cairo-blur.vala"
				if (!_tmp4_) {
#line 313 "cairo-blur.c"
					gint _tmp5_;
#line 68 "../src/utils/cairo-blur.vala"
					_tmp5_ = index;
#line 68 "../src/utils/cairo-blur.vala"
					index = _tmp5_ + 1;
#line 319 "cairo-blur.c"
				}
#line 68 "../src/utils/cairo-blur.vala"
				_tmp4_ = FALSE;
#line 68 "../src/utils/cairo-blur.vala"
				if (!(index < width)) {
#line 68 "../src/utils/cairo-blur.vala"
					break;
#line 327 "cairo-blur.c"
				}
#line 69 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_inner (pixels, (gint) pixels_length1, offset + (index * channels), &zR, &zG, &zB, &zA, alpha, aprec, zprec);
#line 331 "cairo-blur.c"
			}
		}
	}
	{
		gint index = 0;
#line 73 "../src/utils/cairo-blur.vala"
		index = width - 2;
#line 339 "cairo-blur.c"
		{
			gboolean _tmp6_ = FALSE;
#line 73 "../src/utils/cairo-blur.vala"
			_tmp6_ = TRUE;
#line 73 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 73 "../src/utils/cairo-blur.vala"
				if (!_tmp6_) {
#line 348 "cairo-blur.c"
					gint _tmp7_;
#line 73 "../src/utils/cairo-blur.vala"
					_tmp7_ = index;
#line 73 "../src/utils/cairo-blur.vala"
					index = _tmp7_ - 1;
#line 354 "cairo-blur.c"
				}
#line 73 "../src/utils/cairo-blur.vala"
				_tmp6_ = FALSE;
#line 73 "../src/utils/cairo-blur.vala"
				if (!(index >= 0)) {
#line 73 "../src/utils/cairo-blur.vala"
					break;
#line 362 "cairo-blur.c"
				}
#line 74 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_inner (pixels, (gint) pixels_length1, offset + (index * channels), &zR, &zG, &zB, &zA, alpha, aprec, zprec);
#line 366 "cairo-blur.c"
			}
		}
	}
}

void
games_cairo_blur_blur_col (guchar* pixels,
                           gint pixels_length1,
                           gint width,
                           gint height,
                           gint rowstride,
                           gint channels,
                           gint x,
                           gint alpha,
                           gint aprec,
                           gint zprec)
{
	gint offset = 0;
	gint zR = 0;
	guchar _tmp0_;
	gint zG = 0;
	guchar _tmp1_;
	gint zB = 0;
	guchar _tmp2_;
	gint zA = 0;
	guchar _tmp3_;
#line 82 "../src/utils/cairo-blur.vala"
	offset = x * channels;
#line 84 "../src/utils/cairo-blur.vala"
	_tmp0_ = pixels[offset];
#line 84 "../src/utils/cairo-blur.vala"
	zR = _tmp0_ << zprec;
#line 85 "../src/utils/cairo-blur.vala"
	_tmp1_ = pixels[offset + 1];
#line 85 "../src/utils/cairo-blur.vala"
	zG = _tmp1_ << zprec;
#line 86 "../src/utils/cairo-blur.vala"
	_tmp2_ = pixels[offset + 2];
#line 86 "../src/utils/cairo-blur.vala"
	zB = _tmp2_ << zprec;
#line 87 "../src/utils/cairo-blur.vala"
	_tmp3_ = pixels[offset + 3];
#line 87 "../src/utils/cairo-blur.vala"
	zA = _tmp3_ << zprec;
#line 411 "cairo-blur.c"
	{
		gint index = 0;
#line 89 "../src/utils/cairo-blur.vala"
		index = 0;
#line 416 "cairo-blur.c"
		{
			gboolean _tmp4_ = FALSE;
#line 89 "../src/utils/cairo-blur.vala"
			_tmp4_ = TRUE;
#line 89 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 89 "../src/utils/cairo-blur.vala"
				if (!_tmp4_) {
#line 425 "cairo-blur.c"
					gint _tmp5_;
#line 89 "../src/utils/cairo-blur.vala"
					_tmp5_ = index;
#line 89 "../src/utils/cairo-blur.vala"
					index = _tmp5_ + 1;
#line 431 "cairo-blur.c"
				}
#line 89 "../src/utils/cairo-blur.vala"
				_tmp4_ = FALSE;
#line 89 "../src/utils/cairo-blur.vala"
				if (!(index < height)) {
#line 89 "../src/utils/cairo-blur.vala"
					break;
#line 439 "cairo-blur.c"
				}
#line 90 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_inner (pixels, (gint) pixels_length1, offset + (index * rowstride), &zR, &zG, &zB, &zA, alpha, aprec, zprec);
#line 443 "cairo-blur.c"
			}
		}
	}
	{
		gint index = 0;
#line 94 "../src/utils/cairo-blur.vala"
		index = height - 2;
#line 451 "cairo-blur.c"
		{
			gboolean _tmp6_ = FALSE;
#line 94 "../src/utils/cairo-blur.vala"
			_tmp6_ = TRUE;
#line 94 "../src/utils/cairo-blur.vala"
			while (TRUE) {
#line 94 "../src/utils/cairo-blur.vala"
				if (!_tmp6_) {
#line 460 "cairo-blur.c"
					gint _tmp7_;
#line 94 "../src/utils/cairo-blur.vala"
					_tmp7_ = index;
#line 94 "../src/utils/cairo-blur.vala"
					index = _tmp7_ - 1;
#line 466 "cairo-blur.c"
				}
#line 94 "../src/utils/cairo-blur.vala"
				_tmp6_ = FALSE;
#line 94 "../src/utils/cairo-blur.vala"
				if (!(index >= 0)) {
#line 94 "../src/utils/cairo-blur.vala"
					break;
#line 474 "cairo-blur.c"
				}
#line 95 "../src/utils/cairo-blur.vala"
				games_cairo_blur_blur_inner (pixels, (gint) pixels_length1, offset + (index * rowstride), &zR, &zG, &zB, &zA, alpha, aprec, zprec);
#line 478 "cairo-blur.c"
			}
		}
	}
}

void
games_cairo_blur_blur_inner (guchar* pixel,
                             gint pixel_length1,
                             gint offset,
                             gint* zR,
                             gint* zG,
                             gint* zB,
                             gint* zA,
                             gint alpha,
                             gint aprec,
                             gint zprec)
{
	gint R = 0;
	guchar _tmp0_;
	gint G = 0;
	guchar _tmp1_;
	gint B = 0;
	guchar _tmp2_;
	gint A = 0;
	guchar _tmp3_;
#line 103 "../src/utils/cairo-blur.vala"
	_tmp0_ = pixel[offset];
#line 103 "../src/utils/cairo-blur.vala"
	R = (gint) _tmp0_;
#line 104 "../src/utils/cairo-blur.vala"
	_tmp1_ = pixel[offset + 1];
#line 104 "../src/utils/cairo-blur.vala"
	G = (gint) _tmp1_;
#line 105 "../src/utils/cairo-blur.vala"
	_tmp2_ = pixel[offset + 2];
#line 105 "../src/utils/cairo-blur.vala"
	B = (gint) _tmp2_;
#line 106 "../src/utils/cairo-blur.vala"
	_tmp3_ = pixel[offset + 3];
#line 106 "../src/utils/cairo-blur.vala"
	A = (gint) _tmp3_;
#line 108 "../src/utils/cairo-blur.vala"
	*zR = (*zR) + ((alpha * ((R << zprec) - (*zR))) >> aprec);
#line 109 "../src/utils/cairo-blur.vala"
	*zG = (*zG) + ((alpha * ((G << zprec) - (*zG))) >> aprec);
#line 110 "../src/utils/cairo-blur.vala"
	*zB = (*zB) + ((alpha * ((B << zprec) - (*zB))) >> aprec);
#line 111 "../src/utils/cairo-blur.vala"
	*zA = (*zA) + ((alpha * ((A << zprec) - (*zA))) >> aprec);
#line 113 "../src/utils/cairo-blur.vala"
	pixel[offset] = (guchar) ((*zR) >> zprec);
#line 114 "../src/utils/cairo-blur.vala"
	pixel[offset + 1] = (guchar) ((*zG) >> zprec);
#line 115 "../src/utils/cairo-blur.vala"
	pixel[offset + 2] = (guchar) ((*zB) >> zprec);
#line 116 "../src/utils/cairo-blur.vala"
	pixel[offset + 3] = (guchar) ((*zA) >> zprec);
#line 536 "cairo-blur.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 550 "cairo-blur.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 554 "cairo-blur.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 558 "cairo-blur.c"
}

