/* cue-sheet.c generated by valac 0.56.3, the Vala compiler
 * generated from cue-sheet.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define GAMES_CUE_SHEET_NEW_LINE "\n"

enum  {
	GAMES_CUE_SHEET_0_PROPERTY,
	GAMES_CUE_SHEET_FILE_PROPERTY,
	GAMES_CUE_SHEET_TRACKS_NUMBER_PROPERTY,
	GAMES_CUE_SHEET_NUM_PROPERTIES
};
static GParamSpec* games_cue_sheet_properties[GAMES_CUE_SHEET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAMES_TYPE_CUE_SHEET_ERROR (games_cue_sheet_error_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _GamesCueSheetPrivate {
	GFile* _file;
	GamesCueSheetTrackNode** tracks;
	gint tracks_length1;
	gint _tracks_size_;
};

typedef enum  {
	GAMES_CUE_SHEET_ERROR_UNEXPECTED_TOKEN,
	GAMES_CUE_SHEET_ERROR_UNEXPECTED_EOL,
	GAMES_CUE_SHEET_ERROR_UNEXPECTED_EOF,
	GAMES_CUE_SHEET_ERROR_INVALID_FILE_FORMAT,
	GAMES_CUE_SHEET_ERROR_INVALID_TRACK_NUMBER,
	GAMES_CUE_SHEET_ERROR_INVALID_TRACK_MODE,
	GAMES_CUE_SHEET_ERROR_NOT_A_TRACK
} GamesCueSheetError;
#define GAMES_CUE_SHEET_ERROR games_cue_sheet_error_quark ()

static gint GamesCueSheet_private_offset;
static gpointer games_cue_sheet_parent_class = NULL;
static GRegex* games_cue_sheet_token_regex;
static GRegex* games_cue_sheet_token_regex = NULL;

static void games_cue_sheet_parse (GamesCueSheet* self,
                            GError** error);
VALA_EXTERN GQuark games_cue_sheet_error_quark (void);
GType games_cue_sheet_error_get_type (void) G_GNUC_CONST ;
static gchar** games_cue_sheet_tokenize (GamesCueSheet* self,
                                  gint* result_length1,
                                  GError** error);
static gchar** games_cue_sheet_tokenize_line (const gchar* line,
                                       gint* result_length1);
static void _vala_array_add42 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add43 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add44 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add45 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static GamesCueSheetFileNode* games_cue_sheet_parse_file_line (GamesCueSheet* self,
                                                        gchar*** tokens,
                                                        gint* tokens_length1,
                                                        gsize* i,
                                                        gsize line,
                                                        GError** error);
static GamesCueSheetTrackNode* games_cue_sheet_parse_track_line (GamesCueSheet* self,
                                                          gchar*** tokens,
                                                          gint* tokens_length1,
                                                          gsize* i,
                                                          gsize line,
                                                          GamesCueSheetFileNode* parent_file,
                                                          GError** error);
static void _vala_array_add46 (GamesCueSheetTrackNode** * array,
                        gint* length,
                        gint* size,
                        GamesCueSheetTrackNode* value);
static void games_cue_sheet_is_token (GamesCueSheet* self,
                               const gchar* expected_token,
                               gchar*** tokens,
                               gint* tokens_length1,
                               gsize* i,
                               gsize line,
                               GError** error);
static gchar* games_cue_sheet_get_token (GamesCueSheet* self,
                                  gchar*** tokens,
                                  gint* tokens_length1,
                                  gsize* i,
                                  gsize line,
                                  GError** error);
static gchar* games_cue_sheet_get_optional_token (GamesCueSheet* self,
                                           gchar*** tokens,
                                           gint* tokens_length1,
                                           gsize* i,
                                           gsize line);
static void games_cue_sheet_is_end_of_line (GamesCueSheet* self,
                                     gchar*** tokens,
                                     gint* tokens_length1,
                                     gsize* i,
                                     gsize line,
                                     GError** error);
static void games_cue_sheet_finalize (GObject * obj);
static GType games_cue_sheet_get_type_once (void);
static void _vala_games_cue_sheet_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GRegex* _tmp_regex_0 = NULL;

static inline gpointer
games_cue_sheet_get_instance_private (GamesCueSheet* self)
{
	return G_STRUCT_MEMBER_P (self, GamesCueSheet_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/utils/cue-sheet/cue-sheet.vala"
	return self ? g_object_ref (self) : NULL;
#line 147 "cue-sheet.c"
}

GamesCueSheet*
games_cue_sheet_construct (GType object_type,
                           GFile* file,
                           GError** error)
{
	GamesCueSheet * self = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 17 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 17 "../src/utils/cue-sheet/cue-sheet.vala"
	self = (GamesCueSheet*) g_object_new (object_type, NULL);
#line 18 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 18 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (self->priv->_file);
#line 18 "../src/utils/cue-sheet/cue-sheet.vala"
	self->priv->_file = _tmp0_;
#line 20 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_parse (self, &_inner_error0_);
#line 20 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20 "../src/utils/cue-sheet/cue-sheet.vala"
		g_propagate_error (error, _inner_error0_);
#line 20 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_object_unref0 (self);
#line 20 "../src/utils/cue-sheet/cue-sheet.vala"
		return NULL;
#line 178 "cue-sheet.c"
	}
#line 17 "../src/utils/cue-sheet/cue-sheet.vala"
	return self;
#line 182 "cue-sheet.c"
}

GamesCueSheet*
games_cue_sheet_new (GFile* file,
                     GError** error)
{
#line 17 "../src/utils/cue-sheet/cue-sheet.vala"
	return games_cue_sheet_construct (GAMES_TYPE_CUE_SHEET, file, error);
#line 191 "cue-sheet.c"
}

GamesCueSheetTrackNode*
games_cue_sheet_get_track (GamesCueSheet* self,
                           guint i,
                           GError** error)
{
	GamesCueSheetTrackNode** _tmp0_;
	gint _tmp0__length1;
	GamesCueSheetTrackNode** _tmp7_;
	gint _tmp7__length1;
	GamesCueSheetTrackNode* _tmp8_;
	GamesCueSheetTrackNode* _tmp9_;
	GError* _inner_error0_ = NULL;
	GamesCueSheetTrackNode* result;
#line 23 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = self->priv->tracks;
#line 24 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0__length1 = self->priv->tracks_length1;
#line 24 "../src/utils/cue-sheet/cue-sheet.vala"
	if (i >= ((guint) _tmp0__length1)) {
#line 215 "cue-sheet.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = games_cue_sheet_get_file (self);
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = _tmp1_;
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = g_file_get_uri (_tmp2_);
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp4_ = _tmp3_;
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_NOT_A_TRACK, "“%s” doesn’t have a track for index %u.", _tmp4_, i);
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp6_ = _tmp5_;
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp4_);
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp6_;
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		g_propagate_error (error, _inner_error0_);
#line 25 "../src/utils/cue-sheet/cue-sheet.vala"
		return NULL;
#line 242 "cue-sheet.c"
	}
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp7_ = self->priv->tracks;
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp7__length1 = self->priv->tracks_length1;
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp8_ = _tmp7_[i];
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp9_;
#line 27 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 256 "cue-sheet.c"
}

static void
_vala_array_add42 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*length) == (*size)) {
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 271 "cue-sheet.c"
	}
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[(*length)++] = value;
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[*length] = NULL;
#line 277 "cue-sheet.c"
}

static gchar**
games_cue_sheet_tokenize (GamesCueSheet* self,
                          gint* result_length1,
                          GError** error)
{
	GInputStream* stream = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GInputStream* _tmp2_;
	GDataInputStream* data_stream = NULL;
	GInputStream* _tmp3_;
	GDataInputStream* _tmp4_;
	gchar** tokens = NULL;
	gchar** _tmp5_;
	gint tokens_length1;
	gint _tokens_size_;
	gchar* line = NULL;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 30 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = games_cue_sheet_get_file (self);
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp2_ = games_unicode_read (_tmp1_, GAMES_UNICODE_ENCODING_UTF_8, &_inner_error0_);
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
	stream = _tmp2_;
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
		g_propagate_error (error, _inner_error0_);
#line 31 "../src/utils/cue-sheet/cue-sheet.vala"
		return NULL;
#line 317 "cue-sheet.c"
	}
#line 32 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp3_ = stream;
#line 32 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp4_ = g_data_input_stream_new (_tmp3_);
#line 32 "../src/utils/cue-sheet/cue-sheet.vala"
	data_stream = _tmp4_;
#line 34 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 34 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens = _tmp5_;
#line 34 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens_length1 = 0;
#line 34 "../src/utils/cue-sheet/cue-sheet.vala"
	_tokens_size_ = tokens_length1;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
	while (TRUE) {
#line 335 "cue-sheet.c"
		gchar* _tmp6_ = NULL;
		GDataInputStream* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_ = 0;
		gchar** _tmp13_;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp7_ = data_stream;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp8_ = g_data_input_stream_read_line_utf8 (_tmp7_, NULL, NULL, &_inner_error0_);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp6_ = _tmp8_;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (line);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (data_stream);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (stream);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 364 "cue-sheet.c"
		}
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = _tmp6_;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp6_ = NULL;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (line);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		line = _tmp9_;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp10_ = line;
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		if (!(_tmp10_ != NULL)) {
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (_tmp6_);
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
			break;
#line 382 "cue-sheet.c"
		}
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp11_ = line;
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp13_ = games_cue_sheet_tokenize_line (_tmp11_, &_tmp12_);
#line 388 "cue-sheet.c"
		{
			gchar** token_collection = NULL;
			gint token_collection_length1 = 0;
			gint _token_collection_size_ = 0;
			gint token_it = 0;
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
			token_collection = _tmp13_;
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
			token_collection_length1 = _tmp12_;
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
			for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 400 "cue-sheet.c"
				gchar* _tmp14_;
				gchar* token = NULL;
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp14_ = g_strdup (token_collection[token_it]);
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
				token = _tmp14_;
#line 407 "cue-sheet.c"
				{
					const gchar* _tmp15_;
					gchar* _tmp16_;
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
					_tmp15_ = token;
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 39 "../src/utils/cue-sheet/cue-sheet.vala"
					_vala_array_add42 (&tokens, &tokens_length1, &_tokens_size_, _tmp16_);
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
					_g_free0 (token);
#line 419 "cue-sheet.c"
				}
			}
#line 38 "../src/utils/cue-sheet/cue-sheet.vala"
			token_collection = (_vala_array_free (token_collection, token_collection_length1, (GDestroyNotify) g_free), NULL);
#line 424 "cue-sheet.c"
		}
#line 37 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp6_);
#line 428 "cue-sheet.c"
	}
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp17_ = tokens;
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp17__length1 = tokens_length1;
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	if (result_length1) {
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
		*result_length1 = _tmp17__length1;
#line 438 "cue-sheet.c"
	}
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp17_;
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_free0 (line);
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (data_stream);
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (stream);
#line 41 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 450 "cue-sheet.c"
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 464 "cue-sheet.c"
	}
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
	return *re;
#line 468 "cue-sheet.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
	return self ? g_regex_ref (self) : NULL;
#line 476 "cue-sheet.c"
}

static void
_vala_array_add43 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*length) == (*size)) {
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 491 "cue-sheet.c"
	}
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[(*length)++] = value;
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[*length] = NULL;
#line 497 "cue-sheet.c"
}

static void
_vala_array_add44 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*length) == (*size)) {
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 512 "cue-sheet.c"
	}
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[(*length)++] = value;
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[*length] = NULL;
#line 518 "cue-sheet.c"
}

static void
_vala_array_add45 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*length) == (*size)) {
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 533 "cue-sheet.c"
	}
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[(*length)++] = value;
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[*length] = NULL;
#line 539 "cue-sheet.c"
}

static gchar**
games_cue_sheet_tokenize_line (const gchar* line,
                               gint* result_length1)
{
	GRegex* _tmp0_;
	gchar** tokens = NULL;
	gchar** _tmp2_;
	gint tokens_length1;
	gint _tokens_size_;
	GRegex* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gboolean _tmp14_ = FALSE;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar** result;
#line 45 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 46 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = games_cue_sheet_token_regex;
#line 46 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp0_ == NULL) {
#line 566 "cue-sheet.c"
		GRegex* _tmp1_;
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = _g_regex_ref0 (_thread_safe_regex_init (&_tmp_regex_0, "\\s*([^\"\\s]+)|(\".+?\")\\s*", 0));
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_regex_unref0 (games_cue_sheet_token_regex);
#line 48 "../src/utils/cue-sheet/cue-sheet.vala"
		games_cue_sheet_token_regex = _tmp1_;
#line 574 "cue-sheet.c"
	}
#line 50 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 50 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens = _tmp2_;
#line 50 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens_length1 = 0;
#line 50 "../src/utils/cue-sheet/cue-sheet.vala"
	_tokens_size_ = tokens_length1;
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp3_ = games_cue_sheet_token_regex;
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp5_ = _tmp4_ = g_regex_split (_tmp3_, line, 0);
#line 588 "cue-sheet.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
		token_collection = _tmp5_;
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
		token_collection_length1 = _vala_array_length (_tmp4_);
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
		for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 600 "cue-sheet.c"
			gchar* _tmp6_;
			gchar* token = NULL;
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
			_tmp6_ = g_strdup (token_collection[token_it]);
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
			token = _tmp6_;
#line 607 "cue-sheet.c"
			{
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				GQuark _tmp10_ = 0U;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp9_label0 = 0;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp9_label1 = 0;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp9_label2 = 0;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp9_label3 = 0;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp7_ = token;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp8_ = _tmp7_;
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp10_ = (NULL == _tmp8_) ? 0 : g_quark_from_string (_tmp8_);
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
				if ((_tmp10_ == ((0 != _tmp9_label0) ? _tmp9_label0 : (_tmp9_label0 = g_quark_from_static_string ("\r")))) || (_tmp10_ == ((0 != _tmp9_label1) ? _tmp9_label1 : (_tmp9_label1 = g_quark_from_static_string ("\r\n"))))) {
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 630 "cue-sheet.c"
						default:
						{
							gchar* _tmp11_;
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp11_ = g_strdup (GAMES_CUE_SHEET_NEW_LINE);
#line 55 "../src/utils/cue-sheet/cue-sheet.vala"
							_vala_array_add43 (&tokens, &tokens_length1, &_tokens_size_, _tmp11_);
#line 57 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 640 "cue-sheet.c"
						}
					}
				} else if ((_tmp10_ == ((0 != _tmp9_label2) ? _tmp9_label2 : (_tmp9_label2 = g_quark_from_static_string ("")))) || (_tmp10_ == ((0 != _tmp9_label3) ? _tmp9_label3 : (_tmp9_label3 = g_quark_from_static_string (" "))))) {
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 646 "cue-sheet.c"
						default:
						{
#line 60 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 651 "cue-sheet.c"
						}
					}
				} else {
#line 52 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 657 "cue-sheet.c"
						default:
						{
							const gchar* _tmp12_;
							gchar* _tmp13_;
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp12_ = token;
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp13_ = g_strdup (_tmp12_);
#line 62 "../src/utils/cue-sheet/cue-sheet.vala"
							_vala_array_add44 (&tokens, &tokens_length1, &_tokens_size_, _tmp13_);
#line 64 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 670 "cue-sheet.c"
						}
					}
				}
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
				_g_free0 (token);
#line 676 "cue-sheet.c"
			}
		}
#line 51 "../src/utils/cue-sheet/cue-sheet.vala"
		token_collection = (_vala_array_free (token_collection, token_collection_length1, (GDestroyNotify) g_free), NULL);
#line 681 "cue-sheet.c"
	}
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp15_ = tokens;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp15__length1 = tokens_length1;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp15__length1 != 0) {
#line 689 "cue-sheet.c"
		gchar** _tmp16_;
		gint _tmp16__length1;
		gchar** _tmp17_;
		gint _tmp17__length1;
		const gchar* _tmp18_;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp16_ = tokens;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp16__length1 = tokens_length1;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp17_ = tokens;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp17__length1 = tokens_length1;
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp18_ = _tmp16_[_tmp17__length1 - 1];
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp14_ = g_strcmp0 (_tmp18_, GAMES_CUE_SHEET_NEW_LINE) != 0;
#line 707 "cue-sheet.c"
	} else {
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp14_ = FALSE;
#line 711 "cue-sheet.c"
	}
#line 68 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp14_) {
#line 715 "cue-sheet.c"
		gchar* _tmp19_;
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp19_ = g_strdup (GAMES_CUE_SHEET_NEW_LINE);
#line 69 "../src/utils/cue-sheet/cue-sheet.vala"
		_vala_array_add45 (&tokens, &tokens_length1, &_tokens_size_, _tmp19_);
#line 721 "cue-sheet.c"
	}
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp20_ = tokens;
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp20__length1 = tokens_length1;
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
	if (result_length1) {
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
		*result_length1 = _tmp20__length1;
#line 731 "cue-sheet.c"
	}
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp20_;
#line 71 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 737 "cue-sheet.c"
}

static void
_vala_array_add46 (GamesCueSheetTrackNode** * array,
                   gint* length,
                   gint* size,
                   GamesCueSheetTrackNode* value)
{
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*length) == (*size)) {
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
		*array = g_renew (GamesCueSheetTrackNode*, *array, (*size) + 1);
#line 752 "cue-sheet.c"
	}
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[(*length)++] = value;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
	(*array)[*length] = NULL;
#line 758 "cue-sheet.c"
}

static void
games_cue_sheet_parse (GamesCueSheet* self,
                       GError** error)
{
	gchar** tokens = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint tokens_length1;
	gint _tokens_size_;
	GamesCueSheetFileNode* latest_file = NULL;
	gsize line = 0UL;
	GError* _inner_error0_ = NULL;
#line 74 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp1_ = games_cue_sheet_tokenize (self, &_tmp0_, &_inner_error0_);
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens = _tmp1_;
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens_length1 = _tmp0_;
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
	_tokens_size_ = tokens_length1;
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
		g_propagate_error (error, _inner_error0_);
#line 75 "../src/utils/cue-sheet/cue-sheet.vala"
		return;
#line 789 "cue-sheet.c"
	}
#line 77 "../src/utils/cue-sheet/cue-sheet.vala"
	latest_file = NULL;
#line 79 "../src/utils/cue-sheet/cue-sheet.vala"
	line = (gsize) 1;
#line 795 "cue-sheet.c"
	{
		gsize i = 0UL;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
		i = (gsize) 0;
#line 800 "cue-sheet.c"
		{
			gboolean _tmp2_ = FALSE;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
			_tmp2_ = TRUE;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
			while (TRUE) {
#line 807 "cue-sheet.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				GQuark _tmp9_ = 0U;
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp8_label0 = 0;
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				static GQuark _tmp8_label1 = 0;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
				if (!_tmp2_) {
#line 821 "cue-sheet.c"
					gsize _tmp3_;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
					_tmp3_ = line;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
					line = _tmp3_ + 1;
#line 827 "cue-sheet.c"
				}
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp2_ = FALSE;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp4_ = tokens;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp4__length1 = tokens_length1;
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
				if (!(i < ((gsize) _tmp4__length1))) {
#line 80 "../src/utils/cue-sheet/cue-sheet.vala"
					break;
#line 839 "cue-sheet.c"
				}
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp5_ = tokens;
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp5__length1 = tokens_length1;
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp6_ = _tmp5_[i];
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp7_ = _tmp6_;
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				_tmp9_ = (NULL == _tmp7_) ? 0 : g_quark_from_string (_tmp7_);
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
				if (_tmp9_ == ((0 != _tmp8_label0) ? _tmp8_label0 : (_tmp8_label0 = g_quark_from_static_string ("FILE")))) {
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 855 "cue-sheet.c"
						default:
						{
							GamesCueSheetFileNode* _tmp10_ = NULL;
							GamesCueSheetFileNode* _tmp11_;
							GamesCueSheetFileNode* _tmp12_;
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp11_ = games_cue_sheet_parse_file_line (self, &tokens, (gint*) (&tokens_length1), &i, line, &_inner_error0_);
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_tokens_size_ = tokens_length1;
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp10_ = _tmp11_;
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
								g_propagate_error (error, _inner_error0_);
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
								_g_object_unref0 (latest_file);
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
								return;
#line 877 "cue-sheet.c"
							}
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp12_ = _tmp10_;
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp10_ = NULL;
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							_g_object_unref0 (latest_file);
#line 84 "../src/utils/cue-sheet/cue-sheet.vala"
							latest_file = _tmp12_;
#line 86 "../src/utils/cue-sheet/cue-sheet.vala"
							_g_object_unref0 (_tmp10_);
#line 86 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 891 "cue-sheet.c"
						}
					}
				} else if (_tmp9_ == ((0 != _tmp8_label1) ? _tmp8_label1 : (_tmp8_label1 = g_quark_from_static_string ("TRACK")))) {
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 897 "cue-sheet.c"
						default:
						{
							GamesCueSheetTrackNode* _tmp13_ = NULL;
							GamesCueSheetFileNode* _tmp14_;
							GamesCueSheetTrackNode* _tmp15_;
							GamesCueSheetTrackNode* _tmp16_;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp14_ = latest_file;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp15_ = games_cue_sheet_parse_track_line (self, &tokens, (gint*) (&tokens_length1), &i, line, _tmp14_, &_inner_error0_);
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tokens_size_ = tokens_length1;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp13_ = _tmp15_;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
								g_propagate_error (error, _inner_error0_);
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
								_g_object_unref0 (latest_file);
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
								return;
#line 922 "cue-sheet.c"
							}
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp16_ = _tmp13_;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp13_ = NULL;
#line 88 "../src/utils/cue-sheet/cue-sheet.vala"
							_vala_array_add46 (&self->priv->tracks, &self->priv->tracks_length1, &self->priv->_tracks_size_, _tmp16_);
#line 90 "../src/utils/cue-sheet/cue-sheet.vala"
							_g_object_unref0 (_tmp13_);
#line 90 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 934 "cue-sheet.c"
						}
					}
				} else {
#line 82 "../src/utils/cue-sheet/cue-sheet.vala"
					switch (0) {
#line 940 "cue-sheet.c"
						default:
						{
							gsize _tmp22_;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
							while (TRUE) {
#line 946 "cue-sheet.c"
								gboolean _tmp17_ = FALSE;
								gchar** _tmp18_;
								gint _tmp18__length1;
								gsize _tmp21_;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
								_tmp18_ = tokens;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
								_tmp18__length1 = tokens_length1;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
								if (i < ((gsize) _tmp18__length1)) {
#line 957 "cue-sheet.c"
									gchar** _tmp19_;
									gint _tmp19__length1;
									const gchar* _tmp20_;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									_tmp19_ = tokens;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									_tmp19__length1 = tokens_length1;
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									_tmp20_ = _tmp19_[i];
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									_tmp17_ = g_strcmp0 (_tmp20_, GAMES_CUE_SHEET_NEW_LINE) != 0;
#line 969 "cue-sheet.c"
								} else {
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									_tmp17_ = FALSE;
#line 973 "cue-sheet.c"
								}
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
								if (!_tmp17_) {
#line 93 "../src/utils/cue-sheet/cue-sheet.vala"
									break;
#line 979 "cue-sheet.c"
								}
#line 94 "../src/utils/cue-sheet/cue-sheet.vala"
								_tmp21_ = i;
#line 94 "../src/utils/cue-sheet/cue-sheet.vala"
								i = _tmp21_ + 1;
#line 985 "cue-sheet.c"
							}
#line 95 "../src/utils/cue-sheet/cue-sheet.vala"
							_tmp22_ = i;
#line 95 "../src/utils/cue-sheet/cue-sheet.vala"
							i = _tmp22_ + 1;
#line 97 "../src/utils/cue-sheet/cue-sheet.vala"
							break;
#line 993 "cue-sheet.c"
						}
					}
				}
			}
		}
	}
#line 74 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (latest_file);
#line 74 "../src/utils/cue-sheet/cue-sheet.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 1004 "cue-sheet.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 1031 "cue-sheet.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 1037 "cue-sheet.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1043 "cue-sheet.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1047 "cue-sheet.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1055 "cue-sheet.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1059 "cue-sheet.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 1071 "cue-sheet.c"
}

static GamesCueSheetFileNode*
games_cue_sheet_parse_file_line (GamesCueSheet* self,
                                 gchar*** tokens,
                                 gint* tokens_length1,
                                 gsize* i,
                                 gsize line,
                                 GError** error)
{
	gchar* file_name = NULL;
	gchar* _tmp0_;
	gchar* file_format_string = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GFile* dir = NULL;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* child_file = NULL;
	GFile* _tmp17_;
	const gchar* _tmp18_;
	GFile* _tmp19_;
	GamesCueSheetFileFormat file_format = 0;
	const gchar* _tmp20_;
	GFile* _tmp28_;
	GamesCueSheetFileNode* _tmp29_;
	GError* _inner_error0_ = NULL;
	GamesCueSheetFileNode* result;
#line 101 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_is_token (self, "FILE", tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1115 "cue-sheet.c"
		} else {
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 102 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1123 "cue-sheet.c"
		}
	}
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = games_cue_sheet_get_token (self, tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
	file_name = _tmp0_;
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1138 "cue-sheet.c"
		} else {
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 103 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1146 "cue-sheet.c"
		}
	}
#line 104 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp1_ = games_cue_sheet_get_optional_token (self, tokens, (gint*) (tokens_length1), i, line);
#line 104 "../src/utils/cue-sheet/cue-sheet.vala"
	file_format_string = _tmp1_;
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_is_end_of_line (self, tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_format_string);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_name);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1167 "cue-sheet.c"
		} else {
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_format_string);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_name);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 105 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1179 "cue-sheet.c"
		}
	}
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp4_ = file_name;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
	if (g_str_has_prefix (_tmp4_, "\"")) {
#line 1186 "cue-sheet.c"
		const gchar* _tmp5_;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = file_name;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = g_str_has_suffix (_tmp5_, "\"");
#line 1192 "cue-sheet.c"
	} else {
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = FALSE;
#line 1196 "cue-sheet.c"
	}
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp3_) {
#line 1200 "cue-sheet.c"
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp6_ = file_name;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp7_ = strlen (_tmp6_);
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp8_ = _tmp7_;
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = _tmp8_ > 1;
#line 1212 "cue-sheet.c"
	} else {
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = FALSE;
#line 1216 "cue-sheet.c"
	}
#line 107 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp2_) {
#line 1220 "cue-sheet.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = file_name;
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp10_ = file_name;
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp11_ = strlen (_tmp10_);
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp12_ = _tmp11_;
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp13_ = string_slice (_tmp9_, (glong) 1, (glong) (_tmp12_ - 1));
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (file_name);
#line 108 "../src/utils/cue-sheet/cue-sheet.vala"
		file_name = _tmp13_;
#line 1240 "cue-sheet.c"
	}
#line 109 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp14_ = games_cue_sheet_get_file (self);
#line 109 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp15_ = _tmp14_;
#line 109 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp16_ = g_file_get_parent (_tmp15_);
#line 109 "../src/utils/cue-sheet/cue-sheet.vala"
	dir = _tmp16_;
#line 110 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp17_ = dir;
#line 110 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp18_ = file_name;
#line 110 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp19_ = g_file_get_child (_tmp17_, _tmp18_);
#line 110 "../src/utils/cue-sheet/cue-sheet.vala"
	child_file = _tmp19_;
#line 112 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp20_ = file_format_string;
#line 112 "../src/utils/cue-sheet/cue-sheet.vala"
	file_format = games_cue_sheet_file_format_parse_string (_tmp20_);
#line 113 "../src/utils/cue-sheet/cue-sheet.vala"
	if (file_format == GAMES_CUE_SHEET_FILE_FORMAT_INVALID) {
#line 1264 "cue-sheet.c"
		GFile* _tmp21_;
		GFile* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		GError* _tmp26_;
		GError* _tmp27_;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp21_ = games_cue_sheet_get_file (self);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp22_ = _tmp21_;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp23_ = g_file_get_basename (_tmp22_);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp24_ = _tmp23_;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp25_ = file_format_string;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp26_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_INVALID_FILE_FORMAT, "%s:%lu: Invalid file format %s, expected a valid file format or none.", _tmp24_, (gulong) line, _tmp25_);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp27_ = _tmp26_;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp24_);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp27_;
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (child_file);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (dir);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_format_string);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_name);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1304 "cue-sheet.c"
		} else {
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (child_file);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_object_unref0 (dir);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_format_string);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (file_name);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 114 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1320 "cue-sheet.c"
		}
	}
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp28_ = child_file;
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp29_ = games_cue_sheet_file_node_new (_tmp28_, file_format);
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp29_;
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (child_file);
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (dir);
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_free0 (file_format_string);
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_free0 (file_name);
#line 116 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 1339 "cue-sheet.c"
}

static GamesCueSheetTrackNode*
games_cue_sheet_parse_track_line (GamesCueSheet* self,
                                  gchar*** tokens,
                                  gint* tokens_length1,
                                  gsize* i,
                                  gsize line,
                                  GamesCueSheetFileNode* parent_file,
                                  GError** error)
{
	gchar* track_number_string = NULL;
	gchar* _tmp6_;
	gchar* track_mode_string = NULL;
	gchar* _tmp7_;
	gint track_number = 0;
	const gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GamesCueSheetTrackMode track_mode = 0;
	const gchar* _tmp17_;
	GamesCueSheetTrackNode* _tmp25_;
	GError* _inner_error0_ = NULL;
	GamesCueSheetTrackNode* result;
#line 119 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/utils/cue-sheet/cue-sheet.vala"
	if (parent_file == NULL) {
#line 1367 "cue-sheet.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp0_ = games_cue_sheet_get_file (self);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = _tmp0_;
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = g_file_get_basename (_tmp1_);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = _tmp2_;
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp4_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_TOKEN, "%s:%lu: Unexpected token TRACK before a FILE token.", _tmp3_, (gulong) line);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = _tmp4_;
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp3_);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp5_;
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1396 "cue-sheet.c"
		} else {
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 121 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1404 "cue-sheet.c"
		}
	}
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_is_token (self, "TRACK", tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1417 "cue-sheet.c"
		} else {
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 123 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1425 "cue-sheet.c"
		}
	}
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp6_ = games_cue_sheet_get_token (self, tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
	track_number_string = _tmp6_;
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1440 "cue-sheet.c"
		} else {
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1448 "cue-sheet.c"
		}
	}
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp7_ = games_cue_sheet_get_token (self, tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
	track_mode_string = _tmp7_;
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1465 "cue-sheet.c"
		} else {
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 125 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1475 "cue-sheet.c"
		}
	}
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_is_end_of_line (self, tokens, (gint*) (tokens_length1), i, line, &_inner_error0_);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1492 "cue-sheet.c"
		} else {
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 126 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1504 "cue-sheet.c"
		}
	}
#line 128 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp8_ = track_number_string;
#line 128 "../src/utils/cue-sheet/cue-sheet.vala"
	track_number = atoi (_tmp8_);
#line 129 "../src/utils/cue-sheet/cue-sheet.vala"
	if (track_number < 1) {
#line 129 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = TRUE;
#line 1515 "cue-sheet.c"
	} else {
#line 129 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = track_number > 99;
#line 1519 "cue-sheet.c"
	}
#line 129 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp9_) {
#line 1523 "cue-sheet.c"
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		GError* _tmp15_;
		GError* _tmp16_;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp10_ = games_cue_sheet_get_file (self);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp11_ = _tmp10_;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp12_ = g_file_get_basename (_tmp11_);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp13_ = _tmp12_;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp14_ = track_number_string;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp15_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_INVALID_TRACK_NUMBER, "%s:%lu: Invalid track number %s, expected a number in the 1-99 range.", _tmp13_, (gulong) line, _tmp14_);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp16_ = _tmp15_;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp13_);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp16_;
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1559 "cue-sheet.c"
		} else {
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 130 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1571 "cue-sheet.c"
		}
	}
#line 132 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp17_ = track_mode_string;
#line 132 "../src/utils/cue-sheet/cue-sheet.vala"
	track_mode = games_cue_sheet_track_mode_parse_string (_tmp17_);
#line 133 "../src/utils/cue-sheet/cue-sheet.vala"
	if (track_mode == GAMES_CUE_SHEET_TRACK_MODE_INVALID) {
#line 1580 "cue-sheet.c"
		GFile* _tmp18_;
		GFile* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		GError* _tmp23_;
		GError* _tmp24_;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp18_ = games_cue_sheet_get_file (self);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp19_ = _tmp18_;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp20_ = g_file_get_basename (_tmp19_);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp21_ = _tmp20_;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp22_ = track_mode_string;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp23_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_INVALID_TRACK_MODE, "%s:%lu: Invalid track mode %s, expected a valid track mode.", _tmp21_, (gulong) line, _tmp22_);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp24_ = _tmp23_;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp21_);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp24_;
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1616 "cue-sheet.c"
		} else {
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_mode_string);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			_g_free0 (track_number_string);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 134 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1628 "cue-sheet.c"
		}
	}
#line 136 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp25_ = games_cue_sheet_track_node_new (parent_file, track_number, track_mode);
#line 136 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp25_;
#line 136 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_free0 (track_mode_string);
#line 136 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_free0 (track_number_string);
#line 136 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 1641 "cue-sheet.c"
}

static void
games_cue_sheet_is_token (GamesCueSheet* self,
                          const gchar* expected_token,
                          gchar*** tokens,
                          gint* tokens_length1,
                          gsize* i,
                          gsize line,
                          GError** error)
{
	const gchar* _tmp6_;
	gsize _tmp14_;
	GError* _inner_error0_ = NULL;
#line 139 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_if_fail (expected_token != NULL);
#line 140 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*i) >= ((gsize) (*tokens_length1))) {
#line 1662 "cue-sheet.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp0_ = games_cue_sheet_get_file (self);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = _tmp0_;
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = g_file_get_basename (_tmp1_);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = _tmp2_;
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp4_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_EOF, "%s:%lu: Unexpected end of file, expected %s.", _tmp3_, (gulong) line, expected_token);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = _tmp4_;
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp3_);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp5_;
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 1691 "cue-sheet.c"
		} else {
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 141 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 1699 "cue-sheet.c"
		}
	}
#line 143 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp6_ = (*tokens)[*i];
#line 143 "../src/utils/cue-sheet/cue-sheet.vala"
	if (g_strcmp0 (_tmp6_, GAMES_CUE_SHEET_NEW_LINE) == 0) {
#line 1706 "cue-sheet.c"
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
		GError* _tmp13_;
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp7_ = games_cue_sheet_get_file (self);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp8_ = _tmp7_;
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = g_file_get_basename (_tmp8_);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp10_ = _tmp9_;
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp11_ = (*tokens)[*i];
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp12_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_TOKEN, "%s:%lu: Unexpected token %s, expected %s.", _tmp10_, (gulong) line, _tmp11_, expected_token);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp13_ = _tmp12_;
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp10_);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp13_;
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 1738 "cue-sheet.c"
		} else {
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 144 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 1746 "cue-sheet.c"
		}
	}
#line 146 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp14_ = *i;
#line 146 "../src/utils/cue-sheet/cue-sheet.vala"
	*i = _tmp14_ + 1;
#line 1753 "cue-sheet.c"
}

static gchar*
games_cue_sheet_get_token (GamesCueSheet* self,
                           gchar*** tokens,
                           gint* tokens_length1,
                           gsize* i,
                           gsize line,
                           GError** error)
{
	const gchar* _tmp6_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gsize _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 149 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*i) >= ((gsize) (*tokens_length1))) {
#line 1776 "cue-sheet.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp0_ = games_cue_sheet_get_file (self);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = _tmp0_;
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = g_file_get_basename (_tmp1_);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = _tmp2_;
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp4_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_EOF, "%s:%lu: Unexpected end of file, expected a token.", _tmp3_, (gulong) line);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = _tmp4_;
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp3_);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp5_;
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1805 "cue-sheet.c"
		} else {
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 151 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1813 "cue-sheet.c"
		}
	}
#line 153 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp6_ = (*tokens)[*i];
#line 153 "../src/utils/cue-sheet/cue-sheet.vala"
	if (g_strcmp0 (_tmp6_, GAMES_CUE_SHEET_NEW_LINE) == 0) {
#line 1820 "cue-sheet.c"
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		GError* _tmp12_;
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp7_ = games_cue_sheet_get_file (self);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp8_ = _tmp7_;
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp9_ = g_file_get_basename (_tmp8_);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp10_ = _tmp9_;
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp11_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_EOL, "%s:%lu: Unexpected end of line, expected a token.", _tmp10_, (gulong) line);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp12_ = _tmp11_;
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp10_);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp12_;
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1849 "cue-sheet.c"
		} else {
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 154 "../src/utils/cue-sheet/cue-sheet.vala"
			return NULL;
#line 1857 "cue-sheet.c"
		}
	}
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp13_ = *tokens;
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp13__length1 = *tokens_length1;
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp14_ = *i;
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	*i = _tmp14_ + 1;
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp15_ = _tmp13_[_tmp14_];
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp16_;
#line 156 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 1876 "cue-sheet.c"
}

static gchar*
games_cue_sheet_get_optional_token (GamesCueSheet* self,
                                    gchar*** tokens,
                                    gint* tokens_length1,
                                    gsize* i,
                                    gsize line)
{
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gsize _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 159 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*i) >= ((gsize) (*tokens_length1))) {
#line 161 "../src/utils/cue-sheet/cue-sheet.vala"
		result = NULL;
#line 161 "../src/utils/cue-sheet/cue-sheet.vala"
		return result;
#line 1901 "cue-sheet.c"
	}
#line 163 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = (*tokens)[*i];
#line 163 "../src/utils/cue-sheet/cue-sheet.vala"
	if (g_strcmp0 (_tmp0_, GAMES_CUE_SHEET_NEW_LINE) == 0) {
#line 164 "../src/utils/cue-sheet/cue-sheet.vala"
		result = NULL;
#line 164 "../src/utils/cue-sheet/cue-sheet.vala"
		return result;
#line 1911 "cue-sheet.c"
	}
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp1_ = *tokens;
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp1__length1 = *tokens_length1;
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp2_ = *i;
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	*i = _tmp2_ + 1;
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp3_ = _tmp1_[_tmp2_];
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp4_;
#line 166 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 1929 "cue-sheet.c"
}

static void
games_cue_sheet_is_end_of_line (GamesCueSheet* self,
                                gchar*** tokens,
                                gint* tokens_length1,
                                gsize* i,
                                gsize line,
                                GError** error)
{
	gboolean _tmp0_ = FALSE;
	gsize _tmp9_;
	GError* _inner_error0_ = NULL;
#line 169 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/utils/cue-sheet/cue-sheet.vala"
	if ((*i) < ((gsize) (*tokens_length1))) {
#line 1947 "cue-sheet.c"
		const gchar* _tmp1_;
#line 170 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp1_ = (*tokens)[*i];
#line 170 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, GAMES_CUE_SHEET_NEW_LINE) != 0;
#line 1953 "cue-sheet.c"
	} else {
#line 170 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp0_ = FALSE;
#line 1957 "cue-sheet.c"
	}
#line 170 "../src/utils/cue-sheet/cue-sheet.vala"
	if (_tmp0_) {
#line 1961 "cue-sheet.c"
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp2_ = games_cue_sheet_get_file (self);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp3_ = _tmp2_;
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp5_ = _tmp4_;
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp6_ = (*tokens)[*i];
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp7_ = g_error_new (GAMES_CUE_SHEET_ERROR, GAMES_CUE_SHEET_ERROR_UNEXPECTED_TOKEN, "%s:%lu: Unexpected token %s, expected end of line.", _tmp5_, (gulong) line, _tmp6_);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_tmp8_ = _tmp7_;
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_g_free0 (_tmp5_);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		_inner_error0_ = _tmp8_;
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
		if (_inner_error0_->domain == GAMES_CUE_SHEET_ERROR) {
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
			g_propagate_error (error, _inner_error0_);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 1993 "cue-sheet.c"
		} else {
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/utils/cue-sheet/cue-sheet.vala"
			return;
#line 2001 "cue-sheet.c"
		}
	}
#line 173 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp9_ = *i;
#line 173 "../src/utils/cue-sheet/cue-sheet.vala"
	*i = _tmp9_ + 1;
#line 2008 "cue-sheet.c"
}

GFile*
games_cue_sheet_get_file (GamesCueSheet* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 8 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = self->priv->_file;
#line 8 "../src/utils/cue-sheet/cue-sheet.vala"
	result = _tmp0_;
#line 8 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 2024 "cue-sheet.c"
}

guint
games_cue_sheet_get_tracks_number (GamesCueSheet* self)
{
	guint result;
	GamesCueSheetTrackNode** _tmp0_;
	gint _tmp0__length1;
#line 12 "../src/utils/cue-sheet/cue-sheet.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 12 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0_ = self->priv->tracks;
#line 12 "../src/utils/cue-sheet/cue-sheet.vala"
	_tmp0__length1 = self->priv->tracks_length1;
#line 12 "../src/utils/cue-sheet/cue-sheet.vala"
	result = (guint) _tmp0__length1;
#line 12 "../src/utils/cue-sheet/cue-sheet.vala"
	return result;
#line 2043 "cue-sheet.c"
}

static void
games_cue_sheet_class_init (GamesCueSheetClass * klass,
                            gpointer klass_data)
{
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	games_cue_sheet_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	g_type_class_adjust_private_offset (klass, &GamesCueSheet_private_offset);
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_cue_sheet_get_property;
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	G_OBJECT_CLASS (klass)->finalize = games_cue_sheet_finalize;
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_CUE_SHEET_FILE_PROPERTY, games_cue_sheet_properties[GAMES_CUE_SHEET_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_CUE_SHEET_TRACKS_NUMBER_PROPERTY, games_cue_sheet_properties[GAMES_CUE_SHEET_TRACKS_NUMBER_PROPERTY] = g_param_spec_uint ("tracks-number", "tracks-number", "tracks-number", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2062 "cue-sheet.c"
}

static void
games_cue_sheet_instance_init (GamesCueSheet * self,
                               gpointer klass)
{
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	self->priv = games_cue_sheet_get_instance_private (self);
#line 2071 "cue-sheet.c"
}

static void
games_cue_sheet_finalize (GObject * obj)
{
	GamesCueSheet * self;
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_CUE_SHEET, GamesCueSheet);
#line 6 "../src/utils/cue-sheet/cue-sheet.vala"
	_g_object_unref0 (self->priv->_file);
#line 15 "../src/utils/cue-sheet/cue-sheet.vala"
	self->priv->tracks = (_vala_array_free (self->priv->tracks, self->priv->tracks_length1, (GDestroyNotify) g_object_unref), NULL);
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	G_OBJECT_CLASS (games_cue_sheet_parent_class)->finalize (obj);
#line 2086 "cue-sheet.c"
}

static GType
games_cue_sheet_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesCueSheetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_cue_sheet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesCueSheet), 0, (GInstanceInitFunc) games_cue_sheet_instance_init, NULL };
	GType games_cue_sheet_type_id;
	games_cue_sheet_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesCueSheet", &g_define_type_info, 0);
	GamesCueSheet_private_offset = g_type_add_instance_private (games_cue_sheet_type_id, sizeof (GamesCueSheetPrivate));
	return games_cue_sheet_type_id;
}

GType
games_cue_sheet_get_type (void)
{
	static volatile gsize games_cue_sheet_type_id__once = 0;
	if (g_once_init_enter (&games_cue_sheet_type_id__once)) {
		GType games_cue_sheet_type_id;
		games_cue_sheet_type_id = games_cue_sheet_get_type_once ();
		g_once_init_leave (&games_cue_sheet_type_id__once, games_cue_sheet_type_id);
	}
	return games_cue_sheet_type_id__once;
}

static void
_vala_games_cue_sheet_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GamesCueSheet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_CUE_SHEET, GamesCueSheet);
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
	switch (property_id) {
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		case GAMES_CUE_SHEET_FILE_PROPERTY:
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		g_value_set_object (value, games_cue_sheet_get_file (self));
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		break;
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		case GAMES_CUE_SHEET_TRACKS_NUMBER_PROPERTY:
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		g_value_set_uint (value, games_cue_sheet_get_tracks_number (self));
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		break;
#line 2133 "cue-sheet.c"
		default:
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/utils/cue-sheet/cue-sheet.vala"
		break;
#line 2139 "cue-sheet.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2150 "cue-sheet.c"
		gssize i;
#line 3 "../src/core/snapshot.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 3 "../src/core/snapshot.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 3 "../src/core/snapshot.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2158 "cue-sheet.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 3 "../src/core/snapshot.vala"
	g_free (array);
#line 2173 "cue-sheet.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 3 "../src/core/snapshot.vala"
	if (array) {
#line 3 "../src/core/snapshot.vala"
		while (((gpointer*) array)[length]) {
#line 3 "../src/core/snapshot.vala"
			length++;
#line 2187 "cue-sheet.c"
		}
	}
#line 3 "../src/core/snapshot.vala"
	return length;
#line 2192 "cue-sheet.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 2206 "cue-sheet.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 2210 "cue-sheet.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 2214 "cue-sheet.c"
}

