/* file-operations.c generated by valac 0.56.3, the Vala compiler
 * generated from file-operations.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <archive.h>
#include <glib/gi18n-lib.h>
#include <archive_entry.h>
#include <time.h>
#include <sys/stat.h>
#include <gobject/gvaluecollector.h>

#define _archive_write_free0(var) ((var == NULL) ? NULL : (var = (archive_write_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _archive_entry_free0(var) ((var == NULL) ? NULL : (var = (archive_entry_free (var), NULL)))
#define _archive_read_free0(var) ((var == NULL) ? NULL : (var = (archive_read_free (var), NULL)))
typedef struct _GamesParamSpecFileOperations GamesParamSpecFileOperations;

struct _GamesParamSpecFileOperations {
	GParamSpec parent_instance;
};

static gpointer games_file_operations_parent_class = NULL;

static void games_file_operations_backup_data (GFile* parent,
                                        GFile* dir,
                                        struct archive* archive,
                                        gchar** exclusions,
                                        gint exclusions_length1,
                                        GError** error);
static void games_file_operations_compress_files (GFile* parent_working_dir,
                                           GFile* export_dir,
                                           struct archive* export_archive,
                                           GError** error);
static guint8* _vala_array_dup32 (guint8* self,
                           gssize length);
static void games_file_operations_copy_recursively (GFile* src,
                                             GFile* dest,
                                             gboolean merge_flag,
                                             GError** error);
static void games_file_operations_finalize (GamesFileOperations * obj);
static GType games_file_operations_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
games_compression_error_quark (void)
{
#line 3 "../src/core/snapshot.vala"
	return g_quark_from_static_string ("games-compression-error-quark");
#line 60 "file-operations.c"
}

static GType
games_compression_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GAMES_COMPRESSION_ERROR_CLOSING_FAILED, "GAMES_COMPRESSION_ERROR_CLOSING_FAILED", "closing-failed"}, {GAMES_COMPRESSION_ERROR_COULDNT_ENUMERATE_CHILDREN, "GAMES_COMPRESSION_ERROR_COULDNT_ENUMERATE_CHILDREN", "couldnt-enumerate-children"}, {GAMES_COMPRESSION_ERROR_COULDNT_READ_FILE, "GAMES_COMPRESSION_ERROR_COULDNT_READ_FILE", "couldnt-read-file"}, {GAMES_COMPRESSION_ERROR_COULDNT_WRITE_HEADER, "GAMES_COMPRESSION_ERROR_COULDNT_WRITE_HEADER", "couldnt-write-header"}, {GAMES_COMPRESSION_ERROR_COULDNT_WRITE_FILE, "GAMES_COMPRESSION_ERROR_COULDNT_WRITE_FILE", "couldnt-write-file"}, {GAMES_COMPRESSION_ERROR_INITIALIZATION_FAILED, "GAMES_COMPRESSION_ERROR_INITIALIZATION_FAILED", "initialization-failed"}, {0, NULL, NULL}};
	GType games_compression_error_type_id;
	games_compression_error_type_id = g_enum_register_static ("GamesCompressionError", values);
	return games_compression_error_type_id;
}

GType
games_compression_error_get_type (void)
{
	static volatile gsize games_compression_error_type_id__once = 0;
	if (g_once_init_enter (&games_compression_error_type_id__once)) {
		GType games_compression_error_type_id;
		games_compression_error_type_id = games_compression_error_get_type_once ();
		g_once_init_leave (&games_compression_error_type_id__once, games_compression_error_type_id);
	}
	return games_compression_error_type_id__once;
}

GQuark
games_extraction_error_quark (void)
{
#line 3 "../src/core/snapshot.vala"
	return g_quark_from_static_string ("games-extraction-error-quark");
#line 89 "file-operations.c"
}

static GType
games_extraction_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GAMES_EXTRACTION_ERROR_CLEANUP_FAILED, "GAMES_EXTRACTION_ERROR_CLEANUP_FAILED", "cleanup-failed"}, {GAMES_EXTRACTION_ERROR_COULDNT_READ_HEADER, "GAMES_EXTRACTION_ERROR_COULDNT_READ_HEADER", "couldnt-read-header"}, {GAMES_EXTRACTION_ERROR_DIDNT_REACH_EOF, "GAMES_EXTRACTION_ERROR_DIDNT_REACH_EOF", "didnt-reach-eof"}, {0, NULL, NULL}};
	GType games_extraction_error_type_id;
	games_extraction_error_type_id = g_enum_register_static ("GamesExtractionError", values);
	return games_extraction_error_type_id;
}

GType
games_extraction_error_get_type (void)
{
	static volatile gsize games_extraction_error_type_id__once = 0;
	if (g_once_init_enter (&games_extraction_error_type_id__once)) {
		GType games_extraction_error_type_id;
		games_extraction_error_type_id = games_extraction_error_get_type_once ();
		g_once_init_leave (&games_extraction_error_type_id__once, games_extraction_error_type_id);
	}
	return games_extraction_error_type_id__once;
}

void
games_file_operations_compress_dir (const gchar* archive_path,
                                    GFile* exported_data,
                                    gchar** exclude_files,
                                    gint exclude_files_length1,
                                    GError** error)
{
	struct archive* archive = NULL;
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	struct archive* _tmp2_;
	struct archive* _tmp3_;
	struct archive* _tmp4_;
	struct archive* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 19 "../src/utils/file-operations.vala"
	g_return_if_fail (archive_path != NULL);
#line 19 "../src/utils/file-operations.vala"
	g_return_if_fail (exported_data != NULL);
#line 20 "../src/utils/file-operations.vala"
	_tmp0_ = archive_write_new ();
#line 20 "../src/utils/file-operations.vala"
	archive = _tmp0_;
#line 21 "../src/utils/file-operations.vala"
	_tmp1_ = archive;
#line 21 "../src/utils/file-operations.vala"
	archive_write_add_filter_gzip (_tmp1_);
#line 22 "../src/utils/file-operations.vala"
	_tmp2_ = archive;
#line 22 "../src/utils/file-operations.vala"
	archive_write_set_format_pax_restricted (_tmp2_);
#line 23 "../src/utils/file-operations.vala"
	_tmp3_ = archive;
#line 23 "../src/utils/file-operations.vala"
	archive_write_open_filename (_tmp3_, archive_path);
#line 25 "../src/utils/file-operations.vala"
	_tmp4_ = archive;
#line 25 "../src/utils/file-operations.vala"
	games_file_operations_backup_data (exported_data, exported_data, _tmp4_, exclude_files, (gint) exclude_files_length1, &_inner_error0_);
#line 25 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 25 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 25 "../src/utils/file-operations.vala"
			_archive_write_free0 (archive);
#line 25 "../src/utils/file-operations.vala"
			return;
#line 162 "file-operations.c"
		} else {
#line 25 "../src/utils/file-operations.vala"
			_archive_write_free0 (archive);
#line 25 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 25 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 25 "../src/utils/file-operations.vala"
			return;
#line 172 "file-operations.c"
		}
	}
#line 26 "../src/utils/file-operations.vala"
	_tmp5_ = archive;
#line 26 "../src/utils/file-operations.vala"
	if (archive_write_close (_tmp5_) != ARCHIVE_OK) {
#line 179 "file-operations.c"
		gchar* error_message = NULL;
		struct archive* _tmp6_;
		const gchar* _tmp7_;
		struct archive* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
#line 27 "../src/utils/file-operations.vala"
		_tmp6_ = archive;
#line 27 "../src/utils/file-operations.vala"
		_tmp7_ = archive_error_string (_tmp6_);
#line 27 "../src/utils/file-operations.vala"
		_tmp8_ = archive;
#line 27 "../src/utils/file-operations.vala"
		_tmp9_ = g_strdup_printf (_ ("Error: %s (%d)"), _tmp7_, archive_errno (_tmp8_));
#line 27 "../src/utils/file-operations.vala"
		error_message = _tmp9_;
#line 28 "../src/utils/file-operations.vala"
		_tmp10_ = error_message;
#line 28 "../src/utils/file-operations.vala"
		_tmp11_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_CLOSING_FAILED, _tmp10_);
#line 28 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp11_;
#line 28 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 28 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 28 "../src/utils/file-operations.vala"
			_g_free0 (error_message);
#line 28 "../src/utils/file-operations.vala"
			_archive_write_free0 (archive);
#line 28 "../src/utils/file-operations.vala"
			return;
#line 213 "file-operations.c"
		} else {
#line 28 "../src/utils/file-operations.vala"
			_g_free0 (error_message);
#line 28 "../src/utils/file-operations.vala"
			_archive_write_free0 (archive);
#line 28 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 28 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 28 "../src/utils/file-operations.vala"
			return;
#line 225 "file-operations.c"
		}
#line 26 "../src/utils/file-operations.vala"
		_g_free0 (error_message);
#line 229 "file-operations.c"
	}
#line 19 "../src/utils/file-operations.vala"
	_archive_write_free0 (archive);
#line 233 "file-operations.c"
}

static void
games_file_operations_backup_data (GFile* parent,
                                   GFile* dir,
                                   struct archive* archive,
                                   gchar** exclusions,
                                   gint exclusions_length1,
                                   GError** error)
{
	GFileType dtype = 0;
	GError* _inner_error0_ = NULL;
#line 32 "../src/utils/file-operations.vala"
	g_return_if_fail (parent != NULL);
#line 32 "../src/utils/file-operations.vala"
	g_return_if_fail (dir != NULL);
#line 32 "../src/utils/file-operations.vala"
	g_return_if_fail (archive != NULL);
#line 33 "../src/utils/file-operations.vala"
	dtype = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 254 "file-operations.c"
	{
		gchar** filename_collection = NULL;
		gint filename_collection_length1 = 0;
		gint _filename_collection_size_ = 0;
		gint filename_it = 0;
#line 35 "../src/utils/file-operations.vala"
		filename_collection = exclusions;
#line 35 "../src/utils/file-operations.vala"
		filename_collection_length1 = exclusions_length1;
#line 35 "../src/utils/file-operations.vala"
		for (filename_it = 0; filename_it < filename_collection_length1; filename_it = filename_it + 1) {
#line 266 "file-operations.c"
			gchar* _tmp0_;
			gchar* filename = NULL;
#line 35 "../src/utils/file-operations.vala"
			_tmp0_ = g_strdup (filename_collection[filename_it]);
#line 35 "../src/utils/file-operations.vala"
			filename = _tmp0_;
#line 273 "file-operations.c"
			{
				gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
				gboolean _tmp4_;
#line 36 "../src/utils/file-operations.vala"
				_tmp1_ = g_file_get_parse_name (dir);
#line 36 "../src/utils/file-operations.vala"
				_tmp2_ = _tmp1_;
#line 36 "../src/utils/file-operations.vala"
				_tmp3_ = filename;
#line 36 "../src/utils/file-operations.vala"
				_tmp4_ = g_strcmp0 (_tmp2_, _tmp3_) == 0;
#line 36 "../src/utils/file-operations.vala"
				_g_free0 (_tmp2_);
#line 36 "../src/utils/file-operations.vala"
				if (_tmp4_) {
#line 37 "../src/utils/file-operations.vala"
					_g_free0 (filename);
#line 37 "../src/utils/file-operations.vala"
					return;
#line 295 "file-operations.c"
				}
#line 35 "../src/utils/file-operations.vala"
				_g_free0 (filename);
#line 299 "file-operations.c"
			}
		}
	}
#line 39 "../src/utils/file-operations.vala"
	if (dir != parent) {
#line 40 "../src/utils/file-operations.vala"
		games_file_operations_compress_files (parent, dir, archive, &_inner_error0_);
#line 40 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../src/utils/file-operations.vala"
			if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 40 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 40 "../src/utils/file-operations.vala"
				return;
#line 315 "file-operations.c"
			} else {
#line 40 "../src/utils/file-operations.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "../src/utils/file-operations.vala"
				g_clear_error (&_inner_error0_);
#line 40 "../src/utils/file-operations.vala"
				return;
#line 323 "file-operations.c"
			}
		}
	}
#line 42 "../src/utils/file-operations.vala"
	if (dtype == G_FILE_TYPE_DIRECTORY) {
#line 329 "file-operations.c"
		{
			GFileEnumerator* dir_children = NULL;
			GFileEnumerator* _tmp5_;
			GFileInfo* dir_info = NULL;
#line 44 "../src/utils/file-operations.vala"
			_tmp5_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error0_);
#line 44 "../src/utils/file-operations.vala"
			dir_children = _tmp5_;
#line 44 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 340 "file-operations.c"
				goto __catch0_g_error;
			}
#line 46 "../src/utils/file-operations.vala"
			while (TRUE) {
#line 345 "file-operations.c"
				GFileInfo* _tmp6_ = NULL;
				GFileEnumerator* _tmp7_;
				GFileInfo* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFile* file = NULL;
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
#line 46 "../src/utils/file-operations.vala"
				_tmp7_ = dir_children;
#line 46 "../src/utils/file-operations.vala"
				_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
#line 46 "../src/utils/file-operations.vala"
				_tmp6_ = _tmp8_;
#line 46 "../src/utils/file-operations.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/utils/file-operations.vala"
					_g_object_unref0 (dir_info);
#line 46 "../src/utils/file-operations.vala"
					_g_object_unref0 (dir_children);
#line 368 "file-operations.c"
					goto __catch0_g_error;
				}
#line 46 "../src/utils/file-operations.vala"
				_tmp9_ = _tmp6_;
#line 46 "../src/utils/file-operations.vala"
				_tmp6_ = NULL;
#line 46 "../src/utils/file-operations.vala"
				_g_object_unref0 (dir_info);
#line 46 "../src/utils/file-operations.vala"
				dir_info = _tmp9_;
#line 46 "../src/utils/file-operations.vala"
				_tmp10_ = dir_info;
#line 46 "../src/utils/file-operations.vala"
				if (!(_tmp10_ != NULL)) {
#line 46 "../src/utils/file-operations.vala"
					_g_object_unref0 (_tmp6_);
#line 46 "../src/utils/file-operations.vala"
					break;
#line 387 "file-operations.c"
				}
#line 47 "../src/utils/file-operations.vala"
				_tmp11_ = dir_info;
#line 47 "../src/utils/file-operations.vala"
				_tmp12_ = g_file_info_get_name (_tmp11_);
#line 47 "../src/utils/file-operations.vala"
				_tmp13_ = g_file_get_child (dir, _tmp12_);
#line 47 "../src/utils/file-operations.vala"
				file = _tmp13_;
#line 48 "../src/utils/file-operations.vala"
				_tmp14_ = file;
#line 48 "../src/utils/file-operations.vala"
				games_file_operations_backup_data (parent, _tmp14_, archive, exclusions, (gint) exclusions_length1, &_inner_error0_);
#line 48 "../src/utils/file-operations.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/utils/file-operations.vala"
					_g_object_unref0 (file);
#line 48 "../src/utils/file-operations.vala"
					_g_object_unref0 (_tmp6_);
#line 48 "../src/utils/file-operations.vala"
					_g_object_unref0 (dir_info);
#line 48 "../src/utils/file-operations.vala"
					_g_object_unref0 (dir_children);
#line 411 "file-operations.c"
					goto __catch0_g_error;
				}
#line 46 "../src/utils/file-operations.vala"
				_g_object_unref0 (file);
#line 46 "../src/utils/file-operations.vala"
				_g_object_unref0 (_tmp6_);
#line 418 "file-operations.c"
			}
#line 43 "../src/utils/file-operations.vala"
			_g_object_unref0 (dir_info);
#line 43 "../src/utils/file-operations.vala"
			_g_object_unref0 (dir_children);
#line 424 "file-operations.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
			GError* _tmp17_;
#line 43 "../src/utils/file-operations.vala"
			e = _inner_error0_;
#line 43 "../src/utils/file-operations.vala"
			_inner_error0_ = NULL;
#line 52 "../src/utils/file-operations.vala"
			_tmp15_ = e;
#line 52 "../src/utils/file-operations.vala"
			_tmp16_ = _tmp15_->message;
#line 52 "../src/utils/file-operations.vala"
			_tmp17_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_COULDNT_ENUMERATE_CHILDREN, _tmp16_);
#line 52 "../src/utils/file-operations.vala"
			_inner_error0_ = _tmp17_;
#line 52 "../src/utils/file-operations.vala"
			_g_error_free0 (e);
#line 447 "file-operations.c"
			goto __finally0;
		}
		__finally0:
#line 43 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/utils/file-operations.vala"
			if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 43 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 43 "../src/utils/file-operations.vala"
				return;
#line 459 "file-operations.c"
			} else {
#line 43 "../src/utils/file-operations.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/utils/file-operations.vala"
				g_clear_error (&_inner_error0_);
#line 43 "../src/utils/file-operations.vala"
				return;
#line 467 "file-operations.c"
			}
		}
	}
}

static void
games_file_operations_compress_files (GFile* parent_working_dir,
                                      GFile* export_dir,
                                      struct archive* export_archive,
                                      GError** error)
{
	GFileInfo* export_info = NULL;
	GFileType file_type = 0;
	struct archive_entry* entry = NULL;
	struct archive_entry* _tmp7_;
	GDateTime* datetime = NULL;
	GFileInfo* _tmp8_;
	GDateTime* _tmp9_;
	struct archive_entry* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	struct archive_entry* _tmp13_;
	GFileInfo* _tmp14_;
	struct archive_entry* _tmp15_;
	GDateTime* _tmp16_;
	struct archive_entry* _tmp17_;
	GFileInfo* _tmp18_;
	struct archive_entry* _tmp21_;
	struct archive_entry* _tmp29_;
	GDataInputStream* data_input_stream = NULL;
	gsize bytes_read = 0UL;
	guint8* buffer = NULL;
	guint8* _tmp36_;
	gint buffer_length1;
	gint _buffer_size_;
	GError* _inner_error0_ = NULL;
#line 57 "../src/utils/file-operations.vala"
	g_return_if_fail (parent_working_dir != NULL);
#line 57 "../src/utils/file-operations.vala"
	g_return_if_fail (export_dir != NULL);
#line 57 "../src/utils/file-operations.vala"
	g_return_if_fail (export_archive != NULL);
#line 510 "file-operations.c"
	{
		gchar* attributes = NULL;
		gchar* _tmp0_;
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 61 "../src/utils/file-operations.vala"
		_tmp0_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_ATTRIBUTE_UNIX_MODE);
#line 61 "../src/utils/file-operations.vala"
		attributes = _tmp0_;
#line 64 "../src/utils/file-operations.vala"
		_tmp2_ = g_file_query_info (export_dir, attributes, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 64 "../src/utils/file-operations.vala"
		_tmp1_ = _tmp2_;
#line 64 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/utils/file-operations.vala"
			_g_free0 (attributes);
#line 529 "file-operations.c"
			goto __catch0_g_error;
		}
#line 64 "../src/utils/file-operations.vala"
		_tmp3_ = _tmp1_;
#line 64 "../src/utils/file-operations.vala"
		_tmp1_ = NULL;
#line 64 "../src/utils/file-operations.vala"
		_g_object_unref0 (export_info);
#line 64 "../src/utils/file-operations.vala"
		export_info = _tmp3_;
#line 60 "../src/utils/file-operations.vala"
		_g_object_unref0 (_tmp1_);
#line 60 "../src/utils/file-operations.vala"
		_g_free0 (attributes);
#line 544 "file-operations.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
#line 60 "../src/utils/file-operations.vala"
		e = _inner_error0_;
#line 60 "../src/utils/file-operations.vala"
		_inner_error0_ = NULL;
#line 67 "../src/utils/file-operations.vala"
		_tmp4_ = e;
#line 67 "../src/utils/file-operations.vala"
		_tmp5_ = _tmp4_->message;
#line 67 "../src/utils/file-operations.vala"
		_tmp6_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_INITIALIZATION_FAILED, _tmp5_);
#line 67 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp6_;
#line 67 "../src/utils/file-operations.vala"
		_g_error_free0 (e);
#line 567 "file-operations.c"
		goto __finally0;
	}
	__finally0:
#line 60 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 60 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 60 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 60 "../src/utils/file-operations.vala"
			return;
#line 581 "file-operations.c"
		} else {
#line 60 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 60 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 60 "../src/utils/file-operations.vala"
			return;
#line 591 "file-operations.c"
		}
	}
#line 70 "../src/utils/file-operations.vala"
	file_type = g_file_query_file_type (export_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 72 "../src/utils/file-operations.vala"
	_tmp7_ = archive_entry_new2 (NULL);
#line 72 "../src/utils/file-operations.vala"
	entry = _tmp7_;
#line 73 "../src/utils/file-operations.vala"
	_tmp8_ = export_info;
#line 73 "../src/utils/file-operations.vala"
	_tmp9_ = g_file_info_get_modification_date_time (_tmp8_);
#line 73 "../src/utils/file-operations.vala"
	datetime = _tmp9_;
#line 74 "../src/utils/file-operations.vala"
	_tmp10_ = entry;
#line 74 "../src/utils/file-operations.vala"
	_tmp11_ = g_file_get_relative_path (parent_working_dir, export_dir);
#line 74 "../src/utils/file-operations.vala"
	_tmp12_ = _tmp11_;
#line 74 "../src/utils/file-operations.vala"
	archive_entry_set_pathname (_tmp10_, _tmp12_);
#line 74 "../src/utils/file-operations.vala"
	_g_free0 (_tmp12_);
#line 75 "../src/utils/file-operations.vala"
	_tmp13_ = entry;
#line 75 "../src/utils/file-operations.vala"
	_tmp14_ = export_info;
#line 75 "../src/utils/file-operations.vala"
	archive_entry_set_size (_tmp13_, (la_int64_t) g_file_info_get_size (_tmp14_));
#line 76 "../src/utils/file-operations.vala"
	_tmp15_ = entry;
#line 76 "../src/utils/file-operations.vala"
	_tmp16_ = datetime;
#line 76 "../src/utils/file-operations.vala"
	archive_entry_set_mtime (_tmp15_, (time_t) g_date_time_to_unix (_tmp16_), (glong) 0);
#line 77 "../src/utils/file-operations.vala"
	_tmp17_ = entry;
#line 77 "../src/utils/file-operations.vala"
	_tmp18_ = export_info;
#line 77 "../src/utils/file-operations.vala"
	archive_entry_set_perm (_tmp17_, (__LA_MODE_T) g_file_info_get_attribute_uint32 (_tmp18_, G_FILE_ATTRIBUTE_UNIX_MODE));
#line 79 "../src/utils/file-operations.vala"
	if (file_type == G_FILE_TYPE_DIRECTORY) {
#line 636 "file-operations.c"
		struct archive_entry* _tmp19_;
#line 80 "../src/utils/file-operations.vala"
		_tmp19_ = entry;
#line 80 "../src/utils/file-operations.vala"
		archive_entry_set_filetype (_tmp19_, (__LA_MODE_T) S_IFDIR);
#line 642 "file-operations.c"
	} else {
		struct archive_entry* _tmp20_;
#line 82 "../src/utils/file-operations.vala"
		_tmp20_ = entry;
#line 82 "../src/utils/file-operations.vala"
		archive_entry_set_filetype (_tmp20_, (__LA_MODE_T) S_IFREG);
#line 649 "file-operations.c"
	}
#line 84 "../src/utils/file-operations.vala"
	_tmp21_ = entry;
#line 84 "../src/utils/file-operations.vala"
	if (archive_write_header (export_archive, _tmp21_) != ARCHIVE_OK) {
#line 655 "file-operations.c"
		gchar* error_msg = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		GError* _tmp28_;
#line 85 "../src/utils/file-operations.vala"
		_tmp22_ = g_file_get_path (export_dir);
#line 85 "../src/utils/file-operations.vala"
		_tmp23_ = _tmp22_;
#line 85 "../src/utils/file-operations.vala"
		_tmp24_ = archive_error_string (export_archive);
#line 85 "../src/utils/file-operations.vala"
		_tmp25_ = g_strdup_printf (_ ("Error writing “%s”: %s (%d)"), _tmp23_, _tmp24_, archive_errno (export_archive));
#line 85 "../src/utils/file-operations.vala"
		_tmp26_ = _tmp25_;
#line 85 "../src/utils/file-operations.vala"
		_g_free0 (_tmp23_);
#line 85 "../src/utils/file-operations.vala"
		error_msg = _tmp26_;
#line 86 "../src/utils/file-operations.vala"
		_tmp27_ = error_msg;
#line 86 "../src/utils/file-operations.vala"
		_tmp28_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_COULDNT_WRITE_HEADER, _tmp27_);
#line 86 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp28_;
#line 86 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 86 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/utils/file-operations.vala"
			_g_free0 (error_msg);
#line 86 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 86 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 86 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 86 "../src/utils/file-operations.vala"
			return;
#line 698 "file-operations.c"
		} else {
#line 86 "../src/utils/file-operations.vala"
			_g_free0 (error_msg);
#line 86 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 86 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 86 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 86 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 86 "../src/utils/file-operations.vala"
			return;
#line 714 "file-operations.c"
		}
#line 84 "../src/utils/file-operations.vala"
		_g_free0 (error_msg);
#line 718 "file-operations.c"
	}
#line 89 "../src/utils/file-operations.vala"
	_tmp29_ = entry;
#line 89 "../src/utils/file-operations.vala"
	if (archive_entry_size (_tmp29_) <= ((la_int64_t) 0)) {
#line 90 "../src/utils/file-operations.vala"
		_g_date_time_unref0 (datetime);
#line 90 "../src/utils/file-operations.vala"
		_archive_entry_free0 (entry);
#line 90 "../src/utils/file-operations.vala"
		_g_object_unref0 (export_info);
#line 90 "../src/utils/file-operations.vala"
		return;
#line 732 "file-operations.c"
	}
	{
		GFileInputStream* input_stream = NULL;
		GFileInputStream* _tmp30_;
		GFileInputStream* _tmp31_;
		GDataInputStream* _tmp32_;
#line 94 "../src/utils/file-operations.vala"
		_tmp30_ = g_file_read (export_dir, NULL, &_inner_error0_);
#line 94 "../src/utils/file-operations.vala"
		input_stream = _tmp30_;
#line 94 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "file-operations.c"
			goto __catch1_g_error;
		}
#line 95 "../src/utils/file-operations.vala"
		_tmp31_ = input_stream;
#line 95 "../src/utils/file-operations.vala"
		_tmp32_ = g_data_input_stream_new ((GInputStream*) _tmp31_);
#line 95 "../src/utils/file-operations.vala"
		_g_object_unref0 (data_input_stream);
#line 95 "../src/utils/file-operations.vala"
		data_input_stream = _tmp32_;
#line 93 "../src/utils/file-operations.vala"
		_g_object_unref0 (input_stream);
#line 758 "file-operations.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
		GError* _tmp35_;
#line 93 "../src/utils/file-operations.vala"
		e = _inner_error0_;
#line 93 "../src/utils/file-operations.vala"
		_inner_error0_ = NULL;
#line 98 "../src/utils/file-operations.vala"
		_tmp33_ = e;
#line 98 "../src/utils/file-operations.vala"
		_tmp34_ = _tmp33_->message;
#line 98 "../src/utils/file-operations.vala"
		_tmp35_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_COULDNT_READ_FILE, _tmp34_);
#line 98 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp35_;
#line 98 "../src/utils/file-operations.vala"
		_g_error_free0 (e);
#line 781 "file-operations.c"
		goto __finally1;
	}
	__finally1:
#line 93 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 93 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 93 "../src/utils/file-operations.vala"
			_g_object_unref0 (data_input_stream);
#line 93 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 93 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 93 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 93 "../src/utils/file-operations.vala"
			return;
#line 801 "file-operations.c"
		} else {
#line 93 "../src/utils/file-operations.vala"
			_g_object_unref0 (data_input_stream);
#line 93 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 93 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 93 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 93 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 93 "../src/utils/file-operations.vala"
			return;
#line 817 "file-operations.c"
		}
	}
#line 102 "../src/utils/file-operations.vala"
	_tmp36_ = g_new0 (guint8, 64);
#line 102 "../src/utils/file-operations.vala"
	buffer = _tmp36_;
#line 102 "../src/utils/file-operations.vala"
	buffer_length1 = 64;
#line 102 "../src/utils/file-operations.vala"
	_buffer_size_ = buffer_length1;
#line 828 "file-operations.c"
	{
#line 104 "../src/utils/file-operations.vala"
		while (TRUE) {
#line 832 "file-operations.c"
			gboolean _tmp37_ = FALSE;
			GDataInputStream* _tmp38_;
			guint8* _tmp39_;
			gint _tmp39__length1;
			gsize _tmp40_ = 0UL;
			gboolean _tmp41_;
			guint8* _tmp42_;
			gint _tmp42__length1;
#line 104 "../src/utils/file-operations.vala"
			_tmp38_ = data_input_stream;
#line 104 "../src/utils/file-operations.vala"
			_tmp39_ = buffer;
#line 104 "../src/utils/file-operations.vala"
			_tmp39__length1 = buffer_length1;
#line 104 "../src/utils/file-operations.vala"
			_tmp41_ = g_input_stream_read_all ((GInputStream*) _tmp38_, _tmp39_, (gsize) _tmp39__length1, &_tmp40_, NULL, &_inner_error0_);
#line 104 "../src/utils/file-operations.vala"
			bytes_read = _tmp40_;
#line 104 "../src/utils/file-operations.vala"
			_tmp37_ = _tmp41_;
#line 104 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 855 "file-operations.c"
				goto __catch2_g_error;
			}
#line 104 "../src/utils/file-operations.vala"
			if (!_tmp37_) {
#line 104 "../src/utils/file-operations.vala"
				break;
#line 862 "file-operations.c"
			}
#line 105 "../src/utils/file-operations.vala"
			if (bytes_read <= ((gsize) 0)) {
#line 106 "../src/utils/file-operations.vala"
				break;
#line 868 "file-operations.c"
			}
#line 108 "../src/utils/file-operations.vala"
			_tmp42_ = buffer;
#line 108 "../src/utils/file-operations.vala"
			_tmp42__length1 = buffer_length1;
#line 108 "../src/utils/file-operations.vala"
			archive_write_data (export_archive, _tmp42_, (size_t) _tmp42__length1);
#line 876 "file-operations.c"
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
		GError* _tmp45_;
#line 103 "../src/utils/file-operations.vala"
		e = _inner_error0_;
#line 103 "../src/utils/file-operations.vala"
		_inner_error0_ = NULL;
#line 112 "../src/utils/file-operations.vala"
		_tmp43_ = e;
#line 112 "../src/utils/file-operations.vala"
		_tmp44_ = _tmp43_->message;
#line 112 "../src/utils/file-operations.vala"
		_tmp45_ = g_error_new_literal (GAMES_COMPRESSION_ERROR, GAMES_COMPRESSION_ERROR_COULDNT_WRITE_FILE, _tmp44_);
#line 112 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp45_;
#line 112 "../src/utils/file-operations.vala"
		_g_error_free0 (e);
#line 900 "file-operations.c"
		goto __finally2;
	}
	__finally2:
#line 103 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_COMPRESSION_ERROR) {
#line 103 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 103 "../src/utils/file-operations.vala"
			buffer = (g_free (buffer), NULL);
#line 103 "../src/utils/file-operations.vala"
			_g_object_unref0 (data_input_stream);
#line 103 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 103 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 103 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 103 "../src/utils/file-operations.vala"
			return;
#line 922 "file-operations.c"
		} else {
#line 103 "../src/utils/file-operations.vala"
			buffer = (g_free (buffer), NULL);
#line 103 "../src/utils/file-operations.vala"
			_g_object_unref0 (data_input_stream);
#line 103 "../src/utils/file-operations.vala"
			_g_date_time_unref0 (datetime);
#line 103 "../src/utils/file-operations.vala"
			_archive_entry_free0 (entry);
#line 103 "../src/utils/file-operations.vala"
			_g_object_unref0 (export_info);
#line 103 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 103 "../src/utils/file-operations.vala"
			return;
#line 940 "file-operations.c"
		}
	}
#line 57 "../src/utils/file-operations.vala"
	buffer = (g_free (buffer), NULL);
#line 57 "../src/utils/file-operations.vala"
	_g_object_unref0 (data_input_stream);
#line 57 "../src/utils/file-operations.vala"
	_g_date_time_unref0 (datetime);
#line 57 "../src/utils/file-operations.vala"
	_archive_entry_free0 (entry);
#line 57 "../src/utils/file-operations.vala"
	_g_object_unref0 (export_info);
#line 953 "file-operations.c"
}

void
games_file_operations_delete_files (GFile* file,
                                    gchar** excluded,
                                    gint excluded_length1,
                                    GError** error)
{
	GError* _inner_error0_ = NULL;
#line 116 "../src/utils/file-operations.vala"
	g_return_if_fail (file != NULL);
#line 117 "../src/utils/file-operations.vala"
	games_file_operations_delete_files_recurse (file, excluded, (gint) excluded_length1, &_inner_error0_);
#line 117 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/utils/file-operations.vala"
		g_propagate_error (error, _inner_error0_);
#line 117 "../src/utils/file-operations.vala"
		return;
#line 973 "file-operations.c"
	}
}

gboolean
games_file_operations_delete_files_recurse (GFile* file,
                                            gchar** excluded,
                                            gint excluded_length1,
                                            GError** error)
{
	gboolean has_excluded_children = FALSE;
	GFileType dtype = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 120 "../src/utils/file-operations.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 989 "file-operations.c"
	{
		gchar** filename_collection = NULL;
		gint filename_collection_length1 = 0;
		gint _filename_collection_size_ = 0;
		gint filename_it = 0;
#line 121 "../src/utils/file-operations.vala"
		filename_collection = excluded;
#line 121 "../src/utils/file-operations.vala"
		filename_collection_length1 = excluded_length1;
#line 121 "../src/utils/file-operations.vala"
		for (filename_it = 0; filename_it < filename_collection_length1; filename_it = filename_it + 1) {
#line 1001 "file-operations.c"
			gchar* _tmp0_;
			gchar* filename = NULL;
#line 121 "../src/utils/file-operations.vala"
			_tmp0_ = g_strdup (filename_collection[filename_it]);
#line 121 "../src/utils/file-operations.vala"
			filename = _tmp0_;
#line 1008 "file-operations.c"
			{
				gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
				gboolean _tmp4_;
#line 122 "../src/utils/file-operations.vala"
				_tmp1_ = g_file_get_parse_name (file);
#line 122 "../src/utils/file-operations.vala"
				_tmp2_ = _tmp1_;
#line 122 "../src/utils/file-operations.vala"
				_tmp3_ = filename;
#line 122 "../src/utils/file-operations.vala"
				_tmp4_ = g_strcmp0 (_tmp2_, _tmp3_) == 0;
#line 122 "../src/utils/file-operations.vala"
				_g_free0 (_tmp2_);
#line 122 "../src/utils/file-operations.vala"
				if (_tmp4_) {
#line 123 "../src/utils/file-operations.vala"
					result = TRUE;
#line 123 "../src/utils/file-operations.vala"
					_g_free0 (filename);
#line 123 "../src/utils/file-operations.vala"
					return result;
#line 1032 "file-operations.c"
				}
#line 121 "../src/utils/file-operations.vala"
				_g_free0 (filename);
#line 1036 "file-operations.c"
			}
		}
	}
#line 125 "../src/utils/file-operations.vala"
	has_excluded_children = FALSE;
#line 126 "../src/utils/file-operations.vala"
	dtype = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 128 "../src/utils/file-operations.vala"
	if (dtype == G_FILE_TYPE_DIRECTORY) {
#line 1046 "file-operations.c"
		GFileEnumerator* file_children = NULL;
		GFileEnumerator* _tmp5_;
		GFileInfo* file_info = NULL;
#line 129 "../src/utils/file-operations.vala"
		_tmp5_ = g_file_enumerate_children (file, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error0_);
#line 129 "../src/utils/file-operations.vala"
		file_children = _tmp5_;
#line 129 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1056 "file-operations.c"
			gboolean _tmp6_ = FALSE;
#line 129 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 129 "../src/utils/file-operations.vala"
			return _tmp6_;
#line 1062 "file-operations.c"
		}
#line 131 "../src/utils/file-operations.vala"
		while (TRUE) {
#line 1066 "file-operations.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp11_;
			GFileInfo* _tmp12_;
			GFile* child = NULL;
			GFileInfo* _tmp13_;
			const gchar* _tmp14_;
			GFile* _tmp15_;
			gboolean _tmp16_ = FALSE;
			GFile* _tmp17_;
#line 131 "../src/utils/file-operations.vala"
			_tmp8_ = file_children;
#line 131 "../src/utils/file-operations.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 131 "../src/utils/file-operations.vala"
			_tmp7_ = _tmp9_;
#line 131 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1086 "file-operations.c"
				gboolean _tmp10_ = FALSE;
#line 131 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 131 "../src/utils/file-operations.vala"
				_g_object_unref0 (file_info);
#line 131 "../src/utils/file-operations.vala"
				_g_object_unref0 (file_children);
#line 131 "../src/utils/file-operations.vala"
				return _tmp10_;
#line 1096 "file-operations.c"
			}
#line 131 "../src/utils/file-operations.vala"
			_tmp11_ = _tmp7_;
#line 131 "../src/utils/file-operations.vala"
			_tmp7_ = NULL;
#line 131 "../src/utils/file-operations.vala"
			_g_object_unref0 (file_info);
#line 131 "../src/utils/file-operations.vala"
			file_info = _tmp11_;
#line 131 "../src/utils/file-operations.vala"
			_tmp12_ = file_info;
#line 131 "../src/utils/file-operations.vala"
			if (!(_tmp12_ != NULL)) {
#line 131 "../src/utils/file-operations.vala"
				_g_object_unref0 (_tmp7_);
#line 131 "../src/utils/file-operations.vala"
				break;
#line 1114 "file-operations.c"
			}
#line 132 "../src/utils/file-operations.vala"
			_tmp13_ = file_info;
#line 132 "../src/utils/file-operations.vala"
			_tmp14_ = g_file_info_get_name (_tmp13_);
#line 132 "../src/utils/file-operations.vala"
			_tmp15_ = g_file_get_child (file, _tmp14_);
#line 132 "../src/utils/file-operations.vala"
			child = _tmp15_;
#line 133 "../src/utils/file-operations.vala"
			_tmp17_ = child;
#line 133 "../src/utils/file-operations.vala"
			_tmp16_ = games_file_operations_delete_files_recurse (_tmp17_, excluded, (gint) excluded_length1, &_inner_error0_);
#line 133 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1130 "file-operations.c"
				gboolean _tmp18_ = FALSE;
#line 133 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 133 "../src/utils/file-operations.vala"
				_g_object_unref0 (child);
#line 133 "../src/utils/file-operations.vala"
				_g_object_unref0 (_tmp7_);
#line 133 "../src/utils/file-operations.vala"
				_g_object_unref0 (file_info);
#line 133 "../src/utils/file-operations.vala"
				_g_object_unref0 (file_children);
#line 133 "../src/utils/file-operations.vala"
				return _tmp18_;
#line 1144 "file-operations.c"
			}
#line 133 "../src/utils/file-operations.vala"
			has_excluded_children |= _tmp16_;
#line 131 "../src/utils/file-operations.vala"
			_g_object_unref0 (child);
#line 131 "../src/utils/file-operations.vala"
			_g_object_unref0 (_tmp7_);
#line 1152 "file-operations.c"
		}
#line 128 "../src/utils/file-operations.vala"
		_g_object_unref0 (file_info);
#line 128 "../src/utils/file-operations.vala"
		_g_object_unref0 (file_children);
#line 1158 "file-operations.c"
	}
#line 137 "../src/utils/file-operations.vala"
	if (!has_excluded_children) {
#line 138 "../src/utils/file-operations.vala"
		g_file_delete (file, NULL, &_inner_error0_);
#line 138 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1166 "file-operations.c"
			gboolean _tmp19_ = FALSE;
#line 138 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 138 "../src/utils/file-operations.vala"
			return _tmp19_;
#line 1172 "file-operations.c"
		}
	}
#line 140 "../src/utils/file-operations.vala"
	result = FALSE;
#line 140 "../src/utils/file-operations.vala"
	return result;
#line 1179 "file-operations.c"
}

static guint8*
_vala_array_dup32 (guint8* self,
                   gssize length)
{
#line 174 "../src/utils/file-operations.vala"
	if (length > 0) {
#line 174 "../src/utils/file-operations.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1190 "file-operations.c"
	}
#line 174 "../src/utils/file-operations.vala"
	return NULL;
#line 1194 "file-operations.c"
}

void
games_file_operations_extract_archive (const gchar* archive_path,
                                       const gchar* extract_dir,
                                       gchar** exclude,
                                       gint exclude_length1,
                                       GError** error)
{
	struct archive* restore_archive = NULL;
	struct archive* _tmp4_;
	struct archive* _tmp5_;
	struct archive* _tmp6_;
	int flags = 0;
	struct archive* extractor_archive = NULL;
	struct archive* _tmp7_;
	struct archive* _tmp8_;
	struct archive* _tmp9_;
	struct archive* _tmp10_;
	struct archive_entry* entry = NULL;
	int last_result = 0;
	GError* _inner_error0_ = NULL;
#line 143 "../src/utils/file-operations.vala"
	g_return_if_fail (archive_path != NULL);
#line 143 "../src/utils/file-operations.vala"
	g_return_if_fail (extract_dir != NULL);
#line 1221 "file-operations.c"
	{
		GFile* file_dir = NULL;
		GFile* _tmp0_;
#line 145 "../src/utils/file-operations.vala"
		_tmp0_ = g_file_new_for_path (extract_dir);
#line 145 "../src/utils/file-operations.vala"
		file_dir = _tmp0_;
#line 146 "../src/utils/file-operations.vala"
		games_file_operations_delete_files (file_dir, exclude, (gint) exclude_length1, &_inner_error0_);
#line 146 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/utils/file-operations.vala"
			_g_object_unref0 (file_dir);
#line 1235 "file-operations.c"
			goto __catch0_g_error;
		}
#line 144 "../src/utils/file-operations.vala"
		_g_object_unref0 (file_dir);
#line 1240 "file-operations.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 144 "../src/utils/file-operations.vala"
		e = _inner_error0_;
#line 144 "../src/utils/file-operations.vala"
		_inner_error0_ = NULL;
#line 149 "../src/utils/file-operations.vala"
		_tmp1_ = e;
#line 149 "../src/utils/file-operations.vala"
		_tmp2_ = _tmp1_->message;
#line 149 "../src/utils/file-operations.vala"
		_tmp3_ = g_error_new_literal (GAMES_EXTRACTION_ERROR, GAMES_EXTRACTION_ERROR_CLEANUP_FAILED, _tmp2_);
#line 149 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp3_;
#line 149 "../src/utils/file-operations.vala"
		_g_error_free0 (e);
#line 1263 "file-operations.c"
		goto __finally0;
	}
	__finally0:
#line 144 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_EXTRACTION_ERROR) {
#line 144 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 144 "../src/utils/file-operations.vala"
			return;
#line 1275 "file-operations.c"
		} else {
#line 144 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 144 "../src/utils/file-operations.vala"
			return;
#line 1283 "file-operations.c"
		}
	}
#line 152 "../src/utils/file-operations.vala"
	_tmp4_ = archive_read_new ();
#line 152 "../src/utils/file-operations.vala"
	restore_archive = _tmp4_;
#line 153 "../src/utils/file-operations.vala"
	_tmp5_ = restore_archive;
#line 153 "../src/utils/file-operations.vala"
	archive_read_support_format_all (_tmp5_);
#line 154 "../src/utils/file-operations.vala"
	_tmp6_ = restore_archive;
#line 154 "../src/utils/file-operations.vala"
	archive_read_support_filter_all (_tmp6_);
#line 156 "../src/utils/file-operations.vala"
	flags = ARCHIVE_EXTRACT_TIME | ARCHIVE_EXTRACT_PERM;
#line 158 "../src/utils/file-operations.vala"
	_tmp7_ = archive_write_disk_new ();
#line 158 "../src/utils/file-operations.vala"
	extractor_archive = _tmp7_;
#line 159 "../src/utils/file-operations.vala"
	_tmp8_ = extractor_archive;
#line 159 "../src/utils/file-operations.vala"
	archive_write_disk_set_options (_tmp8_, flags);
#line 160 "../src/utils/file-operations.vala"
	_tmp9_ = extractor_archive;
#line 160 "../src/utils/file-operations.vala"
	archive_write_disk_set_standard_lookup (_tmp9_);
#line 162 "../src/utils/file-operations.vala"
	_tmp10_ = restore_archive;
#line 162 "../src/utils/file-operations.vala"
	archive_read_open_filename (_tmp10_, archive_path, (gsize) 10240);
#line 166 "../src/utils/file-operations.vala"
	while (TRUE) {
#line 1318 "file-operations.c"
		struct archive* _tmp11_;
		struct archive_entry* _tmp12_ = NULL;
		int _tmp13_;
		gchar* dir_pathname = NULL;
		struct archive_entry* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		struct archive_entry* _tmp17_;
		const gchar* _tmp18_;
		struct archive* _tmp19_;
		struct archive_entry* _tmp20_;
		guint8* buffer = NULL;
		guint8* _tmp24_;
		gint buffer_length1;
		gint _buffer_size_;
		gsize buffer_length = 0UL;
#line 166 "../src/utils/file-operations.vala"
		_tmp11_ = restore_archive;
#line 166 "../src/utils/file-operations.vala"
		_tmp13_ = archive_read_next_header (_tmp11_, &_tmp12_);
#line 166 "../src/utils/file-operations.vala"
		entry = _tmp12_;
#line 166 "../src/utils/file-operations.vala"
		last_result = _tmp13_;
#line 166 "../src/utils/file-operations.vala"
		if (!(last_result == ARCHIVE_OK)) {
#line 166 "../src/utils/file-operations.vala"
			break;
#line 1347 "file-operations.c"
		}
#line 167 "../src/utils/file-operations.vala"
		_tmp14_ = entry;
#line 167 "../src/utils/file-operations.vala"
		_tmp15_ = archive_entry_pathname (_tmp14_);
#line 167 "../src/utils/file-operations.vala"
		_tmp16_ = g_strdup_printf ("%s/%s", extract_dir, _tmp15_);
#line 167 "../src/utils/file-operations.vala"
		dir_pathname = _tmp16_;
#line 168 "../src/utils/file-operations.vala"
		_tmp17_ = entry;
#line 168 "../src/utils/file-operations.vala"
		_tmp18_ = dir_pathname;
#line 168 "../src/utils/file-operations.vala"
		archive_entry_set_pathname (_tmp17_, _tmp18_);
#line 169 "../src/utils/file-operations.vala"
		_tmp19_ = extractor_archive;
#line 169 "../src/utils/file-operations.vala"
		_tmp20_ = entry;
#line 169 "../src/utils/file-operations.vala"
		if (archive_write_header (_tmp19_, _tmp20_) != ARCHIVE_OK) {
#line 1369 "file-operations.c"
			struct archive* _tmp21_;
			const gchar* _tmp22_;
			GError* _tmp23_;
#line 170 "../src/utils/file-operations.vala"
			_tmp21_ = extractor_archive;
#line 170 "../src/utils/file-operations.vala"
			_tmp22_ = archive_error_string (_tmp21_);
#line 170 "../src/utils/file-operations.vala"
			_tmp23_ = g_error_new (GAMES_EXTRACTION_ERROR, GAMES_EXTRACTION_ERROR_COULDNT_READ_HEADER, "%s\n", _tmp22_);
#line 170 "../src/utils/file-operations.vala"
			_inner_error0_ = _tmp23_;
#line 170 "../src/utils/file-operations.vala"
			if (_inner_error0_->domain == GAMES_EXTRACTION_ERROR) {
#line 170 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 170 "../src/utils/file-operations.vala"
				_g_free0 (dir_pathname);
#line 170 "../src/utils/file-operations.vala"
				_archive_write_free0 (extractor_archive);
#line 170 "../src/utils/file-operations.vala"
				_archive_read_free0 (restore_archive);
#line 170 "../src/utils/file-operations.vala"
				return;
#line 1393 "file-operations.c"
			} else {
#line 170 "../src/utils/file-operations.vala"
				_g_free0 (dir_pathname);
#line 170 "../src/utils/file-operations.vala"
				_archive_write_free0 (extractor_archive);
#line 170 "../src/utils/file-operations.vala"
				_archive_read_free0 (restore_archive);
#line 170 "../src/utils/file-operations.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/utils/file-operations.vala"
				g_clear_error (&_inner_error0_);
#line 170 "../src/utils/file-operations.vala"
				return;
#line 1407 "file-operations.c"
			}
		}
#line 172 "../src/utils/file-operations.vala"
		_tmp24_ = g_new0 (guint8, 64);
#line 172 "../src/utils/file-operations.vala"
		buffer = _tmp24_;
#line 172 "../src/utils/file-operations.vala"
		buffer_length1 = 64;
#line 172 "../src/utils/file-operations.vala"
		_buffer_size_ = buffer_length1;
#line 174 "../src/utils/file-operations.vala"
		while (TRUE) {
#line 1420 "file-operations.c"
			struct archive* _tmp25_;
			guint8* _tmp26_ = NULL;
			size_t _tmp27_ = 0;
			la_int64_t _tmp28_ = {0};
			int _tmp29_;
			guint8* _tmp30_;
			gint _tmp30__length1;
			struct archive* _tmp31_;
			guint8* _tmp32_;
			gint _tmp32__length1;
#line 174 "../src/utils/file-operations.vala"
			_tmp25_ = restore_archive;
#line 174 "../src/utils/file-operations.vala"
			_tmp29_ = archive_read_data_block (_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_);
#line 174 "../src/utils/file-operations.vala"
			buffer = (g_free (buffer), NULL);
#line 174 "../src/utils/file-operations.vala"
			_tmp30_ = (_tmp26_ != NULL) ? _vala_array_dup32 (_tmp26_, _tmp27_) : _tmp26_;
#line 174 "../src/utils/file-operations.vala"
			_tmp30__length1 = _tmp27_;
#line 174 "../src/utils/file-operations.vala"
			buffer = _tmp30_;
#line 174 "../src/utils/file-operations.vala"
			buffer_length1 = _tmp30__length1;
#line 174 "../src/utils/file-operations.vala"
			_buffer_size_ = buffer_length1;
#line 174 "../src/utils/file-operations.vala"
			buffer_length = (gsize) _tmp28_;
#line 174 "../src/utils/file-operations.vala"
			if (!(_tmp29_ == ARCHIVE_OK)) {
#line 174 "../src/utils/file-operations.vala"
				break;
#line 1453 "file-operations.c"
			}
#line 175 "../src/utils/file-operations.vala"
			_tmp31_ = extractor_archive;
#line 175 "../src/utils/file-operations.vala"
			_tmp32_ = buffer;
#line 175 "../src/utils/file-operations.vala"
			_tmp32__length1 = buffer_length1;
#line 175 "../src/utils/file-operations.vala"
			if (archive_write_data_block (_tmp31_, _tmp32_, (size_t) _tmp32__length1, (la_int64_t) buffer_length) != ((gssize) ARCHIVE_OK)) {
#line 176 "../src/utils/file-operations.vala"
				break;
#line 1465 "file-operations.c"
			}
		}
#line 166 "../src/utils/file-operations.vala"
		buffer = (g_free (buffer), NULL);
#line 166 "../src/utils/file-operations.vala"
		_g_free0 (dir_pathname);
#line 1472 "file-operations.c"
	}
#line 179 "../src/utils/file-operations.vala"
	if (last_result != ARCHIVE_EOF) {
#line 1476 "file-operations.c"
		struct archive* _tmp33_;
		const gchar* _tmp34_;
		struct archive* _tmp35_;
		GError* _tmp36_;
#line 180 "../src/utils/file-operations.vala"
		_tmp33_ = restore_archive;
#line 180 "../src/utils/file-operations.vala"
		_tmp34_ = archive_error_string (_tmp33_);
#line 180 "../src/utils/file-operations.vala"
		_tmp35_ = restore_archive;
#line 180 "../src/utils/file-operations.vala"
		_tmp36_ = g_error_new (GAMES_EXTRACTION_ERROR, GAMES_EXTRACTION_ERROR_DIDNT_REACH_EOF, "%s (%d)", _tmp34_, archive_errno (_tmp35_));
#line 180 "../src/utils/file-operations.vala"
		_inner_error0_ = _tmp36_;
#line 180 "../src/utils/file-operations.vala"
		if (_inner_error0_->domain == GAMES_EXTRACTION_ERROR) {
#line 180 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 180 "../src/utils/file-operations.vala"
			_archive_write_free0 (extractor_archive);
#line 180 "../src/utils/file-operations.vala"
			_archive_read_free0 (restore_archive);
#line 180 "../src/utils/file-operations.vala"
			return;
#line 1501 "file-operations.c"
		} else {
#line 180 "../src/utils/file-operations.vala"
			_archive_write_free0 (extractor_archive);
#line 180 "../src/utils/file-operations.vala"
			_archive_read_free0 (restore_archive);
#line 180 "../src/utils/file-operations.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "../src/utils/file-operations.vala"
			g_clear_error (&_inner_error0_);
#line 180 "../src/utils/file-operations.vala"
			return;
#line 1513 "file-operations.c"
		}
	}
#line 143 "../src/utils/file-operations.vala"
	_archive_write_free0 (extractor_archive);
#line 143 "../src/utils/file-operations.vala"
	_archive_read_free0 (restore_archive);
#line 1520 "file-operations.c"
}

void
games_file_operations_copy_dir (GFile* src,
                                GFile* dest,
                                GError** error)
{
	GError* _inner_error0_ = NULL;
#line 183 "../src/utils/file-operations.vala"
	g_return_if_fail (src != NULL);
#line 183 "../src/utils/file-operations.vala"
	g_return_if_fail (dest != NULL);
#line 184 "../src/utils/file-operations.vala"
	games_file_operations_copy_recursively (src, dest, FALSE, &_inner_error0_);
#line 184 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/utils/file-operations.vala"
		g_propagate_error (error, _inner_error0_);
#line 184 "../src/utils/file-operations.vala"
		return;
#line 1541 "file-operations.c"
	}
}

void
games_file_operations_copy_contents (GFile* src,
                                     GFile* dest,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 187 "../src/utils/file-operations.vala"
	g_return_if_fail (src != NULL);
#line 187 "../src/utils/file-operations.vala"
	g_return_if_fail (dest != NULL);
#line 188 "../src/utils/file-operations.vala"
	games_file_operations_copy_recursively (src, dest, TRUE, &_inner_error0_);
#line 188 "../src/utils/file-operations.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/utils/file-operations.vala"
		g_propagate_error (error, _inner_error0_);
#line 188 "../src/utils/file-operations.vala"
		return;
#line 1563 "file-operations.c"
	}
}

static void
games_file_operations_copy_recursively (GFile* src,
                                        GFile* dest,
                                        gboolean merge_flag,
                                        GError** error)
{
	GFileType src_type = 0;
	GError* _inner_error0_ = NULL;
#line 193 "../src/utils/file-operations.vala"
	g_return_if_fail (src != NULL);
#line 193 "../src/utils/file-operations.vala"
	g_return_if_fail (dest != NULL);
#line 194 "../src/utils/file-operations.vala"
	src_type = g_file_query_file_type (src, G_FILE_QUERY_INFO_NONE, NULL);
#line 196 "../src/utils/file-operations.vala"
	if (src_type == G_FILE_TYPE_DIRECTORY) {
#line 1583 "file-operations.c"
		gboolean _tmp0_ = FALSE;
		gchar* src_path = NULL;
		gchar* _tmp1_;
		gchar* dest_path = NULL;
		gchar* _tmp2_;
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp3_;
#line 197 "../src/utils/file-operations.vala"
		if (!g_file_query_exists (dest, NULL)) {
#line 197 "../src/utils/file-operations.vala"
			_tmp0_ = TRUE;
#line 1595 "file-operations.c"
		} else {
#line 197 "../src/utils/file-operations.vala"
			_tmp0_ = !merge_flag;
#line 1599 "file-operations.c"
		}
#line 197 "../src/utils/file-operations.vala"
		if (_tmp0_) {
#line 198 "../src/utils/file-operations.vala"
			g_file_make_directory_with_parents (dest, NULL, &_inner_error0_);
#line 198 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 198 "../src/utils/file-operations.vala"
				return;
#line 1611 "file-operations.c"
			}
#line 199 "../src/utils/file-operations.vala"
			g_file_copy_attributes (src, dest, G_FILE_COPY_NONE, NULL, &_inner_error0_);
#line 199 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 199 "../src/utils/file-operations.vala"
				return;
#line 1621 "file-operations.c"
			}
		}
#line 202 "../src/utils/file-operations.vala"
		_tmp1_ = g_file_get_path (src);
#line 202 "../src/utils/file-operations.vala"
		src_path = _tmp1_;
#line 203 "../src/utils/file-operations.vala"
		_tmp2_ = g_file_get_path (dest);
#line 203 "../src/utils/file-operations.vala"
		dest_path = _tmp2_;
#line 204 "../src/utils/file-operations.vala"
		_tmp3_ = g_file_enumerate_children (src, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 204 "../src/utils/file-operations.vala"
		enumerator = _tmp3_;
#line 204 "../src/utils/file-operations.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/utils/file-operations.vala"
			g_propagate_error (error, _inner_error0_);
#line 204 "../src/utils/file-operations.vala"
			_g_free0 (dest_path);
#line 204 "../src/utils/file-operations.vala"
			_g_free0 (src_path);
#line 204 "../src/utils/file-operations.vala"
			return;
#line 1646 "file-operations.c"
		}
		{
			GFileInfo* info = NULL;
			GFileEnumerator* _tmp4_;
			GFileInfo* _tmp5_;
#line 206 "../src/utils/file-operations.vala"
			_tmp4_ = enumerator;
#line 206 "../src/utils/file-operations.vala"
			_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 206 "../src/utils/file-operations.vala"
			info = _tmp5_;
#line 206 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 206 "../src/utils/file-operations.vala"
				_g_object_unref0 (enumerator);
#line 206 "../src/utils/file-operations.vala"
				_g_free0 (dest_path);
#line 206 "../src/utils/file-operations.vala"
				_g_free0 (src_path);
#line 206 "../src/utils/file-operations.vala"
				return;
#line 1670 "file-operations.c"
			}
			{
				gboolean _tmp6_ = FALSE;
#line 206 "../src/utils/file-operations.vala"
				_tmp6_ = TRUE;
#line 206 "../src/utils/file-operations.vala"
				while (TRUE) {
#line 1678 "file-operations.c"
					GFileInfo* _tmp11_;
					gchar* info_name = NULL;
					GFileInfo* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* src_object_path = NULL;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					GFile* src_object = NULL;
					const gchar* _tmp18_;
					GFile* _tmp19_;
					gchar* dest_object_path = NULL;
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					GFile* dest_object = NULL;
					const gchar* _tmp23_;
					GFile* _tmp24_;
					GFile* _tmp25_;
					GFile* _tmp26_;
#line 206 "../src/utils/file-operations.vala"
					if (!_tmp6_) {
#line 1702 "file-operations.c"
						GFileInfo* _tmp7_ = NULL;
						GFileEnumerator* _tmp8_;
						GFileInfo* _tmp9_;
						GFileInfo* _tmp10_;
#line 206 "../src/utils/file-operations.vala"
						_tmp8_ = enumerator;
#line 206 "../src/utils/file-operations.vala"
						_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 206 "../src/utils/file-operations.vala"
						_tmp7_ = _tmp9_;
#line 206 "../src/utils/file-operations.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/utils/file-operations.vala"
							g_propagate_error (error, _inner_error0_);
#line 206 "../src/utils/file-operations.vala"
							_g_object_unref0 (info);
#line 206 "../src/utils/file-operations.vala"
							_g_object_unref0 (enumerator);
#line 206 "../src/utils/file-operations.vala"
							_g_free0 (dest_path);
#line 206 "../src/utils/file-operations.vala"
							_g_free0 (src_path);
#line 206 "../src/utils/file-operations.vala"
							return;
#line 1727 "file-operations.c"
						}
#line 206 "../src/utils/file-operations.vala"
						_tmp10_ = _tmp7_;
#line 206 "../src/utils/file-operations.vala"
						_tmp7_ = NULL;
#line 206 "../src/utils/file-operations.vala"
						_g_object_unref0 (info);
#line 206 "../src/utils/file-operations.vala"
						info = _tmp10_;
#line 206 "../src/utils/file-operations.vala"
						_g_object_unref0 (_tmp7_);
#line 1739 "file-operations.c"
					}
#line 206 "../src/utils/file-operations.vala"
					_tmp6_ = FALSE;
#line 206 "../src/utils/file-operations.vala"
					_tmp11_ = info;
#line 206 "../src/utils/file-operations.vala"
					if (!(_tmp11_ != NULL)) {
#line 206 "../src/utils/file-operations.vala"
						break;
#line 1749 "file-operations.c"
					}
#line 209 "../src/utils/file-operations.vala"
					_tmp12_ = info;
#line 209 "../src/utils/file-operations.vala"
					_tmp13_ = g_file_info_get_name (_tmp12_);
#line 209 "../src/utils/file-operations.vala"
					_tmp14_ = g_strdup (_tmp13_);
#line 209 "../src/utils/file-operations.vala"
					info_name = _tmp14_;
#line 210 "../src/utils/file-operations.vala"
					_tmp15_ = src_path;
#line 210 "../src/utils/file-operations.vala"
					_tmp16_ = info_name;
#line 210 "../src/utils/file-operations.vala"
					_tmp17_ = g_build_filename (_tmp15_, _tmp16_, NULL);
#line 210 "../src/utils/file-operations.vala"
					src_object_path = _tmp17_;
#line 211 "../src/utils/file-operations.vala"
					_tmp18_ = src_object_path;
#line 211 "../src/utils/file-operations.vala"
					_tmp19_ = g_file_new_for_path (_tmp18_);
#line 211 "../src/utils/file-operations.vala"
					src_object = _tmp19_;
#line 212 "../src/utils/file-operations.vala"
					_tmp20_ = dest_path;
#line 212 "../src/utils/file-operations.vala"
					_tmp21_ = info_name;
#line 212 "../src/utils/file-operations.vala"
					_tmp22_ = g_build_filename (_tmp20_, _tmp21_, NULL);
#line 212 "../src/utils/file-operations.vala"
					dest_object_path = _tmp22_;
#line 213 "../src/utils/file-operations.vala"
					_tmp23_ = dest_object_path;
#line 213 "../src/utils/file-operations.vala"
					_tmp24_ = g_file_new_for_path (_tmp23_);
#line 213 "../src/utils/file-operations.vala"
					dest_object = _tmp24_;
#line 215 "../src/utils/file-operations.vala"
					_tmp25_ = src_object;
#line 215 "../src/utils/file-operations.vala"
					_tmp26_ = dest_object;
#line 215 "../src/utils/file-operations.vala"
					games_file_operations_copy_recursively (_tmp25_, _tmp26_, merge_flag, &_inner_error0_);
#line 215 "../src/utils/file-operations.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/utils/file-operations.vala"
						g_propagate_error (error, _inner_error0_);
#line 215 "../src/utils/file-operations.vala"
						_g_object_unref0 (dest_object);
#line 215 "../src/utils/file-operations.vala"
						_g_free0 (dest_object_path);
#line 215 "../src/utils/file-operations.vala"
						_g_object_unref0 (src_object);
#line 215 "../src/utils/file-operations.vala"
						_g_free0 (src_object_path);
#line 215 "../src/utils/file-operations.vala"
						_g_free0 (info_name);
#line 215 "../src/utils/file-operations.vala"
						_g_object_unref0 (info);
#line 215 "../src/utils/file-operations.vala"
						_g_object_unref0 (enumerator);
#line 215 "../src/utils/file-operations.vala"
						_g_free0 (dest_path);
#line 215 "../src/utils/file-operations.vala"
						_g_free0 (src_path);
#line 215 "../src/utils/file-operations.vala"
						return;
#line 1817 "file-operations.c"
					}
#line 206 "../src/utils/file-operations.vala"
					_g_object_unref0 (dest_object);
#line 206 "../src/utils/file-operations.vala"
					_g_free0 (dest_object_path);
#line 206 "../src/utils/file-operations.vala"
					_g_object_unref0 (src_object);
#line 206 "../src/utils/file-operations.vala"
					_g_free0 (src_object_path);
#line 206 "../src/utils/file-operations.vala"
					_g_free0 (info_name);
#line 1829 "file-operations.c"
				}
			}
#line 206 "../src/utils/file-operations.vala"
			_g_object_unref0 (info);
#line 1834 "file-operations.c"
		}
#line 196 "../src/utils/file-operations.vala"
		_g_object_unref0 (enumerator);
#line 196 "../src/utils/file-operations.vala"
		_g_free0 (dest_path);
#line 196 "../src/utils/file-operations.vala"
		_g_free0 (src_path);
#line 1842 "file-operations.c"
	} else {
#line 218 "../src/utils/file-operations.vala"
		if (src_type == G_FILE_TYPE_REGULAR) {
#line 219 "../src/utils/file-operations.vala"
			g_file_copy (src, dest, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 219 "../src/utils/file-operations.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/utils/file-operations.vala"
				g_propagate_error (error, _inner_error0_);
#line 219 "../src/utils/file-operations.vala"
				return;
#line 1854 "file-operations.c"
			}
		}
	}
}

GamesFileOperations*
games_file_operations_construct (GType object_type)
{
	GamesFileOperations* self = NULL;
#line 18 "../src/utils/file-operations.vala"
	self = (GamesFileOperations*) g_type_create_instance (object_type);
#line 18 "../src/utils/file-operations.vala"
	return self;
#line 1868 "file-operations.c"
}

GamesFileOperations*
games_file_operations_new (void)
{
#line 18 "../src/utils/file-operations.vala"
	return games_file_operations_construct (GAMES_TYPE_FILE_OPERATIONS);
#line 1876 "file-operations.c"
}

static void
games_value_file_operations_init (GValue* value)
{
#line 18 "../src/utils/file-operations.vala"
	value->data[0].v_pointer = NULL;
#line 1884 "file-operations.c"
}

static void
games_value_file_operations_free_value (GValue* value)
{
#line 18 "../src/utils/file-operations.vala"
	if (value->data[0].v_pointer) {
#line 18 "../src/utils/file-operations.vala"
		games_file_operations_unref (value->data[0].v_pointer);
#line 1894 "file-operations.c"
	}
}

static void
games_value_file_operations_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 18 "../src/utils/file-operations.vala"
	if (src_value->data[0].v_pointer) {
#line 18 "../src/utils/file-operations.vala"
		dest_value->data[0].v_pointer = games_file_operations_ref (src_value->data[0].v_pointer);
#line 1906 "file-operations.c"
	} else {
#line 18 "../src/utils/file-operations.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1910 "file-operations.c"
	}
}

static gpointer
games_value_file_operations_peek_pointer (const GValue* value)
{
#line 18 "../src/utils/file-operations.vala"
	return value->data[0].v_pointer;
#line 1919 "file-operations.c"
}

static gchar*
games_value_file_operations_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 18 "../src/utils/file-operations.vala"
	if (collect_values[0].v_pointer) {
#line 1930 "file-operations.c"
		GamesFileOperations * object;
		object = collect_values[0].v_pointer;
#line 18 "../src/utils/file-operations.vala"
		if (object->parent_instance.g_class == NULL) {
#line 18 "../src/utils/file-operations.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1937 "file-operations.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 18 "../src/utils/file-operations.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1941 "file-operations.c"
		}
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = games_file_operations_ref (object);
#line 1945 "file-operations.c"
	} else {
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = NULL;
#line 1949 "file-operations.c"
	}
#line 18 "../src/utils/file-operations.vala"
	return NULL;
#line 1953 "file-operations.c"
}

static gchar*
games_value_file_operations_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	GamesFileOperations ** object_p;
	object_p = collect_values[0].v_pointer;
#line 18 "../src/utils/file-operations.vala"
	if (!object_p) {
#line 18 "../src/utils/file-operations.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1968 "file-operations.c"
	}
#line 18 "../src/utils/file-operations.vala"
	if (!value->data[0].v_pointer) {
#line 18 "../src/utils/file-operations.vala"
		*object_p = NULL;
#line 1974 "file-operations.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 18 "../src/utils/file-operations.vala"
		*object_p = value->data[0].v_pointer;
#line 1978 "file-operations.c"
	} else {
#line 18 "../src/utils/file-operations.vala"
		*object_p = games_file_operations_ref (value->data[0].v_pointer);
#line 1982 "file-operations.c"
	}
#line 18 "../src/utils/file-operations.vala"
	return NULL;
#line 1986 "file-operations.c"
}

GParamSpec*
games_param_spec_file_operations (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	GamesParamSpecFileOperations* spec;
#line 18 "../src/utils/file-operations.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAMES_TYPE_FILE_OPERATIONS), NULL);
#line 18 "../src/utils/file-operations.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 18 "../src/utils/file-operations.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 18 "../src/utils/file-operations.vala"
	return G_PARAM_SPEC (spec);
#line 2005 "file-operations.c"
}

gpointer
games_value_get_file_operations (const GValue* value)
{
#line 18 "../src/utils/file-operations.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_FILE_OPERATIONS), NULL);
#line 18 "../src/utils/file-operations.vala"
	return value->data[0].v_pointer;
#line 2015 "file-operations.c"
}

void
games_value_set_file_operations (GValue* value,
                                 gpointer v_object)
{
	GamesFileOperations * old;
#line 18 "../src/utils/file-operations.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_FILE_OPERATIONS));
#line 18 "../src/utils/file-operations.vala"
	old = value->data[0].v_pointer;
#line 18 "../src/utils/file-operations.vala"
	if (v_object) {
#line 18 "../src/utils/file-operations.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAMES_TYPE_FILE_OPERATIONS));
#line 18 "../src/utils/file-operations.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = v_object;
#line 18 "../src/utils/file-operations.vala"
		games_file_operations_ref (value->data[0].v_pointer);
#line 2037 "file-operations.c"
	} else {
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = NULL;
#line 2041 "file-operations.c"
	}
#line 18 "../src/utils/file-operations.vala"
	if (old) {
#line 18 "../src/utils/file-operations.vala"
		games_file_operations_unref (old);
#line 2047 "file-operations.c"
	}
}

void
games_value_take_file_operations (GValue* value,
                                  gpointer v_object)
{
	GamesFileOperations * old;
#line 18 "../src/utils/file-operations.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_FILE_OPERATIONS));
#line 18 "../src/utils/file-operations.vala"
	old = value->data[0].v_pointer;
#line 18 "../src/utils/file-operations.vala"
	if (v_object) {
#line 18 "../src/utils/file-operations.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAMES_TYPE_FILE_OPERATIONS));
#line 18 "../src/utils/file-operations.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = v_object;
#line 2068 "file-operations.c"
	} else {
#line 18 "../src/utils/file-operations.vala"
		value->data[0].v_pointer = NULL;
#line 2072 "file-operations.c"
	}
#line 18 "../src/utils/file-operations.vala"
	if (old) {
#line 18 "../src/utils/file-operations.vala"
		games_file_operations_unref (old);
#line 2078 "file-operations.c"
	}
}

static void
games_file_operations_class_init (GamesFileOperationsClass * klass,
                                  gpointer klass_data)
{
#line 18 "../src/utils/file-operations.vala"
	games_file_operations_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/utils/file-operations.vala"
	((GamesFileOperationsClass *) klass)->finalize = games_file_operations_finalize;
#line 2090 "file-operations.c"
}

static void
games_file_operations_instance_init (GamesFileOperations * self,
                                     gpointer klass)
{
#line 18 "../src/utils/file-operations.vala"
	self->ref_count = 1;
#line 2099 "file-operations.c"
}

static void
games_file_operations_finalize (GamesFileOperations * obj)
{
	GamesFileOperations * self;
#line 18 "../src/utils/file-operations.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_FILE_OPERATIONS, GamesFileOperations);
#line 18 "../src/utils/file-operations.vala"
	g_signal_handlers_destroy (self);
#line 2110 "file-operations.c"
}

static GType
games_file_operations_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { games_value_file_operations_init, games_value_file_operations_free_value, games_value_file_operations_copy_value, games_value_file_operations_peek_pointer, "p", games_value_file_operations_collect_value, "p", games_value_file_operations_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GamesFileOperationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_file_operations_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesFileOperations), 0, (GInstanceInitFunc) games_file_operations_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType games_file_operations_type_id;
	games_file_operations_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GamesFileOperations", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return games_file_operations_type_id;
}

GType
games_file_operations_get_type (void)
{
	static volatile gsize games_file_operations_type_id__once = 0;
	if (g_once_init_enter (&games_file_operations_type_id__once)) {
		GType games_file_operations_type_id;
		games_file_operations_type_id = games_file_operations_get_type_once ();
		g_once_init_leave (&games_file_operations_type_id__once, games_file_operations_type_id);
	}
	return games_file_operations_type_id__once;
}

gpointer
games_file_operations_ref (gpointer instance)
{
	GamesFileOperations * self;
	self = instance;
#line 18 "../src/utils/file-operations.vala"
	g_atomic_int_inc (&self->ref_count);
#line 18 "../src/utils/file-operations.vala"
	return instance;
#line 2145 "file-operations.c"
}

void
games_file_operations_unref (gpointer instance)
{
	GamesFileOperations * self;
	self = instance;
#line 18 "../src/utils/file-operations.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 18 "../src/utils/file-operations.vala"
		GAMES_FILE_OPERATIONS_GET_CLASS (self)->finalize (self);
#line 18 "../src/utils/file-operations.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2159 "file-operations.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 2174 "file-operations.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 2178 "file-operations.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 2182 "file-operations.c"
}

