/* fingerprint.c generated by valac 0.56.3, the Vala compiler
 * generated from fingerprint.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

VALA_EXTERN gchar* games_fingerprint_get_for_file_uri (GamesUri* uri,
                                           gsize start,
                                           gsize* length,
                                           GError** error);
VALA_EXTERN gchar* games_fingerprint_get_for_file_input_stream (GFileInputStream* file_stream,
                                                    gsize start,
                                                    gsize* length,
                                                    GError** error);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
games_fingerprint_get_for_file_uri (GamesUri* uri,
                                    gsize start,
                                    gsize* length,
                                    GError** error)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInputStream* istream = NULL;
	GFile* _tmp1_;
	GFileInputStream* _tmp2_;
	gchar* _tmp3_ = NULL;
	GFileInputStream* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 4 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 5 "../src/utils/fingerprint.vala"
	_tmp0_ = games_uri_to_file (uri);
#line 5 "../src/utils/fingerprint.vala"
	file = _tmp0_;
#line 6 "../src/utils/fingerprint.vala"
	_tmp1_ = file;
#line 6 "../src/utils/fingerprint.vala"
	_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 6 "../src/utils/fingerprint.vala"
	istream = _tmp2_;
#line 6 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 6 "../src/utils/fingerprint.vala"
		_g_object_unref0 (file);
#line 6 "../src/utils/fingerprint.vala"
		return NULL;
#line 65 "fingerprint.c"
	}
#line 8 "../src/utils/fingerprint.vala"
	_tmp4_ = istream;
#line 8 "../src/utils/fingerprint.vala"
	_tmp5_ = games_fingerprint_get_for_file_input_stream (_tmp4_, start, length, &_inner_error0_);
#line 8 "../src/utils/fingerprint.vala"
	_tmp3_ = _tmp5_;
#line 8 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 8 "../src/utils/fingerprint.vala"
		_g_object_unref0 (istream);
#line 8 "../src/utils/fingerprint.vala"
		_g_object_unref0 (file);
#line 8 "../src/utils/fingerprint.vala"
		return NULL;
#line 83 "fingerprint.c"
	}
#line 8 "../src/utils/fingerprint.vala"
	_tmp6_ = _tmp3_;
#line 8 "../src/utils/fingerprint.vala"
	_tmp3_ = NULL;
#line 8 "../src/utils/fingerprint.vala"
	result = _tmp6_;
#line 8 "../src/utils/fingerprint.vala"
	_g_free0 (_tmp3_);
#line 8 "../src/utils/fingerprint.vala"
	_g_object_unref0 (istream);
#line 8 "../src/utils/fingerprint.vala"
	_g_object_unref0 (file);
#line 8 "../src/utils/fingerprint.vala"
	return result;
#line 99 "fingerprint.c"
}

gchar*
games_fingerprint_get_for_file_input_stream (GFileInputStream* file_stream,
                                             gsize start,
                                             gsize* length,
                                             GError** error)
{
	gsize size = 0UL;
	GBytes* bytes = NULL;
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 11 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (file_stream != NULL, NULL);
#line 13 "../src/utils/fingerprint.vala"
	if (length == NULL) {
#line 14 "../src/utils/fingerprint.vala"
		G_TYPE_INSTANCE_GET_CLASS (file_stream, g_file_input_stream_get_type (), GFileInputStreamClass)->seek (file_stream, (gint64) 0, G_SEEK_END, NULL, &_inner_error0_);
#line 14 "../src/utils/fingerprint.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14 "../src/utils/fingerprint.vala"
			g_propagate_error (error, _inner_error0_);
#line 14 "../src/utils/fingerprint.vala"
			return NULL;
#line 127 "fingerprint.c"
		}
#line 15 "../src/utils/fingerprint.vala"
		size = (gsize) G_TYPE_INSTANCE_GET_CLASS (file_stream, g_file_input_stream_get_type (), GFileInputStreamClass)->tell (file_stream);
#line 131 "fingerprint.c"
	} else {
#line 18 "../src/utils/fingerprint.vala"
		size = *length;
#line 135 "fingerprint.c"
	}
#line 20 "../src/utils/fingerprint.vala"
	G_TYPE_INSTANCE_GET_CLASS (file_stream, g_file_input_stream_get_type (), GFileInputStreamClass)->seek (file_stream, (gint64) start, G_SEEK_SET, NULL, &_inner_error0_);
#line 20 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 20 "../src/utils/fingerprint.vala"
		return NULL;
#line 145 "fingerprint.c"
	}
#line 21 "../src/utils/fingerprint.vala"
	_tmp0_ = g_input_stream_read_bytes ((GInputStream*) file_stream, size, NULL, &_inner_error0_);
#line 21 "../src/utils/fingerprint.vala"
	bytes = _tmp0_;
#line 21 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 21 "../src/utils/fingerprint.vala"
		return NULL;
#line 157 "fingerprint.c"
	}
#line 23 "../src/utils/fingerprint.vala"
	_tmp1_ = bytes;
#line 23 "../src/utils/fingerprint.vala"
	_tmp2_ = g_compute_checksum_for_bytes (G_CHECKSUM_MD5, _tmp1_);
#line 23 "../src/utils/fingerprint.vala"
	result = _tmp2_;
#line 23 "../src/utils/fingerprint.vala"
	_g_bytes_unref0 (bytes);
#line 23 "../src/utils/fingerprint.vala"
	return result;
#line 169 "fingerprint.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 182 "fingerprint.c"
}

gchar*
games_fingerprint_get_uid (GamesUri* uri,
                           const gchar* prefix,
                           GError** error)
{
	gchar* fingerprint = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 26 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 26 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 27 "../src/utils/fingerprint.vala"
	_tmp0_ = games_fingerprint_get_for_file_uri (uri, (gsize) 0, NULL, &_inner_error0_);
#line 27 "../src/utils/fingerprint.vala"
	fingerprint = _tmp0_;
#line 27 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 27 "../src/utils/fingerprint.vala"
		return NULL;
#line 211 "fingerprint.c"
	}
#line 29 "../src/utils/fingerprint.vala"
	_tmp1_ = string_to_string (prefix);
#line 29 "../src/utils/fingerprint.vala"
	_tmp2_ = string_to_string (fingerprint);
#line 29 "../src/utils/fingerprint.vala"
	_tmp3_ = g_strconcat (_tmp1_, "-", _tmp2_, NULL);
#line 29 "../src/utils/fingerprint.vala"
	result = _tmp3_;
#line 29 "../src/utils/fingerprint.vala"
	_g_free0 (fingerprint);
#line 29 "../src/utils/fingerprint.vala"
	return result;
#line 225 "fingerprint.c"
}

gchar*
games_fingerprint_get_uid_for_chunk (GamesUri* uri,
                                     const gchar* prefix,
                                     gsize start,
                                     gsize length,
                                     GError** error)
{
	gchar* fingerprint = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 32 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 32 "../src/utils/fingerprint.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 33 "../src/utils/fingerprint.vala"
	_tmp0_ = games_fingerprint_get_for_file_uri (uri, start, &length, &_inner_error0_);
#line 33 "../src/utils/fingerprint.vala"
	fingerprint = _tmp0_;
#line 33 "../src/utils/fingerprint.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/utils/fingerprint.vala"
		g_propagate_error (error, _inner_error0_);
#line 33 "../src/utils/fingerprint.vala"
		return NULL;
#line 256 "fingerprint.c"
	}
#line 35 "../src/utils/fingerprint.vala"
	_tmp1_ = string_to_string (prefix);
#line 35 "../src/utils/fingerprint.vala"
	_tmp2_ = string_to_string (fingerprint);
#line 35 "../src/utils/fingerprint.vala"
	_tmp3_ = g_strconcat (_tmp1_, "-", _tmp2_, NULL);
#line 35 "../src/utils/fingerprint.vala"
	result = _tmp3_;
#line 35 "../src/utils/fingerprint.vala"
	_g_free0 (fingerprint);
#line 35 "../src/utils/fingerprint.vala"
	return result;
#line 270 "fingerprint.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 284 "fingerprint.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 288 "fingerprint.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 292 "fingerprint.c"
}

