/* uri.c generated by valac 0.56.3, the Vala compiler
 * generated from uri.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _games_uri_unref0(var) ((var == NULL) ? NULL : (var = (games_uri_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define GAMES_TYPE_URI_ERROR (games_uri_error_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _GamesParamSpecUri GamesParamSpecUri;

struct _GamesUriPrivate {
	gchar* uri;
};

typedef enum  {
	GAMES_URI_ERROR_INVALID_SCHEME
} GamesUriError;
#define GAMES_URI_ERROR games_uri_error_quark ()

struct _GamesParamSpecUri {
	GParamSpec parent_instance;
};

static gint GamesUri_private_offset;
static gpointer games_uri_parent_class = NULL;
static GRegex* games_uri_scheme_regex;
static GRegex* games_uri_scheme_regex = NULL;

VALA_EXTERN GQuark games_uri_error_quark (void);
GType games_uri_error_get_type (void) G_GNUC_CONST ;
static void games_uri_finalize (GamesUri * obj);
static GType games_uri_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GRegex* _tmp_regex_0 = NULL;

static inline gpointer
games_uri_get_instance_private (GamesUri* self)
{
	return G_STRUCT_MEMBER_P (self, GamesUri_private_offset);
}

GamesUri*
games_uri_construct (GType object_type,
                     const gchar* uri)
{
	GamesUri* self = NULL;
	gchar* _tmp0_;
#line 8 "../src/utils/uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 8 "../src/utils/uri.vala"
	self = (GamesUri*) g_type_create_instance (object_type);
#line 9 "../src/utils/uri.vala"
	_tmp0_ = g_strdup (uri);
#line 9 "../src/utils/uri.vala"
	_g_free0 (self->priv->uri);
#line 9 "../src/utils/uri.vala"
	self->priv->uri = _tmp0_;
#line 8 "../src/utils/uri.vala"
	return self;
#line 74 "uri.c"
}

GamesUri*
games_uri_new (const gchar* uri)
{
#line 8 "../src/utils/uri.vala"
	return games_uri_construct (GAMES_TYPE_URI, uri);
#line 82 "uri.c"
}

GamesUri*
games_uri_construct_from_uri_and_scheme (GType object_type,
                                         GamesUri* uri,
                                         const gchar* scheme,
                                         GError** error)
{
	GamesUri* self = NULL;
	gchar* _tmp0_ = NULL;
	GRegex* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 12 "../src/utils/uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 12 "../src/utils/uri.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 12 "../src/utils/uri.vala"
	self = (GamesUri*) g_type_create_instance (object_type);
#line 13 "../src/utils/uri.vala"
	_tmp1_ = games_uri_scheme_regex;
#line 13 "../src/utils/uri.vala"
	_tmp2_ = uri->priv->uri;
#line 13 "../src/utils/uri.vala"
	_tmp3_ = g_strconcat (scheme, ":", NULL);
#line 13 "../src/utils/uri.vala"
	_tmp4_ = _tmp3_;
#line 13 "../src/utils/uri.vala"
	_tmp5_ = g_regex_replace (_tmp1_, _tmp2_, (gssize) -1, 0, _tmp4_, 0, &_inner_error0_);
#line 13 "../src/utils/uri.vala"
	_tmp6_ = _tmp5_;
#line 13 "../src/utils/uri.vala"
	_g_free0 (_tmp4_);
#line 13 "../src/utils/uri.vala"
	_tmp0_ = _tmp6_;
#line 13 "../src/utils/uri.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13 "../src/utils/uri.vala"
		g_propagate_error (error, _inner_error0_);
#line 13 "../src/utils/uri.vala"
		_games_uri_unref0 (self);
#line 13 "../src/utils/uri.vala"
		return NULL;
#line 131 "uri.c"
	}
#line 13 "../src/utils/uri.vala"
	_tmp7_ = _tmp0_;
#line 13 "../src/utils/uri.vala"
	_tmp0_ = NULL;
#line 13 "../src/utils/uri.vala"
	_g_free0 (self->priv->uri);
#line 13 "../src/utils/uri.vala"
	self->priv->uri = _tmp7_;
#line 12 "../src/utils/uri.vala"
	_g_free0 (_tmp0_);
#line 12 "../src/utils/uri.vala"
	return self;
#line 145 "uri.c"
}

GamesUri*
games_uri_new_from_uri_and_scheme (GamesUri* uri,
                                   const gchar* scheme,
                                   GError** error)
{
#line 12 "../src/utils/uri.vala"
	return games_uri_construct_from_uri_and_scheme (GAMES_TYPE_URI, uri, scheme, error);
#line 155 "uri.c"
}

GamesUri*
games_uri_construct_from_file (GType object_type,
                               GFile* file)
{
	GamesUri* self = NULL;
	gchar* _tmp0_;
#line 16 "../src/utils/uri.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 16 "../src/utils/uri.vala"
	self = (GamesUri*) g_type_create_instance (object_type);
#line 17 "../src/utils/uri.vala"
	_tmp0_ = g_file_get_uri (file);
#line 17 "../src/utils/uri.vala"
	_g_free0 (self->priv->uri);
#line 17 "../src/utils/uri.vala"
	self->priv->uri = _tmp0_;
#line 16 "../src/utils/uri.vala"
	return self;
#line 176 "uri.c"
}

GamesUri*
games_uri_new_from_file (GFile* file)
{
#line 16 "../src/utils/uri.vala"
	return games_uri_construct_from_file (GAMES_TYPE_URI, file);
#line 184 "uri.c"
}

guint
games_uri_hash (GamesUri* uri)
{
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	guint result;
#line 24 "../src/utils/uri.vala"
	g_return_val_if_fail (uri != NULL, 0U);
#line 25 "../src/utils/uri.vala"
	_tmp0_ = g_str_hash;
#line 25 "../src/utils/uri.vala"
	_tmp1_ = uri->priv->uri;
#line 25 "../src/utils/uri.vala"
	result = _tmp0_ (_tmp1_);
#line 25 "../src/utils/uri.vala"
	return result;
#line 203 "uri.c"
}

gboolean
games_uri_equal (GamesUri* a,
                 GamesUri* b)
{
	GEqualFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 28 "../src/utils/uri.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 28 "../src/utils/uri.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 29 "../src/utils/uri.vala"
	_tmp0_ = g_str_equal;
#line 29 "../src/utils/uri.vala"
	_tmp1_ = a->priv->uri;
#line 29 "../src/utils/uri.vala"
	_tmp2_ = b->priv->uri;
#line 29 "../src/utils/uri.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 29 "../src/utils/uri.vala"
	return result;
#line 228 "uri.c"
}

gchar*
games_uri_to_string (GamesUri* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 32 "../src/utils/uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/utils/uri.vala"
	_tmp0_ = self->priv->uri;
#line 33 "../src/utils/uri.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 33 "../src/utils/uri.vala"
	result = _tmp1_;
#line 33 "../src/utils/uri.vala"
	return result;
#line 247 "uri.c"
}

GFile*
games_uri_to_file (GamesUri* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 36 "../src/utils/uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/utils/uri.vala"
	_tmp0_ = self->priv->uri;
#line 37 "../src/utils/uri.vala"
	_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 37 "../src/utils/uri.vala"
	result = _tmp1_;
#line 37 "../src/utils/uri.vala"
	return result;
#line 266 "uri.c"
}

gchar*
games_uri_get_scheme (GamesUri* self,
                      GError** error)
{
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_;
	GMatchInfo* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 40 "../src/utils/uri.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/utils/uri.vala"
	_tmp0_ = games_uri_scheme_regex;
#line 42 "../src/utils/uri.vala"
	_tmp1_ = self->priv->uri;
#line 42 "../src/utils/uri.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 42 "../src/utils/uri.vala"
	_g_match_info_unref0 (info);
#line 42 "../src/utils/uri.vala"
	info = _tmp2_;
#line 42 "../src/utils/uri.vala"
	if (!_tmp3_) {
#line 296 "uri.c"
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 43 "../src/utils/uri.vala"
		_tmp4_ = self->priv->uri;
#line 43 "../src/utils/uri.vala"
		_tmp5_ = g_error_new (GAMES_URI_ERROR, GAMES_URI_ERROR_INVALID_SCHEME, "The URI doesn't have a valid scheme: %s.", _tmp4_);
#line 43 "../src/utils/uri.vala"
		_inner_error0_ = _tmp5_;
#line 43 "../src/utils/uri.vala"
		g_propagate_error (error, _inner_error0_);
#line 43 "../src/utils/uri.vala"
		_g_match_info_unref0 (info);
#line 43 "../src/utils/uri.vala"
		return NULL;
#line 311 "uri.c"
	}
#line 45 "../src/utils/uri.vala"
	_tmp6_ = info;
#line 45 "../src/utils/uri.vala"
	_tmp7_ = g_match_info_fetch (_tmp6_, 1);
#line 45 "../src/utils/uri.vala"
	result = _tmp7_;
#line 45 "../src/utils/uri.vala"
	_g_match_info_unref0 (info);
#line 45 "../src/utils/uri.vala"
	return result;
#line 323 "uri.c"
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
#line 21 "../src/utils/uri.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 21 "../src/utils/uri.vala"
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
#line 21 "../src/utils/uri.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 337 "uri.c"
	}
#line 21 "../src/utils/uri.vala"
	return *re;
#line 341 "uri.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 21 "../src/utils/uri.vala"
	return self ? g_regex_ref (self) : NULL;
#line 349 "uri.c"
}

static void
games_value_uri_init (GValue* value)
{
#line 3 "../src/utils/uri.vala"
	value->data[0].v_pointer = NULL;
#line 357 "uri.c"
}

static void
games_value_uri_free_value (GValue* value)
{
#line 3 "../src/utils/uri.vala"
	if (value->data[0].v_pointer) {
#line 3 "../src/utils/uri.vala"
		games_uri_unref (value->data[0].v_pointer);
#line 367 "uri.c"
	}
}

static void
games_value_uri_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 3 "../src/utils/uri.vala"
	if (src_value->data[0].v_pointer) {
#line 3 "../src/utils/uri.vala"
		dest_value->data[0].v_pointer = games_uri_ref (src_value->data[0].v_pointer);
#line 379 "uri.c"
	} else {
#line 3 "../src/utils/uri.vala"
		dest_value->data[0].v_pointer = NULL;
#line 383 "uri.c"
	}
}

static gpointer
games_value_uri_peek_pointer (const GValue* value)
{
#line 3 "../src/utils/uri.vala"
	return value->data[0].v_pointer;
#line 392 "uri.c"
}

static gchar*
games_value_uri_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 3 "../src/utils/uri.vala"
	if (collect_values[0].v_pointer) {
#line 403 "uri.c"
		GamesUri * object;
		object = collect_values[0].v_pointer;
#line 3 "../src/utils/uri.vala"
		if (object->parent_instance.g_class == NULL) {
#line 3 "../src/utils/uri.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 410 "uri.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 3 "../src/utils/uri.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 414 "uri.c"
		}
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = games_uri_ref (object);
#line 418 "uri.c"
	} else {
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = NULL;
#line 422 "uri.c"
	}
#line 3 "../src/utils/uri.vala"
	return NULL;
#line 426 "uri.c"
}

static gchar*
games_value_uri_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	GamesUri ** object_p;
	object_p = collect_values[0].v_pointer;
#line 3 "../src/utils/uri.vala"
	if (!object_p) {
#line 3 "../src/utils/uri.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 441 "uri.c"
	}
#line 3 "../src/utils/uri.vala"
	if (!value->data[0].v_pointer) {
#line 3 "../src/utils/uri.vala"
		*object_p = NULL;
#line 447 "uri.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 3 "../src/utils/uri.vala"
		*object_p = value->data[0].v_pointer;
#line 451 "uri.c"
	} else {
#line 3 "../src/utils/uri.vala"
		*object_p = games_uri_ref (value->data[0].v_pointer);
#line 455 "uri.c"
	}
#line 3 "../src/utils/uri.vala"
	return NULL;
#line 459 "uri.c"
}

GParamSpec*
games_param_spec_uri (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	GamesParamSpecUri* spec;
#line 3 "../src/utils/uri.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAMES_TYPE_URI), NULL);
#line 3 "../src/utils/uri.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 3 "../src/utils/uri.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 3 "../src/utils/uri.vala"
	return G_PARAM_SPEC (spec);
#line 478 "uri.c"
}

gpointer
games_value_get_uri (const GValue* value)
{
#line 3 "../src/utils/uri.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_URI), NULL);
#line 3 "../src/utils/uri.vala"
	return value->data[0].v_pointer;
#line 488 "uri.c"
}

void
games_value_set_uri (GValue* value,
                     gpointer v_object)
{
	GamesUri * old;
#line 3 "../src/utils/uri.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_URI));
#line 3 "../src/utils/uri.vala"
	old = value->data[0].v_pointer;
#line 3 "../src/utils/uri.vala"
	if (v_object) {
#line 3 "../src/utils/uri.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAMES_TYPE_URI));
#line 3 "../src/utils/uri.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = v_object;
#line 3 "../src/utils/uri.vala"
		games_uri_ref (value->data[0].v_pointer);
#line 510 "uri.c"
	} else {
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = NULL;
#line 514 "uri.c"
	}
#line 3 "../src/utils/uri.vala"
	if (old) {
#line 3 "../src/utils/uri.vala"
		games_uri_unref (old);
#line 520 "uri.c"
	}
}

void
games_value_take_uri (GValue* value,
                      gpointer v_object)
{
	GamesUri * old;
#line 3 "../src/utils/uri.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAMES_TYPE_URI));
#line 3 "../src/utils/uri.vala"
	old = value->data[0].v_pointer;
#line 3 "../src/utils/uri.vala"
	if (v_object) {
#line 3 "../src/utils/uri.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAMES_TYPE_URI));
#line 3 "../src/utils/uri.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = v_object;
#line 541 "uri.c"
	} else {
#line 3 "../src/utils/uri.vala"
		value->data[0].v_pointer = NULL;
#line 545 "uri.c"
	}
#line 3 "../src/utils/uri.vala"
	if (old) {
#line 3 "../src/utils/uri.vala"
		games_uri_unref (old);
#line 551 "uri.c"
	}
}

static void
games_uri_class_init (GamesUriClass * klass,
                      gpointer klass_data)
{
	GRegex* _tmp0_;
#line 3 "../src/utils/uri.vala"
	games_uri_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/utils/uri.vala"
	((GamesUriClass *) klass)->finalize = games_uri_finalize;
#line 3 "../src/utils/uri.vala"
	g_type_class_adjust_private_offset (klass, &GamesUri_private_offset);
#line 21 "../src/utils/uri.vala"
	_tmp0_ = _g_regex_ref0 (_thread_safe_regex_init (&_tmp_regex_0, "^([a-z][a-z0-9\\+\\.\\-]*):", 0 | G_REGEX_CASELESS));
#line 21 "../src/utils/uri.vala"
	_g_regex_unref0 (games_uri_scheme_regex);
#line 21 "../src/utils/uri.vala"
	games_uri_scheme_regex = _tmp0_;
#line 572 "uri.c"
}

static void
games_uri_instance_init (GamesUri * self,
                         gpointer klass)
{
#line 3 "../src/utils/uri.vala"
	self->priv = games_uri_get_instance_private (self);
#line 3 "../src/utils/uri.vala"
	self->ref_count = 1;
#line 583 "uri.c"
}

static void
games_uri_finalize (GamesUri * obj)
{
	GamesUri * self;
#line 3 "../src/utils/uri.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_URI, GamesUri);
#line 3 "../src/utils/uri.vala"
	g_signal_handlers_destroy (self);
#line 6 "../src/utils/uri.vala"
	_g_free0 (self->priv->uri);
#line 596 "uri.c"
}

static GType
games_uri_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { games_value_uri_init, games_value_uri_free_value, games_value_uri_copy_value, games_value_uri_peek_pointer, "p", games_value_uri_collect_value, "p", games_value_uri_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GamesUriClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_uri_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesUri), 0, (GInstanceInitFunc) games_uri_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType games_uri_type_id;
	games_uri_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GamesUri", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GamesUri_private_offset = g_type_add_instance_private (games_uri_type_id, sizeof (GamesUriPrivate));
	return games_uri_type_id;
}

GType
games_uri_get_type (void)
{
	static volatile gsize games_uri_type_id__once = 0;
	if (g_once_init_enter (&games_uri_type_id__once)) {
		GType games_uri_type_id;
		games_uri_type_id = games_uri_get_type_once ();
		g_once_init_leave (&games_uri_type_id__once, games_uri_type_id);
	}
	return games_uri_type_id__once;
}

gpointer
games_uri_ref (gpointer instance)
{
	GamesUri * self;
	self = instance;
#line 3 "../src/utils/uri.vala"
	g_atomic_int_inc (&self->ref_count);
#line 3 "../src/utils/uri.vala"
	return instance;
#line 632 "uri.c"
}

void
games_uri_unref (gpointer instance)
{
	GamesUri * self;
	self = instance;
#line 3 "../src/utils/uri.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 3 "../src/utils/uri.vala"
		GAMES_URI_GET_CLASS (self)->finalize (self);
#line 3 "../src/utils/uri.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 646 "uri.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 3 "../src/core/snapshot.vala"
	if (mem && byte_size != 0) {
#line 3 "../src/core/snapshot.vala"
		new_mem = g_malloc (byte_size);
#line 3 "../src/core/snapshot.vala"
		memcpy (new_mem, mem, byte_size);
#line 661 "uri.c"
	} else {
#line 3 "../src/core/snapshot.vala"
		new_mem = NULL;
#line 665 "uri.c"
	}
#line 3 "../src/core/snapshot.vala"
	return new_mem;
#line 669 "uri.c"
}

