/* database.c generated by valac 0.56.3, the Vala compiler
 * generated from database.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "gnome-games.h"

#define GAMES_DATABASE_CREATE_RESOURCES_TABLE_QUERY "\n" \
"\t\tCREATE TABLE IF NOT EXISTS game_resources (\n" \
"\t\t\tid INTEGER PRIMARY KEY NOT NULL,\n" \
"\t\t\turi TEXT NOT NULL\n" \
"\t\t);\n" \
"\t"
#define GAMES_DATABASE_CREATE_GAMES_TABLE_QUERY "\n" \
"\t\tCREATE TABLE IF NOT EXISTS games (\n" \
"\t\t\tid INTEGER PRIMARY KEY NOT NULL,\n" \
"\t\t\tuid TEXT NOT NULL UNIQUE,\n" \
"\t\t\ttitle TEXT NOT NULL,\n" \
"\t\t\tplatform TEXT NOT NULL,\n" \
"\t\t\tmedia_set TEXT NULL,\n" \
"\t\t\tis_favorite INTEGER NOT NULL DEFAULT 0,\n" \
"\t\t\tlast_played TEXT DEFAULT NULL\n" \
"\t\t);\n" \
"\t"
#define GAMES_DATABASE_CREATE_URIS_TABLE_QUERY "\n" \
"\t\tCREATE TABLE IF NOT EXISTS uris (\n" \
"\t\t\tid INTEGER PRIMARY KEY NOT NULL,\n" \
"\t\t\tuid TEXT NOT NULL,\n" \
"\t\t\turi TEXT NOT NULL UNIQUE,\n" \
"\t\t\tFOREIGN KEY(uid) REFERENCES games(uid)\n" \
"\t\t);\n" \
"\t"
#define GAMES_DATABASE_CREATE_USER_COLLECTIONS_TABLE_QUERY "\n" \
"\t\tCREATE TABLE IF NOT EXISTS user_collections (\n" \
"\t\t\tid INTEGER PRIMARY KEY NOT NULL,\n" \
"\t\t\tcollection_id TEXT NOT NULL UNIQUE,\n" \
"\t\t\ttitle TEXT NOT NULL UNIQUE\n" \
"\t\t);\n" \
"\t"
#define GAMES_DATABASE_CREATE_USER_COLLECTIONS_GAMES_TABLE_QUERY "\n" \
"\t\tCREATE TABLE IF NOT EXISTS user_collections_games (\n" \
"\t\t\tid INTEGER PRIMARY KEY NOT NULL,\n" \
"\t\t\tcollection TEXT NOT NULL,\n" \
"\t\t\tgame TEXT NOT NULL,\n" \
"\t\t\tFOREIGN KEY(collection) REFERENCES user_collections(collection_i" \
"d) ON DELETE CASCADE,\n" \
"\t\t\tFOREIGN KEY(game) REFERENCES games(uid) ON DELETE CASCADE\n" \
"\t\t);\n" \
"\t"
#define GAMES_DATABASE_ADD_GAME_QUERY "\n" \
"\t\tINSERT INTO games (uid, title, platform, media_set) VALUES ($UID, " \
"$TITLE, $PLATFORM, $MEDIA_SET);\n" \
"\t"
#define GAMES_DATABASE_ADD_GAME_URI_QUERY "\n\t\tINSERT INTO uris (uid, uri) VALUES ($UID, $URI);\n\t"
#define GAMES_DATABASE_UPDATE_GAME_QUERY "\n" \
"\t\tUPDATE games SET title = $TITLE, media_set = $MEDIA_SET WHERE uid " \
"= $UID;\n" \
"\t"
#define GAMES_DATABASE_DELETE_GAME_QUERY "\n\t\tDELETE FROM games WHERE uid = $UID;\n\t"
#define GAMES_DATABASE_DELETE_URI_QUERY "\n\t\tDELETE FROM uris WHERE uri = $URI;\n\t"
#define GAMES_DATABASE_FIND_GAME_URIS_QUERY "\n\t\tSELECT uri FROM uris WHERE uid = $UID;\n\t"
#define GAMES_DATABASE_GET_CACHED_GAME_QUERY "\n" \
"\t\tSELECT uri, title, platform, media_set, is_favorite, last_played\n" \
"\t\tFROM games JOIN uris ON games.uid == uris.uid WHERE games.uid == $" \
"UID;\n" \
"\t"
#define GAMES_DATABASE_LIST_CACHED_GAMES_QUERY "\n" \
"\t\tSELECT games.uid, uri, title, platform, media_set, is_favorite, la" \
"st_played\n" \
"\t\tFROM games JOIN uris ON games.uid == uris.uid ORDER BY title;\n" \
"\t"
#define GAMES_DATABASE_ADD_GAME_RESOURCE_QUERY "\n\t\tINSERT INTO game_resources (id, uri) VALUES (NULL, $URI);\n\t"
#define GAMES_DATABASE_HAS_URI_QUERY "\n" \
"\t\tSELECT EXISTS (SELECT 1 FROM game_resources WHERE uri=$URI LIMIT 1" \
");\n" \
"\t"
#define GAMES_DATABASE_SET_IS_FAVORITE_QUERY "\n" \
"\t\tUPDATE games SET is_favorite = $IS_FAVORITE WHERE uid = $UID;\n" \
"\t"
#define GAMES_DATABASE_IS_GAME_FAVORITE_QUERY "\n" \
"\t\tSELECT EXISTS (SELECT 1 FROM games WHERE uid = $UID AND is_favorit" \
"e = 1 LIMIT 1);\n" \
"\t"
#define GAMES_DATABASE_LIST_FAVORITE_GAMES_QUERY "\n\t\tSELECT uid FROM games WHERE is_favorite = 1;\n\t"
#define GAMES_DATABASE_UPDATE_RECENTLY_PLAYED_GAME_QUERY "\n" \
"\t\tUPDATE games SET last_played = $LAST_PLAYED WHERE uid = $UID;\n" \
"\t"
#define GAMES_DATABASE_LIST_RECENTLY_PLAYED_GAMES_QUERY "\n\t\tSELECT uid FROM games WHERE last_played IS NOT NULL;\n\t"
#define GAMES_DATABASE_ADD_USER_COLLECTION_QUERY "\n" \
"\t\tINSERT INTO user_collections (collection_id, title) VALUES ($COLLE" \
"CTION_ID, $TITLE);\n" \
"\t"
#define GAMES_DATABASE_ADD_GAME_TO_USER_COLLECTION_QUERY "\n" \
"\t\tINSERT INTO user_collections_games (collection, game)\n" \
"\t\tVALUES ($COLLECTION_ID, $GAME_UID);\n" \
"\t"
#define GAMES_DATABASE_DOES_USER_COLLECTION_EXIST_QUERY "\n" \
"\t\tSELECT EXISTS (SELECT 1 FROM user_collections\n" \
"\t\tWHERE collection_id = $COLLECTION_ID LIMIT 1);\n" \
"\t"
#define GAMES_DATABASE_IS_GAME_IN_USER_COLLECTION_QUERY "\n" \
"\t\tSELECT EXISTS (SELECT 1 FROM user_collections_games\n" \
"\t\tWHERE game = $GAME_UID AND collection = $COLLECTION_ID LIMIT 1);\n" \
"\t"
#define GAMES_DATABASE_LIST_USER_COLLECTIONS_QUERY "\n\t\tSELECT collection_id, title FROM user_collections;\n\t"
#define GAMES_DATABASE_LIST_GAMES_IN_USER_COLLECTION_QUERY "\n" \
"\t\tSELECT games.uid FROM games JOIN user_collections_games\n" \
"\t\tON games.uid = game WHERE collection = $COLLECTION_ID;\n" \
"\t"
#define GAMES_DATABASE_REMOVE_USER_COLLECTION_QUERY "\n" \
"\t\tDELETE FROM user_collections WHERE collection_id = $COLLECTION_ID;" \
"\n" \
"\t"
#define GAMES_DATABASE_REMOVE_GAME_FROM_USER_COLLECTION_QUERY "\n" \
"\t\tDELETE FROM user_collections_games WHERE collection = $COLLECTION_" \
"ID AND game = $GAME_UID;\n" \
"\t"
#define GAMES_DATABASE_RENAME_USER_COLLECTION_QUERY "\n" \
"\t\tUPDATE user_collections SET title = $TITLE WHERE collection_id = $" \
"COLLECTION_ID;\n" \
"\t"

#define GAMES_TYPE_DATABASE (games_database_get_type ())
#define GAMES_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_DATABASE, GamesDatabase))
#define GAMES_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_DATABASE, GamesDatabaseClass))
#define GAMES_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_DATABASE))
#define GAMES_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_DATABASE))
#define GAMES_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_DATABASE, GamesDatabaseClass))

typedef struct _GamesDatabase GamesDatabase;
typedef struct _GamesDatabaseClass GamesDatabaseClass;
typedef struct _GamesDatabasePrivate GamesDatabasePrivate;
enum  {
	GAMES_DATABASE_0_PROPERTY,
	GAMES_DATABASE_NUM_PROPERTIES
};
static GParamSpec* games_database_properties[GAMES_DATABASE_NUM_PROPERTIES];
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

#define GAMES_TYPE_DATABASE_ERROR (games_database_error_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GAMES_TYPE_DATABASE_URI_SOURCE (games_database_uri_source_get_type ())
#define GAMES_DATABASE_URI_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_DATABASE_URI_SOURCE, GamesDatabaseUriSource))
#define GAMES_DATABASE_URI_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_DATABASE_URI_SOURCE, GamesDatabaseUriSourceClass))
#define GAMES_IS_DATABASE_URI_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_DATABASE_URI_SOURCE))
#define GAMES_IS_DATABASE_URI_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_DATABASE_URI_SOURCE))
#define GAMES_DATABASE_URI_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_DATABASE_URI_SOURCE, GamesDatabaseUriSourceClass))

typedef struct _GamesDatabaseUriSource GamesDatabaseUriSource;
typedef struct _GamesDatabaseUriSourceClass GamesDatabaseUriSourceClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block17Data Block17Data;
#define _games_uri_unref0(var) ((var == NULL) ? NULL : (var = (games_uri_unref (var), NULL)))

#define GAMES_TYPE_PLATFORM_REGISTER (games_platform_register_get_type ())
#define GAMES_PLATFORM_REGISTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_PLATFORM_REGISTER, GamesPlatformRegister))
#define GAMES_PLATFORM_REGISTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_PLATFORM_REGISTER, GamesPlatformRegisterClass))
#define GAMES_IS_PLATFORM_REGISTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_PLATFORM_REGISTER))
#define GAMES_IS_PLATFORM_REGISTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_PLATFORM_REGISTER))
#define GAMES_PLATFORM_REGISTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_PLATFORM_REGISTER, GamesPlatformRegisterClass))

typedef struct _GamesPlatformRegister GamesPlatformRegister;
typedef struct _GamesPlatformRegisterClass GamesPlatformRegisterClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define GAMES_TYPE_USER_COLLECTION (games_user_collection_get_type ())
#define GAMES_USER_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_USER_COLLECTION, GamesUserCollection))
#define GAMES_USER_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_USER_COLLECTION, GamesUserCollectionClass))
#define GAMES_IS_USER_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_USER_COLLECTION))
#define GAMES_IS_USER_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_USER_COLLECTION))
#define GAMES_USER_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_USER_COLLECTION, GamesUserCollectionClass))

typedef struct _GamesUserCollection GamesUserCollection;
typedef struct _GamesUserCollectionClass GamesUserCollectionClass;

#define GAMES_TYPE_COLLECTION (games_collection_get_type ())
#define GAMES_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_COLLECTION, GamesCollection))
#define GAMES_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_COLLECTION))
#define GAMES_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAMES_TYPE_COLLECTION, GamesCollectionIface))

typedef struct _GamesCollection GamesCollection;
typedef struct _GamesCollectionIface GamesCollectionIface;

#define GAMES_TYPE_GAME_MODEL (games_game_model_get_type ())
#define GAMES_GAME_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_GAME_MODEL, GamesGameModel))
#define GAMES_GAME_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_GAME_MODEL, GamesGameModelClass))
#define GAMES_IS_GAME_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_GAME_MODEL))
#define GAMES_IS_GAME_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_GAME_MODEL))
#define GAMES_GAME_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_GAME_MODEL, GamesGameModelClass))

typedef struct _GamesGameModel GamesGameModel;
typedef struct _GamesGameModelClass GamesGameModelClass;
typedef enum  {
	GAMES_COLLECTION_TYPE_AUTO,
	GAMES_COLLECTION_TYPE_USER,
	GAMES_COLLECTION_TYPE_PLACEHOLDER
} GamesCollectionType;

#define GAMES_TYPE_COLLECTION_TYPE (games_collection_type_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _GamesDatabase {
	GObject parent_instance;
	GamesDatabasePrivate * priv;
};

struct _GamesDatabaseClass {
	GObjectClass parent_class;
};

struct _GamesDatabasePrivate {
	sqlite3* database;
	sqlite3_stmt* add_game_query;
	sqlite3_stmt* add_game_uri_query;
	sqlite3_stmt* update_game_query;
	sqlite3_stmt* delete_game_query;
	sqlite3_stmt* delete_uri_query;
	sqlite3_stmt* find_game_uris_query;
	sqlite3_stmt* get_cached_game_query;
	sqlite3_stmt* list_cached_games_query;
	sqlite3_stmt* add_game_resource_query;
	sqlite3_stmt* has_uri_query;
	sqlite3_stmt* set_is_favorite_query;
	sqlite3_stmt* is_game_favorite_query;
	sqlite3_stmt* list_favorite_games_query;
	sqlite3_stmt* update_recently_played_game_query;
	sqlite3_stmt* list_recently_played_games_query;
	sqlite3_stmt* add_user_collection_query;
	sqlite3_stmt* add_game_to_user_collection_query;
	sqlite3_stmt* does_user_collection_exist_query;
	sqlite3_stmt* is_game_in_user_collection_query;
	sqlite3_stmt* list_user_collections_query;
	sqlite3_stmt* list_games_in_user_collection_query;
	sqlite3_stmt* remove_user_collection_query;
	sqlite3_stmt* remove_game_from_user_collection_query;
	sqlite3_stmt* rename_user_collection_query;
};

typedef enum  {
	GAMES_DATABASE_ERROR_COULDNT_OPEN,
	GAMES_DATABASE_ERROR_EXECUTION_FAILED,
	GAMES_DATABASE_ERROR_PREPARATION_FAILED,
	GAMES_DATABASE_ERROR_BINDING_FAILED
} GamesDatabaseError;
#define GAMES_DATABASE_ERROR games_database_error_quark ()

struct _Block17Data {
	int _ref_count_;
	GamesDatabase* self;
	gchar** uris;
	gint uris_length1;
	gint _uris_size_;
};

struct _GamesCollectionIface {
	GTypeInterface parent_iface;
	void (*load) (GamesCollection* self);
	gchar* (*get_id) (GamesCollection* self);
	gboolean (*get_hide_stars) (GamesCollection* self);
	GamesGameModel* (*get_game_model) (GamesCollection* self);
	GamesCollectionType (*get_collection_type) (GamesCollection* self);
	void (*add_games) (GamesCollection* self, GamesGame** games, gint games_length1);
	void (*remove_games) (GamesCollection* self, GamesGame** games, gint games_length1);
	void (*on_game_added) (GamesCollection* self, GamesGame* game);
	void (*on_game_removed) (GamesCollection* self, GamesGame* game);
	void (*on_game_replaced) (GamesCollection* self, GamesGame* game, GamesGame* prev_game);
	gboolean (*get_is_empty) (GamesCollection* self);
	const gchar* (*get_title) (GamesCollection* self);
};

static gint GamesDatabase_private_offset;
static gpointer games_database_parent_class = NULL;

VALA_EXTERN GType games_database_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesDatabase* games_database_new (const gchar* path,
                                   GError** error);
VALA_EXTERN GamesDatabase* games_database_construct (GType object_type,
                                         const gchar* path,
                                         GError** error);
VALA_EXTERN GQuark games_database_error_quark (void);
GType games_database_error_get_type (void) G_GNUC_CONST ;
static void games_database_exec (GamesDatabase* self,
                          const gchar* query,
                          sqlite3_callback callback,
                          gpointer callback_target,
                          GError** error);
VALA_EXTERN void games_database_prepare_statements (GamesDatabase* self);
VALA_EXTERN sqlite3_stmt* games_database_prepare (sqlite3* database,
                                      const gchar* query,
                                      GError** error);
VALA_EXTERN void games_database_apply_favorites_migration (GamesDatabase* self,
                                               GError** error);
VALA_EXTERN void games_database_apply_recently_played_migration (GamesDatabase* self,
                                                     GError** error);
VALA_EXTERN void games_database_add_uri (GamesDatabase* self,
                             GamesUri* uri,
                             GError** error);
VALA_EXTERN gboolean games_database_has_uri (GamesDatabase* self,
                                 GamesUri* uri,
                                 GError** error);
VALA_EXTERN void games_database_bind_text (sqlite3_stmt* statement,
                               const gchar* parameter,
                               const gchar* text,
                               GError** error);
VALA_EXTERN GType games_database_uri_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesDatabaseUriSource* games_database_get_uri_source (GamesDatabase* self);
VALA_EXTERN GamesDatabaseUriSource* games_database_uri_source_new (sqlite3* database);
VALA_EXTERN GamesDatabaseUriSource* games_database_uri_source_construct (GType object_type,
                                                             sqlite3* database);
VALA_EXTERN void games_database_bind_int (sqlite3_stmt* statement,
                              const gchar* parameter,
                              gint* integer,
                              GError** error);
static gchar* games_database_serialize_media_set (GamesDatabase* self,
                                           GamesGame* game);
static gchar** games_database_get_media_uris (GamesDatabase* self,
                                       GamesGame* game,
                                       gint* result_length1);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void __lambda5_ (Block17Data* _data17_,
                 GamesMedia* media);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda5__games_media_set_media_callback (GamesMedia* media,
                                                 gpointer self);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
static void games_database_store_game_uri (GamesDatabase* self,
                                    const gchar* uid,
                                    const gchar* uri,
                                    GError** error);
VALA_EXTERN GamesGame* games_database_store_game (GamesDatabase* self,
                                      GamesGame* game,
                                      GError** error);
static GamesGame* games_database_get_cached_game (GamesDatabase* self,
                                           const gchar* uid,
                                           GError** error);
VALA_EXTERN void games_database_update_game (GamesDatabase* self,
                                 GamesGame* game,
                                 GamesGame* prev_game,
                                 GError** error);
VALA_EXTERN gboolean games_database_remove_game (GamesDatabase* self,
                                     const gchar* uri,
                                     GamesGame* game,
                                     GError** error);
static GamesGame* games_database_create_game (GamesDatabase* self,
                                       const gchar* uid,
                                       const gchar* uri,
                                       const gchar* title,
                                       const gchar* platform,
                                       const gchar* media_set,
                                       gint is_favorite,
                                       const gchar* last_played);
VALA_EXTERN void games_database_list_cached_games (GamesDatabase* self,
                                       GamesGameCallback game_callback,
                                       gpointer game_callback_target,
                                       GError** error);
VALA_EXTERN GType games_platform_register_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesPlatformRegister* games_platform_register_get_register (void);
VALA_EXTERN GamesPlatform* games_platform_register_get_platform (GamesPlatformRegister* self,
                                                     const gchar* id);
VALA_EXTERN gboolean games_database_set_is_favorite (GamesDatabase* self,
                                         GamesGame* game,
                                         GError** error);
static gboolean games_database_is_game_favorite (GamesDatabase* self,
                                          GamesGame* game,
                                          GError** error);
VALA_EXTERN GHashTable* games_database_list_favorite_games (GamesDatabase* self,
                                                GError** error);
static guint _games_uid_hash_ghash_func (gconstpointer key);
static gboolean _games_uid_equal_gequal_func (gconstpointer a,
                                       gconstpointer b);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN GHashTable* games_database_list_recently_played_games (GamesDatabase* self,
                                                       GError** error);
VALA_EXTERN void games_database_update_recently_played_game (GamesDatabase* self,
                                                 GamesGame* game,
                                                 gboolean remove,
                                                 GError** error);
static gboolean games_database_does_user_collection_exist (GamesDatabase* self,
                                                    const gchar* uuid,
                                                    GError** error);
static gboolean games_database_is_game_in_user_collection (GamesDatabase* self,
                                                    const gchar* game_uid,
                                                    const gchar* collection_id,
                                                    GError** error);
VALA_EXTERN GType games_user_collection_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean games_database_add_user_collection (GamesDatabase* self,
                                             GamesUserCollection* collection,
                                             GError** error);
VALA_EXTERN GType games_game_model_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType games_collection_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType games_collection_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* games_collection_get_id (GamesCollection* self);
VALA_EXTERN const gchar* games_collection_get_title (GamesCollection* self);
VALA_EXTERN gboolean games_database_add_game_to_user_collection (GamesDatabase* self,
                                                     GamesGame* game,
                                                     GamesUserCollection* collection,
                                                     GError** error);
VALA_EXTERN GHashTable* games_database_get_user_collections (GamesDatabase* self,
                                                 GError** error);
VALA_EXTERN guint games_collection_hash (GamesCollection* collection);
static guint _games_collection_hash_ghash_func (gconstpointer key);
VALA_EXTERN gboolean games_collection_equal (GamesCollection* a,
                                 GamesCollection* b);
static gboolean _games_collection_equal_gequal_func (gconstpointer a,
                                              gconstpointer b);
VALA_EXTERN GamesUserCollection* games_user_collection_new (const gchar* id,
                                                const gchar* title,
                                                GamesDatabase* database);
VALA_EXTERN GamesUserCollection* games_user_collection_construct (GType object_type,
                                                      const gchar* id,
                                                      const gchar* title,
                                                      GamesDatabase* database);
VALA_EXTERN GHashTable* games_database_list_games_in_user_collection (GamesDatabase* self,
                                                          GamesUserCollection* collection,
                                                          GError** error);
VALA_EXTERN gboolean games_database_remove_user_collection (GamesDatabase* self,
                                                GamesUserCollection* collection,
                                                GError** error);
VALA_EXTERN gboolean games_database_remove_game_from_user_collection (GamesDatabase* self,
                                                          GamesGame* game,
                                                          GamesUserCollection* collection,
                                                          GError** error);
VALA_EXTERN gboolean games_database_rename_user_collection (GamesDatabase* self,
                                                GamesUserCollection* collection,
                                                const gchar* title,
                                                GError** error);
static void games_database_finalize (GObject * obj);
static GType games_database_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
games_database_get_instance_private (GamesDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, GamesDatabase_private_offset);
}

GamesDatabase*
games_database_construct (GType object_type,
                          const gchar* path,
                          GError** error)
{
	GamesDatabase * self = NULL;
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 184 "../src/database/database.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 184 "../src/database/database.vala"
	self = (GamesDatabase*) g_object_new (object_type, NULL);
#line 185 "../src/database/database.vala"
	_tmp1_ = sqlite3_open (path, &_tmp0_);
#line 185 "../src/database/database.vala"
	_sqlite3_close0 (self->priv->database);
#line 185 "../src/database/database.vala"
	self->priv->database = _tmp0_;
#line 185 "../src/database/database.vala"
	if (_tmp1_ != SQLITE_OK) {
#line 393 "database.c"
		GError* _tmp2_;
#line 186 "../src/database/database.vala"
		_tmp2_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_COULDNT_OPEN, "Couldn’t open the database for “%s”.", path);
#line 186 "../src/database/database.vala"
		_inner_error0_ = _tmp2_;
#line 186 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 186 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 186 "../src/database/database.vala"
		return NULL;
#line 405 "database.c"
	}
#line 188 "../src/database/database.vala"
	games_database_exec (self, GAMES_DATABASE_CREATE_RESOURCES_TABLE_QUERY, NULL, NULL, &_inner_error0_);
#line 188 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 188 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 188 "../src/database/database.vala"
		return NULL;
#line 417 "database.c"
	}
#line 189 "../src/database/database.vala"
	games_database_exec (self, GAMES_DATABASE_CREATE_GAMES_TABLE_QUERY, NULL, NULL, &_inner_error0_);
#line 189 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 189 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 189 "../src/database/database.vala"
		return NULL;
#line 429 "database.c"
	}
#line 190 "../src/database/database.vala"
	games_database_exec (self, GAMES_DATABASE_CREATE_URIS_TABLE_QUERY, NULL, NULL, &_inner_error0_);
#line 190 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 190 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 190 "../src/database/database.vala"
		return NULL;
#line 441 "database.c"
	}
#line 191 "../src/database/database.vala"
	games_database_exec (self, GAMES_DATABASE_CREATE_USER_COLLECTIONS_TABLE_QUERY, NULL, NULL, &_inner_error0_);
#line 191 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 191 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 191 "../src/database/database.vala"
		return NULL;
#line 453 "database.c"
	}
#line 192 "../src/database/database.vala"
	games_database_exec (self, GAMES_DATABASE_CREATE_USER_COLLECTIONS_GAMES_TABLE_QUERY, NULL, NULL, &_inner_error0_);
#line 192 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 192 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 192 "../src/database/database.vala"
		return NULL;
#line 465 "database.c"
	}
#line 184 "../src/database/database.vala"
	return self;
#line 469 "database.c"
}

GamesDatabase*
games_database_new (const gchar* path,
                    GError** error)
{
#line 184 "../src/database/database.vala"
	return games_database_construct (GAMES_TYPE_DATABASE, path, error);
#line 478 "database.c"
}

void
games_database_prepare_statements (GamesDatabase* self)
{
	GError* _inner_error0_ = NULL;
#line 195 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 487 "database.c"
	{
		sqlite3_stmt* _tmp0_ = NULL;
		sqlite3* _tmp1_;
		sqlite3_stmt* _tmp2_;
		sqlite3_stmt* _tmp3_;
		sqlite3_stmt* _tmp4_ = NULL;
		sqlite3* _tmp5_;
		sqlite3_stmt* _tmp6_;
		sqlite3_stmt* _tmp7_;
		sqlite3_stmt* _tmp8_ = NULL;
		sqlite3* _tmp9_;
		sqlite3_stmt* _tmp10_;
		sqlite3_stmt* _tmp11_;
		sqlite3_stmt* _tmp12_ = NULL;
		sqlite3* _tmp13_;
		sqlite3_stmt* _tmp14_;
		sqlite3_stmt* _tmp15_;
		sqlite3_stmt* _tmp16_ = NULL;
		sqlite3* _tmp17_;
		sqlite3_stmt* _tmp18_;
		sqlite3_stmt* _tmp19_;
		sqlite3_stmt* _tmp20_ = NULL;
		sqlite3* _tmp21_;
		sqlite3_stmt* _tmp22_;
		sqlite3_stmt* _tmp23_;
		sqlite3_stmt* _tmp24_ = NULL;
		sqlite3* _tmp25_;
		sqlite3_stmt* _tmp26_;
		sqlite3_stmt* _tmp27_;
		sqlite3_stmt* _tmp28_ = NULL;
		sqlite3* _tmp29_;
		sqlite3_stmt* _tmp30_;
		sqlite3_stmt* _tmp31_;
		sqlite3_stmt* _tmp32_ = NULL;
		sqlite3* _tmp33_;
		sqlite3_stmt* _tmp34_;
		sqlite3_stmt* _tmp35_;
		sqlite3_stmt* _tmp36_ = NULL;
		sqlite3* _tmp37_;
		sqlite3_stmt* _tmp38_;
		sqlite3_stmt* _tmp39_;
		sqlite3_stmt* _tmp40_ = NULL;
		sqlite3* _tmp41_;
		sqlite3_stmt* _tmp42_;
		sqlite3_stmt* _tmp43_;
		sqlite3_stmt* _tmp44_ = NULL;
		sqlite3* _tmp45_;
		sqlite3_stmt* _tmp46_;
		sqlite3_stmt* _tmp47_;
		sqlite3_stmt* _tmp48_ = NULL;
		sqlite3* _tmp49_;
		sqlite3_stmt* _tmp50_;
		sqlite3_stmt* _tmp51_;
		sqlite3_stmt* _tmp52_ = NULL;
		sqlite3* _tmp53_;
		sqlite3_stmt* _tmp54_;
		sqlite3_stmt* _tmp55_;
		sqlite3_stmt* _tmp56_ = NULL;
		sqlite3* _tmp57_;
		sqlite3_stmt* _tmp58_;
		sqlite3_stmt* _tmp59_;
		sqlite3_stmt* _tmp60_ = NULL;
		sqlite3* _tmp61_;
		sqlite3_stmt* _tmp62_;
		sqlite3_stmt* _tmp63_;
		sqlite3_stmt* _tmp64_ = NULL;
		sqlite3* _tmp65_;
		sqlite3_stmt* _tmp66_;
		sqlite3_stmt* _tmp67_;
		sqlite3_stmt* _tmp68_ = NULL;
		sqlite3* _tmp69_;
		sqlite3_stmt* _tmp70_;
		sqlite3_stmt* _tmp71_;
		sqlite3_stmt* _tmp72_ = NULL;
		sqlite3* _tmp73_;
		sqlite3_stmt* _tmp74_;
		sqlite3_stmt* _tmp75_;
		sqlite3_stmt* _tmp76_ = NULL;
		sqlite3* _tmp77_;
		sqlite3_stmt* _tmp78_;
		sqlite3_stmt* _tmp79_;
		sqlite3_stmt* _tmp80_ = NULL;
		sqlite3* _tmp81_;
		sqlite3_stmt* _tmp82_;
		sqlite3_stmt* _tmp83_;
		sqlite3_stmt* _tmp84_ = NULL;
		sqlite3* _tmp85_;
		sqlite3_stmt* _tmp86_;
		sqlite3_stmt* _tmp87_;
		sqlite3_stmt* _tmp88_ = NULL;
		sqlite3* _tmp89_;
		sqlite3_stmt* _tmp90_;
		sqlite3_stmt* _tmp91_;
		sqlite3_stmt* _tmp92_ = NULL;
		sqlite3* _tmp93_;
		sqlite3_stmt* _tmp94_;
		sqlite3_stmt* _tmp95_;
#line 197 "../src/database/database.vala"
		_tmp1_ = self->priv->database;
#line 197 "../src/database/database.vala"
		_tmp2_ = games_database_prepare (_tmp1_, GAMES_DATABASE_ADD_GAME_QUERY, &_inner_error0_);
#line 197 "../src/database/database.vala"
		_tmp0_ = _tmp2_;
#line 197 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "database.c"
			goto __catch0_g_error;
		}
#line 197 "../src/database/database.vala"
		_tmp3_ = _tmp0_;
#line 197 "../src/database/database.vala"
		_tmp0_ = NULL;
#line 197 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->add_game_query);
#line 197 "../src/database/database.vala"
		self->priv->add_game_query = _tmp3_;
#line 198 "../src/database/database.vala"
		_tmp5_ = self->priv->database;
#line 198 "../src/database/database.vala"
		_tmp6_ = games_database_prepare (_tmp5_, GAMES_DATABASE_ADD_GAME_URI_QUERY, &_inner_error0_);
#line 198 "../src/database/database.vala"
		_tmp4_ = _tmp6_;
#line 198 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 614 "database.c"
			goto __catch0_g_error;
		}
#line 198 "../src/database/database.vala"
		_tmp7_ = _tmp4_;
#line 198 "../src/database/database.vala"
		_tmp4_ = NULL;
#line 198 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->add_game_uri_query);
#line 198 "../src/database/database.vala"
		self->priv->add_game_uri_query = _tmp7_;
#line 199 "../src/database/database.vala"
		_tmp9_ = self->priv->database;
#line 199 "../src/database/database.vala"
		_tmp10_ = games_database_prepare (_tmp9_, GAMES_DATABASE_UPDATE_GAME_QUERY, &_inner_error0_);
#line 199 "../src/database/database.vala"
		_tmp8_ = _tmp10_;
#line 199 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 199 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 637 "database.c"
			goto __catch0_g_error;
		}
#line 199 "../src/database/database.vala"
		_tmp11_ = _tmp8_;
#line 199 "../src/database/database.vala"
		_tmp8_ = NULL;
#line 199 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->update_game_query);
#line 199 "../src/database/database.vala"
		self->priv->update_game_query = _tmp11_;
#line 200 "../src/database/database.vala"
		_tmp13_ = self->priv->database;
#line 200 "../src/database/database.vala"
		_tmp14_ = games_database_prepare (_tmp13_, GAMES_DATABASE_DELETE_GAME_QUERY, &_inner_error0_);
#line 200 "../src/database/database.vala"
		_tmp12_ = _tmp14_;
#line 200 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 200 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 200 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 662 "database.c"
			goto __catch0_g_error;
		}
#line 200 "../src/database/database.vala"
		_tmp15_ = _tmp12_;
#line 200 "../src/database/database.vala"
		_tmp12_ = NULL;
#line 200 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->delete_game_query);
#line 200 "../src/database/database.vala"
		self->priv->delete_game_query = _tmp15_;
#line 201 "../src/database/database.vala"
		_tmp17_ = self->priv->database;
#line 201 "../src/database/database.vala"
		_tmp18_ = games_database_prepare (_tmp17_, GAMES_DATABASE_DELETE_URI_QUERY, &_inner_error0_);
#line 201 "../src/database/database.vala"
		_tmp16_ = _tmp18_;
#line 201 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 201 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 201 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 201 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 689 "database.c"
			goto __catch0_g_error;
		}
#line 201 "../src/database/database.vala"
		_tmp19_ = _tmp16_;
#line 201 "../src/database/database.vala"
		_tmp16_ = NULL;
#line 201 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->delete_uri_query);
#line 201 "../src/database/database.vala"
		self->priv->delete_uri_query = _tmp19_;
#line 203 "../src/database/database.vala"
		_tmp21_ = self->priv->database;
#line 203 "../src/database/database.vala"
		_tmp22_ = games_database_prepare (_tmp21_, GAMES_DATABASE_FIND_GAME_URIS_QUERY, &_inner_error0_);
#line 203 "../src/database/database.vala"
		_tmp20_ = _tmp22_;
#line 203 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 203 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 203 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 203 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 203 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 718 "database.c"
			goto __catch0_g_error;
		}
#line 203 "../src/database/database.vala"
		_tmp23_ = _tmp20_;
#line 203 "../src/database/database.vala"
		_tmp20_ = NULL;
#line 203 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->find_game_uris_query);
#line 203 "../src/database/database.vala"
		self->priv->find_game_uris_query = _tmp23_;
#line 204 "../src/database/database.vala"
		_tmp25_ = self->priv->database;
#line 204 "../src/database/database.vala"
		_tmp26_ = games_database_prepare (_tmp25_, GAMES_DATABASE_GET_CACHED_GAME_QUERY, &_inner_error0_);
#line 204 "../src/database/database.vala"
		_tmp24_ = _tmp26_;
#line 204 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 204 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 749 "database.c"
			goto __catch0_g_error;
		}
#line 204 "../src/database/database.vala"
		_tmp27_ = _tmp24_;
#line 204 "../src/database/database.vala"
		_tmp24_ = NULL;
#line 204 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->get_cached_game_query);
#line 204 "../src/database/database.vala"
		self->priv->get_cached_game_query = _tmp27_;
#line 205 "../src/database/database.vala"
		_tmp29_ = self->priv->database;
#line 205 "../src/database/database.vala"
		_tmp30_ = games_database_prepare (_tmp29_, GAMES_DATABASE_LIST_CACHED_GAMES_QUERY, &_inner_error0_);
#line 205 "../src/database/database.vala"
		_tmp28_ = _tmp30_;
#line 205 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 205 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 782 "database.c"
			goto __catch0_g_error;
		}
#line 205 "../src/database/database.vala"
		_tmp31_ = _tmp28_;
#line 205 "../src/database/database.vala"
		_tmp28_ = NULL;
#line 205 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->list_cached_games_query);
#line 205 "../src/database/database.vala"
		self->priv->list_cached_games_query = _tmp31_;
#line 207 "../src/database/database.vala"
		_tmp33_ = self->priv->database;
#line 207 "../src/database/database.vala"
		_tmp34_ = games_database_prepare (_tmp33_, GAMES_DATABASE_ADD_GAME_RESOURCE_QUERY, &_inner_error0_);
#line 207 "../src/database/database.vala"
		_tmp32_ = _tmp34_;
#line 207 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 207 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 817 "database.c"
			goto __catch0_g_error;
		}
#line 207 "../src/database/database.vala"
		_tmp35_ = _tmp32_;
#line 207 "../src/database/database.vala"
		_tmp32_ = NULL;
#line 207 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->add_game_resource_query);
#line 207 "../src/database/database.vala"
		self->priv->add_game_resource_query = _tmp35_;
#line 208 "../src/database/database.vala"
		_tmp37_ = self->priv->database;
#line 208 "../src/database/database.vala"
		_tmp38_ = games_database_prepare (_tmp37_, GAMES_DATABASE_HAS_URI_QUERY, &_inner_error0_);
#line 208 "../src/database/database.vala"
		_tmp36_ = _tmp38_;
#line 208 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 208 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 854 "database.c"
			goto __catch0_g_error;
		}
#line 208 "../src/database/database.vala"
		_tmp39_ = _tmp36_;
#line 208 "../src/database/database.vala"
		_tmp36_ = NULL;
#line 208 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->has_uri_query);
#line 208 "../src/database/database.vala"
		self->priv->has_uri_query = _tmp39_;
#line 210 "../src/database/database.vala"
		_tmp41_ = self->priv->database;
#line 210 "../src/database/database.vala"
		_tmp42_ = games_database_prepare (_tmp41_, GAMES_DATABASE_SET_IS_FAVORITE_QUERY, &_inner_error0_);
#line 210 "../src/database/database.vala"
		_tmp40_ = _tmp42_;
#line 210 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 210 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 893 "database.c"
			goto __catch0_g_error;
		}
#line 210 "../src/database/database.vala"
		_tmp43_ = _tmp40_;
#line 210 "../src/database/database.vala"
		_tmp40_ = NULL;
#line 210 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->set_is_favorite_query);
#line 210 "../src/database/database.vala"
		self->priv->set_is_favorite_query = _tmp43_;
#line 211 "../src/database/database.vala"
		_tmp45_ = self->priv->database;
#line 211 "../src/database/database.vala"
		_tmp46_ = games_database_prepare (_tmp45_, GAMES_DATABASE_IS_GAME_FAVORITE_QUERY, &_inner_error0_);
#line 211 "../src/database/database.vala"
		_tmp44_ = _tmp46_;
#line 211 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 211 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 934 "database.c"
			goto __catch0_g_error;
		}
#line 211 "../src/database/database.vala"
		_tmp47_ = _tmp44_;
#line 211 "../src/database/database.vala"
		_tmp44_ = NULL;
#line 211 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->is_game_favorite_query);
#line 211 "../src/database/database.vala"
		self->priv->is_game_favorite_query = _tmp47_;
#line 212 "../src/database/database.vala"
		_tmp49_ = self->priv->database;
#line 212 "../src/database/database.vala"
		_tmp50_ = games_database_prepare (_tmp49_, GAMES_DATABASE_LIST_FAVORITE_GAMES_QUERY, &_inner_error0_);
#line 212 "../src/database/database.vala"
		_tmp48_ = _tmp50_;
#line 212 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 212 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 977 "database.c"
			goto __catch0_g_error;
		}
#line 212 "../src/database/database.vala"
		_tmp51_ = _tmp48_;
#line 212 "../src/database/database.vala"
		_tmp48_ = NULL;
#line 212 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->list_favorite_games_query);
#line 212 "../src/database/database.vala"
		self->priv->list_favorite_games_query = _tmp51_;
#line 214 "../src/database/database.vala"
		_tmp53_ = self->priv->database;
#line 214 "../src/database/database.vala"
		_tmp54_ = games_database_prepare (_tmp53_, GAMES_DATABASE_UPDATE_RECENTLY_PLAYED_GAME_QUERY, &_inner_error0_);
#line 214 "../src/database/database.vala"
		_tmp52_ = _tmp54_;
#line 214 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 214 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1022 "database.c"
			goto __catch0_g_error;
		}
#line 214 "../src/database/database.vala"
		_tmp55_ = _tmp52_;
#line 214 "../src/database/database.vala"
		_tmp52_ = NULL;
#line 214 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->update_recently_played_game_query);
#line 214 "../src/database/database.vala"
		self->priv->update_recently_played_game_query = _tmp55_;
#line 215 "../src/database/database.vala"
		_tmp57_ = self->priv->database;
#line 215 "../src/database/database.vala"
		_tmp58_ = games_database_prepare (_tmp57_, GAMES_DATABASE_LIST_RECENTLY_PLAYED_GAMES_QUERY, &_inner_error0_);
#line 215 "../src/database/database.vala"
		_tmp56_ = _tmp58_;
#line 215 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 215 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1069 "database.c"
			goto __catch0_g_error;
		}
#line 215 "../src/database/database.vala"
		_tmp59_ = _tmp56_;
#line 215 "../src/database/database.vala"
		_tmp56_ = NULL;
#line 215 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->list_recently_played_games_query);
#line 215 "../src/database/database.vala"
		self->priv->list_recently_played_games_query = _tmp59_;
#line 217 "../src/database/database.vala"
		_tmp61_ = self->priv->database;
#line 217 "../src/database/database.vala"
		_tmp62_ = games_database_prepare (_tmp61_, GAMES_DATABASE_ADD_USER_COLLECTION_QUERY, &_inner_error0_);
#line 217 "../src/database/database.vala"
		_tmp60_ = _tmp62_;
#line 217 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 217 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1118 "database.c"
			goto __catch0_g_error;
		}
#line 217 "../src/database/database.vala"
		_tmp63_ = _tmp60_;
#line 217 "../src/database/database.vala"
		_tmp60_ = NULL;
#line 217 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->add_user_collection_query);
#line 217 "../src/database/database.vala"
		self->priv->add_user_collection_query = _tmp63_;
#line 218 "../src/database/database.vala"
		_tmp65_ = self->priv->database;
#line 218 "../src/database/database.vala"
		_tmp66_ = games_database_prepare (_tmp65_, GAMES_DATABASE_ADD_GAME_TO_USER_COLLECTION_QUERY, &_inner_error0_);
#line 218 "../src/database/database.vala"
		_tmp64_ = _tmp66_;
#line 218 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 218 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1169 "database.c"
			goto __catch0_g_error;
		}
#line 218 "../src/database/database.vala"
		_tmp67_ = _tmp64_;
#line 218 "../src/database/database.vala"
		_tmp64_ = NULL;
#line 218 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->add_game_to_user_collection_query);
#line 218 "../src/database/database.vala"
		self->priv->add_game_to_user_collection_query = _tmp67_;
#line 219 "../src/database/database.vala"
		_tmp69_ = self->priv->database;
#line 219 "../src/database/database.vala"
		_tmp70_ = games_database_prepare (_tmp69_, GAMES_DATABASE_DOES_USER_COLLECTION_EXIST_QUERY, &_inner_error0_);
#line 219 "../src/database/database.vala"
		_tmp68_ = _tmp70_;
#line 219 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 219 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1222 "database.c"
			goto __catch0_g_error;
		}
#line 219 "../src/database/database.vala"
		_tmp71_ = _tmp68_;
#line 219 "../src/database/database.vala"
		_tmp68_ = NULL;
#line 219 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->does_user_collection_exist_query);
#line 219 "../src/database/database.vala"
		self->priv->does_user_collection_exist_query = _tmp71_;
#line 220 "../src/database/database.vala"
		_tmp73_ = self->priv->database;
#line 220 "../src/database/database.vala"
		_tmp74_ = games_database_prepare (_tmp73_, GAMES_DATABASE_IS_GAME_IN_USER_COLLECTION_QUERY, &_inner_error0_);
#line 220 "../src/database/database.vala"
		_tmp72_ = _tmp74_;
#line 220 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 220 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1277 "database.c"
			goto __catch0_g_error;
		}
#line 220 "../src/database/database.vala"
		_tmp75_ = _tmp72_;
#line 220 "../src/database/database.vala"
		_tmp72_ = NULL;
#line 220 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->is_game_in_user_collection_query);
#line 220 "../src/database/database.vala"
		self->priv->is_game_in_user_collection_query = _tmp75_;
#line 221 "../src/database/database.vala"
		_tmp77_ = self->priv->database;
#line 221 "../src/database/database.vala"
		_tmp78_ = games_database_prepare (_tmp77_, GAMES_DATABASE_LIST_USER_COLLECTIONS_QUERY, &_inner_error0_);
#line 221 "../src/database/database.vala"
		_tmp76_ = _tmp78_;
#line 221 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp72_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 221 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1334 "database.c"
			goto __catch0_g_error;
		}
#line 221 "../src/database/database.vala"
		_tmp79_ = _tmp76_;
#line 221 "../src/database/database.vala"
		_tmp76_ = NULL;
#line 221 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->list_user_collections_query);
#line 221 "../src/database/database.vala"
		self->priv->list_user_collections_query = _tmp79_;
#line 222 "../src/database/database.vala"
		_tmp81_ = self->priv->database;
#line 222 "../src/database/database.vala"
		_tmp82_ = games_database_prepare (_tmp81_, GAMES_DATABASE_LIST_GAMES_IN_USER_COLLECTION_QUERY, &_inner_error0_);
#line 222 "../src/database/database.vala"
		_tmp80_ = _tmp82_;
#line 222 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp76_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp72_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 222 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1393 "database.c"
			goto __catch0_g_error;
		}
#line 222 "../src/database/database.vala"
		_tmp83_ = _tmp80_;
#line 222 "../src/database/database.vala"
		_tmp80_ = NULL;
#line 222 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->list_games_in_user_collection_query);
#line 222 "../src/database/database.vala"
		self->priv->list_games_in_user_collection_query = _tmp83_;
#line 223 "../src/database/database.vala"
		_tmp85_ = self->priv->database;
#line 223 "../src/database/database.vala"
		_tmp86_ = games_database_prepare (_tmp85_, GAMES_DATABASE_REMOVE_USER_COLLECTION_QUERY, &_inner_error0_);
#line 223 "../src/database/database.vala"
		_tmp84_ = _tmp86_;
#line 223 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp80_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp76_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp72_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 223 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1454 "database.c"
			goto __catch0_g_error;
		}
#line 223 "../src/database/database.vala"
		_tmp87_ = _tmp84_;
#line 223 "../src/database/database.vala"
		_tmp84_ = NULL;
#line 223 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->remove_user_collection_query);
#line 223 "../src/database/database.vala"
		self->priv->remove_user_collection_query = _tmp87_;
#line 224 "../src/database/database.vala"
		_tmp89_ = self->priv->database;
#line 224 "../src/database/database.vala"
		_tmp90_ = games_database_prepare (_tmp89_, GAMES_DATABASE_REMOVE_GAME_FROM_USER_COLLECTION_QUERY, &_inner_error0_);
#line 224 "../src/database/database.vala"
		_tmp88_ = _tmp90_;
#line 224 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp84_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp80_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp76_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp72_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 224 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1517 "database.c"
			goto __catch0_g_error;
		}
#line 224 "../src/database/database.vala"
		_tmp91_ = _tmp88_;
#line 224 "../src/database/database.vala"
		_tmp88_ = NULL;
#line 224 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->remove_game_from_user_collection_query);
#line 224 "../src/database/database.vala"
		self->priv->remove_game_from_user_collection_query = _tmp91_;
#line 225 "../src/database/database.vala"
		_tmp93_ = self->priv->database;
#line 225 "../src/database/database.vala"
		_tmp94_ = games_database_prepare (_tmp93_, GAMES_DATABASE_RENAME_USER_COLLECTION_QUERY, &_inner_error0_);
#line 225 "../src/database/database.vala"
		_tmp92_ = _tmp94_;
#line 225 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp88_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp84_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp80_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp76_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp72_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp68_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp64_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp60_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp56_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp52_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp48_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp44_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp40_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp36_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp32_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp28_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp24_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp20_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp16_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp12_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp8_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp4_);
#line 225 "../src/database/database.vala"
			_sqlite3_finalize0 (_tmp0_);
#line 1582 "database.c"
			goto __catch0_g_error;
		}
#line 225 "../src/database/database.vala"
		_tmp95_ = _tmp92_;
#line 225 "../src/database/database.vala"
		_tmp92_ = NULL;
#line 225 "../src/database/database.vala"
		_sqlite3_finalize0 (self->priv->rename_user_collection_query);
#line 225 "../src/database/database.vala"
		self->priv->rename_user_collection_query = _tmp95_;
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp92_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp88_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp84_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp80_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp76_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp72_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp68_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp64_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp60_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp56_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp52_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp48_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp44_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp40_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp36_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp32_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp28_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp24_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp20_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp16_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp12_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp8_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp4_);
#line 196 "../src/database/database.vala"
		_sqlite3_finalize0 (_tmp0_);
#line 1641 "database.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp96_;
#line 196 "../src/database/database.vala"
		e = _inner_error0_;
#line 196 "../src/database/database.vala"
		_inner_error0_ = NULL;
#line 228 "../src/database/database.vala"
		_tmp96_ = e->message;
#line 228 "../src/database/database.vala"
		g_critical ("database.vala:228: Failed to prepare statements: %s", _tmp96_);
#line 229 "../src/database/database.vala"
		g_assert_not_reached ();
#line 196 "../src/database/database.vala"
		_g_error_free0 (e);
#line 1660 "database.c"
	}
	__finally0:
#line 196 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/database/database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/database/database.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/database/database.vala"
		return;
#line 1671 "database.c"
	}
}

void
games_database_apply_favorites_migration (GamesDatabase* self,
                                          GError** error)
{
	GError* _inner_error0_ = NULL;
#line 233 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/database/database.vala"
	g_info ("database.vala:234: Applying database migration to support favorites");
#line 235 "../src/database/database.vala"
	games_database_exec (self, "ALTER TABLE games ADD COLUMN is_favorite INTEGER NOT NULL DEFAULT 0;", NULL, NULL, &_inner_error0_);
#line 235 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 235 "../src/database/database.vala"
		return;
#line 1692 "database.c"
	}
}

void
games_database_apply_recently_played_migration (GamesDatabase* self,
                                                GError** error)
{
	GError* _inner_error0_ = NULL;
#line 238 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/database/database.vala"
	g_info ("database.vala:239: Applying database migration to support recently pla" \
"yed games");
#line 240 "../src/database/database.vala"
	games_database_exec (self, "ALTER TABLE games ADD COLUMN last_played TEXT DEFAULT NULL;", NULL, NULL, &_inner_error0_);
#line 240 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 240 "../src/database/database.vala"
		return;
#line 1713 "database.c"
	}
}

void
games_database_add_uri (GamesDatabase* self,
                        GamesUri* uri,
                        GError** error)
{
	gboolean _tmp0_ = FALSE;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 243 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/database/database.vala"
	g_return_if_fail (uri != NULL);
#line 244 "../src/database/database.vala"
	_tmp0_ = games_database_has_uri (self, uri, &_inner_error0_);
#line 244 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 244 "../src/database/database.vala"
		return;
#line 1741 "database.c"
	}
#line 244 "../src/database/database.vala"
	if (_tmp0_) {
#line 245 "../src/database/database.vala"
		return;
#line 1747 "database.c"
	}
#line 247 "../src/database/database.vala"
	_tmp1_ = self->priv->add_game_resource_query;
#line 247 "../src/database/database.vala"
	sqlite3_reset (_tmp1_);
#line 248 "../src/database/database.vala"
	_tmp2_ = self->priv->add_game_resource_query;
#line 248 "../src/database/database.vala"
	_tmp3_ = games_uri_to_string (uri);
#line 248 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 248 "../src/database/database.vala"
	games_database_bind_text (_tmp2_, "$URI", _tmp4_, &_inner_error0_);
#line 248 "../src/database/database.vala"
	_g_free0 (_tmp4_);
#line 248 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 248 "../src/database/database.vala"
		return;
#line 1769 "database.c"
	}
#line 250 "../src/database/database.vala"
	_tmp5_ = self->priv->add_game_resource_query;
#line 250 "../src/database/database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 1775 "database.c"
		GError* _tmp6_;
#line 251 "../src/database/database.vala"
		_tmp6_ = g_error_new_literal (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Execution failed.");
#line 251 "../src/database/database.vala"
		_inner_error0_ = _tmp6_;
#line 251 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 251 "../src/database/database.vala"
		return;
#line 1785 "database.c"
	}
}

gboolean
games_database_has_uri (GamesDatabase* self,
                        GamesUri* uri,
                        GError** error)
{
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 254 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 254 "../src/database/database.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 255 "../src/database/database.vala"
	_tmp0_ = self->priv->has_uri_query;
#line 255 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 256 "../src/database/database.vala"
	_tmp1_ = self->priv->has_uri_query;
#line 256 "../src/database/database.vala"
	_tmp2_ = games_uri_to_string (uri);
#line 256 "../src/database/database.vala"
	_tmp3_ = _tmp2_;
#line 256 "../src/database/database.vala"
	games_database_bind_text (_tmp1_, "$URI", _tmp3_, &_inner_error0_);
#line 256 "../src/database/database.vala"
	_g_free0 (_tmp3_);
#line 256 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1821 "database.c"
		gboolean _tmp4_ = FALSE;
#line 256 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 256 "../src/database/database.vala"
		return _tmp4_;
#line 1827 "database.c"
	}
#line 258 "../src/database/database.vala"
	_tmp5_ = self->priv->has_uri_query;
#line 258 "../src/database/database.vala"
	switch (sqlite3_step (_tmp5_)) {
#line 258 "../src/database/database.vala"
		case SQLITE_ROW:
#line 1835 "database.c"
		{
			sqlite3_stmt* _tmp6_;
			const gchar* _tmp7_;
#line 260 "../src/database/database.vala"
			_tmp6_ = self->priv->has_uri_query;
#line 260 "../src/database/database.vala"
			_tmp7_ = (const gchar*) sqlite3_column_text (_tmp6_, 0);
#line 260 "../src/database/database.vala"
			result = g_strcmp0 (_tmp7_, "1") == 0;
#line 260 "../src/database/database.vala"
			return result;
#line 1847 "database.c"
		}
		default:
		{
#line 262 "../src/database/database.vala"
			g_debug ("database.vala:262: Execution failed.");
#line 264 "../src/database/database.vala"
			result = FALSE;
#line 264 "../src/database/database.vala"
			return result;
#line 1857 "database.c"
		}
	}
}

GamesDatabaseUriSource*
games_database_get_uri_source (GamesDatabase* self)
{
	sqlite3* _tmp0_;
	GamesDatabaseUriSource* _tmp1_;
	GamesDatabaseUriSource* result;
#line 268 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/database/database.vala"
	_tmp0_ = self->priv->database;
#line 269 "../src/database/database.vala"
	_tmp1_ = games_database_uri_source_new (_tmp0_);
#line 269 "../src/database/database.vala"
	result = _tmp1_;
#line 269 "../src/database/database.vala"
	return result;
#line 1878 "database.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 1907 "database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 1918 "database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 1924 "database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 1936 "database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 1940 "database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 1944 "database.c"
}

static void
games_database_exec (GamesDatabase* self,
                     const gchar* query,
                     sqlite3_callback callback,
                     gpointer callback_target,
                     GError** error)
{
	gchar* error_message = NULL;
	sqlite3* _tmp0_;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	GError* _inner_error0_ = NULL;
#line 272 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/database/database.vala"
	g_return_if_fail (query != NULL);
#line 275 "../src/database/database.vala"
	_tmp0_ = self->priv->database;
#line 275 "../src/database/database.vala"
	_tmp2_ = _sqlite3_exec (_tmp0_, query, callback, callback_target, &_tmp1_);
#line 275 "../src/database/database.vala"
	_g_free0 (error_message);
#line 275 "../src/database/database.vala"
	error_message = _tmp1_;
#line 275 "../src/database/database.vala"
	if (_tmp2_ != SQLITE_OK) {
#line 1973 "database.c"
		const gchar* _tmp3_;
		GError* _tmp4_;
#line 276 "../src/database/database.vala"
		_tmp3_ = error_message;
#line 276 "../src/database/database.vala"
		_tmp4_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Execution failed: %s", _tmp3_);
#line 276 "../src/database/database.vala"
		_inner_error0_ = _tmp4_;
#line 276 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 276 "../src/database/database.vala"
		_g_free0 (error_message);
#line 276 "../src/database/database.vala"
		return;
#line 1988 "database.c"
	}
#line 272 "../src/database/database.vala"
	_g_free0 (error_message);
#line 1992 "database.c"
}

sqlite3_stmt*
games_database_prepare (sqlite3* database,
                        const gchar* query,
                        GError** error)
{
	sqlite3_stmt* statement = NULL;
	gint _tmp0_;
	gint _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	GError* _inner_error0_ = NULL;
	sqlite3_stmt* result;
#line 279 "../src/database/database.vala"
	g_return_val_if_fail (database != NULL, NULL);
#line 279 "../src/database/database.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 281 "../src/database/database.vala"
	_tmp0_ = strlen (query);
#line 281 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 281 "../src/database/database.vala"
	_tmp3_ = sqlite3_prepare_v2 (database, query, _tmp1_, &_tmp2_, NULL);
#line 281 "../src/database/database.vala"
	_sqlite3_finalize0 (statement);
#line 281 "../src/database/database.vala"
	statement = _tmp2_;
#line 281 "../src/database/database.vala"
	if (_tmp3_ != SQLITE_OK) {
#line 2023 "database.c"
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 282 "../src/database/database.vala"
		_tmp4_ = sqlite3_errmsg (database);
#line 282 "../src/database/database.vala"
		_tmp5_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_PREPARATION_FAILED, "Preparation failed: %s", _tmp4_);
#line 282 "../src/database/database.vala"
		_inner_error0_ = _tmp5_;
#line 282 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 282 "../src/database/database.vala"
		_sqlite3_finalize0 (statement);
#line 282 "../src/database/database.vala"
		return NULL;
#line 2038 "database.c"
	}
#line 284 "../src/database/database.vala"
	result = statement;
#line 284 "../src/database/database.vala"
	return result;
#line 2044 "database.c"
}

void
games_database_bind_text (sqlite3_stmt* statement,
                          const gchar* parameter,
                          const gchar* text,
                          GError** error)
{
	gint position = 0;
	GError* _inner_error0_ = NULL;
#line 287 "../src/database/database.vala"
	g_return_if_fail (statement != NULL);
#line 287 "../src/database/database.vala"
	g_return_if_fail (parameter != NULL);
#line 288 "../src/database/database.vala"
	position = sqlite3_bind_parameter_index (statement, parameter);
#line 289 "../src/database/database.vala"
	if (position <= 0) {
#line 2063 "database.c"
		GError* _tmp0_;
#line 290 "../src/database/database.vala"
		_tmp0_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_BINDING_FAILED, "Couldn't bind text to the parameter “%s”, unexpected position: %d.", parameter, position);
#line 290 "../src/database/database.vala"
		_inner_error0_ = _tmp0_;
#line 290 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 290 "../src/database/database.vala"
		return;
#line 2073 "database.c"
	}
#line 292 "../src/database/database.vala"
	if (text != NULL) {
#line 2077 "database.c"
		gchar* _tmp1_;
		GDestroyNotify _tmp2_;
#line 293 "../src/database/database.vala"
		_tmp1_ = g_strdup (text);
#line 293 "../src/database/database.vala"
		_tmp2_ = g_free;
#line 293 "../src/database/database.vala"
		sqlite3_bind_text (statement, position, _tmp1_, -1, _tmp2_);
#line 2086 "database.c"
	} else {
#line 295 "../src/database/database.vala"
		sqlite3_bind_null (statement, position);
#line 2090 "database.c"
	}
}

void
games_database_bind_int (sqlite3_stmt* statement,
                         const gchar* parameter,
                         gint* integer,
                         GError** error)
{
	gint position = 0;
	GError* _inner_error0_ = NULL;
#line 298 "../src/database/database.vala"
	g_return_if_fail (statement != NULL);
#line 298 "../src/database/database.vala"
	g_return_if_fail (parameter != NULL);
#line 299 "../src/database/database.vala"
	position = sqlite3_bind_parameter_index (statement, parameter);
#line 300 "../src/database/database.vala"
	if (position <= 0) {
#line 2110 "database.c"
		GError* _tmp0_;
#line 301 "../src/database/database.vala"
		_tmp0_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_BINDING_FAILED, "Couldn't bind text to the parameter “%s”, unexpected position: %d.", parameter, position);
#line 301 "../src/database/database.vala"
		_inner_error0_ = _tmp0_;
#line 301 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 301 "../src/database/database.vala"
		return;
#line 2120 "database.c"
	}
#line 303 "../src/database/database.vala"
	if (integer != NULL) {
#line 304 "../src/database/database.vala"
		sqlite3_bind_int (statement, position, *integer);
#line 2126 "database.c"
	} else {
#line 306 "../src/database/database.vala"
		sqlite3_bind_null (statement, position);
#line 2130 "database.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 310 "../src/database/database.vala"
	return self ? g_object_ref (self) : NULL;
#line 2139 "database.c"
}

static gchar*
games_database_serialize_media_set (GamesDatabase* self,
                                    GamesGame* game)
{
	GamesMediaSet* media_set = NULL;
	GamesMediaSet* _tmp0_;
	GamesMediaSet* _tmp1_;
	GamesMediaSet* _tmp2_;
	GamesMediaSet* _tmp3_;
	GamesMediaSet* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 309 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 310 "../src/database/database.vala"
	_tmp0_ = games_game_get_media_set (game);
#line 310 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 310 "../src/database/database.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 310 "../src/database/database.vala"
	media_set = _tmp2_;
#line 312 "../src/database/database.vala"
	_tmp3_ = media_set;
#line 312 "../src/database/database.vala"
	if (_tmp3_ == NULL) {
#line 313 "../src/database/database.vala"
		result = NULL;
#line 313 "../src/database/database.vala"
		_g_object_unref0 (media_set);
#line 313 "../src/database/database.vala"
		return result;
#line 2179 "database.c"
	}
#line 315 "../src/database/database.vala"
	_tmp4_ = media_set;
#line 315 "../src/database/database.vala"
	_tmp5_ = games_media_set_serialize (_tmp4_);
#line 315 "../src/database/database.vala"
	_tmp6_ = _tmp5_;
#line 315 "../src/database/database.vala"
	_tmp7_ = g_variant_print (_tmp6_, TRUE);
#line 315 "../src/database/database.vala"
	_tmp8_ = _tmp7_;
#line 315 "../src/database/database.vala"
	_g_variant_unref0 (_tmp6_);
#line 315 "../src/database/database.vala"
	result = _tmp8_;
#line 315 "../src/database/database.vala"
	_g_object_unref0 (media_set);
#line 315 "../src/database/database.vala"
	return result;
#line 2199 "database.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 318 "../src/database/database.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 318 "../src/database/database.vala"
	return _data17_;
#line 2209 "database.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 318 "../src/database/database.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 2219 "database.c"
		GamesDatabase* self;
#line 318 "../src/database/database.vala"
		self = _data17_->self;
#line 318 "../src/database/database.vala"
		_data17_->uris = (_vala_array_free (_data17_->uris, _data17_->uris_length1, (GDestroyNotify) g_free), NULL);
#line 318 "../src/database/database.vala"
		_g_object_unref0 (self);
#line 318 "../src/database/database.vala"
		g_slice_free (Block17Data, _data17_);
#line 2229 "database.c"
	}
}

static gpointer
_games_uri_ref0 (gpointer self)
{
#line 326 "../src/database/database.vala"
	return self ? games_uri_ref (self) : NULL;
#line 2238 "database.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 327 "../src/database/database.vala"
	if ((*length) == (*size)) {
#line 327 "../src/database/database.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 327 "../src/database/database.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2253 "database.c"
	}
#line 327 "../src/database/database.vala"
	(*array)[(*length)++] = value;
#line 327 "../src/database/database.vala"
	(*array)[*length] = NULL;
#line 2259 "database.c"
}

static void
__lambda5_ (Block17Data* _data17_,
            GamesMedia* media)
{
	GamesDatabase* self;
	gint _tmp0_ = 0;
	GamesUri** _tmp1_;
#line 325 "../src/database/database.vala"
	self = _data17_->self;
#line 325 "../src/database/database.vala"
	g_return_if_fail (media != NULL);
#line 326 "../src/database/database.vala"
	_tmp1_ = games_media_get_uris (media, &_tmp0_);
#line 2275 "database.c"
	{
		GamesUri** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 326 "../src/database/database.vala"
		uri_collection = _tmp1_;
#line 326 "../src/database/database.vala"
		uri_collection_length1 = _tmp0_;
#line 326 "../src/database/database.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 2287 "database.c"
			GamesUri* _tmp2_;
			GamesUri* uri = NULL;
#line 326 "../src/database/database.vala"
			_tmp2_ = _games_uri_ref0 (uri_collection[uri_it]);
#line 326 "../src/database/database.vala"
			uri = _tmp2_;
#line 2294 "database.c"
			{
				GamesUri* _tmp3_;
				gchar* _tmp4_;
#line 327 "../src/database/database.vala"
				_tmp3_ = uri;
#line 327 "../src/database/database.vala"
				_tmp4_ = games_uri_to_string (_tmp3_);
#line 327 "../src/database/database.vala"
				_vala_array_add18 (&_data17_->uris, &_data17_->uris_length1, &_data17_->_uris_size_, _tmp4_);
#line 326 "../src/database/database.vala"
				_games_uri_unref0 (uri);
#line 2306 "database.c"
			}
		}
#line 326 "../src/database/database.vala"
		uri_collection = (_vala_array_free (uri_collection, uri_collection_length1, (GDestroyNotify) games_uri_unref), NULL);
#line 2311 "database.c"
	}
}

static void
___lambda5__games_media_set_media_callback (GamesMedia* media,
                                            gpointer self)
{
#line 325 "../src/database/database.vala"
	__lambda5_ (self, media);
#line 2321 "database.c"
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 330 "../src/database/database.vala"
	if (length >= 0) {
#line 2330 "database.c"
		gchar** result;
		gssize i;
#line 330 "../src/database/database.vala"
		result = g_new0 (gchar*, length + 1);
#line 330 "../src/database/database.vala"
		for (i = 0; i < length; i++) {
#line 2337 "database.c"
			gchar* _tmp0_;
#line 330 "../src/database/database.vala"
			_tmp0_ = g_strdup (self[i]);
#line 330 "../src/database/database.vala"
			result[i] = _tmp0_;
#line 2343 "database.c"
		}
#line 330 "../src/database/database.vala"
		return result;
#line 2347 "database.c"
	}
#line 330 "../src/database/database.vala"
	return NULL;
#line 2351 "database.c"
}

static gchar**
games_database_get_media_uris (GamesDatabase* self,
                               GamesGame* game,
                               gint* result_length1)
{
	Block17Data* _data17_;
	GamesMediaSet* media_set = NULL;
	GamesMediaSet* _tmp0_;
	GamesMediaSet* _tmp1_;
	GamesMediaSet* _tmp2_;
	GamesMediaSet* _tmp3_;
	gchar** _tmp6_;
	GamesMediaSet* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** result;
#line 318 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 318 "../src/database/database.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 318 "../src/database/database.vala"
	_data17_->_ref_count_ = 1;
#line 318 "../src/database/database.vala"
	_data17_->self = g_object_ref (self);
#line 319 "../src/database/database.vala"
	_tmp0_ = games_game_get_media_set (game);
#line 319 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 319 "../src/database/database.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 319 "../src/database/database.vala"
	media_set = _tmp2_;
#line 321 "../src/database/database.vala"
	_tmp3_ = media_set;
#line 321 "../src/database/database.vala"
	if (_tmp3_ == NULL) {
#line 2396 "database.c"
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 322 "../src/database/database.vala"
		_tmp4_ = g_new0 (gchar*, 0 + 1);
#line 322 "../src/database/database.vala"
		_tmp5_ = _tmp4_;
#line 322 "../src/database/database.vala"
		_tmp5__length1 = 0;
#line 322 "../src/database/database.vala"
		if (result_length1) {
#line 322 "../src/database/database.vala"
			*result_length1 = _tmp5__length1;
#line 2410 "database.c"
		}
#line 322 "../src/database/database.vala"
		result = _tmp5_;
#line 322 "../src/database/database.vala"
		_g_object_unref0 (media_set);
#line 322 "../src/database/database.vala"
		block17_data_unref (_data17_);
#line 322 "../src/database/database.vala"
		_data17_ = NULL;
#line 322 "../src/database/database.vala"
		return result;
#line 2422 "database.c"
	}
#line 324 "../src/database/database.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 324 "../src/database/database.vala"
	_data17_->uris = _tmp6_;
#line 324 "../src/database/database.vala"
	_data17_->uris_length1 = 0;
#line 324 "../src/database/database.vala"
	_data17_->_uris_size_ = _data17_->uris_length1;
#line 325 "../src/database/database.vala"
	_tmp7_ = media_set;
#line 325 "../src/database/database.vala"
	games_media_set_foreach_media (_tmp7_, ___lambda5__games_media_set_media_callback, _data17_);
#line 330 "../src/database/database.vala"
	_tmp8_ = _data17_->uris;
#line 330 "../src/database/database.vala"
	_tmp8__length1 = _data17_->uris_length1;
#line 330 "../src/database/database.vala"
	_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup8 (_tmp8_, _tmp8__length1) : _tmp8_;
#line 330 "../src/database/database.vala"
	_tmp9__length1 = _tmp8__length1;
#line 330 "../src/database/database.vala"
	_tmp10_ = _tmp9_;
#line 330 "../src/database/database.vala"
	_tmp10__length1 = _tmp9__length1;
#line 330 "../src/database/database.vala"
	if (result_length1) {
#line 330 "../src/database/database.vala"
		*result_length1 = _tmp10__length1;
#line 2452 "database.c"
	}
#line 330 "../src/database/database.vala"
	result = _tmp10_;
#line 330 "../src/database/database.vala"
	_g_object_unref0 (media_set);
#line 330 "../src/database/database.vala"
	block17_data_unref (_data17_);
#line 330 "../src/database/database.vala"
	_data17_ = NULL;
#line 330 "../src/database/database.vala"
	return result;
#line 2464 "database.c"
}

static void
games_database_store_game_uri (GamesDatabase* self,
                               const gchar* uid,
                               const gchar* uri,
                               GError** error)
{
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 333 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/database/database.vala"
	g_return_if_fail (uid != NULL);
#line 333 "../src/database/database.vala"
	g_return_if_fail (uri != NULL);
#line 334 "../src/database/database.vala"
	_tmp0_ = self->priv->add_game_uri_query;
#line 334 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 335 "../src/database/database.vala"
	_tmp1_ = self->priv->add_game_uri_query;
#line 335 "../src/database/database.vala"
	games_database_bind_text (_tmp1_, "$UID", uid, &_inner_error0_);
#line 335 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 335 "../src/database/database.vala"
		return;
#line 2500 "database.c"
	}
#line 336 "../src/database/database.vala"
	_tmp2_ = self->priv->add_game_uri_query;
#line 336 "../src/database/database.vala"
	games_database_bind_text (_tmp2_, "$URI", uri, &_inner_error0_);
#line 336 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 336 "../src/database/database.vala"
		return;
#line 2512 "database.c"
	}
#line 338 "../src/database/database.vala"
	_tmp3_ = self->priv->add_game_uri_query;
#line 338 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp3_);
#line 339 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 339 "../src/database/database.vala"
		_tmp4_ = _result_ != SQLITE_CONSTRAINT;
#line 2522 "database.c"
	} else {
#line 339 "../src/database/database.vala"
		_tmp4_ = FALSE;
#line 2526 "database.c"
	}
#line 339 "../src/database/database.vala"
	if (_tmp4_) {
#line 2530 "database.c"
		GError* _tmp5_;
#line 340 "../src/database/database.vala"
		_tmp5_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't add uri (%s, %s)", uid, uri);
#line 340 "../src/database/database.vala"
		_inner_error0_ = _tmp5_;
#line 340 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 340 "../src/database/database.vala"
		return;
#line 2540 "database.c"
	}
}

GamesGame*
games_database_store_game (GamesDatabase* self,
                           GamesGame* game,
                           GError** error)
{
	gchar* uid = NULL;
	GamesUid* _tmp0_;
	GamesUid* _tmp1_;
	gchar* _tmp2_;
	gchar* uri = NULL;
	GamesUri* _tmp3_;
	GamesUri* _tmp4_;
	gchar* _tmp5_;
	gchar* title = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* platform = NULL;
	GamesPlatform* _tmp9_;
	GamesPlatform* _tmp10_;
	gchar* _tmp11_;
	gchar* media_set = NULL;
	gchar* _tmp12_;
	GamesMediaSet* _tmp13_;
	GamesMediaSet* _tmp14_;
	sqlite3_stmt* _tmp22_;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	const gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	sqlite3_stmt* _tmp29_;
	const gchar* _tmp30_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp31_;
	GError* _inner_error0_ = NULL;
	GamesGame* result;
#line 343 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 343 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 344 "../src/database/database.vala"
	_tmp0_ = games_game_get_uid (game);
#line 344 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 344 "../src/database/database.vala"
	_tmp2_ = games_uid_to_string (_tmp1_);
#line 344 "../src/database/database.vala"
	uid = _tmp2_;
#line 345 "../src/database/database.vala"
	_tmp3_ = games_game_get_uri (game);
#line 345 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 345 "../src/database/database.vala"
	_tmp5_ = games_uri_to_string (_tmp4_);
#line 345 "../src/database/database.vala"
	uri = _tmp5_;
#line 346 "../src/database/database.vala"
	_tmp6_ = games_game_get_name (game);
#line 346 "../src/database/database.vala"
	_tmp7_ = _tmp6_;
#line 346 "../src/database/database.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 346 "../src/database/database.vala"
	title = _tmp8_;
#line 347 "../src/database/database.vala"
	_tmp9_ = games_game_get_platform (game);
#line 347 "../src/database/database.vala"
	_tmp10_ = _tmp9_;
#line 347 "../src/database/database.vala"
	_tmp11_ = games_platform_get_id (_tmp10_);
#line 347 "../src/database/database.vala"
	platform = _tmp11_;
#line 348 "../src/database/database.vala"
	_tmp12_ = games_database_serialize_media_set (self, game);
#line 348 "../src/database/database.vala"
	media_set = _tmp12_;
#line 352 "../src/database/database.vala"
	_tmp13_ = games_game_get_media_set (game);
#line 352 "../src/database/database.vala"
	_tmp14_ = _tmp13_;
#line 352 "../src/database/database.vala"
	if (_tmp14_ != NULL) {
#line 2628 "database.c"
		gint _tmp15_ = 0;
		gchar** _tmp16_;
#line 353 "../src/database/database.vala"
		_tmp16_ = games_database_get_media_uris (self, game, &_tmp15_);
#line 2633 "database.c"
		{
			gchar** media_uri_collection = NULL;
			gint media_uri_collection_length1 = 0;
			gint _media_uri_collection_size_ = 0;
			gint media_uri_it = 0;
#line 353 "../src/database/database.vala"
			media_uri_collection = _tmp16_;
#line 353 "../src/database/database.vala"
			media_uri_collection_length1 = _tmp15_;
#line 353 "../src/database/database.vala"
			for (media_uri_it = 0; media_uri_it < media_uri_collection_length1; media_uri_it = media_uri_it + 1) {
#line 2645 "database.c"
				gchar* _tmp17_;
				gchar* media_uri = NULL;
#line 353 "../src/database/database.vala"
				_tmp17_ = g_strdup (media_uri_collection[media_uri_it]);
#line 353 "../src/database/database.vala"
				media_uri = _tmp17_;
#line 2652 "database.c"
				{
					const gchar* _tmp18_;
					const gchar* _tmp19_;
#line 354 "../src/database/database.vala"
					_tmp18_ = uid;
#line 354 "../src/database/database.vala"
					_tmp19_ = media_uri;
#line 354 "../src/database/database.vala"
					games_database_store_game_uri (self, _tmp18_, _tmp19_, &_inner_error0_);
#line 354 "../src/database/database.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 354 "../src/database/database.vala"
						g_propagate_error (error, _inner_error0_);
#line 354 "../src/database/database.vala"
						_g_free0 (media_uri);
#line 354 "../src/database/database.vala"
						media_uri_collection = (_vala_array_free (media_uri_collection, media_uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 354 "../src/database/database.vala"
						_g_free0 (media_set);
#line 354 "../src/database/database.vala"
						_g_free0 (platform);
#line 354 "../src/database/database.vala"
						_g_free0 (title);
#line 354 "../src/database/database.vala"
						_g_free0 (uri);
#line 354 "../src/database/database.vala"
						_g_free0 (uid);
#line 354 "../src/database/database.vala"
						return NULL;
#line 2682 "database.c"
					}
#line 353 "../src/database/database.vala"
					_g_free0 (media_uri);
#line 2686 "database.c"
				}
			}
#line 353 "../src/database/database.vala"
			media_uri_collection = (_vala_array_free (media_uri_collection, media_uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2691 "database.c"
		}
	} else {
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 356 "../src/database/database.vala"
		_tmp20_ = uid;
#line 356 "../src/database/database.vala"
		_tmp21_ = uri;
#line 356 "../src/database/database.vala"
		games_database_store_game_uri (self, _tmp20_, _tmp21_, &_inner_error0_);
#line 356 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/database/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 356 "../src/database/database.vala"
			_g_free0 (media_set);
#line 356 "../src/database/database.vala"
			_g_free0 (platform);
#line 356 "../src/database/database.vala"
			_g_free0 (title);
#line 356 "../src/database/database.vala"
			_g_free0 (uri);
#line 356 "../src/database/database.vala"
			_g_free0 (uid);
#line 356 "../src/database/database.vala"
			return NULL;
#line 2718 "database.c"
		}
	}
#line 358 "../src/database/database.vala"
	_tmp22_ = self->priv->add_game_query;
#line 358 "../src/database/database.vala"
	sqlite3_reset (_tmp22_);
#line 359 "../src/database/database.vala"
	_tmp23_ = self->priv->add_game_query;
#line 359 "../src/database/database.vala"
	_tmp24_ = uid;
#line 359 "../src/database/database.vala"
	games_database_bind_text (_tmp23_, "$UID", _tmp24_, &_inner_error0_);
#line 359 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 359 "../src/database/database.vala"
		_g_free0 (media_set);
#line 359 "../src/database/database.vala"
		_g_free0 (platform);
#line 359 "../src/database/database.vala"
		_g_free0 (title);
#line 359 "../src/database/database.vala"
		_g_free0 (uri);
#line 359 "../src/database/database.vala"
		_g_free0 (uid);
#line 359 "../src/database/database.vala"
		return NULL;
#line 2747 "database.c"
	}
#line 360 "../src/database/database.vala"
	_tmp25_ = self->priv->add_game_query;
#line 360 "../src/database/database.vala"
	_tmp26_ = title;
#line 360 "../src/database/database.vala"
	games_database_bind_text (_tmp25_, "$TITLE", _tmp26_, &_inner_error0_);
#line 360 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 360 "../src/database/database.vala"
		_g_free0 (media_set);
#line 360 "../src/database/database.vala"
		_g_free0 (platform);
#line 360 "../src/database/database.vala"
		_g_free0 (title);
#line 360 "../src/database/database.vala"
		_g_free0 (uri);
#line 360 "../src/database/database.vala"
		_g_free0 (uid);
#line 360 "../src/database/database.vala"
		return NULL;
#line 2771 "database.c"
	}
#line 361 "../src/database/database.vala"
	_tmp27_ = self->priv->add_game_query;
#line 361 "../src/database/database.vala"
	_tmp28_ = platform;
#line 361 "../src/database/database.vala"
	games_database_bind_text (_tmp27_, "$PLATFORM", _tmp28_, &_inner_error0_);
#line 361 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 361 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 361 "../src/database/database.vala"
		_g_free0 (media_set);
#line 361 "../src/database/database.vala"
		_g_free0 (platform);
#line 361 "../src/database/database.vala"
		_g_free0 (title);
#line 361 "../src/database/database.vala"
		_g_free0 (uri);
#line 361 "../src/database/database.vala"
		_g_free0 (uid);
#line 361 "../src/database/database.vala"
		return NULL;
#line 2795 "database.c"
	}
#line 362 "../src/database/database.vala"
	_tmp29_ = self->priv->add_game_query;
#line 362 "../src/database/database.vala"
	_tmp30_ = media_set;
#line 362 "../src/database/database.vala"
	games_database_bind_text (_tmp29_, "$MEDIA_SET", _tmp30_, &_inner_error0_);
#line 362 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 362 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 362 "../src/database/database.vala"
		_g_free0 (media_set);
#line 362 "../src/database/database.vala"
		_g_free0 (platform);
#line 362 "../src/database/database.vala"
		_g_free0 (title);
#line 362 "../src/database/database.vala"
		_g_free0 (uri);
#line 362 "../src/database/database.vala"
		_g_free0 (uid);
#line 362 "../src/database/database.vala"
		return NULL;
#line 2819 "database.c"
	}
#line 364 "../src/database/database.vala"
	_tmp31_ = self->priv->add_game_query;
#line 364 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp31_);
#line 365 "../src/database/database.vala"
	if (_result_ == SQLITE_CONSTRAINT) {
#line 2827 "database.c"
		GamesGame* prev_game = NULL;
		const gchar* _tmp32_;
		GamesGame* _tmp33_;
		GamesGame* _tmp34_;
#line 366 "../src/database/database.vala"
		_tmp32_ = uid;
#line 366 "../src/database/database.vala"
		_tmp33_ = games_database_get_cached_game (self, _tmp32_, &_inner_error0_);
#line 366 "../src/database/database.vala"
		prev_game = _tmp33_;
#line 366 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 366 "../src/database/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 366 "../src/database/database.vala"
			_g_free0 (media_set);
#line 366 "../src/database/database.vala"
			_g_free0 (platform);
#line 366 "../src/database/database.vala"
			_g_free0 (title);
#line 366 "../src/database/database.vala"
			_g_free0 (uri);
#line 366 "../src/database/database.vala"
			_g_free0 (uid);
#line 366 "../src/database/database.vala"
			return NULL;
#line 2854 "database.c"
		}
#line 367 "../src/database/database.vala"
		_tmp34_ = prev_game;
#line 367 "../src/database/database.vala"
		games_database_update_game (self, game, _tmp34_, &_inner_error0_);
#line 367 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 367 "../src/database/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 367 "../src/database/database.vala"
			_g_object_unref0 (prev_game);
#line 367 "../src/database/database.vala"
			_g_free0 (media_set);
#line 367 "../src/database/database.vala"
			_g_free0 (platform);
#line 367 "../src/database/database.vala"
			_g_free0 (title);
#line 367 "../src/database/database.vala"
			_g_free0 (uri);
#line 367 "../src/database/database.vala"
			_g_free0 (uid);
#line 367 "../src/database/database.vala"
			return NULL;
#line 2878 "database.c"
		}
#line 368 "../src/database/database.vala"
		result = prev_game;
#line 368 "../src/database/database.vala"
		_g_free0 (media_set);
#line 368 "../src/database/database.vala"
		_g_free0 (platform);
#line 368 "../src/database/database.vala"
		_g_free0 (title);
#line 368 "../src/database/database.vala"
		_g_free0 (uri);
#line 368 "../src/database/database.vala"
		_g_free0 (uid);
#line 368 "../src/database/database.vala"
		return result;
#line 2894 "database.c"
	}
#line 371 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 2898 "database.c"
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		GError* _tmp39_;
#line 372 "../src/database/database.vala"
		_tmp35_ = uid;
#line 372 "../src/database/database.vala"
		_tmp36_ = title;
#line 372 "../src/database/database.vala"
		_tmp37_ = platform;
#line 372 "../src/database/database.vala"
		_tmp38_ = media_set;
#line 372 "../src/database/database.vala"
		_tmp39_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't add game (%s, %s, %s, %s)", _tmp35_, _tmp36_, _tmp37_, _tmp38_);
#line 372 "../src/database/database.vala"
		_inner_error0_ = _tmp39_;
#line 372 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 372 "../src/database/database.vala"
		_g_free0 (media_set);
#line 372 "../src/database/database.vala"
		_g_free0 (platform);
#line 372 "../src/database/database.vala"
		_g_free0 (title);
#line 372 "../src/database/database.vala"
		_g_free0 (uri);
#line 372 "../src/database/database.vala"
		_g_free0 (uid);
#line 372 "../src/database/database.vala"
		return NULL;
#line 2930 "database.c"
	}
#line 374 "../src/database/database.vala"
	result = NULL;
#line 374 "../src/database/database.vala"
	_g_free0 (media_set);
#line 374 "../src/database/database.vala"
	_g_free0 (platform);
#line 374 "../src/database/database.vala"
	_g_free0 (title);
#line 374 "../src/database/database.vala"
	_g_free0 (uri);
#line 374 "../src/database/database.vala"
	_g_free0 (uid);
#line 374 "../src/database/database.vala"
	return result;
#line 2946 "database.c"
}

void
games_database_update_game (GamesDatabase* self,
                            GamesGame* game,
                            GamesGame* prev_game,
                            GError** error)
{
	gchar* uid = NULL;
	GamesUid* _tmp0_;
	GamesUid* _tmp1_;
	gchar* _tmp2_;
	gchar* uri = NULL;
	GamesUri* _tmp3_;
	GamesUri* _tmp4_;
	gchar* _tmp5_;
	gchar* title = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* media_set = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_ = NULL;
	gchar* old_title = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* old_media_set = NULL;
	gchar* _tmp16_;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp22_;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	const gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	sqlite3_stmt* _tmp29_;
	GamesMediaSet* _tmp34_;
	GamesMediaSet* _tmp35_;
	GError* _inner_error0_ = NULL;
#line 377 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 377 "../src/database/database.vala"
	g_return_if_fail (game != NULL);
#line 378 "../src/database/database.vala"
	_tmp0_ = games_game_get_uid (game);
#line 378 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 378 "../src/database/database.vala"
	_tmp2_ = games_uid_to_string (_tmp1_);
#line 378 "../src/database/database.vala"
	uid = _tmp2_;
#line 379 "../src/database/database.vala"
	_tmp3_ = games_game_get_uri (game);
#line 379 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 379 "../src/database/database.vala"
	_tmp5_ = games_uri_to_string (_tmp4_);
#line 379 "../src/database/database.vala"
	uri = _tmp5_;
#line 380 "../src/database/database.vala"
	_tmp6_ = games_game_get_name (game);
#line 380 "../src/database/database.vala"
	_tmp7_ = _tmp6_;
#line 380 "../src/database/database.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 380 "../src/database/database.vala"
	title = _tmp8_;
#line 381 "../src/database/database.vala"
	_tmp9_ = games_database_serialize_media_set (self, game);
#line 381 "../src/database/database.vala"
	media_set = _tmp9_;
#line 382 "../src/database/database.vala"
	if (prev_game != NULL) {
#line 3023 "database.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 382 "../src/database/database.vala"
		_tmp11_ = games_game_get_name (prev_game);
#line 382 "../src/database/database.vala"
		_tmp12_ = _tmp11_;
#line 382 "../src/database/database.vala"
		_tmp10_ = _tmp12_;
#line 3032 "database.c"
	} else {
#line 382 "../src/database/database.vala"
		_tmp10_ = NULL;
#line 3036 "database.c"
	}
#line 382 "../src/database/database.vala"
	_tmp13_ = g_strdup (_tmp10_);
#line 382 "../src/database/database.vala"
	old_title = _tmp13_;
#line 383 "../src/database/database.vala"
	if (prev_game != NULL) {
#line 3044 "database.c"
		gchar* _tmp15_;
#line 383 "../src/database/database.vala"
		_tmp15_ = games_database_serialize_media_set (self, prev_game);
#line 383 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 383 "../src/database/database.vala"
		_tmp14_ = _tmp15_;
#line 3052 "database.c"
	} else {
#line 383 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 383 "../src/database/database.vala"
		_tmp14_ = NULL;
#line 3058 "database.c"
	}
#line 383 "../src/database/database.vala"
	_tmp16_ = g_strdup (_tmp14_);
#line 383 "../src/database/database.vala"
	old_media_set = _tmp16_;
#line 385 "../src/database/database.vala"
	_tmp18_ = old_title;
#line 385 "../src/database/database.vala"
	_tmp19_ = title;
#line 385 "../src/database/database.vala"
	if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
#line 3070 "database.c"
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 385 "../src/database/database.vala"
		_tmp20_ = old_media_set;
#line 385 "../src/database/database.vala"
		_tmp21_ = media_set;
#line 385 "../src/database/database.vala"
		_tmp17_ = g_strcmp0 (_tmp20_, _tmp21_) == 0;
#line 3079 "database.c"
	} else {
#line 385 "../src/database/database.vala"
		_tmp17_ = FALSE;
#line 3083 "database.c"
	}
#line 385 "../src/database/database.vala"
	if (_tmp17_) {
#line 386 "../src/database/database.vala"
		_g_free0 (old_media_set);
#line 386 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 386 "../src/database/database.vala"
		_g_free0 (old_title);
#line 386 "../src/database/database.vala"
		_g_free0 (media_set);
#line 386 "../src/database/database.vala"
		_g_free0 (title);
#line 386 "../src/database/database.vala"
		_g_free0 (uri);
#line 386 "../src/database/database.vala"
		_g_free0 (uid);
#line 386 "../src/database/database.vala"
		return;
#line 3103 "database.c"
	}
#line 388 "../src/database/database.vala"
	_tmp22_ = self->priv->update_game_query;
#line 388 "../src/database/database.vala"
	sqlite3_reset (_tmp22_);
#line 389 "../src/database/database.vala"
	_tmp23_ = self->priv->update_game_query;
#line 389 "../src/database/database.vala"
	_tmp24_ = uid;
#line 389 "../src/database/database.vala"
	games_database_bind_text (_tmp23_, "$UID", _tmp24_, &_inner_error0_);
#line 389 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 389 "../src/database/database.vala"
		_g_free0 (old_media_set);
#line 389 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 389 "../src/database/database.vala"
		_g_free0 (old_title);
#line 389 "../src/database/database.vala"
		_g_free0 (media_set);
#line 389 "../src/database/database.vala"
		_g_free0 (title);
#line 389 "../src/database/database.vala"
		_g_free0 (uri);
#line 389 "../src/database/database.vala"
		_g_free0 (uid);
#line 389 "../src/database/database.vala"
		return;
#line 3135 "database.c"
	}
#line 390 "../src/database/database.vala"
	_tmp25_ = self->priv->update_game_query;
#line 390 "../src/database/database.vala"
	_tmp26_ = title;
#line 390 "../src/database/database.vala"
	games_database_bind_text (_tmp25_, "$TITLE", _tmp26_, &_inner_error0_);
#line 390 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 390 "../src/database/database.vala"
		_g_free0 (old_media_set);
#line 390 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 390 "../src/database/database.vala"
		_g_free0 (old_title);
#line 390 "../src/database/database.vala"
		_g_free0 (media_set);
#line 390 "../src/database/database.vala"
		_g_free0 (title);
#line 390 "../src/database/database.vala"
		_g_free0 (uri);
#line 390 "../src/database/database.vala"
		_g_free0 (uid);
#line 390 "../src/database/database.vala"
		return;
#line 3163 "database.c"
	}
#line 391 "../src/database/database.vala"
	_tmp27_ = self->priv->update_game_query;
#line 391 "../src/database/database.vala"
	_tmp28_ = media_set;
#line 391 "../src/database/database.vala"
	games_database_bind_text (_tmp27_, "$MEDIA_SET", _tmp28_, &_inner_error0_);
#line 391 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 391 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 391 "../src/database/database.vala"
		_g_free0 (old_media_set);
#line 391 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 391 "../src/database/database.vala"
		_g_free0 (old_title);
#line 391 "../src/database/database.vala"
		_g_free0 (media_set);
#line 391 "../src/database/database.vala"
		_g_free0 (title);
#line 391 "../src/database/database.vala"
		_g_free0 (uri);
#line 391 "../src/database/database.vala"
		_g_free0 (uid);
#line 391 "../src/database/database.vala"
		return;
#line 3191 "database.c"
	}
#line 393 "../src/database/database.vala"
	_tmp29_ = self->priv->update_game_query;
#line 393 "../src/database/database.vala"
	if (sqlite3_step (_tmp29_) != SQLITE_DONE) {
#line 3197 "database.c"
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		GError* _tmp33_;
#line 394 "../src/database/database.vala"
		_tmp30_ = uid;
#line 394 "../src/database/database.vala"
		_tmp31_ = title;
#line 394 "../src/database/database.vala"
		_tmp32_ = media_set;
#line 394 "../src/database/database.vala"
		_tmp33_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't update game (%s, %s, %s)", _tmp30_, _tmp31_, _tmp32_);
#line 394 "../src/database/database.vala"
		_inner_error0_ = _tmp33_;
#line 394 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 394 "../src/database/database.vala"
		_g_free0 (old_media_set);
#line 394 "../src/database/database.vala"
		_g_free0 (_tmp14_);
#line 394 "../src/database/database.vala"
		_g_free0 (old_title);
#line 394 "../src/database/database.vala"
		_g_free0 (media_set);
#line 394 "../src/database/database.vala"
		_g_free0 (title);
#line 394 "../src/database/database.vala"
		_g_free0 (uri);
#line 394 "../src/database/database.vala"
		_g_free0 (uid);
#line 394 "../src/database/database.vala"
		return;
#line 3230 "database.c"
	}
#line 396 "../src/database/database.vala"
	_tmp34_ = games_game_get_media_set (game);
#line 396 "../src/database/database.vala"
	_tmp35_ = _tmp34_;
#line 396 "../src/database/database.vala"
	if (_tmp35_ != NULL) {
#line 3238 "database.c"
		gint _tmp36_ = 0;
		gchar** _tmp37_;
#line 397 "../src/database/database.vala"
		_tmp37_ = games_database_get_media_uris (self, game, &_tmp36_);
#line 3243 "database.c"
		{
			gchar** media_uri_collection = NULL;
			gint media_uri_collection_length1 = 0;
			gint _media_uri_collection_size_ = 0;
			gint media_uri_it = 0;
#line 397 "../src/database/database.vala"
			media_uri_collection = _tmp37_;
#line 397 "../src/database/database.vala"
			media_uri_collection_length1 = _tmp36_;
#line 397 "../src/database/database.vala"
			for (media_uri_it = 0; media_uri_it < media_uri_collection_length1; media_uri_it = media_uri_it + 1) {
#line 3255 "database.c"
				gchar* _tmp38_;
				gchar* media_uri = NULL;
#line 397 "../src/database/database.vala"
				_tmp38_ = g_strdup (media_uri_collection[media_uri_it]);
#line 397 "../src/database/database.vala"
				media_uri = _tmp38_;
#line 3262 "database.c"
				{
					const gchar* _tmp39_;
					const gchar* _tmp40_;
#line 398 "../src/database/database.vala"
					_tmp39_ = uid;
#line 398 "../src/database/database.vala"
					_tmp40_ = media_uri;
#line 398 "../src/database/database.vala"
					games_database_store_game_uri (self, _tmp39_, _tmp40_, &_inner_error0_);
#line 398 "../src/database/database.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/database/database.vala"
						g_propagate_error (error, _inner_error0_);
#line 398 "../src/database/database.vala"
						_g_free0 (media_uri);
#line 398 "../src/database/database.vala"
						media_uri_collection = (_vala_array_free (media_uri_collection, media_uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 398 "../src/database/database.vala"
						_g_free0 (old_media_set);
#line 398 "../src/database/database.vala"
						_g_free0 (_tmp14_);
#line 398 "../src/database/database.vala"
						_g_free0 (old_title);
#line 398 "../src/database/database.vala"
						_g_free0 (media_set);
#line 398 "../src/database/database.vala"
						_g_free0 (title);
#line 398 "../src/database/database.vala"
						_g_free0 (uri);
#line 398 "../src/database/database.vala"
						_g_free0 (uid);
#line 398 "../src/database/database.vala"
						return;
#line 3296 "database.c"
					}
#line 397 "../src/database/database.vala"
					_g_free0 (media_uri);
#line 3300 "database.c"
				}
			}
#line 397 "../src/database/database.vala"
			media_uri_collection = (_vala_array_free (media_uri_collection, media_uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3305 "database.c"
		}
	} else {
		const gchar* _tmp41_;
		const gchar* _tmp42_;
#line 400 "../src/database/database.vala"
		_tmp41_ = uid;
#line 400 "../src/database/database.vala"
		_tmp42_ = uri;
#line 400 "../src/database/database.vala"
		games_database_store_game_uri (self, _tmp41_, _tmp42_, &_inner_error0_);
#line 400 "../src/database/database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 400 "../src/database/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 400 "../src/database/database.vala"
			_g_free0 (old_media_set);
#line 400 "../src/database/database.vala"
			_g_free0 (_tmp14_);
#line 400 "../src/database/database.vala"
			_g_free0 (old_title);
#line 400 "../src/database/database.vala"
			_g_free0 (media_set);
#line 400 "../src/database/database.vala"
			_g_free0 (title);
#line 400 "../src/database/database.vala"
			_g_free0 (uri);
#line 400 "../src/database/database.vala"
			_g_free0 (uid);
#line 400 "../src/database/database.vala"
			return;
#line 3336 "database.c"
		}
	}
#line 377 "../src/database/database.vala"
	_g_free0 (old_media_set);
#line 377 "../src/database/database.vala"
	_g_free0 (_tmp14_);
#line 377 "../src/database/database.vala"
	_g_free0 (old_title);
#line 377 "../src/database/database.vala"
	_g_free0 (media_set);
#line 377 "../src/database/database.vala"
	_g_free0 (title);
#line 377 "../src/database/database.vala"
	_g_free0 (uri);
#line 377 "../src/database/database.vala"
	_g_free0 (uid);
#line 3353 "database.c"
}

gboolean
games_database_remove_game (GamesDatabase* self,
                            const gchar* uri,
                            GamesGame* game,
                            GError** error)
{
	gchar* uid = NULL;
	GamesUid* _tmp0_;
	GamesUid* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 403 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 403 "../src/database/database.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 403 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, FALSE);
#line 404 "../src/database/database.vala"
	_tmp0_ = games_game_get_uid (game);
#line 404 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 404 "../src/database/database.vala"
	_tmp2_ = games_uid_to_string (_tmp1_);
#line 404 "../src/database/database.vala"
	uid = _tmp2_;
#line 406 "../src/database/database.vala"
	_tmp3_ = self->priv->delete_uri_query;
#line 406 "../src/database/database.vala"
	sqlite3_reset (_tmp3_);
#line 407 "../src/database/database.vala"
	_tmp4_ = self->priv->delete_uri_query;
#line 407 "../src/database/database.vala"
	games_database_bind_text (_tmp4_, "$URI", uri, &_inner_error0_);
#line 407 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3404 "database.c"
		gboolean _tmp5_ = FALSE;
#line 407 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 407 "../src/database/database.vala"
		_g_free0 (uid);
#line 407 "../src/database/database.vala"
		return _tmp5_;
#line 3412 "database.c"
	}
#line 409 "../src/database/database.vala"
	_tmp6_ = self->priv->delete_uri_query;
#line 409 "../src/database/database.vala"
	if (sqlite3_step (_tmp6_) != SQLITE_DONE) {
#line 3418 "database.c"
		GError* _tmp7_;
		gboolean _tmp8_ = FALSE;
#line 410 "../src/database/database.vala"
		_tmp7_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't delete uri (%s)", uri);
#line 410 "../src/database/database.vala"
		_inner_error0_ = _tmp7_;
#line 410 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 410 "../src/database/database.vala"
		_g_free0 (uid);
#line 410 "../src/database/database.vala"
		return _tmp8_;
#line 3431 "database.c"
	}
#line 412 "../src/database/database.vala"
	_tmp9_ = self->priv->find_game_uris_query;
#line 412 "../src/database/database.vala"
	sqlite3_reset (_tmp9_);
#line 413 "../src/database/database.vala"
	_tmp10_ = self->priv->find_game_uris_query;
#line 413 "../src/database/database.vala"
	_tmp11_ = uid;
#line 413 "../src/database/database.vala"
	games_database_bind_text (_tmp10_, "$UID", _tmp11_, &_inner_error0_);
#line 413 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3445 "database.c"
		gboolean _tmp12_ = FALSE;
#line 413 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 413 "../src/database/database.vala"
		_g_free0 (uid);
#line 413 "../src/database/database.vala"
		return _tmp12_;
#line 3453 "database.c"
	}
#line 415 "../src/database/database.vala"
	_tmp13_ = self->priv->find_game_uris_query;
#line 415 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp13_);
#line 416 "../src/database/database.vala"
	if (_result_ == SQLITE_ROW) {
#line 417 "../src/database/database.vala"
		result = FALSE;
#line 417 "../src/database/database.vala"
		_g_free0 (uid);
#line 417 "../src/database/database.vala"
		return result;
#line 3467 "database.c"
	}
#line 419 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 3471 "database.c"
		const gchar* _tmp14_;
		GError* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 420 "../src/database/database.vala"
		_tmp14_ = uid;
#line 420 "../src/database/database.vala"
		_tmp15_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't find uris (%s)", _tmp14_);
#line 420 "../src/database/database.vala"
		_inner_error0_ = _tmp15_;
#line 420 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 420 "../src/database/database.vala"
		_g_free0 (uid);
#line 420 "../src/database/database.vala"
		return _tmp16_;
#line 3487 "database.c"
	}
#line 422 "../src/database/database.vala"
	_tmp17_ = self->priv->delete_game_query;
#line 422 "../src/database/database.vala"
	sqlite3_reset (_tmp17_);
#line 423 "../src/database/database.vala"
	_tmp18_ = self->priv->delete_game_query;
#line 423 "../src/database/database.vala"
	_tmp19_ = uid;
#line 423 "../src/database/database.vala"
	games_database_bind_text (_tmp18_, "$UID", _tmp19_, &_inner_error0_);
#line 423 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3501 "database.c"
		gboolean _tmp20_ = FALSE;
#line 423 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 423 "../src/database/database.vala"
		_g_free0 (uid);
#line 423 "../src/database/database.vala"
		return _tmp20_;
#line 3509 "database.c"
	}
#line 425 "../src/database/database.vala"
	_tmp21_ = self->priv->delete_game_query;
#line 425 "../src/database/database.vala"
	if (sqlite3_step (_tmp21_) != SQLITE_DONE) {
#line 3515 "database.c"
		const gchar* _tmp22_;
		GError* _tmp23_;
		gboolean _tmp24_ = FALSE;
#line 426 "../src/database/database.vala"
		_tmp22_ = uid;
#line 426 "../src/database/database.vala"
		_tmp23_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't delete game (%s)", _tmp22_);
#line 426 "../src/database/database.vala"
		_inner_error0_ = _tmp23_;
#line 426 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 426 "../src/database/database.vala"
		_g_free0 (uid);
#line 426 "../src/database/database.vala"
		return _tmp24_;
#line 3531 "database.c"
	}
#line 428 "../src/database/database.vala"
	result = TRUE;
#line 428 "../src/database/database.vala"
	_g_free0 (uid);
#line 428 "../src/database/database.vala"
	return result;
#line 3539 "database.c"
}

static GamesGame*
games_database_get_cached_game (GamesDatabase* self,
                                const gchar* uid,
                                GError** error)
{
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _tmp25_;
	GError* _inner_error0_ = NULL;
	GamesGame* result;
#line 431 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 431 "../src/database/database.vala"
	g_return_val_if_fail (uid != NULL, NULL);
#line 432 "../src/database/database.vala"
	_tmp0_ = self->priv->get_cached_game_query;
#line 432 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 433 "../src/database/database.vala"
	_tmp1_ = self->priv->get_cached_game_query;
#line 433 "../src/database/database.vala"
	games_database_bind_text (_tmp1_, "$UID", uid, &_inner_error0_);
#line 433 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 433 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 433 "../src/database/database.vala"
		return NULL;
#line 3571 "database.c"
	}
#line 435 "../src/database/database.vala"
	_tmp2_ = self->priv->get_cached_game_query;
#line 435 "../src/database/database.vala"
	if (sqlite3_step (_tmp2_) == SQLITE_ROW) {
#line 3577 "database.c"
		gchar* uri = NULL;
		sqlite3_stmt* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* title = NULL;
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* platform = NULL;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* media_set = NULL;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gint is_favorite = 0;
		sqlite3_stmt* _tmp15_;
		gchar* last_played = NULL;
		sqlite3_stmt* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		GamesGame* _tmp24_;
#line 436 "../src/database/database.vala"
		_tmp3_ = self->priv->get_cached_game_query;
#line 436 "../src/database/database.vala"
		_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 436 "../src/database/database.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 436 "../src/database/database.vala"
		uri = _tmp5_;
#line 437 "../src/database/database.vala"
		_tmp6_ = self->priv->get_cached_game_query;
#line 437 "../src/database/database.vala"
		_tmp7_ = (const gchar*) sqlite3_column_text (_tmp6_, 1);
#line 437 "../src/database/database.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 437 "../src/database/database.vala"
		title = _tmp8_;
#line 438 "../src/database/database.vala"
		_tmp9_ = self->priv->get_cached_game_query;
#line 438 "../src/database/database.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 2);
#line 438 "../src/database/database.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 438 "../src/database/database.vala"
		platform = _tmp11_;
#line 439 "../src/database/database.vala"
		_tmp12_ = self->priv->get_cached_game_query;
#line 439 "../src/database/database.vala"
		_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, 3);
#line 439 "../src/database/database.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 439 "../src/database/database.vala"
		media_set = _tmp14_;
#line 440 "../src/database/database.vala"
		_tmp15_ = self->priv->get_cached_game_query;
#line 440 "../src/database/database.vala"
		is_favorite = sqlite3_column_int (_tmp15_, 4);
#line 441 "../src/database/database.vala"
		_tmp16_ = self->priv->get_cached_game_query;
#line 441 "../src/database/database.vala"
		_tmp17_ = (const gchar*) sqlite3_column_text (_tmp16_, 5);
#line 441 "../src/database/database.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 441 "../src/database/database.vala"
		last_played = _tmp18_;
#line 443 "../src/database/database.vala"
		_tmp19_ = uri;
#line 443 "../src/database/database.vala"
		_tmp20_ = title;
#line 443 "../src/database/database.vala"
		_tmp21_ = platform;
#line 443 "../src/database/database.vala"
		_tmp22_ = media_set;
#line 443 "../src/database/database.vala"
		_tmp23_ = last_played;
#line 443 "../src/database/database.vala"
		_tmp24_ = games_database_create_game (self, uid, _tmp19_, _tmp20_, _tmp21_, _tmp22_, is_favorite, _tmp23_);
#line 443 "../src/database/database.vala"
		result = _tmp24_;
#line 443 "../src/database/database.vala"
		_g_free0 (last_played);
#line 443 "../src/database/database.vala"
		_g_free0 (media_set);
#line 443 "../src/database/database.vala"
		_g_free0 (platform);
#line 443 "../src/database/database.vala"
		_g_free0 (title);
#line 443 "../src/database/database.vala"
		_g_free0 (uri);
#line 443 "../src/database/database.vala"
		return result;
#line 3676 "database.c"
	}
#line 446 "../src/database/database.vala"
	_tmp25_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Couldn't get game for uid (%s)", uid);
#line 446 "../src/database/database.vala"
	_inner_error0_ = _tmp25_;
#line 446 "../src/database/database.vala"
	g_propagate_error (error, _inner_error0_);
#line 446 "../src/database/database.vala"
	return NULL;
#line 3686 "database.c"
}

void
games_database_list_cached_games (GamesDatabase* self,
                                  GamesGameCallback game_callback,
                                  gpointer game_callback_target,
                                  GError** error)
{
	sqlite3_stmt* _tmp0_;
#line 449 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/database/database.vala"
	_tmp0_ = self->priv->list_cached_games_query;
#line 450 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 452 "../src/database/database.vala"
	while (TRUE) {
#line 3704 "database.c"
		sqlite3_stmt* _tmp1_;
		gchar* uid = NULL;
		sqlite3_stmt* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* uri = NULL;
		sqlite3_stmt* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* title = NULL;
		sqlite3_stmt* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* platform = NULL;
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* media_set = NULL;
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gint is_favorite = 0;
		sqlite3_stmt* _tmp17_;
		gchar* last_played = NULL;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		GamesGame* game = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GamesGame* _tmp27_;
		GamesGame* _tmp28_;
#line 452 "../src/database/database.vala"
		_tmp1_ = self->priv->list_cached_games_query;
#line 452 "../src/database/database.vala"
		if (!(sqlite3_step (_tmp1_) == SQLITE_ROW)) {
#line 452 "../src/database/database.vala"
			break;
#line 3747 "database.c"
		}
#line 453 "../src/database/database.vala"
		_tmp2_ = self->priv->list_cached_games_query;
#line 453 "../src/database/database.vala"
		_tmp3_ = (const gchar*) sqlite3_column_text (_tmp2_, 0);
#line 453 "../src/database/database.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 453 "../src/database/database.vala"
		uid = _tmp4_;
#line 454 "../src/database/database.vala"
		_tmp5_ = self->priv->list_cached_games_query;
#line 454 "../src/database/database.vala"
		_tmp6_ = (const gchar*) sqlite3_column_text (_tmp5_, 1);
#line 454 "../src/database/database.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 454 "../src/database/database.vala"
		uri = _tmp7_;
#line 455 "../src/database/database.vala"
		_tmp8_ = self->priv->list_cached_games_query;
#line 455 "../src/database/database.vala"
		_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 2);
#line 455 "../src/database/database.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 455 "../src/database/database.vala"
		title = _tmp10_;
#line 456 "../src/database/database.vala"
		_tmp11_ = self->priv->list_cached_games_query;
#line 456 "../src/database/database.vala"
		_tmp12_ = (const gchar*) sqlite3_column_text (_tmp11_, 3);
#line 456 "../src/database/database.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 456 "../src/database/database.vala"
		platform = _tmp13_;
#line 457 "../src/database/database.vala"
		_tmp14_ = self->priv->list_cached_games_query;
#line 457 "../src/database/database.vala"
		_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 4);
#line 457 "../src/database/database.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 457 "../src/database/database.vala"
		media_set = _tmp16_;
#line 458 "../src/database/database.vala"
		_tmp17_ = self->priv->list_cached_games_query;
#line 458 "../src/database/database.vala"
		is_favorite = sqlite3_column_int (_tmp17_, 5);
#line 459 "../src/database/database.vala"
		_tmp18_ = self->priv->list_cached_games_query;
#line 459 "../src/database/database.vala"
		_tmp19_ = (const gchar*) sqlite3_column_text (_tmp18_, 6);
#line 459 "../src/database/database.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 459 "../src/database/database.vala"
		last_played = _tmp20_;
#line 461 "../src/database/database.vala"
		_tmp21_ = uid;
#line 461 "../src/database/database.vala"
		_tmp22_ = uri;
#line 461 "../src/database/database.vala"
		_tmp23_ = title;
#line 461 "../src/database/database.vala"
		_tmp24_ = platform;
#line 461 "../src/database/database.vala"
		_tmp25_ = media_set;
#line 461 "../src/database/database.vala"
		_tmp26_ = last_played;
#line 461 "../src/database/database.vala"
		_tmp27_ = games_database_create_game (self, _tmp21_, _tmp22_, _tmp23_, _tmp24_, _tmp25_, is_favorite, _tmp26_);
#line 461 "../src/database/database.vala"
		game = _tmp27_;
#line 462 "../src/database/database.vala"
		_tmp28_ = game;
#line 462 "../src/database/database.vala"
		game_callback (_tmp28_, game_callback_target);
#line 452 "../src/database/database.vala"
		_g_object_unref0 (game);
#line 452 "../src/database/database.vala"
		_g_free0 (last_played);
#line 452 "../src/database/database.vala"
		_g_free0 (media_set);
#line 452 "../src/database/database.vala"
		_g_free0 (platform);
#line 452 "../src/database/database.vala"
		_g_free0 (title);
#line 452 "../src/database/database.vala"
		_g_free0 (uri);
#line 452 "../src/database/database.vala"
		_g_free0 (uid);
#line 3835 "database.c"
	}
}

static GamesGame*
games_database_create_game (GamesDatabase* self,
                            const gchar* uid,
                            const gchar* uri,
                            const gchar* title,
                            const gchar* platform,
                            const gchar* media_set,
                            gint is_favorite,
                            const gchar* last_played)
{
	GamesUid* game_uid = NULL;
	GamesUid* _tmp0_;
	GamesUri* game_uri = NULL;
	GamesUri* _tmp1_;
	GamesGenericTitle* game_title = NULL;
	GamesGenericTitle* _tmp2_;
	GamesPlatform* game_platform = NULL;
	GamesPlatformRegister* _tmp3_;
	GamesPlatformRegister* _tmp4_;
	GamesPlatform* _tmp5_;
	GamesPlatform* _tmp6_;
	GamesPlatform* _tmp7_;
	GamesGame* game = NULL;
	GamesUid* _tmp9_;
	GamesUri* _tmp10_;
	GamesGenericTitle* _tmp11_;
	GamesPlatform* _tmp12_;
	GamesGame* _tmp13_;
	GamesGame* _tmp14_;
	GamesGame* result;
#line 466 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 466 "../src/database/database.vala"
	g_return_val_if_fail (uid != NULL, NULL);
#line 466 "../src/database/database.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 466 "../src/database/database.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 466 "../src/database/database.vala"
	g_return_val_if_fail (platform != NULL, NULL);
#line 469 "../src/database/database.vala"
	_tmp0_ = games_uid_new (uid);
#line 469 "../src/database/database.vala"
	game_uid = _tmp0_;
#line 470 "../src/database/database.vala"
	_tmp1_ = games_uri_new (uri);
#line 470 "../src/database/database.vala"
	game_uri = _tmp1_;
#line 471 "../src/database/database.vala"
	_tmp2_ = games_generic_title_new (title);
#line 471 "../src/database/database.vala"
	game_title = _tmp2_;
#line 472 "../src/database/database.vala"
	_tmp3_ = games_platform_register_get_register ();
#line 472 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 472 "../src/database/database.vala"
	_tmp5_ = games_platform_register_get_platform (_tmp4_, platform);
#line 472 "../src/database/database.vala"
	_tmp6_ = _tmp5_;
#line 472 "../src/database/database.vala"
	_g_object_unref0 (_tmp4_);
#line 472 "../src/database/database.vala"
	game_platform = _tmp6_;
#line 474 "../src/database/database.vala"
	_tmp7_ = game_platform;
#line 474 "../src/database/database.vala"
	if (_tmp7_ == NULL) {
#line 3907 "database.c"
		GamesDummyPlatform* _tmp8_;
#line 475 "../src/database/database.vala"
		_tmp8_ = games_dummy_platform_new ();
#line 475 "../src/database/database.vala"
		_g_object_unref0 (game_platform);
#line 475 "../src/database/database.vala"
		game_platform = (GamesPlatform*) _tmp8_;
#line 3915 "database.c"
	}
#line 477 "../src/database/database.vala"
	_tmp9_ = game_uid;
#line 477 "../src/database/database.vala"
	_tmp10_ = game_uri;
#line 477 "../src/database/database.vala"
	_tmp11_ = game_title;
#line 477 "../src/database/database.vala"
	_tmp12_ = game_platform;
#line 477 "../src/database/database.vala"
	_tmp13_ = games_game_new (_tmp9_, _tmp10_, (GamesTitle*) _tmp11_, _tmp12_);
#line 477 "../src/database/database.vala"
	game = _tmp13_;
#line 478 "../src/database/database.vala"
	_tmp14_ = game;
#line 478 "../src/database/database.vala"
	games_game_set_is_favorite (_tmp14_, is_favorite == 1);
#line 480 "../src/database/database.vala"
	if (last_played != NULL) {
#line 3935 "database.c"
		GamesGame* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
#line 481 "../src/database/database.vala"
		_tmp15_ = game;
#line 481 "../src/database/database.vala"
		_tmp16_ = g_date_time_new_from_iso8601 (last_played, NULL);
#line 481 "../src/database/database.vala"
		_tmp17_ = _tmp16_;
#line 481 "../src/database/database.vala"
		games_game_set_last_played (_tmp15_, _tmp17_);
#line 481 "../src/database/database.vala"
		_g_date_time_unref0 (_tmp17_);
#line 3949 "database.c"
	}
#line 483 "../src/database/database.vala"
	if (media_set != NULL) {
#line 3953 "database.c"
		GamesGame* _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		GamesMediaSet* _tmp21_;
		GamesMediaSet* _tmp22_;
#line 484 "../src/database/database.vala"
		_tmp18_ = game;
#line 484 "../src/database/database.vala"
		_tmp19_ = g_variant_new_parsed (media_set, NULL);
#line 484 "../src/database/database.vala"
		g_variant_ref_sink (_tmp19_);
#line 484 "../src/database/database.vala"
		_tmp20_ = _tmp19_;
#line 484 "../src/database/database.vala"
		_tmp21_ = games_media_set_new_parse (_tmp20_);
#line 484 "../src/database/database.vala"
		_tmp22_ = _tmp21_;
#line 484 "../src/database/database.vala"
		games_game_set_media_set (_tmp18_, _tmp22_);
#line 484 "../src/database/database.vala"
		_g_object_unref0 (_tmp22_);
#line 484 "../src/database/database.vala"
		_g_variant_unref0 (_tmp20_);
#line 3977 "database.c"
	}
#line 486 "../src/database/database.vala"
	result = game;
#line 486 "../src/database/database.vala"
	_g_object_unref0 (game_platform);
#line 486 "../src/database/database.vala"
	_g_object_unref0 (game_title);
#line 486 "../src/database/database.vala"
	_games_uri_unref0 (game_uri);
#line 486 "../src/database/database.vala"
	_g_object_unref0 (game_uid);
#line 486 "../src/database/database.vala"
	return result;
#line 3991 "database.c"
}

gboolean
games_database_set_is_favorite (GamesDatabase* self,
                                GamesGame* game,
                                GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gboolean _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp10_;
	GamesUid* _tmp11_;
	GamesUid* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 489 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 489 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, FALSE);
#line 490 "../src/database/database.vala"
	_tmp0_ = games_database_is_game_favorite (self, game, &_inner_error0_);
#line 490 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4024 "database.c"
		gboolean _tmp1_ = FALSE;
#line 490 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 490 "../src/database/database.vala"
		return _tmp1_;
#line 4030 "database.c"
	}
#line 490 "../src/database/database.vala"
	_tmp2_ = games_game_get_is_favorite (game);
#line 490 "../src/database/database.vala"
	_tmp3_ = _tmp2_;
#line 490 "../src/database/database.vala"
	if (_tmp3_ == _tmp0_) {
#line 491 "../src/database/database.vala"
		result = FALSE;
#line 491 "../src/database/database.vala"
		return result;
#line 4042 "database.c"
	}
#line 493 "../src/database/database.vala"
	_tmp4_ = self->priv->set_is_favorite_query;
#line 493 "../src/database/database.vala"
	sqlite3_reset (_tmp4_);
#line 494 "../src/database/database.vala"
	_tmp6_ = games_game_get_is_favorite (game);
#line 494 "../src/database/database.vala"
	_tmp7_ = _tmp6_;
#line 494 "../src/database/database.vala"
	if (_tmp7_) {
#line 494 "../src/database/database.vala"
		_tmp5_ = 1;
#line 4056 "database.c"
	} else {
#line 494 "../src/database/database.vala"
		_tmp5_ = 0;
#line 4060 "database.c"
	}
#line 494 "../src/database/database.vala"
	_tmp8_ = self->priv->set_is_favorite_query;
#line 494 "../src/database/database.vala"
	games_database_bind_int (_tmp8_, "$IS_FAVORITE", &_tmp5_, &_inner_error0_);
#line 494 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4068 "database.c"
		gboolean _tmp9_ = FALSE;
#line 494 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 494 "../src/database/database.vala"
		return _tmp9_;
#line 4074 "database.c"
	}
#line 495 "../src/database/database.vala"
	_tmp10_ = self->priv->set_is_favorite_query;
#line 495 "../src/database/database.vala"
	_tmp11_ = games_game_get_uid (game);
#line 495 "../src/database/database.vala"
	_tmp12_ = _tmp11_;
#line 495 "../src/database/database.vala"
	_tmp13_ = games_uid_to_string (_tmp12_);
#line 495 "../src/database/database.vala"
	_tmp14_ = _tmp13_;
#line 495 "../src/database/database.vala"
	games_database_bind_text (_tmp10_, "$UID", _tmp14_, &_inner_error0_);
#line 495 "../src/database/database.vala"
	_g_free0 (_tmp14_);
#line 495 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4092 "database.c"
		gboolean _tmp15_ = FALSE;
#line 495 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 495 "../src/database/database.vala"
		return _tmp15_;
#line 4098 "database.c"
	}
#line 497 "../src/database/database.vala"
	_tmp16_ = self->priv->set_is_favorite_query;
#line 497 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp16_);
#line 498 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 4106 "database.c"
		const gchar* _tmp17_ = NULL;
		gboolean _tmp18_;
		gboolean _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GError* _tmp22_;
		gboolean _tmp23_ = FALSE;
#line 500 "../src/database/database.vala"
		_tmp18_ = games_game_get_is_favorite (game);
#line 500 "../src/database/database.vala"
		_tmp19_ = _tmp18_;
#line 500 "../src/database/database.vala"
		if (_tmp19_) {
#line 500 "../src/database/database.vala"
			_tmp17_ = "";
#line 4122 "database.c"
		} else {
#line 500 "../src/database/database.vala"
			_tmp17_ = "non-";
#line 4126 "database.c"
		}
#line 499 "../src/database/database.vala"
		_tmp20_ = games_game_get_name (game);
#line 499 "../src/database/database.vala"
		_tmp21_ = _tmp20_;
#line 499 "../src/database/database.vala"
		_tmp22_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to make %s %sfavorite", _tmp21_, _tmp17_);
#line 499 "../src/database/database.vala"
		_inner_error0_ = _tmp22_;
#line 499 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 499 "../src/database/database.vala"
		return _tmp23_;
#line 4140 "database.c"
	}
#line 502 "../src/database/database.vala"
	result = TRUE;
#line 502 "../src/database/database.vala"
	return result;
#line 4146 "database.c"
}

static guint
_games_uid_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = games_uid_hash ((GamesUid*) key);
#line 507 "../src/database/database.vala"
	return result;
#line 4156 "database.c"
}

static gboolean
_games_uid_equal_gequal_func (gconstpointer a,
                              gconstpointer b)
{
	gboolean result;
	result = games_uid_equal ((GamesUid*) a, (GamesUid*) b);
#line 507 "../src/database/database.vala"
	return result;
#line 4167 "database.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 507 "../src/database/database.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4175 "database.c"
}

GHashTable*
games_database_list_favorite_games (GamesDatabase* self,
                                    GError** error)
{
	sqlite3_stmt* _tmp0_;
	GHashTable* games = NULL;
	GHashTable* _tmp1_;
	GHashTable* result;
#line 505 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 506 "../src/database/database.vala"
	_tmp0_ = self->priv->list_favorite_games_query;
#line 506 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 507 "../src/database/database.vala"
	_tmp1_ = g_hash_table_new_full (_games_uid_hash_ghash_func, _games_uid_equal_gequal_func, NULL, _g_object_unref0_);
#line 507 "../src/database/database.vala"
	games = _tmp1_;
#line 509 "../src/database/database.vala"
	while (TRUE) {
#line 4198 "database.c"
		sqlite3_stmt* _tmp2_;
		GHashTable* _tmp3_;
		sqlite3_stmt* _tmp4_;
		const gchar* _tmp5_;
		GamesUid* _tmp6_;
#line 509 "../src/database/database.vala"
		_tmp2_ = self->priv->list_favorite_games_query;
#line 509 "../src/database/database.vala"
		if (!(sqlite3_step (_tmp2_) == SQLITE_ROW)) {
#line 509 "../src/database/database.vala"
			break;
#line 4210 "database.c"
		}
#line 510 "../src/database/database.vala"
		_tmp3_ = games;
#line 510 "../src/database/database.vala"
		_tmp4_ = self->priv->list_favorite_games_query;
#line 510 "../src/database/database.vala"
		_tmp5_ = (const gchar*) sqlite3_column_text (_tmp4_, 0);
#line 510 "../src/database/database.vala"
		_tmp6_ = games_uid_new (_tmp5_);
#line 510 "../src/database/database.vala"
		g_hash_table_add (_tmp3_, _tmp6_);
#line 4222 "database.c"
	}
#line 512 "../src/database/database.vala"
	result = games;
#line 512 "../src/database/database.vala"
	return result;
#line 4228 "database.c"
}

static gboolean
games_database_is_game_favorite (GamesDatabase* self,
                                 GamesGame* game,
                                 GError** error)
{
	gchar* uid = NULL;
	GamesUid* _tmp0_;
	GamesUid* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 515 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 515 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, FALSE);
#line 516 "../src/database/database.vala"
	_tmp0_ = games_game_get_uid (game);
#line 516 "../src/database/database.vala"
	_tmp1_ = _tmp0_;
#line 516 "../src/database/database.vala"
	_tmp2_ = games_uid_to_string (_tmp1_);
#line 516 "../src/database/database.vala"
	uid = _tmp2_;
#line 517 "../src/database/database.vala"
	_tmp3_ = self->priv->is_game_favorite_query;
#line 517 "../src/database/database.vala"
	sqlite3_reset (_tmp3_);
#line 518 "../src/database/database.vala"
	_tmp4_ = self->priv->is_game_favorite_query;
#line 518 "../src/database/database.vala"
	_tmp5_ = uid;
#line 518 "../src/database/database.vala"
	games_database_bind_text (_tmp4_, "$UID", _tmp5_, &_inner_error0_);
#line 518 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4270 "database.c"
		gboolean _tmp6_ = FALSE;
#line 518 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 518 "../src/database/database.vala"
		_g_free0 (uid);
#line 518 "../src/database/database.vala"
		return _tmp6_;
#line 4278 "database.c"
	}
#line 520 "../src/database/database.vala"
	_tmp7_ = self->priv->is_game_favorite_query;
#line 520 "../src/database/database.vala"
	switch (sqlite3_step (_tmp7_)) {
#line 520 "../src/database/database.vala"
		case SQLITE_ROW:
#line 4286 "database.c"
		{
			sqlite3_stmt* _tmp8_;
#line 522 "../src/database/database.vala"
			_tmp8_ = self->priv->is_game_favorite_query;
#line 522 "../src/database/database.vala"
			result = sqlite3_column_int (_tmp8_, 0) == 1;
#line 522 "../src/database/database.vala"
			_g_free0 (uid);
#line 522 "../src/database/database.vala"
			return result;
#line 4297 "database.c"
		}
		default:
		{
			GError* _tmp9_;
			gboolean _tmp10_ = FALSE;
#line 524 "../src/database/database.vala"
			_tmp9_ = g_error_new_literal (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Execution failed.");
#line 524 "../src/database/database.vala"
			_inner_error0_ = _tmp9_;
#line 524 "../src/database/database.vala"
			g_propagate_error (error, _inner_error0_);
#line 524 "../src/database/database.vala"
			_g_free0 (uid);
#line 524 "../src/database/database.vala"
			return _tmp10_;
#line 4313 "database.c"
		}
	}
}

GHashTable*
games_database_list_recently_played_games (GamesDatabase* self,
                                           GError** error)
{
	sqlite3_stmt* _tmp0_;
	GHashTable* games = NULL;
	GHashTable* _tmp1_;
	GHashTable* result;
#line 528 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 529 "../src/database/database.vala"
	_tmp0_ = self->priv->list_recently_played_games_query;
#line 529 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 530 "../src/database/database.vala"
	_tmp1_ = g_hash_table_new_full (_games_uid_hash_ghash_func, _games_uid_equal_gequal_func, NULL, _g_object_unref0_);
#line 530 "../src/database/database.vala"
	games = _tmp1_;
#line 532 "../src/database/database.vala"
	while (TRUE) {
#line 4338 "database.c"
		sqlite3_stmt* _tmp2_;
		GHashTable* _tmp3_;
		sqlite3_stmt* _tmp4_;
		const gchar* _tmp5_;
		GamesUid* _tmp6_;
#line 532 "../src/database/database.vala"
		_tmp2_ = self->priv->list_recently_played_games_query;
#line 532 "../src/database/database.vala"
		if (!(sqlite3_step (_tmp2_) == SQLITE_ROW)) {
#line 532 "../src/database/database.vala"
			break;
#line 4350 "database.c"
		}
#line 533 "../src/database/database.vala"
		_tmp3_ = games;
#line 533 "../src/database/database.vala"
		_tmp4_ = self->priv->list_recently_played_games_query;
#line 533 "../src/database/database.vala"
		_tmp5_ = (const gchar*) sqlite3_column_text (_tmp4_, 0);
#line 533 "../src/database/database.vala"
		_tmp6_ = games_uid_new (_tmp5_);
#line 533 "../src/database/database.vala"
		g_hash_table_add (_tmp3_, _tmp6_);
#line 4362 "database.c"
	}
#line 535 "../src/database/database.vala"
	result = games;
#line 535 "../src/database/database.vala"
	return result;
#line 4368 "database.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3320 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3321 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3321 "glib-2.0.vapi"
	result = _tmp0_;
#line 3321 "glib-2.0.vapi"
	return result;
#line 4384 "database.c"
}

void
games_database_update_recently_played_game (GamesDatabase* self,
                                            GamesGame* game,
                                            gboolean remove,
                                            GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* last_played = NULL;
	gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GamesUid* _tmp9_;
	GamesUid* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 538 "../src/database/database.vala"
	g_return_if_fail (self != NULL);
#line 538 "../src/database/database.vala"
	g_return_if_fail (game != NULL);
#line 539 "../src/database/database.vala"
	if (remove) {
#line 539 "../src/database/database.vala"
		_g_free0 (_tmp0_);
#line 539 "../src/database/database.vala"
		_tmp0_ = NULL;
#line 4417 "database.c"
	} else {
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		gchar* _tmp3_;
#line 539 "../src/database/database.vala"
		_tmp1_ = games_game_get_last_played (game);
#line 539 "../src/database/database.vala"
		_tmp2_ = _tmp1_;
#line 539 "../src/database/database.vala"
		_tmp3_ = g_date_time_to_string (_tmp2_);
#line 539 "../src/database/database.vala"
		_g_free0 (_tmp0_);
#line 539 "../src/database/database.vala"
		_tmp0_ = _tmp3_;
#line 4432 "database.c"
	}
#line 539 "../src/database/database.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 539 "../src/database/database.vala"
	last_played = _tmp4_;
#line 541 "../src/database/database.vala"
	_tmp5_ = self->priv->update_recently_played_game_query;
#line 541 "../src/database/database.vala"
	sqlite3_reset (_tmp5_);
#line 542 "../src/database/database.vala"
	_tmp6_ = self->priv->update_recently_played_game_query;
#line 542 "../src/database/database.vala"
	_tmp7_ = last_played;
#line 542 "../src/database/database.vala"
	games_database_bind_text (_tmp6_, "$LAST_PLAYED", _tmp7_, &_inner_error0_);
#line 542 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 542 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 542 "../src/database/database.vala"
		_g_free0 (last_played);
#line 542 "../src/database/database.vala"
		_g_free0 (_tmp0_);
#line 542 "../src/database/database.vala"
		return;
#line 4458 "database.c"
	}
#line 543 "../src/database/database.vala"
	_tmp8_ = self->priv->update_recently_played_game_query;
#line 543 "../src/database/database.vala"
	_tmp9_ = games_game_get_uid (game);
#line 543 "../src/database/database.vala"
	_tmp10_ = _tmp9_;
#line 543 "../src/database/database.vala"
	_tmp11_ = games_uid_to_string (_tmp10_);
#line 543 "../src/database/database.vala"
	_tmp12_ = _tmp11_;
#line 543 "../src/database/database.vala"
	games_database_bind_text (_tmp8_, "$UID", _tmp12_, &_inner_error0_);
#line 543 "../src/database/database.vala"
	_g_free0 (_tmp12_);
#line 543 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 543 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 543 "../src/database/database.vala"
		_g_free0 (last_played);
#line 543 "../src/database/database.vala"
		_g_free0 (_tmp0_);
#line 543 "../src/database/database.vala"
		return;
#line 4484 "database.c"
	}
#line 545 "../src/database/database.vala"
	_tmp13_ = self->priv->update_recently_played_game_query;
#line 545 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp13_);
#line 546 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 4492 "database.c"
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GError* _tmp16_;
#line 547 "../src/database/database.vala"
		_tmp14_ = games_game_get_name (game);
#line 547 "../src/database/database.vala"
		_tmp15_ = _tmp14_;
#line 547 "../src/database/database.vala"
		_tmp16_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to update last played date-time of %s", _tmp15_);
#line 547 "../src/database/database.vala"
		_inner_error0_ = _tmp16_;
#line 547 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 547 "../src/database/database.vala"
		_g_free0 (last_played);
#line 547 "../src/database/database.vala"
		_g_free0 (_tmp0_);
#line 547 "../src/database/database.vala"
		return;
#line 4512 "database.c"
	}
#line 538 "../src/database/database.vala"
	_g_free0 (last_played);
#line 538 "../src/database/database.vala"
	_g_free0 (_tmp0_);
#line 4518 "database.c"
}

static gboolean
games_database_does_user_collection_exist (GamesDatabase* self,
                                           const gchar* uuid,
                                           GError** error)
{
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 550 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 550 "../src/database/database.vala"
	g_return_val_if_fail (uuid != NULL, FALSE);
#line 551 "../src/database/database.vala"
	if (!g_uuid_string_is_valid (uuid)) {
#line 552 "../src/database/database.vala"
		result = FALSE;
#line 552 "../src/database/database.vala"
		return result;
#line 4541 "database.c"
	}
#line 554 "../src/database/database.vala"
	_tmp0_ = self->priv->does_user_collection_exist_query;
#line 554 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 555 "../src/database/database.vala"
	_tmp1_ = self->priv->does_user_collection_exist_query;
#line 555 "../src/database/database.vala"
	games_database_bind_text (_tmp1_, "$COLLECTION_ID", uuid, &_inner_error0_);
#line 555 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4553 "database.c"
		gboolean _tmp2_ = FALSE;
#line 555 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 555 "../src/database/database.vala"
		return _tmp2_;
#line 4559 "database.c"
	}
#line 557 "../src/database/database.vala"
	_tmp3_ = self->priv->does_user_collection_exist_query;
#line 557 "../src/database/database.vala"
	if (sqlite3_step (_tmp3_) == SQLITE_ROW) {
#line 4565 "database.c"
		sqlite3_stmt* _tmp4_;
#line 558 "../src/database/database.vala"
		_tmp4_ = self->priv->does_user_collection_exist_query;
#line 558 "../src/database/database.vala"
		result = sqlite3_column_int (_tmp4_, 0) == 1;
#line 558 "../src/database/database.vala"
		return result;
#line 4573 "database.c"
	}
#line 560 "../src/database/database.vala"
	result = FALSE;
#line 560 "../src/database/database.vala"
	return result;
#line 4579 "database.c"
}

static gboolean
games_database_is_game_in_user_collection (GamesDatabase* self,
                                           const gchar* game_uid,
                                           const gchar* collection_id,
                                           GError** error)
{
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 563 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 563 "../src/database/database.vala"
	g_return_val_if_fail (game_uid != NULL, FALSE);
#line 563 "../src/database/database.vala"
	g_return_val_if_fail (collection_id != NULL, FALSE);
#line 564 "../src/database/database.vala"
	_tmp0_ = self->priv->is_game_in_user_collection_query;
#line 564 "../src/database/database.vala"
	sqlite3_reset (_tmp0_);
#line 565 "../src/database/database.vala"
	_tmp1_ = self->priv->is_game_in_user_collection_query;
#line 565 "../src/database/database.vala"
	games_database_bind_text (_tmp1_, "$GAME_UID", game_uid, &_inner_error0_);
#line 565 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4610 "database.c"
		gboolean _tmp2_ = FALSE;
#line 565 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 565 "../src/database/database.vala"
		return _tmp2_;
#line 4616 "database.c"
	}
#line 566 "../src/database/database.vala"
	_tmp3_ = self->priv->is_game_in_user_collection_query;
#line 566 "../src/database/database.vala"
	games_database_bind_text (_tmp3_, "$COLLECTION_ID", collection_id, &_inner_error0_);
#line 566 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4624 "database.c"
		gboolean _tmp4_ = FALSE;
#line 566 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 566 "../src/database/database.vala"
		return _tmp4_;
#line 4630 "database.c"
	}
#line 568 "../src/database/database.vala"
	_tmp5_ = self->priv->is_game_in_user_collection_query;
#line 568 "../src/database/database.vala"
	if (sqlite3_step (_tmp5_) == SQLITE_ROW) {
#line 4636 "database.c"
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
#line 569 "../src/database/database.vala"
		_tmp6_ = self->priv->is_game_in_user_collection_query;
#line 569 "../src/database/database.vala"
		_tmp7_ = (const gchar*) sqlite3_column_text (_tmp6_, 0);
#line 569 "../src/database/database.vala"
		result = g_strcmp0 (_tmp7_, "1") == 0;
#line 569 "../src/database/database.vala"
		return result;
#line 4647 "database.c"
	}
#line 571 "../src/database/database.vala"
	result = FALSE;
#line 571 "../src/database/database.vala"
	return result;
#line 4653 "database.c"
}

gboolean
games_database_add_user_collection (GamesDatabase* self,
                                    GamesUserCollection* collection,
                                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	sqlite3_stmt* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 574 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 574 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 575 "../src/database/database.vala"
	_tmp1_ = games_collection_get_id ((GamesCollection*) collection);
#line 575 "../src/database/database.vala"
	_tmp2_ = _tmp1_;
#line 575 "../src/database/database.vala"
	_tmp3_ = games_database_does_user_collection_exist (self, _tmp2_, &_inner_error0_);
#line 575 "../src/database/database.vala"
	_g_free0 (_tmp2_);
#line 575 "../src/database/database.vala"
	_tmp0_ = _tmp3_;
#line 575 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4692 "database.c"
		gboolean _tmp4_ = FALSE;
#line 575 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 575 "../src/database/database.vala"
		return _tmp4_;
#line 4698 "database.c"
	}
#line 575 "../src/database/database.vala"
	if (_tmp0_) {
#line 4702 "database.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 576 "../src/database/database.vala"
		_tmp5_ = games_collection_get_title ((GamesCollection*) collection);
#line 576 "../src/database/database.vala"
		_tmp6_ = _tmp5_;
#line 576 "../src/database/database.vala"
		g_critical ("database.vala:576: A collection named %s already exists", _tmp6_);
#line 577 "../src/database/database.vala"
		result = FALSE;
#line 577 "../src/database/database.vala"
		return result;
#line 4715 "database.c"
	}
#line 580 "../src/database/database.vala"
	_tmp7_ = self->priv->add_user_collection_query;
#line 580 "../src/database/database.vala"
	sqlite3_reset (_tmp7_);
#line 581 "../src/database/database.vala"
	_tmp8_ = self->priv->add_user_collection_query;
#line 581 "../src/database/database.vala"
	_tmp9_ = games_collection_get_id ((GamesCollection*) collection);
#line 581 "../src/database/database.vala"
	_tmp10_ = _tmp9_;
#line 581 "../src/database/database.vala"
	games_database_bind_text (_tmp8_, "$COLLECTION_ID", _tmp10_, &_inner_error0_);
#line 581 "../src/database/database.vala"
	_g_free0 (_tmp10_);
#line 581 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4733 "database.c"
		gboolean _tmp11_ = FALSE;
#line 581 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 581 "../src/database/database.vala"
		return _tmp11_;
#line 4739 "database.c"
	}
#line 582 "../src/database/database.vala"
	_tmp12_ = self->priv->add_user_collection_query;
#line 582 "../src/database/database.vala"
	_tmp13_ = games_collection_get_title ((GamesCollection*) collection);
#line 582 "../src/database/database.vala"
	_tmp14_ = _tmp13_;
#line 582 "../src/database/database.vala"
	games_database_bind_text (_tmp12_, "$TITLE", _tmp14_, &_inner_error0_);
#line 582 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4751 "database.c"
		gboolean _tmp15_ = FALSE;
#line 582 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 582 "../src/database/database.vala"
		return _tmp15_;
#line 4757 "database.c"
	}
#line 584 "../src/database/database.vala"
	_tmp16_ = self->priv->add_user_collection_query;
#line 584 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp16_);
#line 585 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 4765 "database.c"
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GError* _tmp21_;
		GError* _tmp22_;
		gboolean _tmp23_ = FALSE;
#line 586 "../src/database/database.vala"
		_tmp17_ = games_collection_get_title ((GamesCollection*) collection);
#line 586 "../src/database/database.vala"
		_tmp18_ = _tmp17_;
#line 586 "../src/database/database.vala"
		_tmp19_ = g_strdup_printf ("%i", _result_);
#line 586 "../src/database/database.vala"
		_tmp20_ = _tmp19_;
#line 586 "../src/database/database.vala"
		_tmp21_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to add user collection %s: %s", _tmp18_, _tmp20_);
#line 586 "../src/database/database.vala"
		_tmp22_ = _tmp21_;
#line 586 "../src/database/database.vala"
		_g_free0 (_tmp20_);
#line 586 "../src/database/database.vala"
		_inner_error0_ = _tmp22_;
#line 586 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 586 "../src/database/database.vala"
		return _tmp23_;
#line 4793 "database.c"
	}
#line 589 "../src/database/database.vala"
	result = TRUE;
#line 589 "../src/database/database.vala"
	return result;
#line 4799 "database.c"
}

gboolean
games_database_add_game_to_user_collection (GamesDatabase* self,
                                            GamesGame* game,
                                            GamesUserCollection* collection,
                                            GError** error)
{
	gboolean _tmp0_ = FALSE;
	GamesUid* _tmp1_;
	GamesUid* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	sqlite3_stmt* _tmp14_;
	GamesUid* _tmp15_;
	GamesUid* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 592 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 592 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, FALSE);
#line 592 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 593 "../src/database/database.vala"
	_tmp1_ = games_game_get_uid (game);
#line 593 "../src/database/database.vala"
	_tmp2_ = _tmp1_;
#line 593 "../src/database/database.vala"
	_tmp3_ = games_uid_to_string (_tmp2_);
#line 593 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 593 "../src/database/database.vala"
	_tmp5_ = games_collection_get_id ((GamesCollection*) collection);
#line 593 "../src/database/database.vala"
	_tmp6_ = _tmp5_;
#line 593 "../src/database/database.vala"
	_tmp7_ = games_database_is_game_in_user_collection (self, _tmp4_, _tmp6_, &_inner_error0_);
#line 593 "../src/database/database.vala"
	_g_free0 (_tmp6_);
#line 593 "../src/database/database.vala"
	_g_free0 (_tmp4_);
#line 593 "../src/database/database.vala"
	_tmp0_ = _tmp7_;
#line 593 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4857 "database.c"
		gboolean _tmp8_ = FALSE;
#line 593 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 593 "../src/database/database.vala"
		return _tmp8_;
#line 4863 "database.c"
	}
#line 593 "../src/database/database.vala"
	if (_tmp0_) {
#line 594 "../src/database/database.vala"
		result = FALSE;
#line 594 "../src/database/database.vala"
		return result;
#line 4871 "database.c"
	}
#line 596 "../src/database/database.vala"
	_tmp9_ = self->priv->add_game_to_user_collection_query;
#line 596 "../src/database/database.vala"
	sqlite3_reset (_tmp9_);
#line 597 "../src/database/database.vala"
	_tmp10_ = self->priv->add_game_to_user_collection_query;
#line 597 "../src/database/database.vala"
	_tmp11_ = games_collection_get_id ((GamesCollection*) collection);
#line 597 "../src/database/database.vala"
	_tmp12_ = _tmp11_;
#line 597 "../src/database/database.vala"
	games_database_bind_text (_tmp10_, "$COLLECTION_ID", _tmp12_, &_inner_error0_);
#line 597 "../src/database/database.vala"
	_g_free0 (_tmp12_);
#line 597 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4889 "database.c"
		gboolean _tmp13_ = FALSE;
#line 597 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 597 "../src/database/database.vala"
		return _tmp13_;
#line 4895 "database.c"
	}
#line 598 "../src/database/database.vala"
	_tmp14_ = self->priv->add_game_to_user_collection_query;
#line 598 "../src/database/database.vala"
	_tmp15_ = games_game_get_uid (game);
#line 598 "../src/database/database.vala"
	_tmp16_ = _tmp15_;
#line 598 "../src/database/database.vala"
	_tmp17_ = games_uid_to_string (_tmp16_);
#line 598 "../src/database/database.vala"
	_tmp18_ = _tmp17_;
#line 598 "../src/database/database.vala"
	games_database_bind_text (_tmp14_, "$GAME_UID", _tmp18_, &_inner_error0_);
#line 598 "../src/database/database.vala"
	_g_free0 (_tmp18_);
#line 598 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4913 "database.c"
		gboolean _tmp19_ = FALSE;
#line 598 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 598 "../src/database/database.vala"
		return _tmp19_;
#line 4919 "database.c"
	}
#line 600 "../src/database/database.vala"
	_tmp20_ = self->priv->add_game_to_user_collection_query;
#line 600 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp20_);
#line 601 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 4927 "database.c"
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		GError* _tmp25_;
		gboolean _tmp26_ = FALSE;
#line 602 "../src/database/database.vala"
		_tmp21_ = games_game_get_name (game);
#line 602 "../src/database/database.vala"
		_tmp22_ = _tmp21_;
#line 602 "../src/database/database.vala"
		_tmp23_ = games_collection_get_title ((GamesCollection*) collection);
#line 602 "../src/database/database.vala"
		_tmp24_ = _tmp23_;
#line 602 "../src/database/database.vala"
		_tmp25_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to add %s to user collection %s", _tmp22_, _tmp24_);
#line 602 "../src/database/database.vala"
		_inner_error0_ = _tmp25_;
#line 602 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 602 "../src/database/database.vala"
		return _tmp26_;
#line 4950 "database.c"
	}
#line 605 "../src/database/database.vala"
	result = TRUE;
#line 605 "../src/database/database.vala"
	return result;
#line 4956 "database.c"
}

static guint
_games_collection_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = games_collection_hash ((GamesCollection*) key);
#line 609 "../src/database/database.vala"
	return result;
#line 4966 "database.c"
}

static gboolean
_games_collection_equal_gequal_func (gconstpointer a,
                                     gconstpointer b)
{
	gboolean result;
	result = games_collection_equal ((GamesCollection*) a, (GamesCollection*) b);
#line 609 "../src/database/database.vala"
	return result;
#line 4977 "database.c"
}

GHashTable*
games_database_get_user_collections (GamesDatabase* self,
                                     GError** error)
{
	GHashTable* collections = NULL;
	GHashTable* _tmp0_;
	GHashTable* result;
#line 608 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 609 "../src/database/database.vala"
	_tmp0_ = g_hash_table_new_full (_games_collection_hash_ghash_func, _games_collection_equal_gequal_func, NULL, _g_object_unref0_);
#line 609 "../src/database/database.vala"
	collections = _tmp0_;
#line 611 "../src/database/database.vala"
	while (TRUE) {
#line 4995 "database.c"
		sqlite3_stmt* _tmp1_;
		gchar* uuid = NULL;
		sqlite3_stmt* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* title = NULL;
		sqlite3_stmt* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		GamesUserCollection* collection = NULL;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GamesUserCollection* _tmp10_;
		GHashTable* _tmp11_;
		GamesUserCollection* _tmp12_;
		GamesUserCollection* _tmp13_;
#line 611 "../src/database/database.vala"
		_tmp1_ = self->priv->list_user_collections_query;
#line 611 "../src/database/database.vala"
		if (!(sqlite3_step (_tmp1_) == SQLITE_ROW)) {
#line 611 "../src/database/database.vala"
			break;
#line 5018 "database.c"
		}
#line 612 "../src/database/database.vala"
		_tmp2_ = self->priv->list_user_collections_query;
#line 612 "../src/database/database.vala"
		_tmp3_ = (const gchar*) sqlite3_column_text (_tmp2_, 0);
#line 612 "../src/database/database.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 612 "../src/database/database.vala"
		uuid = _tmp4_;
#line 613 "../src/database/database.vala"
		_tmp5_ = self->priv->list_user_collections_query;
#line 613 "../src/database/database.vala"
		_tmp6_ = (const gchar*) sqlite3_column_text (_tmp5_, 1);
#line 613 "../src/database/database.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 613 "../src/database/database.vala"
		title = _tmp7_;
#line 614 "../src/database/database.vala"
		_tmp8_ = uuid;
#line 614 "../src/database/database.vala"
		_tmp9_ = title;
#line 614 "../src/database/database.vala"
		_tmp10_ = games_user_collection_new (_tmp8_, _tmp9_, self);
#line 614 "../src/database/database.vala"
		collection = _tmp10_;
#line 615 "../src/database/database.vala"
		_tmp11_ = collections;
#line 615 "../src/database/database.vala"
		_tmp12_ = collection;
#line 615 "../src/database/database.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 615 "../src/database/database.vala"
		g_hash_table_add (_tmp11_, _tmp13_);
#line 611 "../src/database/database.vala"
		_g_object_unref0 (collection);
#line 611 "../src/database/database.vala"
		_g_free0 (title);
#line 611 "../src/database/database.vala"
		_g_free0 (uuid);
#line 5058 "database.c"
	}
#line 618 "../src/database/database.vala"
	result = collections;
#line 618 "../src/database/database.vala"
	return result;
#line 5064 "database.c"
}

GHashTable*
games_database_list_games_in_user_collection (GamesDatabase* self,
                                              GamesUserCollection* collection,
                                              GError** error)
{
	GHashTable* games = NULL;
	GHashTable* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	GHashTable* result;
#line 621 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 621 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, NULL);
#line 622 "../src/database/database.vala"
	_tmp0_ = g_hash_table_new_full (_games_uid_hash_ghash_func, _games_uid_equal_gequal_func, NULL, _g_object_unref0_);
#line 622 "../src/database/database.vala"
	games = _tmp0_;
#line 624 "../src/database/database.vala"
	_tmp1_ = self->priv->list_games_in_user_collection_query;
#line 624 "../src/database/database.vala"
	sqlite3_reset (_tmp1_);
#line 625 "../src/database/database.vala"
	_tmp2_ = self->priv->list_games_in_user_collection_query;
#line 625 "../src/database/database.vala"
	_tmp3_ = games_collection_get_id ((GamesCollection*) collection);
#line 625 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 625 "../src/database/database.vala"
	games_database_bind_text (_tmp2_, "$COLLECTION_ID", _tmp4_, &_inner_error0_);
#line 625 "../src/database/database.vala"
	_g_free0 (_tmp4_);
#line 625 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 625 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 625 "../src/database/database.vala"
		_g_hash_table_unref0 (games);
#line 625 "../src/database/database.vala"
		return NULL;
#line 5110 "database.c"
	}
#line 627 "../src/database/database.vala"
	while (TRUE) {
#line 5114 "database.c"
		sqlite3_stmt* _tmp5_;
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
		GamesUid* _tmp8_;
#line 627 "../src/database/database.vala"
		_tmp5_ = self->priv->list_games_in_user_collection_query;
#line 627 "../src/database/database.vala"
		if (!(sqlite3_step (_tmp5_) == SQLITE_ROW)) {
#line 627 "../src/database/database.vala"
			break;
#line 5125 "database.c"
		}
#line 628 "../src/database/database.vala"
		_tmp6_ = self->priv->list_games_in_user_collection_query;
#line 628 "../src/database/database.vala"
		_tmp7_ = (const gchar*) sqlite3_column_text (_tmp6_, 0);
#line 628 "../src/database/database.vala"
		_tmp8_ = games_uid_new (_tmp7_);
#line 628 "../src/database/database.vala"
		g_hash_table_add (games, _tmp8_);
#line 5135 "database.c"
	}
#line 630 "../src/database/database.vala"
	result = games;
#line 630 "../src/database/database.vala"
	return result;
#line 5141 "database.c"
}

gboolean
games_database_remove_user_collection (GamesDatabase* self,
                                       GamesUserCollection* collection,
                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp10_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 633 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 633 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 634 "../src/database/database.vala"
	_tmp1_ = games_collection_get_id ((GamesCollection*) collection);
#line 634 "../src/database/database.vala"
	_tmp2_ = _tmp1_;
#line 634 "../src/database/database.vala"
	_tmp3_ = games_database_does_user_collection_exist (self, _tmp2_, &_inner_error0_);
#line 634 "../src/database/database.vala"
	_g_free0 (_tmp2_);
#line 634 "../src/database/database.vala"
	_tmp0_ = _tmp3_;
#line 634 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5177 "database.c"
		gboolean _tmp4_ = FALSE;
#line 634 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 634 "../src/database/database.vala"
		return _tmp4_;
#line 5183 "database.c"
	}
#line 634 "../src/database/database.vala"
	if (!_tmp0_) {
#line 635 "../src/database/database.vala"
		result = FALSE;
#line 635 "../src/database/database.vala"
		return result;
#line 5191 "database.c"
	}
#line 637 "../src/database/database.vala"
	_tmp5_ = self->priv->remove_user_collection_query;
#line 637 "../src/database/database.vala"
	sqlite3_reset (_tmp5_);
#line 638 "../src/database/database.vala"
	_tmp6_ = self->priv->remove_user_collection_query;
#line 638 "../src/database/database.vala"
	_tmp7_ = games_collection_get_id ((GamesCollection*) collection);
#line 638 "../src/database/database.vala"
	_tmp8_ = _tmp7_;
#line 638 "../src/database/database.vala"
	games_database_bind_text (_tmp6_, "$COLLECTION_ID", _tmp8_, &_inner_error0_);
#line 638 "../src/database/database.vala"
	_g_free0 (_tmp8_);
#line 638 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5209 "database.c"
		gboolean _tmp9_ = FALSE;
#line 638 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 638 "../src/database/database.vala"
		return _tmp9_;
#line 5215 "database.c"
	}
#line 640 "../src/database/database.vala"
	_tmp10_ = self->priv->remove_user_collection_query;
#line 640 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp10_);
#line 641 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 5223 "database.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GError* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 642 "../src/database/database.vala"
		_tmp11_ = games_collection_get_title ((GamesCollection*) collection);
#line 642 "../src/database/database.vala"
		_tmp12_ = _tmp11_;
#line 642 "../src/database/database.vala"
		_tmp13_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to remove user collection %s", _tmp12_);
#line 642 "../src/database/database.vala"
		_inner_error0_ = _tmp13_;
#line 642 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 642 "../src/database/database.vala"
		return _tmp14_;
#line 5240 "database.c"
	}
#line 644 "../src/database/database.vala"
	result = TRUE;
#line 644 "../src/database/database.vala"
	return result;
#line 5246 "database.c"
}

gboolean
games_database_remove_game_from_user_collection (GamesDatabase* self,
                                                 GamesGame* game,
                                                 GamesUserCollection* collection,
                                                 GError** error)
{
	gboolean _tmp0_ = FALSE;
	GamesUid* _tmp1_;
	GamesUid* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	GamesUid* _tmp11_;
	GamesUid* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	sqlite3_stmt* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 647 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 647 "../src/database/database.vala"
	g_return_val_if_fail (game != NULL, FALSE);
#line 647 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 648 "../src/database/database.vala"
	_tmp1_ = games_game_get_uid (game);
#line 648 "../src/database/database.vala"
	_tmp2_ = _tmp1_;
#line 648 "../src/database/database.vala"
	_tmp3_ = games_uid_to_string (_tmp2_);
#line 648 "../src/database/database.vala"
	_tmp4_ = _tmp3_;
#line 648 "../src/database/database.vala"
	_tmp5_ = games_collection_get_id ((GamesCollection*) collection);
#line 648 "../src/database/database.vala"
	_tmp6_ = _tmp5_;
#line 648 "../src/database/database.vala"
	_tmp7_ = games_database_is_game_in_user_collection (self, _tmp4_, _tmp6_, &_inner_error0_);
#line 648 "../src/database/database.vala"
	_g_free0 (_tmp6_);
#line 648 "../src/database/database.vala"
	_g_free0 (_tmp4_);
#line 648 "../src/database/database.vala"
	_tmp0_ = _tmp7_;
#line 648 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5304 "database.c"
		gboolean _tmp8_ = FALSE;
#line 648 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 648 "../src/database/database.vala"
		return _tmp8_;
#line 5310 "database.c"
	}
#line 648 "../src/database/database.vala"
	if (!_tmp0_) {
#line 649 "../src/database/database.vala"
		result = FALSE;
#line 649 "../src/database/database.vala"
		return result;
#line 5318 "database.c"
	}
#line 651 "../src/database/database.vala"
	_tmp9_ = self->priv->remove_game_from_user_collection_query;
#line 651 "../src/database/database.vala"
	sqlite3_reset (_tmp9_);
#line 652 "../src/database/database.vala"
	_tmp10_ = self->priv->remove_game_from_user_collection_query;
#line 652 "../src/database/database.vala"
	_tmp11_ = games_game_get_uid (game);
#line 652 "../src/database/database.vala"
	_tmp12_ = _tmp11_;
#line 652 "../src/database/database.vala"
	_tmp13_ = games_uid_to_string (_tmp12_);
#line 652 "../src/database/database.vala"
	_tmp14_ = _tmp13_;
#line 652 "../src/database/database.vala"
	games_database_bind_text (_tmp10_, "$GAME_UID", _tmp14_, &_inner_error0_);
#line 652 "../src/database/database.vala"
	_g_free0 (_tmp14_);
#line 652 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5340 "database.c"
		gboolean _tmp15_ = FALSE;
#line 652 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 652 "../src/database/database.vala"
		return _tmp15_;
#line 5346 "database.c"
	}
#line 653 "../src/database/database.vala"
	_tmp16_ = self->priv->remove_game_from_user_collection_query;
#line 653 "../src/database/database.vala"
	_tmp17_ = games_collection_get_id ((GamesCollection*) collection);
#line 653 "../src/database/database.vala"
	_tmp18_ = _tmp17_;
#line 653 "../src/database/database.vala"
	games_database_bind_text (_tmp16_, "$COLLECTION_ID", _tmp18_, &_inner_error0_);
#line 653 "../src/database/database.vala"
	_g_free0 (_tmp18_);
#line 653 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5360 "database.c"
		gboolean _tmp19_ = FALSE;
#line 653 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 653 "../src/database/database.vala"
		return _tmp19_;
#line 5366 "database.c"
	}
#line 655 "../src/database/database.vala"
	_tmp20_ = self->priv->remove_game_from_user_collection_query;
#line 655 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp20_);
#line 656 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 5374 "database.c"
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		GError* _tmp25_;
		gboolean _tmp26_ = FALSE;
#line 657 "../src/database/database.vala"
		_tmp21_ = games_game_get_name (game);
#line 657 "../src/database/database.vala"
		_tmp22_ = _tmp21_;
#line 657 "../src/database/database.vala"
		_tmp23_ = games_collection_get_title ((GamesCollection*) collection);
#line 657 "../src/database/database.vala"
		_tmp24_ = _tmp23_;
#line 657 "../src/database/database.vala"
		_tmp25_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to remove %s from user collection %s", _tmp22_, _tmp24_);
#line 657 "../src/database/database.vala"
		_inner_error0_ = _tmp25_;
#line 657 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 657 "../src/database/database.vala"
		return _tmp26_;
#line 5397 "database.c"
	}
#line 660 "../src/database/database.vala"
	result = TRUE;
#line 660 "../src/database/database.vala"
	return result;
#line 5403 "database.c"
}

gboolean
games_database_rename_user_collection (GamesDatabase* self,
                                       GamesUserCollection* collection,
                                       const gchar* title,
                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _result_ = 0;
	sqlite3_stmt* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 663 "../src/database/database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 663 "../src/database/database.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 663 "../src/database/database.vala"
	g_return_val_if_fail (title != NULL, FALSE);
#line 664 "../src/database/database.vala"
	_tmp1_ = games_collection_get_id ((GamesCollection*) collection);
#line 664 "../src/database/database.vala"
	_tmp2_ = _tmp1_;
#line 664 "../src/database/database.vala"
	_tmp3_ = games_database_does_user_collection_exist (self, _tmp2_, &_inner_error0_);
#line 664 "../src/database/database.vala"
	_g_free0 (_tmp2_);
#line 664 "../src/database/database.vala"
	_tmp0_ = _tmp3_;
#line 664 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5443 "database.c"
		gboolean _tmp4_ = FALSE;
#line 664 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 664 "../src/database/database.vala"
		return _tmp4_;
#line 5449 "database.c"
	}
#line 664 "../src/database/database.vala"
	if (!_tmp0_) {
#line 665 "../src/database/database.vala"
		result = FALSE;
#line 665 "../src/database/database.vala"
		return result;
#line 5457 "database.c"
	}
#line 667 "../src/database/database.vala"
	_tmp5_ = self->priv->rename_user_collection_query;
#line 667 "../src/database/database.vala"
	sqlite3_reset (_tmp5_);
#line 668 "../src/database/database.vala"
	_tmp6_ = self->priv->rename_user_collection_query;
#line 668 "../src/database/database.vala"
	games_database_bind_text (_tmp6_, "$TITLE", title, &_inner_error0_);
#line 668 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5469 "database.c"
		gboolean _tmp7_ = FALSE;
#line 668 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 668 "../src/database/database.vala"
		return _tmp7_;
#line 5475 "database.c"
	}
#line 669 "../src/database/database.vala"
	_tmp8_ = self->priv->rename_user_collection_query;
#line 669 "../src/database/database.vala"
	_tmp9_ = games_collection_get_id ((GamesCollection*) collection);
#line 669 "../src/database/database.vala"
	_tmp10_ = _tmp9_;
#line 669 "../src/database/database.vala"
	games_database_bind_text (_tmp8_, "$COLLECTION_ID", _tmp10_, &_inner_error0_);
#line 669 "../src/database/database.vala"
	_g_free0 (_tmp10_);
#line 669 "../src/database/database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5489 "database.c"
		gboolean _tmp11_ = FALSE;
#line 669 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 669 "../src/database/database.vala"
		return _tmp11_;
#line 5495 "database.c"
	}
#line 671 "../src/database/database.vala"
	_tmp12_ = self->priv->rename_user_collection_query;
#line 671 "../src/database/database.vala"
	_result_ = sqlite3_step (_tmp12_);
#line 672 "../src/database/database.vala"
	if (_result_ != SQLITE_DONE) {
#line 5503 "database.c"
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		GError* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 673 "../src/database/database.vala"
		_tmp13_ = games_collection_get_title ((GamesCollection*) collection);
#line 673 "../src/database/database.vala"
		_tmp14_ = _tmp13_;
#line 673 "../src/database/database.vala"
		_tmp15_ = g_error_new (GAMES_DATABASE_ERROR, GAMES_DATABASE_ERROR_EXECUTION_FAILED, "Failed to rename user collection %s", _tmp14_);
#line 673 "../src/database/database.vala"
		_inner_error0_ = _tmp15_;
#line 673 "../src/database/database.vala"
		g_propagate_error (error, _inner_error0_);
#line 673 "../src/database/database.vala"
		return _tmp16_;
#line 5520 "database.c"
	}
#line 676 "../src/database/database.vala"
	result = TRUE;
#line 676 "../src/database/database.vala"
	return result;
#line 5526 "database.c"
}

static void
games_database_class_init (GamesDatabaseClass * klass,
                           gpointer klass_data)
{
#line 3 "../src/database/database.vala"
	games_database_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/database/database.vala"
	g_type_class_adjust_private_offset (klass, &GamesDatabase_private_offset);
#line 3 "../src/database/database.vala"
	G_OBJECT_CLASS (klass)->finalize = games_database_finalize;
#line 5539 "database.c"
}

static void
games_database_instance_init (GamesDatabase * self,
                              gpointer klass)
{
#line 3 "../src/database/database.vala"
	self->priv = games_database_get_instance_private (self);
#line 5548 "database.c"
}

static void
games_database_finalize (GObject * obj)
{
	GamesDatabase * self;
#line 3 "../src/database/database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_DATABASE, GamesDatabase);
#line 4 "../src/database/database.vala"
	_sqlite3_close0 (self->priv->database);
#line 154 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->add_game_query);
#line 155 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->add_game_uri_query);
#line 156 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->update_game_query);
#line 157 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->delete_game_query);
#line 158 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->delete_uri_query);
#line 160 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->find_game_uris_query);
#line 161 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->get_cached_game_query);
#line 162 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->list_cached_games_query);
#line 164 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->add_game_resource_query);
#line 165 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->has_uri_query);
#line 167 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->set_is_favorite_query);
#line 168 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->is_game_favorite_query);
#line 169 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->list_favorite_games_query);
#line 171 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->update_recently_played_game_query);
#line 172 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->list_recently_played_games_query);
#line 174 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->add_user_collection_query);
#line 175 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->add_game_to_user_collection_query);
#line 176 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->does_user_collection_exist_query);
#line 177 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->is_game_in_user_collection_query);
#line 178 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->list_user_collections_query);
#line 179 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->list_games_in_user_collection_query);
#line 180 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->remove_user_collection_query);
#line 181 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->remove_game_from_user_collection_query);
#line 182 "../src/database/database.vala"
	_sqlite3_finalize0 (self->priv->rename_user_collection_query);
#line 3 "../src/database/database.vala"
	G_OBJECT_CLASS (games_database_parent_class)->finalize (obj);
#line 5609 "database.c"
}

static GType
games_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesDatabase), 0, (GInstanceInitFunc) games_database_instance_init, NULL };
	GType games_database_type_id;
	games_database_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesDatabase", &g_define_type_info, 0);
	GamesDatabase_private_offset = g_type_add_instance_private (games_database_type_id, sizeof (GamesDatabasePrivate));
	return games_database_type_id;
}

GType
games_database_get_type (void)
{
	static volatile gsize games_database_type_id__once = 0;
	if (g_once_init_enter (&games_database_type_id__once)) {
		GType games_database_type_id;
		games_database_type_id = games_database_get_type_once ();
		g_once_init_leave (&games_database_type_id__once, games_database_type_id);
	}
	return games_database_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5641 "database.c"
		gssize i;
#line 3 "../src/core/snapshot.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 3 "../src/core/snapshot.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 3 "../src/core/snapshot.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5649 "database.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 3 "../src/core/snapshot.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 3 "../src/core/snapshot.vala"
	g_free (array);
#line 5664 "database.c"
}

